import bb.cascades 1.3
import bb.platform 1.3

Sheet{
    onCreationCompleted: {
        open();
    } 
    property string iconSource
    attachedObjects:[HomeScreen{id:homescreen}]
content:Page {
    id: hs
    titleBar: TitleBar {
        appearance: TitleBarAppearance.Branded
        title: qsTr("Add To Homescreen")
        
        dismissAction: ActionItem {
            title: "Cancel"
            onTriggered: {
                close();hs.destroy();
            }
        }
        acceptAction: ActionItem {
            title: qsTr("Add")
            onTriggered: {
                if(textfield.text===""){toast.showText(qsTr("Please enter a Label"))}
                else if(iconSource===""){toast.showText(qsTr("Please choose a Icon"))}
                else{
                    if(sourceStreamed){homescreen.addShortcut(iconSource, textfield.text, "starplayer://" + audioSource); toast.showText(qsTr("Homescreen Shortcut Added: ")+ textfield.text); close(); hs.destroy()}

                    else homescreen.addShortcut(iconSource, textfield.text, "starplayer://" + originalSource); toast.showText(qsTr("Homescreen Shortcut Added: ")+ textfield.text); close(); hs.destroy()}
            }
        }
    }
    Container {
        topPadding: 5
        TextField {
            id: textfield
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            hintText: qsTr("Type Shortcut Label Here")
            text: metaDataTitle===""?metaDataFileName: metaDataArtist+ " - " +metaDataTitle
        }    Container {
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
        ImageView{
         imageSource:iconSource
         maxHeight: 350
         maxWidth: 350
        }
    }
    DropDown {
        id: iconDrop2
        visible: mediaFormat==="Audio"? true:false
        onSelectedIndexChanged: { iconSource= selectedValue}
        title:qsTr("Choose Icon")
        Option {
            text: qsTr("Song Art Work")
            value:artWorkURI
            id: artWork1
            imageSource: artWorkURI
            onCreationCompleted: { if(artWorkURI=="")iconDrop2.remove(artWork1)  }
        }
        Option {
            text: qsTr("Icon 1")
            imageSource: "asset:///images/Homescreen/audio_red.png"
            value:"asset:///images/Homescreen/audio_red.png"
        }
        Option {
            text: qsTr("Icon 2")
            imageSource: "asset:///images/Homescreen/audio_defaultt.png"
            value:"asset:///images/Homescreen/audio_defaultt.png"
        }
        Option {
            text: qsTr("Icon 3")
            imageSource: "asset:///images/Homescreen/audio_blue.png"
            value:"asset:///images/Homescreen/audio_blue.png"
        }
        Option {
            text: qsTr("Icon 4")
            imageSource: "asset:///images/Homescreen/audio_magenta.png"
            value:"asset:///images/Homescreen/audio_magenta.png"
        }
        Option {
            text: qsTr("Icon 5")
            imageSource: "asset:///images/Homescreen/audio_deeppink.png"
            value:"asset:///images/Homescreen/audio_deeppink.png"
        }
        Option {
            text: qsTr("Icon 6")
            imageSource: "asset:///images/Homescreen/audio_purple.png"
            value:"asset:///images/Homescreen/audio_purple.png"
        }
        Option {
            text: qsTr("Icon 7")
            imageSource: "asset:///images/Homescreen/audio_red_circle.png"
            value:"asset:///images/Homescreen/audio_red_circle.png"
        }
        Option {
            text:qsTr( "Icon 8")
            imageSource: "asset:///images/Homescreen/audio_default_circle.png"
            value:"asset:///images/Homescreen/audio_default_circle.png"
        }
        
        Option {
            text: qsTr("Icon 9")
            imageSource: "asset:///images/Homescreen/audio_blue_dark_circle.png"
            value:"asset:///images/Homescreen/audio_blue_dark_circle.png"
        }
        
        Option {
            text: qsTr("Icon 10")
            imageSource: "asset:///images/Homescreen/audio_magenta_circle.png"
            value:"asset:///images/Homescreen/audio_magenta_circle.png"
        }
        Option {
            text: qsTr("Icon 11")
            imageSource: "asset:///images/Homescreen/audio_deeppink_circle.png"
            value:"asset:///images/Homescreen/audio_deeppink_circle.png"
        }
        
        Option {
            text: qsTr("Icon 12")
            imageSource: "asset:///images/Homescreen/audio_purple_circle.png"
            value:"asset:///images/Homescreen/audio_purple_circle.png"
        }
    
    }
        DropDown {
            id: iconDrop
            visible: mediaFormat==="Video"? true:false
            onSelectedIndexChanged: { iconSource= selectedValue}
            title:qsTr("Choose Icon")
            Option {
                text: qsTr("Video Thumbnail")
                value:artWorkURI
                id: artWork
                imageSource: artWorkURI
                onCreationCompleted: { if(artWorkURI==="")iconDrop.remove(artWork)  }
            }
            Option {
                text: qsTr("Icon 1")
                imageSource: "asset:///images/video_red.png"
                value:"asset:///images/video_red.png"
            }
            Option {
                text:qsTr( "Icon 2")
                imageSource: "asset:///images/video_blue.png"
                value:"asset:///images/video_blue.png"
            }
            Option {
                text: qsTr("Icon 3")
                imageSource: "asset:///images/video_magenta.png"
                value:"asset:///images/video_magenta.png"
            }
            Option {
                text:qsTr( "Icon 4")
                imageSource: "asset:///images/Homescreen/video_deeppink.png"
                value:"asset:///images/Homescreen/video_deeppink.png"
            }
            Option {
                text: qsTr("Icon 5")
                imageSource: "asset:///images/video_purple.png"
                value:"asset:///images/video_purple.png"
            }
            Option {
                text: qsTr("Icon 6")
                imageSource: "asset:///images/video_red_circle.png"
                value:"asset:///images/video_red_circle.png"
            }

            Option {
                text: qsTr("Icon 7")
                imageSource: "asset:///images/video_blue_circle.png"
                value:"asset:///images/video_blue_circle.png"
            }
            Option {
                text: qsTr("Icon 8")
                imageSource: "asset:///images/video_magenta_circle.png"
                value:"asset:///images/video_magenta_circle.png"
            }
            Option {
                text:qsTr( "Icon 9")
                imageSource: "asset:///images/Homescreen/video_deeppink_circle.png"
                value:"asset:///images/Homescreen/video_deeppink_circle.png"
            }
           
            
            Option {
                text: qsTr("Icon 10")
                imageSource: "asset:///images/video_purple_circle.png"
                value:"asset:///images/video_purple_circle.png"
            }
            
        }
       

    }
}
}
