import bb.cascades 1.4
import bb.cascades.pickers 1.0
import timer 1.0
import "Custom"

Sheet{
    id: settingspinned
    onCreationCompleted: { open(); toggler.start(); }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title: qsTr( "Announcement Settings")
            
            dismissAction: ActionItem {
                title:  qsTr("Close") 
                onTriggered: {
                    close();settingspinned.destroy();
                }
            }
        }
        attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true;}}
                
        
        ScrollView {
            id: scroller
            content: Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Center
                id: conter
                topPadding: 5
                bottomPadding: 5
                
                layout: StackLayout { }
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Auto check for Announcements on startup")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("announcementsAutoCheck", "")===""? true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("announcementsAutoCheck", "")===""){ appsettings.saveSystemSetting("announcementsAutoCheck", "false");}
                                else{ appsettings.saveSystemSetting("announcementsAutoCheck", "");}
                            
                            }
                        }
                    }
                } 
            
            
            
            
            }
        }
    }
}