import QtQuick 1.0
import bb.cascades 1.4

Sheet{
    id: sheet
    onCreationCompleted: {open(); downloadingAnnouncements=true;activityInd.running=true;_app.deleteFile(_app.homePath() + "/" +"announcements.xml");downloadManager.download("http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/Announcements/announcements.xml", _app.homePath() + "/" +"announcements.xml");
}
property string announcementsModelURL
attachedObjects: Connections {
    target:mainnav
    onInternalDownloadErrorOccured:{activityInd.running=false;}
    onAnnouncementsDownloaded:{activityInd.running=false;announcementsModelURL= "file://" +_app.homePath() + "/" +"announcements.xml";lastAnnouncementsCount= modelr.childCount(0,0);  appsettings.saveSystemSetting("lastAnnouncementsCount", lastAnnouncementsCount);console.log("Model Page count = "+ modelr.childCount(0,0))}
}

Page {
    titleBar: TitleBar {
        title: "Announcements"
        dismissAction: ActionItem {
            title: "Back"
            onTriggered: {
                sheet.close();
            }
        }
        
    }
    actionBarVisibility: ChromeVisibility.Compact

    actions: ActionItem {
        ActionBar.placement: ActionBarPlacement.Signature
        title: "Settings"
        onTriggered: {
            creator.createQMLObject("AnnouncementSettings.qml")
        }
    }
    Container {
        layout: DockLayout{}
        Container {
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            
            ActivityIndicator {
                id: activityInd
                visible: true
                running: false
                minHeight:  passport? 170:150
                minWidth:  passport? 170:150
            }
        }
        ListView {
            id: listView
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            scrollRole: ScrollRole.Main
            layout: StackListLayout {
                headerMode: ListHeaderMode.Sticky
            }
            dataModel: XmlDataModel {
                
                id: modelr
                source: announcementsModelURL
            }
            onTriggered: {
                var data=dataModel.data(indexPath)
                if(data.title===""){toast.showText("No data found")}
                else{
                    announcementsReaderTitle= data.title;
                    announcementsReaderText= data.description;
                    announcementsReaderURL= data.url;
                    announcementsReaderImage= data.image;
                    announcementsReaderDate=data.date;
                    creator.createQMLObject("AnnouncementsReader.qml")
                    
                   
}
            }
            listItemComponents: [
                ListItemComponent {
                    type: "header"
                    Header {
                        title:""
                    }  
                },
                ListItemComponent {
                    type: "item"
                    
                    Container {
                        id: rootListItemContainer
                        
                        StandardListItem {
                           
                            title: ListItemData.title
                            description: "\n"
                            status: ListItemData.date
                        
                        }     
                    
                    }
                }
            ]
        }
    }
}
}
