import QtQuick 1.0
import bb.cascades 1.4
import bb.multimedia 1.4
import timer 1.0
import bb.cascades.pickers 1.0
Sheet {
    id: sheet
    function bytesToSize(bytes) {
        if (isNaN(bytes)) {return;}
        var units = [ ' bytes', ' KB', ' MB', ' GB', ' TB', ' PB', ' EB', ' ZB', ' YB' ];
        var amountOf2s = Math.floor(Math.log(+ bytes) / Math.log(2));
        if (amountOf2s < 1) {
            amountOf2s = 0;
        }
        var i = Math.floor(amountOf2s / 10);
        bytes = + bytes / Math.pow(2, 10 * i);
        
        // Rounds to 3 decimals places.
        if (bytes.toString().length > bytes.toFixed(3).toString().length) {
            bytes = bytes.toFixed(3);
        }
        return bytes + units[i];
    }
    property double recordingLevel
    property string nonFileOutput:audrec.outputUrl.toString()

    onCreationCompleted: { open();_app.dirCheckOrCreate(_app.homePath()+ "/voice")}   
 function updateOutputURL(){if(drop.selectedIndex===0){ audrec.setOutputUrl(""); audrec.setOutputUrl("file:///accounts/1000/shared/voice/StarPlayerRecording" + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a")          
 }
 else if(drop.selectedIndex===2){audrec.setOutputUrl("file:///"+_app.homePath()+"/"+ "voice/StarPlayerRecording"+ Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a")}

 else{audrec.setOutputUrl("file:////accounts/1000/removable/sdcard/voice/StarPlayerRecording" + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +" - " +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a")}
console.log("New Output URL "+ audrec.outputUrl)
 }
 
 function recordingCompleted(){completedCont.opacity=1;audioIsRecording=false;flashCoverRecordIcon(); Application.clearClosePrompt();
     if(drop.selectedIndex===2){_inAppRecordings.addToJson(Qt.formatDateTime (new Date(), "dd/MM/yyyy") +"-" +Qt.formatDateTime (new Date(), "hh:mm:ss"), audrec.outputUrl, "", bytesToSize(_app.getFileSize(nonFileOutput.replace("file:///", ""))))}
     
     console.log(bytesToSize(_app.getFileSize(nonFileOutput.replace("file:///", ""))))
 }
 function getTimeFromMSec(msec) {
     if (msec <= 0 || msec == undefined) {
         return "0:00"
     
     } else {
         var sec = "" + Math.floor(msec / 1000) % 60
         if (sec.length == 1)
             sec = "0" + sec
         
         var hour = Math.floor(msec / 3600000)
         if (hour < 1) {
             return Math.floor(msec / 60000) + ":" + sec
         } else {
             var min = "" + Math.floor(msec / 60000) % 60
             if (min.length == 1)
                 min = "0" + min
             
             return hour + ":" + min + ":" + sec
         }
     }
 }
 property bool recording
 property bool dropDownExpanded:false
attachedObjects: [AudioRecorder {
    id: audrec
   
    onRecordingLevelChanged: {
        recordingLevel=percentage
        audRecordLevel=percentage
    }
    onAudioChannelConfigurationChanged: { console.log(audioChannelConfiguration)}
    outputUrl:   "file:///accounts/1000/shared/voice/StarPlayerRecording" + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a"
   audioChannelConfiguration: AudioChannelConfiguration.Mono
   onError: {
       image.enabled=false
       toast.showText("An Error Occured - " +mediaError)
   }
},
FilePicker {
    id: saver
    property string saveName
    mode: FilePickerMode.Saver
    title : qsTr("Save Location")
    directories : ["/accounts/"]
    onFileSelected: {
        console.log(defaultSaveFileNames)
        saveName="file://"+  selectedFiles[0].toString() + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss") + ".m4a"
        appsettings.saveSystemSetting("customAudioRecorderPath", saveName);
        console.log(saveName)
        audrec.setOutputUrl(saveName)
    }
},
SystemTimer {
    id: sizeTimer
    interval: 1000
    onTimeout: {
        console.log(bytesToSize(_app.getFileSize(nonFileOutput.replace("file:///", ""))))
    }
},
 Connections {
target: _inAppRecordings 
onAudioRecordingRequested:{sheet.close();}
}
]
Page {
    titleBar: TitleBar {
        visibility: recording?ChromeVisibility.Hidden: ChromeVisibility.Visible
        title: qsTr("Recorder")
        dismissAction: ActionItem {
            title:qsTr( "Close")
            onTriggered: {
                sheet.close();
            }
        }
        acceptAction: ActionItem {
            title: qsTr("In App Recordings")
            onTriggered: {
                if (protectedMode) {
                    creator.createQMLObject("ProtectedModeRecor.qml")
                } else {
                    creator.createQMLObject("InAppRecordings.qml")
                }
            }
        }
    }
   
    
    Container {
        layout: DockLayout {  }
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        Container {
            topPadding: 10
            verticalAlignment: VerticalAlignment.Top
            layout: StackLayout {} 
            opacity: recording? 0:1

        DropDown {
            opacity:nightMode? 0.8:1
            visible:  _app.checkSDCard();
            id: drop
            onExpandedChanged: {
                if(expanded)dropDownExpanded=true;
                else dropDownExpanded=false
            }
            onCreationCompleted: {
                if(appsettings.getSystemSetting("AudRecordSaveLocationIndex", "")===""){selectedIndex=0}
                else{selectedIndex= parseInt(appsettings.getSystemSetting("AudRecordSaveLocationIndex", ""))}
            }
            onSelectedIndexChanged: {
                if(selectedIndex===0){audrec.setOutputUrl( "file:///accounts/1000/shared/voice/StarPlayerRecording" + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a")}
                if(selectedIndex===1){audrec.setOutputUrl( "file:///accounts/1000/removable/sdcard/voice/StarPlayerRecording" + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a")}
                if(selectedIndex===2){audrec.setOutputUrl("file:///"+_app.homePath()+"/"+ "voice/StarPlayerRecording"+ Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a")}
                if(selectedIndex===3){if(expanded===true)saver.open();}
     
           appsettings.saveSystemSetting("AudRecordSaveLocationIndex", selectedIndex);
            }
            title: qsTr("Save Location")
            Option {
                value: "file:///accounts/1000/shared/voice/StarPlayerRecording" + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a"
                text: qsTr("Device Memory")
            }
            Option {
                id: sdC
                enabled: _app.checkSDCard()
                value: "file:////accounts/1000/removable/sdcard/voice/StarPlayerRecording" + Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a"
                text: qsTr("SD Card")
            }
            Option {
                text:qsTr( "In-App")
                description:qsTr( "Can only be accessed by Star Player")
                value:_app.homePath()+"/"+ "voice/StarPlayerRecording"+ Qt.formatDateTime (new Date(), "dd-MM-yyyy") +"-" +Qt.formatDateTime (new Date(), "hh-mm-ss")+ ".m4a"
            }
            Option {
                text: "Custom"
                description: "Choose your own Save Location"
                value: appsettings.getSystemSetting("customAudioRecorderPath", "")
            }
        }
     
           
        
        DropDown {
            opacity:nightMode? 0.8:1
            onCreationCompleted: {
                if(appsettings.getSystemSetting("AudRecordChannelIndex", "")===""){selectedIndex=0}
                else{selectedIndex= parseInt(appsettings.getSystemSetting("AudRecordChannelIndex", ""))}
            }
            onExpandedChanged: {
                if(expanded)dropDownExpanded=true;
                else dropDownExpanded=false
            }
            title:qsTr( "Channel Configuration")
            onSelectedIndexChanged: {
                if(selectedIndex===0){audrec.audioChannelConfiguration=AudioChannelConfiguration.Stereo}
                if(selectedIndex===1){audrec.audioChannelConfiguration=AudioChannelConfiguration.Mono}
                appsettings.saveSystemSetting("AudRecordChannelIndex", selectedIndex);

            }
            Option {
                text:qsTr( "Stereo")
            }
            Option {
                text: qsTr("Mono")
            }
        }}
        Container {
            topPadding: miniSquareDevice?100: OrientationSupport.orientation == UIOrientation.Portrait?0:140
            opacity:dropDownExpanded? 0: nightMode? 0.8:1
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            
            ImageButton {
                id: image
                minHeight: 350
                minWidth: 350
                onClicked: {
                    if(recording==true){recording=false;audrec.reset();recordingCompleted();}
                    else {updateOutputURL();audrec.prepare();recording=true;audrec.record();completedCont.opacity=0;console.log(audrec.outputUrl);Application.setClosePrompt("Star Player", "Closing will Stop your Audio Recording are you sure you want to close?");nonFileOutput=audrec.outputUrl.toString();audioIsRecording=true;flashCoverRecordIcon();}
                }
                disabledImageSource:passport?"images/recording_inprogress_passport_pressed.png": "images/recording_inprogress_pressed.png"
                defaultImageSource: if(passport) recording?"images/recording_notinprogress_passport.png" : "images/recording_inprogress_passport.png"
                else  recording?"images/recording_notinprogress.png" : "images/recording_inprogress.png"
                 
                pressedImageSource: if(passport) recording?"images/recording_notinprogress_passport_pressed.png" : "images/recording_inprogress_passport_pressed.png"
                else  recording?"images/recording_notinprogress_pressed.png" : "images/recording_inprogress_pressed.png"
     
            }
            Label {
                horizontalAlignment: HorizontalAlignment.Center
               verticalAlignment: VerticalAlignment.Bottom
               text: getTimeFromMSec(audrec.duration )
               onTextChanged: { audioIsRecordingDuration= text;}
               textStyle {
                   fontSize: FontSize.PointValue
                   fontSizeValue: recording? 15:8
                   base: SystemDefaults.TextStyles.BigText
               }
            }
        }
        Container {
            id: completedCont
            layout: DockLayout {
                
            }
            opacity: 0
           horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Bottom
           Container {
               horizontalAlignment: HorizontalAlignment.Center
               Button {
                   text: qsTr("Play Recording" )
                   color: Color.create(getAppColour())
                onClicked: {
                    audioSource=audrec.outputUrl;
                    activity.running = true;
                    activity.visible = true;
                    sheet.close();
                    lastrecentPlay.start();
                }  
               }
           }

        }
        Container {
           horizontalAlignment: HorizontalAlignment.Fill
           verticalAlignment: VerticalAlignment.Bottom 
           gestureHandlers: TapHandler {onTapped: { levelInd.opacity===0? levelInd.opacity=1: levelInd.opacity=0
           }}
        
        ProgressIndicator {
            id: levelInd
            opacity: recording?1:0
            value:recording? recordingLevel: 0
            fromValue: 0.0
            toValue: 1.0
        }
    }
      
    }
}
}