import bb.cascades 1.4
import timer 1.0
import "Custom"
Sheet{
    id: sheet
    onCreationCompleted: {
        sheet.open();if( customStationsView) _customStations.updateHistoryDataModel()
    }
    attachedObjects:[
         SystemTimer {
            id: delay
            interval: 200
            
            onTimeout: {

                console.log("TIMER TRIGGERED");
                delay.stop();
                playMedia();
            
            }
        }
]
    
    Page {
        titleBar: TitleBar {
            title: carmodeInternetRadioModelTitle
            dismissAction: ActionItem {
                title: "Close"
                onTriggered: {
                    customStationsView=false;

                    sheet.close();
                    resetCarModeUI();
                }
            }
        }
        Container {
            layout: DockLayout {
            }
            ListView{
                id: view
                opacity: nightMode?0.8:1.0

                dataModel: _customStations.dataModel
                visible: customStationsView?true:false
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                scrollRole: ScrollRole.Main
                scrollIndicatorMode: ScrollIndicatorMode.ProportionalBar
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                onTriggered: {
                    
                    var data = _customStations.dataModel.data(indexPath);
                    audioSource= data.url;
                    metaDataTitle= data.title;
                    carModeInternetRadio=true;
                    delay.start();
                    sheet.close();
                
                }
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            visible: false
                        }  
                    },
                    
                    ListItemComponent {
                        type: "item"
                        
                        Container {
                            id: rootListItemContainerr
                            property string pathIndex
                            property string title
                            property string urle
                            property string icon
                            
                            
                            PlaylistItemCarMode {
                                quickDeleteActive: false
                                miniMode: true
                                imageEnabled: false
                                id: stationChangeListItemm
                                title: ListItemData.title
                            
                            }     
                        
                        }
                    }
                ]
            }
            ListView {
                id: listView
                visible: customStationsView?false:true
                opacity: nightMode?0.8:1.0
                scrollRole: ScrollRole.Main
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                dataModel: XmlDataModel {
                    id: modelr
                    source: carmodeInternetRadioModelURL
                }
                onTriggered: {
                    var data= modelr.data(indexPath);
                    audioSource= data.url;
                    metaDataTitle= data.title;
                    carModeInternetRadio=true;
                    delay.start();
                    sheet.close();
                }
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            title:""
                        }  
                    },
                    ListItemComponent {
                        type: "item"
                        
                        Container {
                            id: rootListItemContainer
                            
                            
                            PlaylistItemCarMode {
                                quickDeleteActive: false
                                miniMode: true
                                imageEnabled: false
                                id: stationChangeListItem
                                title: ListItemData.title

                            }     
                        
                        }
                    }
                ]
            }
        }
    }
}
