import QtQuick 1.0
import bb.cascades 1.4
import bb.multimedia 1.4
import timer 1.0
import bb.cascades.pickers 1.0
import bb.system 1.2
import "Custom"
import AppSettings 1.0
import bb.device 1.3
Sheet{
    id: sheet
    property string invokedURL
    
    property bool buttonsRecentlyPressed
    property bool externalButtonPressed:false
    property bool autoResuming: false
    property bool changeButtonsEnabled: true
    property int audioBufferProgress
    property int duratione: 1
    property int eqValue
    property double playerVolume: 0.0
    property bool sleepTimerPopup: false
    property bool videoDimensionsChanged: false
    property double changedVideoScale
    property bool repeatModeEnabled:false
    property int stoppedProgress
    property bool awaitingBT:false
    property int positione: 1
    property string newPosition
    property bool showPlaylist: false
    
    property string eqName: appsettings.getSystemSetting("EQValueName", "Off")
    property bool showControls: true
    property int minutes: Math.floor(positione / 1000 / 60)
    property int seconds: Math.floor(positione / 1000 % 60)
    property bool alreadyRecentlyAdded: false
    property int pwidth
    Component.onDestruction: {
        
        if(appsettings.getSystemSetting("nightModeTimeCheck", "")===""){nightModeTimeCheck.start();}
    }
    onCreationCompleted: {
        OrientationSupport.supportedDisplayOrientation =SupportedDisplayOrientation.DisplayPortrait;
        sheet.open();

        eQChanged();
        
        if (carModeAlwaysKeepScreenOn) _app.setScreenIdle("KeepAwake");
        stopNightModeTimeCheckerSession();
        if(inheritPlaylistMode){playlistMode=true;}
     launchTimer.start();


    }
    
    function exitCarMode(){
        
        artWorkURI = "";
        artWorkUriNonMod="";
        playerDuration = 0;
        playerProgress = 0;
        elapsedTime = "";
        playlistMode = false;
        mediaPlaying = false;
        sourceInvoked = false;
        sourceStreamed = false;
        activity.running = false;
        activity.visible = false;
        videoOpening = false;
        clearMetaData();
        
        mediaRepeat = false;
        // customPickerUsed=false;
        inAppRecordingPlaying = false;
        internetRadioActive = false;
        albumArtActiveFrame = false;
        shuffleMode = false;
        bypassFormatCheck = false;
        internetRadioSource = "";
        fileSystemLyricsFound = false;
        originalSource = "";
        updateCoverImage();
        playlistEditorOpened = false;
        carModeInternetRadio=false;
        autoResizeAttempted = false;
        playQueue.clear();
        var oro = appsettings.getSystemSetting("orientation", "");
        if (oro === "Automatic") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
        } else if (oro === "Portrait") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
        } else if (oro === "Landscape") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayLandscape
        }
        sheet.close();

    }
    
    function autoVideoResize(){
        console.log("Auto Resize Function Fired")
        if(autoResizeAttempted===false){
            autoResizeAttempted=true;
            if(mediaFormat==="Video") {
                if(appsettings.getSystemSetting("autoVideoResize", "")===""){
                    console.log("Auto Resize Function Setting Correct")
                    player.pause(); player.play();
                    if(OrientationSupport.orientation == UIOrientation.Portrait) {
                        console.log("Portrait")
                        //this is needed to make the MediaPlayer actually give me the width, yeah BB really broke it that badly
                        
                        if(player.videoDimensions.width>0) {
                            fwcVideoSurface.scaleX = _app.screenWidth() / player.videoDimensions.width;
                            fwcVideoSurface.scaleY = fwcVideoSurface.scaleX;
                            fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleX;
                            fwcVideoSurface.initialScale=fwcVideoSurface.scaleX;
                            
                            if (fwcVideoSurface.scaleY * player.videoDimensions.height > _app.screenHeight()) {
                                fwcVideoSurface.scaleY = _app.screenHeight() / player.videoDimensions.height;
                                fwcVideoSurface.scaleX = fwcVideoSurface.scaleY;
                                
                                fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleY;
                                fwcVideoSurface.initialScale=fwcVideoSurface.scaleY;
                            }
                            
                            console.log("scale should have changed");
                            videoDimensionsChanged = true;
                            changedVideoScale = fwcVideoSurface.newScaleVal;
                            console.log("Changed Scale " + changedVideoScale);
                        }
                        else{ fwcVideoSurface.newScaleVal=1.0;fwcVideoSurface.initialScale=1.0; }
                    }
                    
                    if(OrientationSupport.orientation == UIOrientation.Landscape) {
                        console.log("Landscape")
                        player.pause(); player.play(); //this is needed to make the MediaPlayer actually give me the width, yeah BB really broke it that badly
                        if(player.videoDimensions.height>0) {
                            
                            fwcVideoSurface.scaleX = _app.screenHeight() / player.videoDimensions.height;
                            fwcVideoSurface.scaleY = fwcVideoSurface.scaleX;
                            fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleX;
                            fwcVideoSurface.initialScale=fwcVideoSurface.scaleX;
                            
                            if (fwcVideoSurface.scaleY * player.videoDimensions.width > _app.screenWidth()) {
                                fwcVideoSurface.scaleY = _app.screenWidth() / player.videoDimensions.width;
                                fwcVideoSurface.scaleX = fwcVideoSurface.scaleY;
                                
                                fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleY;
                                fwcVideoSurface.initialScale=fwcVideoSurface.scaleY;
                            }
                            
                            console.log("scale should have changed");
                            videoDimensionsChanged = true;
                            changedVideoScale = fwcVideoSurface.newScaleVal;
                            console.log("Changed Scale " + changedVideoScale);
                        }
                    }
                }
            }
        }
    }
    
    
    
    function playPauseMedia() {
        if (mainnav.playbackCompleted) {
            player.play();
            if (fadeInAudio === true) {
                volFade.start();
            } else {
                playerVolume = 1.0
            }
        } else if (player.mediaState == 2) {
            player.pause();
        } else if (player.mediaState == 3) {
            player.play();
            if (fadeInAudio === true) {
                volFade.start();
            }
        } else if (player.mediaState == 4) {
            player.seekTime(videoProgress);
            player.play();
            player.play();
            if (fadeInAudio === true) {
                volFade.start();
            }
        }
    }
    function nextTrack(){
        if(playlistMode){console.log(globalIndexPath);lister.triggered(playQueue.after(globalIndexPath))
        }
    
    }
    function previousTrack(){ 
        if(playlistMode){console.log(globalIndexPath);lister.triggered(playQueue.before(globalIndexPath))}
    
    }
    
    
    
    function rewindTrackShort() {
        var pos = player.position;
        pos -= fowardRewindButtonValue;
        player.seekTime(pos);
        if(externalButtonPressed===false){
            showControls=true;
            autoHideTimer.restart();}
        externalButtonPressed=false;
    }
    function forwardTrackShort() {
        var pos = player.position;
        pos += fowardRewindButtonValue;
        player.seekTime(pos);
        if(externalButtonPressed===false){
            showControls=true;
            autoHideTimer.restart();}
        externalButtonPressed=false;
    }
    function rewindTrackLong() {
        var pos = player.position
        pos -= longPressfowardRewindButtonValue;
        player.seekTime(pos);
        if(externalButtonPressed===false){
            showControls=true;
            autoHideTimer.restart();}
        externalButtonPressed=false;
    }
    function forwardTrackLong() {
        var pos = player.position;
        pos += longPressfowardRewindButtonValue;
        player.seekTime(pos);
        if(externalButtonPressed===false){
            showControls=true;
            autoHideTimer.restart();}
        externalButtonPressed=false;
    }
    function showPlaylistUI() {
        hideControlsUI();
        _playlist.updatePlaylistModel();
        showPlaylist = true;
    }
    function hidePlaylistUI() {
        showControlsUI();
        showPlaylist = false;
    }
    function showControlsUI() {
        if(mediaFormat==="Video"){if(showVideoUnderControls==true){ fwcVideoSurface.visible=true;}}
        titleCont.opacity = 1;
        topRow.opacity = 1;
        middleRow2.opacity = 1;
        centerRow.opacity = 1;
        bottomRow1.opacity = 1;
        if(appsettings.getSystemSetting("carModeExtendedHint", "")===""){mainCont.add(creator.createQMLObject("Custom/CarModeTimeLabelTapHint.qml"))}
    }
    function hideControlsUI() {
        //  playlistMode=false;
        carModeInternetRadio=false;
        autoResizeAttempted=false;
        fwcVideoSurface.visible=false;
        titleCont.opacity = 0;
        topRow.opacity = 0;
        middleRow2.opacity = 0;
        centerRow.opacity = 0;
        bottomRow1.opacity = 0;
    }
    
    
    function showStartUI() {
        hideControlsUI(); chooseAud.opacity=1; chooseVid.opacity=1;chooseInternetRadio.opacity=1; choosePlaylist.opacity=1;settings.opacity=1;cf.opacity=1;homeIMG.opacity=1;playlistMode=false;
    }
    function hideStartUI() { showControlsUI(); chooseAud.opacity=0; chooseInternetRadio.opacity=0;chooseVid.opacity=0; choosePlaylist.opacity=0;settings.opacity=0;cf.opacity=0;homeIMG.opacity=0;}
    function runCarModeStart() {


        if (aboutToLoadCarMode) {
            
            autoResuming=true;
            if (autoPlayWhenBluetoothIsConnected == true) {
                if (btDeviceConnected == true) {
                    if(originalSource===""){invokedURL= audioSource;originalSource= invokedURL.replace("file://", "/");console.log("ORIGINAL SOURCE CHANGED : " + originalSource)}
                    
                    setFileFormat();
                    hideStartUI();
                    showControlsUI();
                    player.play();
                    if (fadeInAudio === true) {
                        volFade.start();
                    }
                    getFileArtWork();
                }
                else{
                    awaitingBT=true;
                    if(originalSource===""){invokedURL= audioSource;originalSource= invokedURL.replace("file://", "/");console.log("ORIGINAL SOURCE CHANGED : " + originalSource)}
                    
                    setFileFormat();
                    hideStartUI();
                    showControlsUI();
                    bluetoothIcon.flash();
                
                }
            } else {
                if(originalSource===""){invokedURL= audioSource;originalSource= invokedURL.replace("file://", "/");console.log("ORIGINAL SOURCE CHANGED : " + originalSource)}
                
                hideStartUI();
                showControlsUI();
                setFileFormat();
                player.play();
                if (fadeInAudio === true) {
                    volFade.start();
                }
                getFileArtWork();
            
            
            }
        
        } else {
            
            if (resumeCarModeLastPlayedTrack) {
                if (appsettings.getSystemSetting("fileDidNotCompleteURL", "") === "") {
                    console.log("Value empty")
                }
                else {
                    audioSource = appsettings.getSystemSetting("fileDidNotCompleteURL", "");
                    autoResuming = true;
                    if (autoPlayWhenBluetoothIsConnected == true) {
                        if (btDeviceConnected == true) {
                            if(originalSource===""){invokedURL= audioSource;originalSource= invokedURL.replace("file://", "");console.log("ORIGINAL SOURCE CHANGED : " + originalSource)}
                            
                            hideStartUI();
                            showControlsUI();
                            setFileFormat();
                            player.play();
                            if (fadeInAudio === true) {
                                volFade.start();
                            }
                            getFileArtWork();
                        }
                        else{
                            
                            awaitingBT=true;
                            if(originalSource===""){invokedURL= audioSource;originalSource= invokedURL.replace("file://", "");console.log("ORIGINAL SOURCE CHANGED : " + originalSource)}
                            
                            hideStartUI();
                            setFileFormat();
                            showControlsUI();
                            bluetoothIcon.flash();
                        }
                    
                    } 
                    
                    else {
                        if(originalSource===""){invokedURL= audioSource;originalSource= invokedURL.replace("file://", "");console.log("ORIGINAL SOURCE CHANGED : " + originalSource)}
                        player.prepare();
                        hideStartUI();
                        showControlsUI(); 
                        setFileFormat();
                        player.play();
                        if (fadeInAudio === true) {
                            volFade.start();
                        }
                        getFileArtWork();
                    }
                
                }
            
            }
        }
        safetyWarningTimer.start();

    
    }
    function openExtendedControlsPopup(){
        mainCont.add(extendedControls.createObject());
    }
    
    
    
    function getTimeFromMSec(msec) {
        if (msec <= 0 || msec == undefined) {
            return "0:00"
        
        } else {
            var sec = "" + Math.floor(msec / 1000) % 60
            if (sec.length == 1)
                sec = "0" + sec
            
            var hour = Math.floor(msec / 3600000)
            if (hour < 1) {
                return Math.floor(msec / 60000) + ":" + sec
            } else {
                var min = "" + Math.floor(msec / 60000) % 60
                if (min.length == 1)
                    min = "0" + min
                
                return hour + ":" + min + ":" + sec
            }
        }
    }
Page {
    actionBarVisibility: ChromeVisibility.Hidden

 
  
    
    shortcuts: [
        Shortcut {
            key: qsTr("i")
            onTriggered: { _app.increaseMediaVolume();}
        },
        Shortcut {
            key: qsTr("d")
            onTriggered: {_app.decreaseMediaVolume();}
        
        },
        
        Shortcut {
        key: qsTr("b")
        onTriggered: {
            previousTrack();
        }
        },
        Shortcut {
            id:playpause
            key: qsTr("p")
            onTriggered: {
                playPauseMedia();
            }
        },
        
        Shortcut {
            key: qsTr("n")
            onTriggered: {
                nextTrack();
            }
        },
        Shortcut {
            id: eqshort
            key: qsTr("e")
            onTriggered: {
                creator.createQMLObject("EqualiserPresetPage.qml");
            }
        }
        
    ]

   
    attachedObjects: [
        ListView {
            id: lister;
            visible: false
            dataModel: playQueue
            onTriggered: {
                globalIndexPath=indexPath;
                var dataa = playQueue.data(indexPath);
                console.log("Title: " + dataa.title);
                console.log("Source URL: " + dataa.sourceUrl);
                originalSource= dataa.sourceUrl;
                
                
                if( _app.checkIsHttp(dataa.sourceUrl)==true){ audioSource=  dataa.sourceUrl}
                else{
                    audioSource= "file://" + dataa.sourceUrl}
                setFileFormat();
                playlistViewerOpen=false;
                //playlistURL="";
                //playlistName="";
                playMedia();
                getFileArtWork();
            
            }  
        },
        ComponentDefinition {
            id: extendedControls
            content: 
                Container{
                    animations:[  TranslateTransition {
                        id: showAnim
                        toY:0
                        fromY: passport? -_app.screenHeight()/4:-_app.screenHeight()/4
                        duration: 500
                    },
                    TranslateTransition {
                        id: hideAnim
                        toY: passport? -_app.screenHeight()/4:-_app.screenHeight()/4
                      
                        duration: 600
                    }
                    ]
                    onCreationCompleted: {opacity=brightTheme? 0.95:0.9; showAnim.play()}
                    id: main
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    layout: DockLayout {}
                    Container{
                        
                        onCreationCompleted: {opacity=brightTheme? 0.95:0.9}
                        preferredHeight: passport?_app.screenHeight()/4:_app.screenHeight()/4
                        horizontalAlignment: HorizontalAlignment.Fill
                        verticalAlignment: VerticalAlignment.Top
                        background: brightTheme? Color.White: Color.Black

                        layout: StackLayout {   
                        }
                        Container {
                            horizontalAlignment: HorizontalAlignment.Center
                          //  verticalAlignment: VerticalAlignment.Top
                            topMargin: 10
                            opacity:1.0
                            
                            Label {
                                id:label
                                
                                textStyle{
                                    fontSize: FontSize.PointValue
                                    fontSizeValue: passport?13:11 
                                    color: brightTheme? Color.Black: Color.White
                                    fontWeight: FontWeight.Bold}
                                text: elapsedTime  + " / " + getTimeFromMSec(player.duration)
                            }
                        }
                        Container {
                            topMargin: passport?80:75
                        
                        Slider {
                            opacity: nightMode? 0.8:1
                            enabled: player.seekable
                            fromValue: 0
                            toValue: player.duration
                            value: player.position
                            property bool touchh
                            property bool sliderUpdatedByTouch
                            onImmediateValueChanged: {
                            newPosition= getTimeFromMSec(immediateValue)
                            label.text=  newPosition+ " / " + getTimeFromMSec(player.duration)
                            
                            }
                            onTouch: {
                                if (event.isUp()) {sliderUpdatedByTouch=true;main.opacity=0.9}
                                if(event.isMove()){ main.opacity=0.5 }
                                if(event.isCancel()){main.opacity=0.9}
                                if(OrientationSupport.orientation == UIOrientation.Portrait){player.pause();}
                               // console.log("UPDATED BY TOUCH")
                            
                            }
                            
                            onValueChanged: {
                                if (sliderUpdatedByTouch == true) {
                                    player.seekTime(value)
                                    sliderUpdatedByTouch = false;
                                    
                                    player.play();
                                }
                            }
                        }
                    }
                    Container {
                        topMargin:75
                        horizontalAlignment: HorizontalAlignment.Center
                        Button{
                            
                            color: Color.create(getAppColour())
                            minWidth:_app.screenWidth()-20; text: "File Properties"; onClicked:{main.opacity=0;hideAnim.play();main.destroy(900)
                        if(mediaPaused===true){creator.createQMLObject("FileDetails.qml")}
                        else if(videoDimensionsChanged){creator.createQMLObject("FileDetails.qml")}
                        else if(mainnav.playbackCompleted===true){player.pause();creator.createQMLObject("FileDetails.qml")
                        } 
                        else{ player.pause();player.play();creator.createQMLObject("FileDetails.qml")}}} 
                    
                    }
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center

                        topMargin:10
                        Button{minWidth:_app.screenWidth()-20;
                            color: Color.create(getAppColour())
                            text: "Open Normal Player"; onClicked:{appsettings.saveSystemSetting("carModeReverseURL", audioSource);exitCarMode();backFromCarMode=true;activity.running = true;
                                activity.visible = true;ti.start();}} 
                    
                    }
                    Container {
                        topMargin:10
                        bottomPadding: 10
                        horizontalAlignment: HorizontalAlignment.Center
                        Button{color: Color.create(getAppColour()); minWidth:_app.screenWidth()-20; text: "Hide"; onClicked:{main.opacity=0;hideAnim.play();main.destroy(900)}} 

                    }
                   

                    }
                
            } 
        },
        SystemTimer{
            id: launchTimer; interval: 750; onTimeout: {launchTimer.stop();runCarModeStart();

          } 
        },
        SystemTimer {
            id: autoHideTimer
            interval: videoControlsTimeout
            onTimeout: {
                showControls=false;
                autoHideTimer.stop();
            }  
        },
        SystemTimer {
          id: buttonsChange
          interval: 2000
          onTimeout: {
              buttonsChange.stop();
              buttonsRecentlyPressed=false;
          }  
        },
        LayoutUpdateHandler {
            id: layout  
        },
        SystemTimer {
            id:autoResizeDelay; interval:autoResuming? playlistMode?1200:900:  playlistMode?700:250
            onTimeout: {
                autoResizeDelay.stop();  autoVideoResize();
            }  
        },
        
        OrientationHandler {
            onOrientationChanged: {
                console.log(displayInfo.pixelSize.width)
                fwcVideoSurface.preferredHeight= player.videoDimensions.height
                fwcVideoSurface.preferredWidth= player.videoDimensions.width
                if (OrientationSupport.orientation == UIOrientation.Landscape) {
                   //(videoDimensionsChanged){resetTouchZoom();}
                }
                
                else if (OrientationSupport.orientation == UIOrientation.Portrait) {
                    
                    if(videoDimensionsChanged){console.log("Changed Scale " +changedVideoScale); fwcVideoSurface.scaleX=changedVideoScale; ;fwcVideoSurface.scaleY=changedVideoScale ;fwcVideoSurface.newScaleVal = changedVideoScale; fwcVideoSurface.initialScale=changedVideoScale }   
                    
                    else {autoVideoResize(); }
                }
            
            }
        },
        SystemTimer {
          id: safetyWarningTimer;interval: 200
          onTimeout: {
              safetyWarningTimer.stop();
              if(appsettings.getSystemSetting("carModeSafetywarning", "")===""){creator.createQMLObject("CarModeSafetyWarning.qml")}

          }
            
        },
        ComponentDefinition {
            id: picker
            signal bob
            content: FilePicker {
                id: filePicker
                onError: {
                    toast.showText(error)
                }
                Component.onCompleted: {open();  activity.running=true;activity.visible=true; }
                type: FileType.Video
                mode: FilePickerMode.Picker
                title:  qsTr("Select Video")
                property string bob
                property string path: appsettings.getSystemSetting("filepickerDefaultPath", "/accounts/");
                directories: [ path]
                filter: FileType.Video
                
                onFileSelected: {
                    console.log("FileSelected signal received : " + selectedFiles);
                    if(getFileType(selectedFiles[0].toString())==="m3u"){canceled();importSource=selectedFiles[0].toString(); creator.createQMLObject("ImportM3uPlaylistClear.qml")}
                    else{
                    audioSource = "file://" + selectedFiles[0].toString();
                    originalSource = selectedFiles[0].toString();
                   setFileFormat();
                    player.play();
                    if (fadeInAudio === true) {
                        volFade.start();
                    }
                    hideStartUI();
                    showControlsUI();
                    getFileArtWork();
                    var bob0= selectedFiles[0].toString()
                    var bob1= _app.getFileName(selectedFiles[0].toString());
                    var bob2= getFileType(bob0);
                    var bob3 = bob1 + "." +bob2
                    console.log("PLSSSSSSS WRRRK  " + bob3)
                    bob=bob0.replace(bob3, "")
                    if(appsettings.getSystemSetting("filepickerDefaultPathLast", "")==="true"){appsettings.saveSystemSetting("filepickerDefaultPath", bob)}
                    console.log("ggggggggg       "+ bob)
                }

                }
            }
        },
        ComponentDefinition {
            id: pickerAudio
            content: FilePicker {
                id: filePicker1
                Component.onCompleted: {open();  activity.running=true;activity.visible=true;}
                type: FileType.Music
                mode: FilePickerMode.Picker
                property string bob
                title:  qsTr("Select Audio")
                property string path: appsettings.getSystemSetting("filepickerDefaultPath", "/accounts/");
                directories: [ path]
                filter: FileType.Music
                
                onCanceled: {
                    
                }
                onFileSelected: {
                    console.log("FileSelected signal received : " + selectedFiles);
                    if(getFileType(selectedFiles[0].toString())==="m3u"){canceled();importSource=selectedFiles[0].toString(); creator.createQMLObject("ImportM3uPlaylistClear.qml")}
                    else{
                    audioSource = "file://" + selectedFiles[0].toString();
                    originalSource = selectedFiles[0].toString();
                    setFileFormat();
                   player.play();
                   if (fadeInAudio === true) {
                       volFade.start();
                   }
                   hideStartUI();
                   showControlsUI();
                   getFileArtWork();
                   var bob0= selectedFiles[0].toString()
                   var bob1= _app.getFileName(selectedFiles[0].toString());
                   var bob2= getFileType(bob0);
                   var bob3 = bob1 + "." +bob2
                   console.log("PLSSSSSSS WRRRK  " + bob3)
                   bob=bob0.replace(bob3, "")
                   if(appsettings.getSystemSetting("filepickerDefaultPathLast", "")==="true"){appsettings.saveSystemSetting("filepickerDefaultPath", bob)}
                   console.log("ggggggggg       "+ bob)
               }

                }
            }
        },
        SystemTimer {
          id: seekDelay;interval: 1000;  onTimeout: {
              seekDelay.stop(); console.log("New Seek Progress: " +newVideoProgress );player.seekTime(newVideoProgress)
          }
        },
        Connections {
            target: mainnav
            onResetCarModeUI:{hideControlsUI();hidePlaylistUI(); showStartUI();}
            onVideoSourceUpdated:{audioSource= newAudioSource; player.prepare(); player.play(); hideStartUI();showControlsUI();seekDelay.start();}
            onClosePlayer:{player.stop();hideControlsUI();showStartUI();}
            onPlayMedia:{player.prepare(); player.play(); hidePlaylistUI();hideStartUI(); showControlsUI();}
            onCarModeShuffle:{shufflePlayback();}
            onOpenCarModePlaylist:{hideStartUI();showPlaylistUI();}
            onBluetoothConnected: {

                if (autoPlayWhenBluetoothIsConnected) {
                    if (btDeviceConnected) {
                        awaitingBT=false;
                        player.play();
                        if (fadeInAudio === true) {
                            volFade.start();
                        }
                        getFileArtWork();
                        bluetoothIcon.stopFlash();
                        bluetoothIcon.opacity=1.0;
 
                    }
                }
            }
            onPlaybackCompletedSignal:{ 
                if(mainnav.playbackCompleted===true){
                    if(playlistMode){ 
                        if(shuffleMode){
                            if(playQueue.after(globalIndexPath)==""){
                                console.log("Should Be End of list" ); lister.triggered(playQueue.first());}
                                else{
                                
                                sheet.nextTrack();}}
                                else if(playlistMode){ 
                            if(playQueue.after(globalIndexPath)==""){
                                if(shuffleMode){sheet.nextTrack();}
                                else{
                                    
                                    console.log("End of list");}}
                                    else{
                                if(repeatModeEnabled===false){sheet.nextTrack();}}
                                }
                    }
                    else{showPlaylist=false; if(mediaFormat==="Video"){autoHideTimer.stop();}mediaPlaying=false;}
                    
                    
                    albumArtActiveFrame=false;
                }
            }
            onEQChanged:{
                eqValue = parseInt(appsettings.getSystemSetting("EQValue", ""));
                if(eqValue===0) {player.equalizerPreset= EqualizerPreset.Off}
                else if(eqValue===1) {player.equalizerPreset= EqualizerPreset.Airplane}
                else if(eqValue===2) {player.equalizerPreset= EqualizerPreset.BassBoost}
                else if(eqValue===3) {player.equalizerPreset= EqualizerPreset.TrebleBoost}
                else if(eqValue===4) {player.equalizerPreset= EqualizerPreset.VoiceBoost}
                else if(eqValue===5) {player.equalizerPreset= EqualizerPreset.BassLower}
                else if(eqValue===6) {player.equalizerPreset= EqualizerPreset.TrebleLower}
                else if(eqValue===7) {player.equalizerPreset= EqualizerPreset.VoiceLower}
                else if(eqValue===8) {player.equalizerPreset= EqualizerPreset.Acoustic}
                else if(eqValue===9) {player.equalizerPreset= EqualizerPreset.Dance}
                else if(eqValue===10) {player.equalizerPreset= EqualizerPreset.Electronic}
                else if(eqValue===11) {player.equalizerPreset= EqualizerPreset.HipHop}
                else if(eqValue===12) {player.equalizerPreset= EqualizerPreset.Jazz}
                else if(eqValue===13) {player.equalizerPreset= EqualizerPreset.Lounge}
                else if(eqValue===14) {player.equalizerPreset= EqualizerPreset.Piano}
                else if(eqValue===15) {player.equalizerPreset= EqualizerPreset.RhythmAndBlues}
                else if(eqValue===16) {player.equalizerPreset= EqualizerPreset.Rock}
                else if(eqValue===17) {player.equalizerPreset= EqualizerPreset.SpokenWord}
                eqName= appsettings.getSystemSetting("EQValueName", "Off");
            
            }
        },
        SystemTimer {
            id: volFade
            interval: parseInt(appsettings.getSystemSetting("audioFadeSpeed", ""))
            onTimeout: {
                if (playerVolume > 1.0) {
                    volFade.stop();
                } else {
                    playerVolume += 0.010
                }
            }
        },
        NowPlayingConnection {
            id: nowPlaying
            priorityLevel: PriorityLevel.Low

            function getIcon() {
                if (mediaFormat === "Audio") {

                    if (nightMode === true) {
                        return "../images/FancyControls/nightMode_music.png"
                    } else if (themeValue === "") {
                        return "../images/FancyControls/default_music.png"
                    } else if (themeValue === "#0092cc") {
                        return "../images/FancyControls/default_music.png"
                    } else if (themeValue === "#0000ff") {
                        return "../images/FancyControls/blue_music.png"
                    } else if (themeValue === "#F52887") {
                        return "../images/FancyControls/deeppink_music.png"
                    } else if (themeValue === "red") {
                        return "../images/FancyControls/red_music.png"
                    } else if (themeValue === "#ff00ff") {
                        return "../images/FancyControls/magenta_music.png"
                    } else if (themeValue === "#9900ff") {
                        return "../images/FancyControls/purple_music.png"
                    }

                } else if (mediaFormat === "Video") {
                    if (nightMode === true) {
                        return "../images/FancyControls/nightMode_video.png"
                    } else if (themeValue === "") {
                        return "../images/FancyControls/default_video.png"
                    } else if (themeValue === "#0092cc") {
                        return "../images/FancyControls/default_video.png"
                    } else if (themeValue === "#0000ff") {
                        return "../images/FancyControls/blue_video.png"
                    } else if (themeValue === "#F52887") {
                        return "../images/FancyControls/deeppink_video.png"
                    } else if (themeValue === "red") {
                        return "../images/FancyControls/red_video.png"
                    } else if (themeValue === "#ff00ff") {
                        return "../images/FancyControls/magenta_video.png"
                    } else if (themeValue === "#9900ff") {
                        return "../images/FancyControls/purple_video.png"
                    }
                }
            }
            overlayStyle: thumbnailed == true ? OverlayStyle.Fancy : OverlayStyle.Plain
            onOverlayStyleChanged: {
                var metaData = {
                    "track": player.addiInfo,
                    "artist": player.bob
                };
                nowPlaying.setMetaData(metaData)
            }
            duration: player.duration
            position: player.position
            iconUrl: artWorkURI === "" ? getIcon() : artWorkURI
            mediaState: player.mediaState
            connectionName: "StarPlayer"
            nextEnabled: playlistMode ? playlistMode ? propertyToSaveIndexPathAsNumber === _playlist.dataModell.size() - 1 ? false : true : false : false
            previousEnabled: playlistMode ? propertyToSaveIndexPathAsNumber === 0 ? false : true : false
            onNext: {
                externalButtonPressed=true;
                if(playlistMode){
                sheet.nextTrack();}
                else{forwardTrackShort();}
            }
            onPrevious: {
                externalButtonPressed=true;
                if(playlistMode){
                previousTrack()}
                else{rewindTrackShort();}
            
            }
            onAcquired: {
                var metadata = {
                    "track": player.addiInfo,
                    "artist": player.bob
                };
                playPauseMedia();
                nowPlaying.mediaState = MediaState.Started;
                nowPlaying.setMetaData(metadata);
              
            }
            onRewind: {
                externalButtonPressed=true;
                rewindTrackLong();
            }
            onForward: {
                externalButtonPressed=true;
               forwardTrackLong();
            }

            onPause: {
                playPauseMedia();
                nowPlaying.mediaState = player.mediaState;
            }

            onPlay: {
                if (phoneCallActive === false) {
                    playPauseMedia();
                    nowPlaying.mediaState = player.mediaState;
                }
            }
            onRevoked: {
                player.stop();
                nowPlaying.mediaState = player.mediaState;

            }
        },

        MediaPlayer {
            id: player
            volume: fadeInAudio ? playerVolume : 1.0
            autoPause: autoPausePlayer
            sourceUrl: audioSource
            property string addiInfo: metaDataArtist === "" ? getTimeFromMSec(player.position) : metaDataArtist
            property string bob: metaDataTitle === "" ? _app.withoutExtension(metaData.uri).toString() : metaDataTitle
            audioManagerHandle: AudioChannelConfiguration.Stereo
            //repeatMode: repeatModeEnabled? RepeatMode.Track: RepeatMode.None
            videoOutput: VideoOutput.PrimaryDisplay
            windowId: fwcVideoSurface.windowId
            
            onVideoDimensionsChanged: {console.log("DIMENSIONS UPDATED:" + "Width: "+ videoDimensions.width);fwcVideoSurface.preferredWidth= videoDimensions.width;fwcVideoSurface.maxWidth=  layout.layoutFrame.width; autoResizeAttempted=false;autoVideoResize(); }

            function bytesTosize(bytes) {
                if (bytes == 0) return 'Undefined';
                var k = 1000;
                var sizes = [ 'Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB' ];
                var i = Math.floor(Math.log(bytes) / Math.log(k));
                return (bytes / Math.pow(k, i)).toPrecision(3) + ' ' + sizes[i];
            }

            onMetaDataChanged: {
                if (artWorkURI === "") {} else {
                    if (appsettings.getSystemSetting("albumArtActiveFrame", "") === "true") {
                        albumArtActiveFrame = true;
                        updateCoverImage();
                    }
                }
                console.log("player onMetaDataChanged " + metaData);
                console.log("--------------------------------bit_rate=" + metaData.bit_rate);
                console.log("-----------------------------------genre=" + metaData.genre);
                console.log("-----------------------------------duration=" + metaData.duration);
                console.log("-----------------------------sample_rate=" + metaData.sample_rate);
                console.log("-----------------------------------title=" + metaData.title);
                console.log("-----------------------------------uri=" + metaData.uri);
                console.log("-----------------------------------art=" + metaData.artwork_uri);
                console.log("-----------------------------------album=" + metaData.album);

                metaDataFileName = _app.withoutExtension(metaData.uri);
                metaDataFileLocation = metaData.uri.toString();
                metaDataSampleRate = metaData.sample_rate.toString();
                metaDataArtist = metaData.artist.toString();
                metaDataFileSize = bytesTosize(_app.getFileSize(metaData.uri));
                console.log(metaDataFileSize);
                metaDataDuration = getTimeFromMSec(player.duration);
                if(player.metaData.title==undefined){metaDataTitle=metaDataFileName;}
                else{ metaDataTitle= player.metaData.title;}
                
                
                if(player.metaData.album==undefined){}
                else{ metaDataAlbum= player.metaData.album;}
                
                if(player.metaData.genre==undefined){}
                else{ metaDataGenre= player.metaData.genre;}
                metaDataBitRate = Math.round(metaData.bit_rate / 1000)
                var metaDataa = {
                    "track": addiInfo,
                    "artist": bob
                };
                nowPlaying.setMetaData(metaDataa);
            }

            onError: { console.log("Error: " + mediaError)}
            onBufferStatusChanged: { audioBufferProgress = bufferStatus}

            onPositionChanged: {
                videoProgress = position
                duratione = nowPlaying.duration
                positione = nowPlaying.position
                elapsedTime = getTimeFromMSec(position)
                playerDuration = duration
                playerProgress = position
                var metaData = {
                    "track": player.addiInfo,
                    "artist": player.bob
                };
                nowPlaying.setMetaData(metaData)
            }
            onPlaybackCompleted: {
                mainnav.playbackCompleted = true;
                if (playlistMode === false) { mediaPlaying = false;}
                mediaPaused = false;
                playerProgress = 0;
            }

            onMediaStateChanged: {
                console.log("Media State" + mediaState)
                nowPlaying.mediaState = player.mediaState

                if (mediaState == 0) {
                    console.log("UnPrepared")
                } else if (mediaState == 1) {
                    nowPlaying.acquire();
                    console.log("Prepared")
                } else if (mediaState == 2) {
                    console.log("Started")
                    nowPlaying.acquire();
                    mainnav.playbackCompleted = false;
                    mediaPlaying = true;
                    mediaPaused = false;
                    console.log("Video Height" + videoDimensions.height)
                    console.log("Video Width" + videoDimensions.width)
                    
                    
                 
                    if (autoResuming) {
                        if (aboutToLoadCarMode){
                            player.seekTime(videoProgress);autoResuming=false;aboutToLoadCarMode=false;
                            appsettings.saveSystemSetting("fileDidNotCompletePosition", "");
                            appsettings.saveSystemSetting("fileDidNotCompleteURL", "");
                            console.log("Video Height" + videoDimensions.height)
                            console.log("Video Width" + videoDimensions.width)
                           
                        }
                        else{
                            console.log(appsettings.getSystemSetting("fileDidNotCompletePosition", ""));
                        var bob = appsettings.getSystemSetting("fileDidNotCompletePosition", "");
                        player.seekTime(bob);
                        appsettings.saveSystemSetting("fileDidNotCompletePosition", "");
                        appsettings.saveSystemSetting("fileDidNotCompleteURL", "");
                        autoResuming = false;
                        console.log("Video Height" + videoDimensions.height)
                        console.log("Video Width" + videoDimensions.width)
                    }
                    }

                    metaDataDuration = getTimeFromMSec(player.duration);
                    if(player.metaData.title==undefined){metaDataTitle=metaDataFileName;}
                    else{ metaDataTitle= player.metaData.title;}
                    var metaData = {
                        "track": addiInfo,
                        "artist": bob
                    };
                    nowPlaying.setMetaData(metaData)
                    if(mediaFormat==="Video"){
                        if(showVideoUnderControls===true){ autoHideTimer.start();}
                       }
                    metaDataHeight= videoDimensions.height;
                    metaDataWidth= videoDimensions.width;
                    autoResizeDelay.start();
                

                } else if (mediaState == 3) {
                    console.log("Paused")
                    metaDataHeight= videoDimensions.height;
                    metaDataWidth= videoDimensions.width;
                    mediaPaused = true;

                } else if (mediaState == 4) {
                    mediaPlaying = false;
                }
            }
        }
    ]

    Container {
        property double minScreenScale: 0.2
        property double maxScreenScale: 3.0 
        property double initialScreenScale: 1.0
        property int xDown
        property int yDown
        property int startingX
        property int startingY
        overlapTouchPolicy: OverlapTouchPolicy.Allow
        id: mainCont

        layout: DockLayout {
        }
        Container {
            id: bufferCont
            layout: DockLayout {}
            horizontalAlignment:HorizontalAlignment.Fill
            background: Color.Black
            verticalAlignment: VerticalAlignment.Fill
            visible: true
            opacity: audioBufferProgress===1? 0.8:0
            Container {
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                
                ActivityIndicator {
                    id: bufferInd
                    preferredHeight: passport? 170:150
                    preferredWidth:  passport? 170:150
                    running: audioBufferProgress===1? true:false
                }
            }
        
        }
     
        onTouch: {
            console.log("Touched, Format:"+ mediaFormat)
            if(showPlaylist===false){
                if(buttonsRecentlyPressed===false){
                    if(event.isUp()) {
                        if(mediaFormat==="Video"){
                            if(showVideoUnderControls===true){
                            if(showControls==false){ autoHideTimer.start(); showControls=true;}
                            
                            else{ showControls=false}
}
                            }
                    }
                }
                
            }
        }
       
        ForeignWindowControl {
            id: fwcVideoSurface
            windowId: "myVideoSurface"
            visible:showPlaylist? false:true 
            property double initialScale: mainCont.initialScreenScale
            property double scaleFactor: 0.1
            property double newScaleVal  
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            preferredWidth:player.videoDimensions.width
            preferredHeight: player.videoDimensions.height
            maxHeight: showVideoUnderControls?undefined:0
            minWidth: player.videoDimensions.width
            updatedProperties: WindowProperty.Size |
            WindowProperty.Position |
            WindowProperty.Visible
        
        }
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: StackLayout {  }
          
        
    Container {
        horizontalAlignment: HorizontalAlignment.Center
        topPadding: 20
        id: homeIMG
        ImageView {
            opacity: nightMode?0.8:1.0
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            filterColor: brightTheme? Color.Black: undefined
            imageSource: passport?  "images/CarMode/CarMode_passport.png": "images/CarMode/CarMode_normal.png"
        }
    }
        Container {
           
            id: chooseVid
            topPadding: 20;leftPadding: 5
            horizontalAlignment: HorizontalAlignment.Fill
            
            PlaylistItemCarMode {
                centerText:true
                imageEnabled:false
                quickDeleteActive: false
                miniMode:true
                title: "Choose Video"
                opacity: nightMode?0.8:1.0
                property string pickerType:appsettings.getSystemSetting("homeSigActionPicker", "")
                onClicked: {
                    if(_app.checkSharedFiles()===true){
                        //if(pickerType==="clean"){  creator.createQMLObject("VideoPicker.qml")}
                        // else{
                        picker.createObject();
                        //}
                    }
                    else{toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")}
                }
            }
           
        }
        Container {
            topPadding:20;leftPadding: 5
            horizontalAlignment: HorizontalAlignment.Fill
            id: chooseAud
            
            PlaylistItemCarMode {
                imageEnabled:false
                quickDeleteActive: false
                miniMode:true
                opacity: nightMode?0.8:1.0
                centerText:true
                title: "Choose Audio"
                onClicked: {
                    
                    if(_app.checkSharedFiles()===true){
                        
                        pickerAudio.createObject();
                    }
                    else{toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")}
                
                }
            }
          
        }
        Container {
            id: choosePlaylist
            topPadding: 20;leftPadding: 5
            horizontalAlignment: HorizontalAlignment.Fill
            PlaylistItemCarMode {
                imageEnabled:false
                opacity: nightMode?0.8:1.0
                centerText:true
                quickDeleteActive: false
                miniMode:true
                title: "Playlist"
                onClicked: {
                    hideStartUI();showPlaylistUI();
                }
                }
          
        }
        Container {
            id: chooseInternetRadio
            topPadding: 20;leftPadding: 5
            horizontalAlignment: HorizontalAlignment.Fill
            PlaylistItemCarMode {
                imageEnabled:false
                opacity: nightMode?0.8:1.0
                centerText:true
                quickDeleteActive: false
                miniMode:true
                title: "Internet Radio"
                onClicked: {
                    hideStartUI();creator.createQMLObject("CarModeInternetRadioCountrySelector.qml");
                }
            }
        
        }
        
        Container {
            id: settings
            topPadding: 20;leftPadding: 5
            horizontalAlignment: HorizontalAlignment.Fill
            PlaylistItemCarMode {
                imageEnabled:false
                opacity: nightMode?0.8:1.0
                quickDeleteActive: false
                miniMode:true
                title: "Settings"
                centerText:true
                onClicked: {
                    creator.createQMLObject("CarModeSettings.qml")
                }
            }
          
        }
        Container {
            id: cf
            topPadding: 20;leftPadding: 5
            
            horizontalAlignment: HorizontalAlignment.Fill
            PlaylistItemCarMode {
                imageEnabled:false
                opacity: nightMode?0.8:1.0
                quickDeleteActive: false
                centerText:true
                miniMode:true
                title: "Exit Car Mode"
                onClicked: {
                   exitCarMode();
                }
            }
            
        }}
        CarModeButton {
            
            opacity: showPlaylist ? 1 : 0
            type: "Left"
            horizontalAlignment: HorizontalAlignment.Left
            verticalAlignment: VerticalAlignment.Top
            topPadding: 0
            defaultIMG:passport?brightTheme? "asset:///images/CarMode/Close_passport_dark.png": "asset:///images/CarMode/Close_passport.png": brightTheme? "asset:///images/CarMode/Close_normal_dark.png": "asset:///images/CarMode/Close_normal.png"
            onClicked: {
                if(audioSource===""){
                hidePlaylistUI();hideControlsUI(); showStartUI();}
                else{hidePlaylistUI();}
            }
        }
       
       
        Container {
            id: playerlist
            horizontalAlignment: HorizontalAlignment.Fill
            //topPadding: 120
            translationY: passport?150:120
            bottomPadding:passport? 70:40
            verticalAlignment: VerticalAlignment.Top
            opacity: showPlaylist ? 1 : 0
            layout: DockLayout {

            }
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                Label {
                    visible: _playlist.dataModell.size() === 0 ? true : false
                    text: qsTr("No Playlist Entries")
                    textStyle.color: Color.White
                    opacity: nightMode ? 0.8 : 1.0
                    textStyle {
                        fontSize: FontSize.PointValue
                        fontSizeValue: 16
                        base: SystemDefaults.TextStyles.BigText
                    }
                }
            }

            ListView {
                id: playListView
                opacity: nightMode?0.8:1
                 
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                bottomPadding: 50
                dataModel: _playlist.dataModell
              
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            visible: false
                        }
                    },
                    ListItemComponent {
                        type: "item"
                        CustomListItem {
                            id: customItem
                            dividerVisible: false
                            highlightAppearance: HighlightAppearance.Frame

                            Container {
                                id: itemContainer
                                function bob() {
                                    diodelete.show();
                                }

                                PlaylistItemCarMode {
                                    id: itemr

                                    onCreationCompleted: {
                                    }
                                    
                                    title: ListItemData.videoTitle
                                    imageEnabled: false
   
                                    }

                                }
                            }

                        }
                    

                ]
              
                    onTriggered: {
                      //  playQueue.clear();
                        var data = _playlist.dataModell.data(indexPath);
                        incomingNewPlaylistAddition=false;

                        playlistName= data.videoTitle;
                        playlistURL= data.videoURL;
                        openingPlaylist=true;
                        creator.createQMLObject("CarModePlaylistViewer.qml")
                    }
                
            }

        }
      
        Container {
            id: titleCont
            opacity: 0
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Top
            layout: DockLayout {
                
            }
            
            eventHandlers: [
                TouchKeyboardHandler {
                    property int downX: 0
                    property int downY: 0
                    onTouch: {
                        /*
                         0 = down
                         1= move
                         2= up
                         3= cancel
                         */ 
                        
                        //toast.showText("TouchKeyboard: " + event.touchType + "Y:" + event.screenY + " X: " +event.screenX)
                        console.log("TouchKeyboard: " + event.touchType + "Y:" + event.screenY + " X: " +event.screenX)
                        if(passportTrackKeyboard===true){
                            if (event.touchType===0) {
                                
                                
                                downX = event.screenX;
                                
                                downY = event.screenY;
                            
                            } else if (event.touchType===2) {
                                console.log(event.screenY)
                                var yDiff = downY - event.screenY;
                                
                                // take absolute value of yDiff
                                
                                if (yDiff < 0) yDiff = -1 * yDiff;
                                
                                // I check if the minimum y movement is less than 200.  Don't want to move left or right if 
                                
                                // the user is actually want to move up or down.
                                
                                if ((yDiff) < 200) {
                                    
                                    if ((downX - event.screenX) > 250) {
                                        
                                        console.log("RIGHT SWIPE")
                                        sheet.nextTrack();
                                    
                                    } else if ((event.screenX - downX) > 250) {
                                        
                                        console.log("LEFT SWIPE")
                                       sheet.previousTrack();
                                    
                                    
                                    }
                                
                                }
                            
                            }
                        }
                    }
                
                }
            
            ] 
            Container {
                opacity:mediaFormat==="Audio"?1:  nightMode? showControls?0.6:0:  showControls?0.8:0
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                layout: DockLayout {
                    
                }

                Label {
                    maxWidth:  autoPlayWhenBluetoothIsConnected==true?pixelWidth==""? originalPixelWidth-115: pixelWidth-115:  pixelWidth==""? originalPixelWidth-50: pixelWidth-50
                    horizontalAlignment: HorizontalAlignment.Left
                    verticalAlignment: VerticalAlignment.Top
                    textStyle {
                        color: brightTheme? Color.Black: Color.White
                        fontSize: FontSize.PointValue
                        fontSizeValue: 11
                    }
                    text:  awaitingBT? "Waiting For Bluetooth Connection": metaDataTitle === "" ? metaDataFileName : metaDataTitle
                }
                ImageFader{
                    visible: autoPlayWhenBluetoothIsConnected
                    id:bluetoothIcon
                    horizontalAlignment: HorizontalAlignment.Right
                    verticalAlignment: VerticalAlignment.Top
                    imageSource: "images/Bluetooth.png"
                }
            }
          
        }
        
        Container {
            verticalAlignment: VerticalAlignment.Top
            horizontalAlignment: HorizontalAlignment.Fill
            layout: DockLayout {
            }
            opacity: 0
            topPadding:passport? 85: 60
            id: topRow
            Divider {
                opacity:mediaFormat==="Audio"? nightMode?0.6:1: showControls?0.8: nightMode?0.6:0
            }
            CarModeButton {

                type: "Left"
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Center
                topPadding: 20
                defaultIMG: passport? brightTheme? "asset:///images/CarMode/Close_passport_dark.png": "asset:///images/CarMode/Close_passport.png": brightTheme? "asset:///images/CarMode/Close_normal_dark.png":"asset:///images/CarMode/Close_normal.png"
                onClicked: {
                  player.stop(); hideControlsUI(); showStartUI();}
            }

            CarModeTimeLabel {
                topPadding: 20
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                onClicked: {
                    if(carModeInternetRadio===false)openExtendedControlsPopup();
                }
            }
            

            CarModeButton {

                type: "Right"
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Center
                topPadding: 15
                defaultIMG:passport?brightTheme? "asset:///images/CarMode/Settings_passport_dark.png": "asset:///images/CarMode/Settings_passport.png":brightTheme? "asset:///images/CarMode/Settings_normal_dark.png":  "asset:///images/CarMode/Settings_normal.png"
                onClicked: {
                    creator.createQMLObject("CarModeSettings.qml")
                }
            }

        }
        
        Container {
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: passport? 580:500
            opacity: 1
            visible:carModeInternetRadio
            horizontalAlignment: HorizontalAlignment.Fill
            layout: DockLayout {
            }
            
            CarModeButton {
                type: "Center"
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 15
                defaultIMG: passport? brightTheme? "images/CarMode/Playlist_passport_dark.png":"images/CarMode/Playlist_passport.png": brightTheme? "images/CarMode/Playlist_normal_dark.png":"images/CarMode/Playlist_normal.png"
                onClicked: {
                    creator.createQMLObject("CarModeInternetRadioCountrySelector.qml");
                    buttonsRecentlyPressed=true; buttonsChange.start();
                
                }
            }
            
            
        }
      

        Container {
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: passport? 580:500
            opacity: 0
            horizontalAlignment: HorizontalAlignment.Fill
            layout: DockLayout {
            }
            id: middleRow2
            visible: playlistMode ? true : false
            
            CarModeButtonLongPress {
                //id: prevTrack
                type: "Left"
                
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 15
                defaultIMG:passport? brightTheme? "asset:///images/CarMode/Rewind_passport_dark.png":"asset:///images/CarMode/Rewind_passport.png" : brightTheme? "asset:///images/CarMode/Rewind_normal_dark.png":"asset:///images/CarMode/Rewind_normal.png"
                onClicked: {
                    console.log("clicked")
                    sheet.rewindTrackShort();autoHideTimer.restart();
                    buttonsRecentlyPressed=true; buttonsChange.start();
                }
                onHeld: {
                    console.log("held");
                    sheet.rewindTrackLong();autoHideTimer.restart();
                    buttonsRecentlyPressed=true; buttonsChange.start();

                }
            }
            CarModeButtonLongPress {
                //id: prevTrack
                type: "Left"
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 15
                defaultIMG: passport?  brightTheme?"asset:///images/CarMode/Forward_passport_dark.png":"asset:///images/CarMode/Forward_passport.png":brightTheme? "asset:///images/CarMode/Forward_normal_dark.png":"asset:///images/CarMode/Forward_normal.png"
                onClicked: {
                    console.log("clicked")
                    sheet.forwardTrackShort();autoHideTimer.restart();
                    buttonsRecentlyPressed=true; buttonsChange.start();

                }
                onHeld: {
                    console.log("held");
                    sheet.forwardTrackLong();autoHideTimer.restart();
                    buttonsRecentlyPressed=true; buttonsChange.start();

                }
            }
            CarModeButton {
                //   id: playPause
                type: "Center"
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 15
                defaultIMG: passport?darkTheme? "images/CarMode/Playlist_passport_dark.png": "images/CarMode/Playlist_passport.png":brightTheme? "images/CarMode/Playlist_normal_dark.png":"images/CarMode/Playlist_normal.png"
                onClicked: {
                   // sheet.showPlaylistUI();
                    creator.createQMLObject("CarModePlaylistViewer.qml");
                    buttonsRecentlyPressed=true; buttonsChange.start();

                }
            }
        }
        
        Container{
            id: internetRadioPlayControls
            visible: carModeInternetRadio
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Fill
            opacity: 1
            topPadding: passport?130:100
            layout: DockLayout {
            }
            CarModeButton {
                id: playPausinternet
                type: "Center"
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                //  bottomPadding: 15
                defaultIMG:passport? player.mediaState == 2 ? brightTheme? "asset:///images/CarMode/Pause_passport_dark.png": "asset:///images/CarMode/Pause_passport_dark.png" : "asset:///images/CarMode/Play_passport.png": player.mediaState == 2 ?brightTheme? "asset:///images/CarMode/Pause_normal_dark.png": "asset:///images/CarMode/Pause_normal.png" :brightTheme? "asset:///images/CarMode/Play_normal_dark.png": "asset:///images/CarMode/Play_normal.png"
                onClicked: {
                    if(aboutToLoadCarMode){player.play(); autoHideTimer.restart();if (fadeInAudio === true) {
                            volFade.start();
                        
                    }
                    }
                    else{
                        sheet.playPauseMedia();autoHideTimer.restart();
                    }
                    buttonsRecentlyPressed=true; buttonsChange.start();
                
                }
            }
            
            
        }

        Container {
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Fill
            opacity: 0
            visible:carModeInternetRadio?false:true
            topPadding: playlistMode? passport?130:100:0
            layout: DockLayout {
            }
            id: centerRow
            

            CarModeButtonLongPress {
                id: prevTrack
                type: "Left"
                enabled: playlistMode ?playQueue.before(globalIndexPath) == "" ? false : true : false
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Center
                //  bottomPadding: 15
                defaultIMG:passport? playlistMode ? brightTheme? "asset:///images/CarMode/Previous_passport_dark.png": "asset:///images/CarMode/Previous_passport.png" :brightTheme? "asset:///images/CarMode/Rewind_passport_dark.png": "asset:///images/CarMode/Rewind_passport.png":  playlistMode ?brightTheme? "asset:///images/CarMode/Previous_normal_dark.png":  "asset:///images/CarMode/Previous_normal.png" : brightTheme? "asset:///images/CarMode/Rewind_normal_dark.png": "asset:///images/CarMode/Rewind_normal.png"
                onClicked: {
                    if (playlistMode) {
                        sheet.previousTrack();showControls=true;
                        buttonsRecentlyPressed=true; buttonsChange.start();

                    } else {
                        autoHideTimer.stop();showControls=true;sheet.rewindTrackShort();
                        buttonsRecentlyPressed=true; buttonsChange.start();

                    }
                }
                onHeld: {
                    if (playlistMode==false) {
                        autoHideTimer.stop(); showControls=true;sheet.rewindTrackLong();
                        buttonsRecentlyPressed=true; buttonsChange.start();

                }
                }
            }
            CarModeButtonLongPress {
                id: nextTrack
                type: "Right"
                enabled: playlistMode ? playlistMode ?playQueue.after(globalIndexPath)==""?false:true: false : false
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Center
                // bottomPadding: 15
                defaultIMG:passport? playlistMode ?brightTheme? "asset:///images/CarMode/Next_passport_dark.png": "asset:///images/CarMode/Next_passport.png" :brightTheme? "asset:///images/CarMode/Forward_passport_dark.png": "asset:///images/CarMode/Forward_passport.png": playlistMode ?brightTheme? "asset:///images/CarMode/Next_normal_dark.png": "asset:///images/CarMode/Next_normal.png" : brightTheme? "asset:///images/CarMode/Forward_normal_dark.png":"asset:///images/CarMode/Forward_normal.png"
                onClicked: {
                    if (playlistMode) {
                        sheet.nextTrack();
                        autoHideTimer.restart();
                        buttonsRecentlyPressed=true; buttonsChange.start();

                    }
                    else {
                        sheet.forwardTrackShort();
                        autoHideTimer.restart();
                        buttonsRecentlyPressed=true; buttonsChange.start();


                    }
                }
                onHeld: {
                    if (playlistMode==false) {
                    sheet.forwardTrackLong();
                    autoHideTimer.restart();
                    buttonsRecentlyPressed=true; buttonsChange.start();


                    
                }
            }
            }
            CarModeButton {
                id: playPause
                type: "Center"
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                //  bottomPadding: 15
                defaultIMG:passport? player.mediaState == 2 ?brightTheme? "asset:///images/CarMode/Pause_passport_dark.png": "asset:///images/CarMode/Pause_passport.png" : brightTheme?"asset:///images/CarMode/Play_passport_dark.png": "asset:///images/CarMode/Play_passport.png": player.mediaState == 2 ? brightTheme? "asset:///images/CarMode/Pause_normal_dark.png":"asset:///images/CarMode/Pause_normal.png" : brightTheme? "asset:///images/CarMode/Play_normal_dark.png": "asset:///images/CarMode/Play_normal.png"
                onClicked: {
                    if(aboutToLoadCarMode){player.play(); autoHideTimer.restart();if (fadeInAudio === true) {
                            volFade.start();
                            
                    }
}
                    else{
                        sheet.playPauseMedia();autoHideTimer.restart();
}
buttonsRecentlyPressed=true; buttonsChange.start();

                }
            }
        }
    
        Container {
            verticalAlignment: VerticalAlignment.Bottom
            horizontalAlignment: HorizontalAlignment.Fill
            layout: DockLayout {
            }
            opacity: 0
            id: bottomRow1
            

            CarModeButton {
                id: volDown
                type: "Left"
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 15
                leftPadding: 6
                defaultIMG:passport? brightTheme? "images/CarMode/volumeDown_passport_dark.png":"images/CarMode/volumeDown_passport.png": brightTheme?"images/CarMode/volumeDown_normal_dark.png":"images/CarMode/volumeDown_normal.png"
                onClicked: {
                    _app.decreaseMediaVolume();
                    autoHideTimer.restart();
                }

            }
            CarModeButton {
                id: mute
                type: "Center"
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 15
                defaultIMG: passport?brightTheme?"images/CarMode/muted_passport_dark.png": "images/CarMode/muted_passport.png":brightTheme?"images/CarMode/muted_normal_dark.png":"images/CarMode/muted_normal.png"
                onClicked: {
                    _app.muteOutputVolume();
                    autoHideTimer.restart();
                }

            }
            CarModeButton {
                id: volUp
                type: "Right"
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 15
                rightPadding: 5
                defaultIMG: passport? brightTheme?"images/CarMode/volumeUp_passport_dark.png":"images/CarMode/volumeUp_passport.png":brightTheme?"images/CarMode/volumeUp_normal_dark.png":"images/CarMode/volumeUp_normal.png"
                onClicked: {
                    _app.increaseMediaVolume();
                    autoHideTimer.restart();
                }

            }

        }
    }
}
}
