import bb.cascades 1.4
import bb.cascades.pickers 1.0
import timer 1.0

Sheet{
    id: settingscm
    onCreationCompleted: { open(); toggler.start(); }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title: qsTr( "Car Mode Settings")
            
            dismissAction: ActionItem {
                title:  qsTr("Close") 
                onTriggered: {
                    close();settingscm.destroy();
                }
            }
            
            acceptAction: ActionItem {
                title: "Safety"
                onTriggered: {
                    creator.createQMLObject("CarModeSafetyWarningManual.qml")
                }
            }
        }
        attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true;togglebutton1.enabled=true;togglebutton2.enabled=true; togglebutton3.enabled=true;togglebutton4.enabled=true;toggler.destroy();}}
        ScrollView {
            id: scroller
            content: Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Center
                id: conter
                topPadding: 5
                bottomPadding: 5
                
                layout: StackLayout { }
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Launch Car Mode on Startup")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton3
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:launchCarModeonStartup
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("LaunchCarModeonStartup", "")===""){ appsettings.saveSystemSetting("LaunchCarModeonStartup", "true");launchCarModeonStartup=true;}
                                else{ appsettings.saveSystemSetting("LaunchCarModeonStartup", "");launchCarModeonStartup=false;}
                            
                            }
                        }
                    }
                } 
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Resume Last Played Track")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:resumeCarModeLastPlayedTrack
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("resumeCarModeLastPlayedTrack", "")===""){ appsettings.saveSystemSetting("resumeCarModeLastPlayedTrack", "true"); resumeCarModeLastPlayedTrack=true;}
                                else{ appsettings.saveSystemSetting("resumeCarModeLastPlayedTrack", "");resumeCarModeLastPlayedTrack=false;appsettings.saveSystemSetting("autoPlayWhenBluetoothIsConnected", "");autoPlayWhenBluetoothIsConnected=false}
                            
                            }
                        }
                    }
                } 
                Container {
                    opacity: resumeCarModeLastPlayedTrack?1:0
                    visible: resumeCarModeLastPlayedTrack?true:false
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Auto Play When Bluetooth Is Connected")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton1
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:autoPlayWhenBluetoothIsConnected
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("autoPlayWhenBluetoothIsConnected", "")===""){ appsettings.saveSystemSetting("autoPlayWhenBluetoothIsConnected", "true");autoPlayWhenBluetoothIsConnected=true;}
                                
                                else{ appsettings.saveSystemSetting("autoPlayWhenBluetoothIsConnected", "");autoPlayWhenBluetoothIsConnected=false}
                            
                            }
                        }
                    }
                } 
                
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Always Keep Screen On")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton2
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:carModeAlwaysKeepScreenOn
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("carModeAlwaysKeepScreenOn", "")==="false"){ appsettings.saveSystemSetting("carModeAlwaysKeepScreenOn", ""); carModeAlwaysKeepScreenOn=true;_app.setScreenIdle("KeepAwake")}
                                else{ appsettings.saveSystemSetting("carModeAlwaysKeepScreenOn", "false");carModeAlwaysKeepScreenOn=false; _app.setScreenIdle("Normal");}
                            
                            }
                        }
                    }
                }
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Show Video Under Controls")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton4
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:showVideoUnderControls
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                            if(showVideoUnderControls===true){ appsettings.saveSystemSetting("showVideoUnderControls", "false"); showVideoUnderControls=false;}
                                else{ appsettings.saveSystemSetting("showVideoUnderControls", "");showVideoUnderControls=true;}
                            
                            }
                        }
                    }
                }
                
                Container {
                    leftPadding: 20;rightPadding: 20; topPadding: 15
                    layout: DockLayout {}
                    minHeight:120
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Foward/Rewind Button Value:")
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7
                        }
                    }
                    Label {
                        opacity: nightMode?0.8:1
                        text: Math.floor((slider.immediateValue/1000) % 60) + " Seconds"
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Right
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 6
                        }
                    }
                    Slider {
                        opacity: nightMode?0.8:1
                        id:slider
                        verticalAlignment: VerticalAlignment.Bottom
                        horizontalAlignment: HorizontalAlignment.Fill
                        value: fowardRewindButtonValue
                        toValue:59000
                        fromValue: 1000
                        onValueChanged: {fowardRewindButtonValue=slider.immediateValue;appsettings.saveSystemSetting("fowardRewindButtonValue", immediateValue)}
                    }
                }
                Container {
                    leftPadding: 20;rightPadding: 20; topPadding: 15
                    layout: DockLayout {}
                    minHeight:120
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Long Press Foward/Rewind Button Value:")
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7
                        }
                    }
                    Label {
                        opacity: nightMode?0.8:1
                        text: Math.floor((slider1.immediateValue/1000) % 60) + " Seconds"
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Right
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 6
                        }
                    }
                   
                    Slider {
                        opacity: nightMode?0.8:1
                        id:slider1
                        verticalAlignment: VerticalAlignment.Bottom
                        horizontalAlignment: HorizontalAlignment.Fill
                        value: longPressfowardRewindButtonValue
                        toValue:59000
                        fromValue: 5000
                        onValueChanged: {longPressfowardRewindButtonValue=slider1.immediateValue;appsettings.saveSystemSetting("longPressfowardRewindButtonValue", immediateValue)}
                    }
                }
                Container {
                    
                leftPadding: 10; rightPadding: 10; topPadding: 10; horizontalAlignment: HorizontalAlignment.Fill
                Button {
                    color: Color.create(getAppColour())
                    opacity: nightMode?0.8:1
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    text: qsTr("Equaliser Present")
                    onClicked: {
                        creator.createQMLObject("EqualiserPresetPage.qml");
                    }
                }
            }

            }
        }
    }
}