import QtQuick 1.0
import bb.cascades 1.3
import "Custom"

MultiCover {
    id: multiCover
    onCreationCompleted: {
        console.log("Cover Created")
    }
    attachedObjects: Connections{target: mainnav; onFlashCoverRecordIcon:{ if(webRecordingActive) {imge.flash(); }else if(audioIsRecording)imge.flash(); else imge.stopFlash();}onUpdateCoverImage:{artViewer.imageSource=artWorkUriNonMod;} onThemeChanged:{largeIcon.imageSource= largeIcon.getIcon(); smallIcon.imageSource=smallIcon.getIcon();}}
    SceneCover {
        id: large
        MultiCover.level: CoverDetailLevel.High
        content:

Container {
    background:Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.White: Color.Black
            layout: DockLayout {}
            Container {
                
                topPadding: mediaFormat==="Audio"? passport?80: 66: 0
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment:mediaFormat==="Audio"? VerticalAlignment.Fill:VerticalAlignment.Center
            ImageView {

                id: artViewer
                scalingMethod: internetRadioActive?ScalingMethod.AspectFit:ScalingMethod.Fill
                imageSource: artWorkUriNonMod
                visible: albumArtActiveFrame
            }}
            Container {
                visible: liveActiveFrame? false:true
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                
              
               ImageView {
                    id: largeIcon
                    
                    function getIcon(){if (themeValue === "") {
                            return  "images/ActiveFrame/icon_activeframe_default.png"
                    } else if (themeValue === "#0092cc") {
                        return "images/ActiveFrame/icon_activeframe_default.png"
                    } else if (themeValue === "#0000ff") {
                        return "images/ActiveFrame/icon_activeframe_blue.png"
                    }
                    else if (themeValue === "#F52887") {
                        return "images/ActiveFrame/icon_activeframe_deep_pink.png"
                    }
                    else if (themeValue === "red") {
                        return "images/ActiveFrame/icon_activeframe_red.png"
                    } else if (themeValue === "#ff00ff") {
                        return "images/ActiveFrame/icon_activeframe_magenta.png"
                    } else if (themeValue === "#9900ff") {
                        return "images/ActiveFrame/icon_activeframe_purple.png"
                    }}
                imageSource: getIcon()
                }
            }
      Container {
          visible: liveActiveFrame
          horizontalAlignment: HorizontalAlignment.Fill
          verticalAlignment: VerticalAlignment.Fill
          layout: DockLayout {}
         // background: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.White: Color.Black

            Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Top
            
           Header {
                visible: mediaPlaying? false: true
                mode: HeaderMode.Interactive
                title: audioIsRecording? qsTr("Recording: ") + audioIsRecordingDuration:downloadActive?qsTr("Downloading.. ")+ downloadPercentage+"%":  mediaPlaying? mediaPaused? qsTr("Paused: ") + elapsedTime : qsTr("Playing: ") + elapsedTime : qsTr("No Media Playing")
            }
            Container{
                background:Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.White: Color.Black

                visible: mediaPlaying
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Top
                preferredHeight:passport?80: 66
                opacity:1
                layout: DockLayout {
                }
                
                Container {
                    id: titleCont
                    horizontalAlignment: HorizontalAlignment.Left
                    leftPadding: 5
                    verticalAlignment: VerticalAlignment.Top
                    topPadding: 3
                    Label {
                        textStyle{
                            color: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.Black: Color.White
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7 }
                        text:  metaDataTitle===""? metaDataFileName:  metaDataTitle
                    }
                }
                Container {
                    id:subTitleCont
                    leftPadding: 5
                    horizontalAlignment: HorizontalAlignment.Left
                    verticalAlignment: VerticalAlignment.Bottom
                    bottomPadding: 3
                    opacity: 0.8
                    Label {
                        textStyle{
                            color: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.Black: Color.White

                            fontSize: FontSize.PointValue
                            fontSizeValue: 5 }
                        text: downloadActive?qsTr("Downloading.. ")+ downloadPercentage+"%":  mediaPlaying? mediaPaused? qsTr("Paused: ") + elapsedTime : qsTr("Playing: ") + elapsedTime :qsTr( "No Media Playing")
                    }
                }
                Divider { }

            }
        }
            Container{
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Bottom
                bottomPadding: 20
                visible:mediaRepeat
                Label {

                    text:qsTr("Repeat Enabled")
                    textStyle.fontSize: FontSize.XSmall
                    opacity: 0.8
                    textStyle.color: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.Black: Color.White

                }
            }
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                
                visible:if(audioIsRecording){return true}
               else if(webRecordingActive){return true}
                else if (albumArtActiveFrame){
                    if(artWorkUriNonMod===""){return true}
                    else{return false }
                }
                    
            
            ImageFader {
                id: imge
                imageSource:  webRecordingActive?"images/record_radio.png":audioIsRecording? "images/record_radio.png":downloadActive? "images/ic_download.png":mediaPlaying? mediaPaused? "images/ic_pause.png" : "images/ic_play.png" : ""
            }
            
        }
            Container{
               bottomPadding: 5
               visible: internetRadioActive?false:true
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Bottom
                ProgressIndicator {
                    fromValue: 0
                    toValue: playerDuration
                    value: downloadActive? downloadProgress: playerProgress
                }
            }
        
        }
        }
    }
    
    SceneCover{
        id: small
        MultiCover.level: CoverDetailLevel.Medium
        content: Container {
            background: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.White: Color.Black

            layout: DockLayout {}
            ImageView {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                scalingMethod: ScalingMethod.Fill
                imageSource: artWorkUriNonMod
                visible:  albumArtActiveFrame
            }
            Container {
                visible: liveActiveFrame? false:true
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                
                ImageView {
                    id: smallIcon
                
                    function getIcon(){ if (themeValue === "") {
                            return  "images/ActiveFrame/icon_activeframe_default_small.png"
                    } else if (themeValue === "#0092cc") {
                        return "images/ActiveFrame/icon_activeframe_default_small.png"
                    } else if (themeValue === "#0000ff") {
                        return "images/ActiveFrame/icon_activeframe_blue_small.png"
                    }
                    else if (themeValue === "#F52887") {
                        return "images/ActiveFrame/icon_activeframe_deep_pink_small.png"
                    }
                    else if (themeValue === "red") {
                        return "images/ActiveFrame/icon_activeframe_red_small.png"
                    } else if (themeValue === "#ff00ff") {
                        return "images/ActiveFrame/icon_activeframe_magenta_small.png"
                    } else if (themeValue === "#9900ff") {
                        return "images/ActiveFrame/icon_activeframe_purple_small.png"
                    }
                
                    }
            
                    scalingMethod: ScalingMethod.None
                    imageSource:  getIcon();
                
            }
            }
            Container {
                visible: liveActiveFrame
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                layout: DockLayout {}
            Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Top
                
                Header {
                    visible: mediaPlaying? false: true
                    mode: HeaderMode.Interactive
                    title: audioIsRecording? qsTr("Recording: " )+ audioIsRecordingDuration:downloadActive?qsTr("Downloading.. ")+ downloadPercentage+"%":  mediaPlaying? mediaPaused? qsTr("Paused: " )+ elapsedTime :qsTr( "Playing: " )+ elapsedTime : qsTr("No Media Playing")
                }
                Container{
                    background: Color.Black
                    visible: mediaPlaying
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Top
                    preferredHeight: 65
                    opacity:albumArtActiveFrame? 0.8:1
                    layout: DockLayout {
                    }
                    
                    Container {
                        id: titleContsmall
                        horizontalAlignment: HorizontalAlignment.Left
                        leftPadding: 5
                        verticalAlignment: VerticalAlignment.Top
                        topPadding: 3
                        Label {
                            textStyle{
                                color: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.Black: Color.White

                                fontSize: FontSize.PointValue
                                fontSizeValue: 7 }
                            text:  metaDataTitle===""? metaDataFileName:  metaDataTitle
                        }
                    }
                    Container {
                        id:subTitleContsmall
                        leftPadding: 5
                        horizontalAlignment: HorizontalAlignment.Left
                        verticalAlignment: VerticalAlignment.Bottom
                        bottomPadding: 1
                        opacity: 0.8
                        Label {
                            textStyle{
                                color: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.Black: Color.White

                                fontSize: FontSize.PointValue
                                fontSizeValue: 5 }
                            text: downloadActive?qsTr("Downloading.. ")+ downloadPercentage+"%":  mediaPlaying? mediaPaused? qsTr("Paused: ") + elapsedTime : qsTr("Playing: ") + elapsedTime : qsTr("No Media Playing")
                        }
                    }
                    Divider { }
                
                }
            }
            Container{
                bottomPadding: 5
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Bottom
                ProgressIndicator {
                    fromValue: 0
                    toValue: playerDuration
                    value: downloadActive? downloadProgress: playerProgress
                }
            }
            
    }
        }
    }
}


