import QtQuick 1.0
import bb.cascades 1.4
import timer 1.0


Container {
property int dotCount
id: roote
signal killDots
property bool dotKillFired
property int visualisationNumber: 5
opacity: 0
function start(){opacity=1.0; currentVisualisation=visualisationNumber; jumpIn.start();}
background: brightTheme? Color.White: Color.Black
minHeight:_app.screenHeight();
minWidth: _app.screenWidth();
ImageView {
    id: img
    filterColor: artWorkURI===""? Color.create(getAppColour()): undefined
    imageSource: artWorkURI===""? "../images/music_vis.png": artWorkURI
    loadEffect: loadEffect.Subtle
    scalingMethod: artWorkURI===""? ScalingMethod.None :ScalingMethod.AspectFill
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
  
}
gestureHandlers: TapHandler {
onTapped: {
engine.toggleMenu();
}
}
layout: DockLayout {  
}
attachedObjects:[
    SystemTimer {
        id: jumpIn; interval: 450; onTimeout: {img.scaleY=0.96; img.scaleX=0.96;jumpIn.stop(); jumpOut.start(); }
    },
    SystemTimer {
        id: jumpOut; interval: 150; onTimeout: {img.scaleY=1; img.scaleX=1;jumpOut.stop(); jumpIn.start(); }
    },
Connections {
target: engine
onForceStop:{visible=false;} //obviously program these as we go along
onStop:{ opacity=0;jumpIn.stop(); jumpOut.stop(); img.scaleX=1; img.scaleY=1;}//obviously program these as we go along
}
]
}
