import QtQuick 1.0
import bb.cascades 1.4

import timer 1.0


Container {
    id: root
    property int visualisationNumber: 1
    property int moveCount
    property bool moveUp
    property bool moveDown:true
    gestureHandlers: TapHandler {
        onTapped: {
            engine.toggleMenu();
        }
    }
    attachedObjects:[
        Connections {
            target: engine
            onForceStop:{thinkingAnimation.stop(); visible=false;} //obviously program these as we go along
            onStop:{thinkingAnimation.stop(); opacity=0;moverMinus.stop(); moverPlus.stop(); moveTimerMinus.stop(); moveTimerPlus.stop(); }//obviously program these as we go along
        },
        SystemTimer {
            id: starterTimer; interval: 100; onTimeout: {
                root.opacity=1; stop();
            }},
        SystemTimer{id: moverPlus; interval: 1000; onTimeout: {
            thinkingDomainIcon.translationY+=2; thinkingCircle1.translationY+=2; thinkingCircle2.translationY+=2;}
        },
        SystemTimer{id: moverMinus; interval: 1000; onTimeout: {
                thinkingDomainIcon.translationY-=2; thinkingCircle1.translationY-=2; thinkingCircle2.translationY-=2;}
        },
        SystemTimer{
            id: moveTimerPlus; interval: 60000;onTimeout: {
                moverPlus.stop();moveTimerPlus.stop();moveTimerMinus.start(); moverMinus.start();
            }
            
        },
        SystemTimer{
            id: moveTimerMinus; interval: 60000;onTimeout: {
                moveTimerMinus.stop(); moverMinus.stop(); moveTimerPlus.start(); moverPlus.start();
            }
        
        }
    
    ]
    opacity: 0
    background: brightTheme? Color.White: Color.Black
    minHeight:_app.screenHeight();
    minWidth: _app.screenWidth();
   // horizontalAlignment: HorizontalAlignment.Fill
   // verticalAlignment: VerticalAlignment.Fill
    layout: DockLayout {}
    visible: true
    
    
    property string imageSourcee: decideSplashIMG();
    function start() {
        opacity=1; thinkingAnimation.play();currentVisualisation=visualisationNumber;moveTimerPlus.start(); moverPlus.start()
    }
    function decideSplashIMG(){
        if(passport===true){
            
            if (themeValue === "") {
                return "../images/icon_splash_passport.png"
            } else if (themeValue === "#0092cc") {
                return "../images/icon_splash_passport.png"
            } else if (themeValue === "#0000ff") {
                return "../images/icon_splash_blue_passport.png"
            }
            else if (themeValue === "#F52887") {
                return "../images/icon_splash_deep_pink_passport.png"
            }
            
            else if (themeValue === "red") {
                return "../images/icon_splash_red_passport.png"
            } else if (themeValue === "#ff00ff") {
                return "../images/icon_splash_magenta_passport.png"
            } else if (themeValue === "#9900ff") {
                return "../images/icon_splash_purple_passport.png"
            }
        
        } 
        else{
            if (themeValue === "") {
                return "../images/icon_splash.png"
            } else if (themeValue === "#0092cc") {
                return "../images/icon_splash.png"
            } else if (themeValue === "#0000ff") {
                return "../images/icon_splash_blue.png"
            }
            else if (themeValue === "#F52887") {
                return "../images/icon_splash_deep_pink.png"
            }
            
            else if (themeValue === "red") {
                return "../images/icon_splash_red.png"
            } else if (themeValue === "#ff00ff") {
                return "../images/icon_splash_magenta.png"
            } else if (themeValue === "#9900ff") {
                return "../images/icon_splash_purple.png"
            }
        }
    }
    horizontalAlignment: HorizontalAlignment.Center
    verticalAlignment: VerticalAlignment.Center
       
    property bool thinkingPlaying: (
    thinkingAnimation.state == AnimationState.Playing || 
    thinkingEnding.state == AnimationState.Playing ||
    thinkingAnimation.state == AnimationState.Started || 
    thinkingEnding.state == AnimationState.Started
    )
        
        
       
        
        //Start the thinking animation
       
        function repeat(){
            thinkingAnimation.stop();
            thinkingCircle1.scaleX = 0;
            thinkingCircle1.scaleY = 0;
            thinkingCircle2.scaleX = 0;
            thinkingCircle2.scaleY = 0;
            thinkingDomainIcon.scaleX = 0;
            thinkingDomainIcon.scaleY = 0;
            thinkingDomainIcon.opacity = 0.0;
            thinkingCircle1.opacity=0.0;
            thinkingCircle2.opacity=0.0;
            thinkingAnimation.play();
            
        }
        
        //End the animation with an animation finale
        function stop() {
            
            thinkingAnimation.stop();
            thinkingCircle1.scaleX = 0;
            thinkingCircle1.scaleY = 0;
            thinkingCircle2.scaleX = 0;
            thinkingCircle2.scaleY = 0;
            thinkingDomainIcon.scaleX = 0;
            thinkingDomainIcon.scaleY = 0;
            thinkingDomainIcon.opacity = 0.0;
            thinkingCircle1.opacity=0.0;
            thinkingCircle2.opacity=0.0;
        }
        
        
        animations: [
            //Thinking/pulsing animation
            ParallelAnimation {
                id: thinkingAnimation
               repeatCount: AnimationRepeatCount.Forever
                property int transitionTime: 500
                
                onStarted: {
                    thinkingDomainIcon.scaleX = 0.65;
                    thinkingDomainIcon.scaleY = 0.65;
                    thinkingDomainIcon.opacity = 1.0;
                }
                
                onStateChanged: {
                    if (state == AnimationState.Stopping || state == AnimationState.Stopped) {
                        if (!thinkingEnding.isPlaying() && !thinkingEnding.isStarted()) {
                            thinkingEnding.play();
                        }
                    }
                }
                
                ScaleTransition {
                    target: thinkingCircle1
                    fromX: 0.0
                    fromY: 0.0
                    toX: 1.0
                    toY: 1.0
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                
                }
                FadeTransition {
                    target: thinkingCircle1
                    fromOpacity: 0.0
                    toOpacity: 1.0
                    duration: thinkingAnimation.transitionTime/2
                    easingCurve: StockCurve.Linear
                }
                ScaleTransition {
                    target: thinkingCircle1
                    fromX: 1.0
                    fromY: 1.0
                    toX: 0.6
                    toY: 0.6
                    delay: thinkingAnimation.transitionTime
                    duration: thinkingAnimation.transitionTime*2
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle1
                    fromOpacity: 1.0
                    toOpacity: 0.2
                    delay: thinkingAnimation.transitionTime
                    duration: thinkingAnimation.transitionTime*2
                    easingCurve: StockCurve.Linear
                }
                //Circle 2 fading out while circle 1 is fading in to make it more fluid
                ScaleTransition {
                    target: thinkingCircle2
                    fromX: 0.0
                    fromY: 0.0
                    toX: 0.5
                    toY: 0.5
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle2
                    fromOpacity: 0.8
                    toOpacity: 0.6
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }
                
                ScaleTransition {
                    target: thinkingCircle2
                    fromX: 0.0
                    fromY: 0.0
                    toX: 0.9
                    toY: 0.9
                    delay: thinkingAnimation.transitionTime*2
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle2
                    
                    fromOpacity: 0.0
                    toOpacity: 1.0
                    delay: thinkingAnimation.transitionTime*2
                    duration: thinkingAnimation.transitionTime/2
                    easingCurve: StockCurve.Linear
                }
                
                FadeTransition {
                    target: thinkingCircle2
                    
                    fromOpacity: 0.0
                    toOpacity: 0.95
                    delay: thinkingAnimation.transitionTime*2
                    duration: thinkingAnimation.transitionTime/2
                    easingCurve: StockCurve.Linear
                }
                
              
                
              
              /*  ScaleTransition {
                    target: thinkingCircle2
                    fromX: 1.0
                    fromY: 1.0
                    toX: 0.95
                    toY: 0.95
                    delay: thinkingAnimation.transitionTime*3
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }*/
             
                FadeTransition {
                    target: thinkingCircle2
                    fromOpacity: 1.0
                    toOpacity: 0.0 //hide in the way second img
                    delay: thinkingAnimation.transitionTime*3
                    duration: thinkingAnimation.transitionTime*2
                    easingCurve: StockCurve.Linear
                    onEnded: {
                    }
                
                }
            },
            
            //Ending expand and fade animation
            ParallelAnimation {
                id: thinkingEnding
                repeatCount: 0
                property int transitionTime: 400
                
                onEnded: {
                  thinkingAnimation.play();
                
                }
                ScaleTransition {
                    target: thinkingCircle1
                    fromX: 1.0
                    fromY: 1.0
                    toX: 1.5
                    toY: 1.5
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle1
                    fromOpacity: 1.0
                    toOpacity: 0.0
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                
                }
                ScaleTransition {
                    target: thinkingCircle2
                    fromX: 1.0
                    fromY: 1.0
                    toX: 1.5
                    toY:1.5
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle2
                    fromOpacity: 1.0
                    toOpacity: 0.0
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                ScaleTransition {
                    target: thinkingDomainIcon
                    fromX: 0.75
                    fromY: 0.75
                    toX: 1.5
                    toY: 1.5
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingDomainIcon
                    fromOpacity: 1.0
                    toOpacity: 0.0
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                    onEnded: {
                        root.repeat();
                        console.log("Ended")
                    
                    }
                }
            }
        ]
        
        ImageView {
            preferredHeight: passport? 500:350
            preferredWidth:  passport? 500:350
            id: thinkingCircle1
            touchPropagationMode: TouchPropagationMode.None
            overlapTouchPolicy: OverlapTouchPolicy.Allow
            imageSource: imageSourcee
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            scaleX: 0
            scaleY: 0
        }
        
        ImageView {
            preferredHeight: passport? 500:350
            preferredWidth:  passport? 500:350
            id: thinkingCircle2
            touchPropagationMode: TouchPropagationMode.None
            overlapTouchPolicy: OverlapTouchPolicy.Allow
            imageSource:  imageSourcee
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            scaleX: 0
            scaleY: 0
        }
        
        ImageView {
            preferredHeight: passport? 500:350
            preferredWidth:  passport? 500:350
            id: thinkingDomainIcon
            touchPropagationMode: TouchPropagationMode.None
            overlapTouchPolicy: OverlapTouchPolicy.Allow
            imageSource:  imageSourcee
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            scaleX: 0
            scaleY: 0
        }

}
