import bb.cascades 1.4
import QtQuick 1.0


ImageView{
    id: circle
    visible: true
    opacity: 0
    scaleX: 0.8;scaleY: 0.8
    imageSource: createCirlce()
    filterColor: Color.create(changeColour())
    onCreationCompleted: {
        circleCount++; opacity=0.8;scaleUp.play()
    }
    animations: [
        ScaleTransition {
            id: scaleUp
            target: circle
            fromX: 0.8
            fromY: 0.8
            toX: 1.3
            toY: 1.3
            delay: 50
            duration: 600
            easingCurve: StockCurve.Linear
            onEnded: {
                fadeOut.play();
            }
            
        
        },
        FadeTransition {
                    target: circle
                    id: fadeOut
                    fromOpacity: 0.8
                    toOpacity: 0
                    duration: 400
                    easingCurve: StockCurve.Linear
        }
        
    ]
    
   
    attachedObjects: Connections {
        target: roote
        onKillCircles:{roote.remove(circle) ;circle.destroy(); circleCount--}
    }
   
    function changeColour(){
        var letters = '0123456789ABCDEF'.split('');
        var color = '#';
        for (var i = 0; i < 6; i++ ) {
            color += letters[Math.round(Math.random() * 15)];
        }
        return color;
    
    }
    
    function createCirlce(){
        // stick circle size urls in Array then return filter Colour elswhere
        var arr = ["../images/VisualisationGraphics/base_circle_350.png","../images/VisualisationGraphics/base_circle_300.png","../images/VisualisationGraphics/base_circle_270.png","../images/VisualisationGraphics/base_circle_250.png", "../images/VisualisationGraphics/base_circle_200.png", "../images/VisualisationGraphics/base_circle_180.png","../images/VisualisationGraphics/base_circle_140.png", "../images/VisualisationGraphics/base_circle_100.png","../images/VisualisationGraphics/base_circle_80.png", "../images/VisualisationGraphics/base_circle_60.png", "../images/VisualisationGraphics/base_circle_40.png"];
        arr = shuffle(arr)
       // console.log("Random Array Value: "+ arr);

        return arr;
    }
    
    
    function shuffle(array) {
        var currentIndex = array.length, temporaryValue, randomIndex;
        
        // While there remain elements to shuffle...
        while (0 !== currentIndex) {
            
            // Pick a remaining element...
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex -= 1;
            
            // And swap it with the current element.
            temporaryValue = array[currentIndex];
            array[currentIndex] = array[randomIndex];
            array[randomIndex] = temporaryValue;
        }
        
        return array[currentIndex];
    }
    
    translationX: Math.floor(Math.random() * (_app.screenWidth() - 100 + 1)) + 1
    translationY: Math.floor(Math.random() * (_app.screenHeight() - 100 + 1)) + 1 
}
