import bb.cascades 1.4
import QtQuick 1.0
import timer 1.0


    Container {
       id: root
       layout: DockLayout {
           
       }
       onCreationCompleted: {
           show();
       }
       horizontalAlignment: HorizontalAlignment.Fill
       verticalAlignment: VerticalAlignment.Fill
       background:brightTheme? Color.White:  Color.Black
       opacity: 0
       function show(){opacity=nightMode? 0.8:1;fromRightSwipeIMG.doAnim()
}
function hide(){opacity=0;close(); artIMG.opacity=nightMode?0.8:1; appsettings.saveSystemSetting("FullTouchPlayerSwipeAnim", "true");touchAnimSwipeTut.hide();}
       function close(){root.destroy(1000);}
       attachedObjects: [SystemTimer {
           id: leftIn; interval: 300; onTimeout: {
               leftIn.stop();
               fromLeftSwipeIMG.doAnim();
           }
       },
       SystemTimer {
           id: lastStep; interval: 200; onTimeout: {lastStep.stop();swipeLabel.opacity=0; root.hide();               
           }
       }]
       Container {
           id: fromRightSwipeIMG
           horizontalAlignment: HorizontalAlignment.Right
           verticalAlignment: VerticalAlignment.Center
           function doAnim(){exitAnim.play();fadeOut.play();swipeLabel.text="Swipe From The Right For The Next Track";}
           animations: [
               TranslateTransition {
                   id: exitAnim
                   toX: -200
                   duration: 1100
               },
               FadeTransition {
                   id: fadeOut
                   fromOpacity: 1
                   toOpacity: 0.0
                   duration: 1300
                   onEnded: {leftIn.start();}
               }
               
           ]
           
           ImageView {
               filterColor: brightTheme? Color.Black: undefined
               imageSource: "../images/FingerSwipeFromRight.png"
               
           }
       }
       Container {
           id: fromLeftSwipeIMG
           horizontalAlignment: HorizontalAlignment.Left
           verticalAlignment: VerticalAlignment.Center
           function doAnim(){exitAnim1.play();fadeOut1.play();swipeLabel.text="Swipe From The Left For The Previous Track";}
           animations: [
               TranslateTransition {
                   id: exitAnim1
                   toX: 200
                   duration: 1100
               },
               FadeTransition {
                   id: fadeOut1
                   fromOpacity: 1
                   toOpacity: 0.0
                   duration: 1300
                   onEnded: {lastStep.start()}
               }
           
           ]
           ImageView {
               filterColor: brightTheme? Color.Black: undefined
               imageSource: "../images/FingerSwipeFromLeft.png"
               
           }
       }
       Container {
           horizontalAlignment: HorizontalAlignment.Center
           verticalAlignment: VerticalAlignment.Bottom
           bottomPadding: 10
           Label {
               id: swipeLabel
               textStyle{fontSize: FontSize.PointValue
                   fontSizeValue: 7.5
                   color: brightTheme? Color.Black: Color.White
                   base: SystemDefaults.TextStyles.BigText}
               text: "Swipe From The Edge Of The Screen To Change Track"
           }
       }
        
    }

