import bb.cascades 1.4
import QtQuick 1.0
import timer 1.0


Container {
    id: root
    layout: DockLayout {
    
    }
    onCreationCompleted: {
    }
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    background: brightTheme? Color.White: Color.Black
    opacity: 0
    function show(){opacity=nightMode? 0.8:1;fromRightSwipeIMG.doAnim()
    }
    function hide(){opacity=0;close(); listView.opacity=nightMode?0.8:1; appsettings.saveSystemSetting("HSPinnedSwipeAnim", "true");}
    function close(){root.destroy(1000);}
    attachedObjects: [
    SystemTimer {
        id: lastStep; interval: 200; onTimeout: {lastStep.stop();swipeLabel.opacity=0; root.hide();               
        }
    }]
Container {
    id: fromRightSwipeIMG
    horizontalAlignment: HorizontalAlignment.Right
    verticalAlignment: VerticalAlignment.Center
    function doAnim(){exitAnim.play();fadeOut.play();}
    animations: [
        TranslateTransition {
            id: exitAnim
            toX: -430              
            duration: 1800
        },
        FadeTransition {
            id: fadeOut
            fromOpacity: 1
            toOpacity: 0.0
            duration: 2000
            onEnded: {hide();}
        }
    
    ]
    
    ImageView {
        filterColor: brightTheme? Color.Black:undefined
        imageSource: "../images/FingerSwipeFromRight.png"
    
    }
}
Container {
    horizontalAlignment: HorizontalAlignment.Center
    verticalAlignment: VerticalAlignment.Bottom
    bottomPadding: 10
    Label {
        id: swipeLabel
        textStyle{fontSize: FontSize.PointValue
            fontSizeValue: 7.5
            color: brightTheme? Color.Black: Color.White
            base: SystemDefaults.TextStyles.BigText}
        text: "Slide From the Right Edge To Change Item"
    }
}

}

