import QtQuick 1.0

import bb.cascades 1.4
import timer 1.0
import bb.multimedia 1.4


Container{
    id: root
    layout: DockLayout {} 
    function hide(){}
    function show(){opacity=1.0}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Top
    maxHeight: passport? 400:380
    minHeight: passport? 400:380
    opacity:0
    onCreationCompleted: {}
    onMinWidthChanged: {
        //console.log("MIN LIST WIDTH " + minWidth)
        console.log("PINNED COUNT " + pinnedCount)
    }
    property int pageShown
    minWidth:_app.screenWidth()

   
Container {
    opacity: nightMode?0.8:1

    layout: DockLayout {} 
    horizontalAlignment: HorizontalAlignment.Center
    verticalAlignment: VerticalAlignment.Top
    maxHeight: root.maxHeight
    minWidth: root.minWidth
    HSPinnedSwipeAnim {
        onCreationCompleted: {
            if(pinnedCount>0)if(appsettings.getSystemSetting("HSPinnedSwipeAnim", "")===""){listView.opacity=0; show();}
            else{tutSwipe.destroy();}
        }
        id: tutSwipe
    }
    ListView {
        id: listView
        visible: true
        enabled: downloadActive? false: true
        function updatePageShown(page) {
            root.pageShown = page
        }
        property bool listScrolling:false
        minWidth: root.minWidth
        property double maximumImageWidth:720
        flickMode: FlickMode.SingleItem
        scrollRole: ScrollRole.Main
        snapMode: SnapMode.LeadingEdge
        dataModel: _pinnedVideos.dataModel
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        onCreationCompleted: {}
        layout: StackListLayout {  orientation: LayoutOrientation.LeftToRight }
     
        onTriggered: {
            var dat = _pinnedVideos.dataModel.data(indexPath);
            _app.stopVideoPreview();
            if(dat.itemType==="InternetRadioStation"){internetRadioSource=dat.videoURL;activity.running = true;activity.visible = true;artWorkURI=dat.artWork;internetRadioOpenDelay.start();}
            else if(dat.itemType==="WebStream"){audioSource=dat.videoURL; activity.running=true;activity.visible=true;sourceStreamed=true;streamTimer.start();}
           else if(dat.itemType==="Playlist"){
               playlistURL=dat.videoURL;
               playlistName=dat.videoTitle;
               creator.createQMLObject("PlaylistViewer.qml");
               
           }
                else{
                    audioSource = dat.videoURL;
                    artWorkURI=dat.artWork;
                    artWorkUriNonMod= dat.artWork;
                activity.running = true;
                activity.visible = true;
                pinnedVideoTimer.start(); 

           // _pinnedVideos.openPinnedVideo(dat.videoURL, dat.itemType, dat.artWork)
           console.log("URL " + dat.videoURL)
           console.log("Title " + dat.videoTitle)
           console.log("Page value " + dat.page)
           console.log("ArtWork " + dat.artWork)
           console.log("Type " + dat.itemType)

        }
           }
        attachedObjects: ListScrollStateHandler {
            id: scrollStateHandler
            onScrollingChanged: {
                if(scrolling)listView.listScrolling=true 
                else listView.listScrolling=false
            }
        }
        
        listItemComponents: [
            ListItemComponent {
                id: headerListItemComponent
                type: "header"
                Container {visible:true}
            },
            
            ListItemComponent {
                type: "item"
                CustomListItem {

                    id: customItem
                    dividerVisible: false
                    preferredWidth:_app.screenWidth()
                    preferredHeight: _app.screenWidth()===1440?400:380
                    highlightAppearance: HighlightAppearance.Frame
                Container {
                    id: itemContainer
                    layout: DockLayout {}
                    preferredWidth:_app.screenWidth()
                    preferredHeight:_app.screenWidth()===1440?400:380
                    attachedObjects: LayoutUpdateHandler {
                        id: luhPosition
                    
                        onLayoutFrameChanged: {
                            if (luhPosition.layoutFrame.x >= -customItem.preferredWidth / 2 && luhPosition.layoutFrame.x <= customItem.preferredWidth / 2) {
                                customItem.ListItem.view.updatePageShown(ListItemData.page)
                            } 
                        }
                    }
                Container {
                    gestureHandlers: LongPressHandler {
                        onLongPressed: {
                            if(ListItemData.itemType==="Video"){
                            imagee.opacity=0;
                            console.log("long pressed");
                            fwcVideoSurface.visible=true;
                            player.play();}
                        }
                    }
                    onTouch: {
                        if(TouchType.Up){
                            //       console.log("Touch up/release")
                        }
                    }
                    
                    onTouchExit: {
                        console.log("Touch exit")
                        player.stop();
                        fwcVideoSurface.visible=false; 
                        imagee.opacity=1.0
                        
                    }
                    visible:true
                    background: Color.Transparent
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    minWidth: _app.screenWidth()
                    ForeignWindowControl {
                        id: fwcVideoSurface
                        windowId: "myVideo" + Math.random()
                        onCreationCompleted: {
                            console.log("Window ID: " +windowId)
                        }
                      visible:false
                   //     property double initialScale: mainCont.initialScreenScale
                   //     property double scaleFactor: 0.1
                       // property double newScaleVal  
                       
                        horizontalAlignment: HorizontalAlignment.Fill
                        verticalAlignment: VerticalAlignment.Fill
                        preferredWidth:_app.screenWidth()===1440?345:335
                        preferredHeight: _app.screenWidth()===1440?345:335
                        
                        minWidth: _app.screenWidth()===1440?345:335
                        minHeight:  itemContainer.preferredHeight
                        updatedProperties: WindowProperty.Size |
                        WindowProperty.Position |
                        WindowProperty.Visible
                    
                    }
                   attachedObjects: [
                       Connections{
                           target: _app
                         onStopVideoTilePreview:{ player.stop();
                             fwcVideoSurface.visible=false; 
                             imagee.opacity=1.0}
                       },
                       
                       SystemTimer {
                         id: stopTimer; interval: 10000; onTimeout: {
                             stop(); player.stop();
                             fwcVideoSurface.visible=false; 
                             imagee.opacity=1.0
                         } 
                       },
                       MediaPlayer{
                       id:player
                       autoPause:true
                       videoOutput: VideoOutput.PrimaryDisplay
                       sourceUrl:ListItemData.videoURL
                       windowId: fwcVideoSurface.windowId
                       onVideoDimensionsChanged: {
                          // fwcVideoSurface.preferredWidth= player.videoDimensions.width
                         //  fwcVideoSurface.maxWidth=  layout.layoutFrame.width
                       }
                       
                       onMediaStateChanged: {
                           console.log(mediaState)
                           
                           if(mediaState==0){
                               console.log("UnPrepared")
                           }
                           else if(mediaState==1){
                               console.log("Prepared")
                              
                           }
                           else if(mediaState==2){
                               console.log("Started");
                               stopTimer.start();
                              
                           
                           
                           }
                           else if(mediaState==3){
                            
                               console.log("Paused")
                              
                           
                           }
                           else if(mediaState==4){
                               
                           }
                       }
                   }]
                    ImageView {
                        id: imagee
                        scalingMethod:ListItemData.artWork===""?ScalingMethod.None: ScalingMethod.Fill
                        filterColor: ListItemData.artWork===""? Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? Color.Black: undefined : undefined
                        imageSource:if(ListItemData.artWork===""){
                            if(ListItemData.itemType==="WebStream"){return  "../images/web_pinnedMediaLarge.png"}
                            else if(ListItemData.itemType==="InternetRadioStation"){return "../images/radio_pinnedMediaLarge.png"}
                            else if(ListItemData.itemType==="Playlist"){return "../images/playlist_largePinned.png"}

                            
                            else{return  "../images/pin_pinnedMediaLarge.png"}  
                        
                        }
                        else{return ListItemData.artWork}
                            
                           
                        loadEffect: ImageViewLoadEffect.Subtle
                        opacity: customItem.ListItem.view.listScrolling?0.8:1
                        onCreationCompleted: {
                            console.log(visible)
                            console.log(imageSource)
                            
                        }
                        minWidth: _app.screenWidth()
                        minHeight: _app.screenWidth()===1440?345:335
                        maxHeight: _app.screenWidth()===1440?345:335
                        maxWidth: _app.screenWidth()
                    }
                    
                    Container {
                        horizontalAlignment: HorizontalAlignment.Fill
                        verticalAlignment: VerticalAlignment.Bottom
                        background: Color.Transparent
                        opacity: customItem.ListItem.view.listScrolling?0: 0.8
                        minHeight: _app.screenWidth()===1440? 75:55
                        maxHeight: _app.screenWidth()===1440? 75:55
                        layout: DockLayout{}
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Top
                        Label {
                            text: ListItemData.videoTitle
                            textStyle {
                                fontSize: FontSize.PointValue
                                fontSizeValue: 6
                                base: SystemDefaults.TextStyles.BigText
                            }
                        }
                    }

                    }
                }
            }
                
            }
            }
        ]
    }

}
}