import bb.cascades 1.4
import timer 1.0
Container{
    id: root
    layout: DockLayout {} 
    function hide(){}
    function show(){opacity=nightMode? 0.7:1}
    property double maxiHeight: passport? 400:280
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Top
    maxHeight: maxiHeight
    minHeight:maxiHeight
    opacity:0
    property bool alternativeIcon:false
    onCreationCompleted: {iconSwitcher.start();
    }
    attachedObjects: SystemTimer {
        id: iconSwitcher; interval: 7000; onTimeout: {
            if(alternativeIcon===false){alternativeIcon=true;iconView.imageSource=passport?"../images/WelcomeSlate/people_normal_passport.png":"../images/WelcomeSlate/people_normal.png"}
            else {alternativeIcon=false;iconView.imageSource=passport?"../images/WelcomeSlate/music_normal_passport.png":"../images/WelcomeSlate/music_normal.png"}
        }
    }
    
    onMinWidthChanged: {
        console.log("PINNED COUNT " + pinnedCount)
    }
    minWidth:_app.screenWidth()

function getGreeting(){
    var myDate = new Date();
    var hrs = myDate.getHours();
    var greet;
    if (hrs < 12)
        greet = 'Good Morning';
    else if (hrs >= 12 && hrs <= 17)
        greet = 'Good Afternoon';
    else if (hrs >= 17 && hrs <= 20)
        greet = 'Good Evening';
    else if (hrs >= 20 && hrs <= 24)
        greet = 'Good Night';
   return greet ;
}

function getBackground(){
    if(nightMode){return "../images/WelcomeSlate/nightmode_background.png";}
    else{
    if(themeValue === ""){return "../images/WelcomeSlate/blue_background.png";}
    
    if (themeValue === "#0092cc") {return "../images/WelcomeSlate/blue_background.png"; } 
    else if (themeValue === "red") {return "../images/WelcomeSlate/red_background.png";} 
    else if (themeValue === "#0000ff") {return "../images/WelcomeSlate/darkblue_background.png"; }
    else if (themeValue === "#F52887") {return "../images/WelcomeSlate/deeppink_background.png";}
    else if (themeValue === "#ff00ff") { return "../images/WelcomeSlate/magenta_background.png"; }
    else if (themeValue === "#9900ff") {return "../images/WelcomeSlate/purple_background.png"; }
}
}


Container {
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    ImageView {
        opacity:nightMode? 0.7:1
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        imageSource: getBackground();
        preferredHeight: maxiHeight
        maxHeight: maxiHeight
    }
}

Container {
        opacity: nightMode?0.7:1
        
        layout: DockLayout {} 
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        maxHeight: root.maxHeight
        minWidth: root.minWidth
       
       Container{id: childLabelContainer 
       leftPadding: 20
       horizontalAlignment: HorizontalAlignment.Left
       verticalAlignment: VerticalAlignment.Center

       Label{
           id: childLabel
           opacity: 0.95
           horizontalAlignment: HorizontalAlignment.Fill
           verticalAlignment: VerticalAlignment.Fill
           text: getGreeting()
           textStyle{
               fontSize: FontSize.PointValue
               fontSizeValue:14
               color:  Color.White
               base: SystemDefaults.TextStyles.BodyText     
           } 
       }
       
       
   }
   Container{
       rightPadding: 20
       horizontalAlignment: HorizontalAlignment.Right
       verticalAlignment: VerticalAlignment.Center
       ImageView {
       opacity: nightMode? 0.7:1
           horizontalAlignment: HorizontalAlignment.Fill
           verticalAlignment: VerticalAlignment.Fill
           id: iconView
         filterColor: nightMode? Color.DarkGrey: Color.create(getAppColour())
           imageSource:
             if(passport){
             return "../images/WelcomeSlate/music_normal_passport.png"} else{return "../images/WelcomeSlate/people_normal.png"}
       }
   }
   
                                
              
          
      
    

}
}