import bb.cascades 1.4
import QtQuick 1.0

Container {
    id: mainItem
    background: Color.Transparent
    horizontalAlignment: HorizontalAlignment.Fill
    minHeight:  100
    maxHeight:  100
    attachedObjects: [Connections{target: mainItem.allowQuickDelete? _app: null; onPlayistItemQuickDeleteMode:{if(quickDeleteActive===false){quickDeleteActive=true; } else{quickDeleteActive=false}}},
        OrientationHandler {
            id: ori
            onOrientationChanged: {
                screenWidth=widther();
            }
        }
    ]
    property double screenWidth:widther()
    
    onScreenWidthChanged: {
        console.log(screenWidth)
    }
    property bool allowQuickDelete:true
    property bool selected:false
    property bool imageEnabled:true
    property alias img: artImage.imageSource
    property alias title: titleLabel.text
    property bool quickDeleteActive:false
    signal quickDeleteClicked
    layout:DockLayout{}
    function widther(){
        if (OrientationSupport.orientation == UIOrientation.Portrait) {return _app.screenWidth()
        } else if (OrientationSupport.orientation == UIOrientation.Landscape) { return _app.screenHeight();
        }
    
    
    }
    Container {
        horizontalAlignment: HorizontalAlignment.Left
        verticalAlignment: VerticalAlignment.Fill
        visible: imageEnabled
        ImageView {
            maxHeight:mainItem.minHeight-10
            maxWidth: mainItem.minHeight-10
            minHeight: mainItem.minHeight-10
            minWidth: mainItem.minHeight-10
            scalingMethod: ScalingMethod.AspectFit
            id: artImage
        
        }
    }
    Container {
        horizontalAlignment: HorizontalAlignment.Left
        verticalAlignment: VerticalAlignment.Top
        topPadding: 15
        leftPadding: mainItem.imageEnabled?mainItem.minHeight+ 20: 10 
        minWidth:  quickDeleteActive?screenWidth-130: screenWidth
        maxWidth: quickDeleteActive?screenWidth-130: screenWidth
        Label {
            id: titleLabel
            textStyle{
                fontSize: FontSize.Medium
                color:Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright? selected?Color.create("#3090C7"):Color.Black: selected?Color.create("#3090C7") :Color.White
            }
        }
    }
    Container {
        visible: quickDeleteActive
        horizontalAlignment: HorizontalAlignment.Right
        verticalAlignment: VerticalAlignment.Center
        rightPadding: 10
        
        ImageButton {
            maxHeight: mainItem.minHeight-40
            maxWidth: mainItem.minHeight-40
            minHeight: mainItem.minHeight-40
            minWidth: mainItem.minHeight-40
            defaultImageSource: "asset:///images/ic_delete.png"
            pressedImageSource: "asset:///images/ic_delete_blue.png"
            onClicked: {
                quickDeleteClicked();
            }
        }
    }
    Divider {
    
    }
}

