import QtQuick 1.0
import bb.cascades 1.4

import timer 1.0


Container {
    property int dotCount
    id: roote
    signal killDots
    property bool dotKillFired
    property int visualisationNumber: 3
    gestureHandlers: TapHandler {
        onTapped: {
            engine.toggleMenu();
        }
    }
    layout: DockLayout {  
    }
    attachedObjects:[
        Connections {
            target: engine
            onForceStop:{visible=false;dotCreatorTimer.stop();killDots();} //obviously program these as we go along
            onStop:{ opacity=0;dotCreatorTimer.stop();killDots();}//obviously program these as we go along
        },
        SystemTimer{id: dotCreatorTimer; interval: 300; onTimeout: {
            
            if(dotCount===400){killDots();}
            else{
            
                var createdControl =dotter.createQMLObject("Dot.qml")
                roote.add(createdControl);
               }
        }},
        ComponentDefinition {
            id: dotter
            onError: {
                toast.showTextWithButton(errorMessage, "OK", "")
            }
            
            function createQMLObject(sourceUrl) {
                source = sourceUrl;
                return dotter.createObject()
            
            }
        }
    
    ]

    opacity: 0
    function start(){opacity=1.0; console.log("Dotter loaded"); dotCreatorTimer.start();currentVisualisation=visualisationNumber}
    background: brightTheme? Color.White: Color.Black
    minHeight:_app.screenHeight();
    minWidth: _app.screenWidth();
    
    
}
