import bb.cascades 1.4
import timer 1.0


Container {
    id:  videohelp
    onTouch: {
        if(event.isUp()){fadeOut.play(); videohelp.destroy(600);}
    }
    onCreationCompleted: { fadeIn.play();}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Bottom
    bottomPadding: passport? 170:160
    background: Color.Black
    minHeight: passport?130: 120
    opacity: 0
    attachedObjects:[ SystemTimer {
            id: closeTimer; interval: 5000; onTimeout: {
                fadeOut.play(); videohelp.destroy(600);
            }
        
    }
]

animations:[ FadeTransition {
        id: fadeIn
        fromOpacity: 0
        toOpacity:0.8
        duration: 800
        onEnded: {closeTimer.start()}},
    FadeTransition {
        id: fadeOut
        fromOpacity: 0.8
        toOpacity: 0
        duration: 500
        onEnded: { 
        }
    }

]
layout: DockLayout {}

Container {
    horizontalAlignment: HorizontalAlignment.Left
    verticalAlignment: VerticalAlignment.Center
    leftPadding: 5
    maxWidth:pixelWidth==""? originalPixelWidth-150: pixelWidth-150
    Label {
        textStyle {
            fontSize: FontSize.PointValue
            fontSizeValue: passport?7:6
            base: SystemDefaults.TextStyles.SmallText
        }
        text: qsTr("Tap The Blue Circle to open the Video Picker (this can be changed via Home Signature Action in Settings)")
        multiline: true
    }
}
Container {
    horizontalAlignment: HorizontalAlignment.Right
    verticalAlignment: VerticalAlignment.Center
    rightPadding: 15
    ImageView {
        imageSource: "asset:///images/bluecircle.png"
    }
}
}

