import bb.cascades 1.4
import timer 1.0

Sheet {
    id: sheet
    peekEnabled: false
    property bool nextTrackEnabled: playQueue.after(globalIndexPath)==""?false:true
    property bool previousTrackEnabled: playQueue.before(globalIndexPath)==""?false:true
    property int downX: 0
    property bool closingVisuals
    property int numberOfVisualisations    //remember int starts at 0 and not 1

    property int currentVisualisation:1
    
    property int downY: 0
    property bool menuVisible
    onCreationCompleted: {sheet.open();_app.setScreenIdle("KeepAwake");
        OrientationSupport.supportedDisplayOrientation =SupportedDisplayOrientation.DisplayPortrait;

    startFirst();}
    function startFirst(){bbBouncingVis.start()}
    function closeSheet(){engine.stopVisualisation();sheet.close();   var oro = appsettings.getSystemSetting("orientation", "");
        if (oro === "Automatic") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
        } else if (oro === "Portrait") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
        } else if (oro === "Landscape") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayLandscape
        }
        if(mediaFormat==="Audio"){_app.setScreenIdle("Normal");}
        
        sheet.destroy(500)}
    content:Page {
        id: page
        
  
        
       attachedObjects: [VisualisationEngine { id: engine
       onToggleMenuVisibility: {           
           if(menuVisible)menuVisible=false
           else menuVisible=true; menuDelay.start()
       }
       onLoadNext: {
           if(currentVisualisation===1){
           engine.stopVisualisation();
           colourChangeVis.startVis();
           }
           else if(currentVisualisation===2){
               engine.stopVisualisation();randomDots.start();
           }
           else if(currentVisualisation===3){
               engine.stopVisualisation();upDownVis.start();
           }
           else if(currentVisualisation===4){
               engine.stopVisualisation();albumArtVis.start();
           }
           else if(currentVisualisation===5){
               engine.stopVisualisation();zoomingCirclesVis.start();
           }
           
          
           
       }
       onLoadPrevious: {
           if(currentVisualisation===1){
            //   engine.stopVisualisation();
             //  bbBouncingVis.start();
           }
           else if (currentVisualisation===2){
               engine.stopVisualisation();
               bbBouncingVis.start();
           }
           else if (currentVisualisation===3){
               engine.stopVisualisation();
               colourChangeVis.startVis()
           }
           else if (currentVisualisation===4){
               engine.stopVisualisation();
               randomDots.start();
           }
           else if (currentVisualisation===5){
               engine.stopVisualisation();
               upDownVis.start();
           }
           else if (currentVisualisation===6){
               engine.stopVisualisation();
               albumArtVis.start();
           }
           
       }
       }
      
       ]
        Container {
            layout: DockLayout {}
            background: brightTheme? Color.White: Color.Black
            id: visualisationContainer
            opacity: nightMode? 0.8: 1
            horizontalAlignment:HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            BBBouncingVisualisation {
                id: bbBouncingVis
            }
            ColourChangeVisualisation {
            id: colourChangeVis
            }
            RandomDotsVisualisation {
                id: randomDots
            }
            UpDownTransitionVisualisation{
               id: upDownVis 
            }
            AlbumArtVisualisation{
                id: albumArtVis
            }
            ZoomingCirclesVisualisation {
                id: zoomingCirclesVis
            }
            Container {
                overlapTouchPolicy: OverlapTouchPolicy.Allow
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Bottom
                minHeight: menuVisible?180:0
                opacity: menuVisible? 0.8:0
                background:brightTheme? Color.White: Color.Black
                layout: DockLayout {}
                id: menuu
                attachedObjects: [SystemTimer{id: menuDelay; interval: 5000; onTimeout:{menuVisible=false; menuDelay.stop();}},
                SystemTimer {id: closeDelay; interval: 3000; onTimeout: {
                    closeSheet();
                }
                }
                ]
                gestureHandlers: TapHandler {
                    onTapped: {
                        if(closingVisuals)closeDelay.stop(); closingVisuals=false; menuDelay.start(); menuu.background=brightTheme? Color.White: Color.Black
                    }
                }
                
                onTouch: {
                    if (event.isDown()) {
                        
                        downX = event.windowX;
                        
                        downY = event.windowY;
                    
                    } else if (event.isUp()) {
                        console.log(event.windowY)
                        var yDiff = downY - event.windowY;
                        
                        // take absolute value of yDiff
                        
                        if (yDiff < 0) yDiff = -1 * yDiff;
                        
                        // I check if the minimum y movement is less than 200.  Don't want to move left or right if 
                        // the user actually wants to move up or down.
                        
                        if ((yDiff) < 200) {
                            
                            if ((downX - event.windowX) > 320) {
                                console.log("RIGHT SWIPE")
                            
                            } else if ((event.windowX - downX) > 320) {
                                console.log("LEFT SWIPE Menu")
                                menuu.background= Color.Red;
                                menuDelay.stop(); closingVisuals=true;closeDelay.start();
                                
                            }
                        
                        }
                    
                    }
                
                }
                Container {
                    visible: closingVisuals?false:true

                    
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Top
                topPadding: 2;leftPadding: 2
               
                Label {
                    opacity: nightMode? 0.8:1
                    textStyle{
                        color: brightTheme?Color.Black: Color.White
                        fontSize: FontSize.PointValue
                        fontSizeValue:7}
                    text: metaDataTitle===""?metaDataFileName : metaDataTitle
                }
                
            }
            Container {
                visible: closingVisuals?true:false
                
                
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center                
                Label {
                    multiline: true
                    opacity: nightMode? 0.8:1
                    textStyle{
                        textAlign: TextAlign.Center
                        color: brightTheme?Color.Black: Color.White
                        fontSize: FontSize.PointValue
                        fontSizeValue:10}
                    text: "Closing Visualisations..\nTap here to cancel"
                }
            
            }
            Container {
                visible: closingVisuals?false:true

                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                
                ImageButton {
                    defaultImageSource:  mediaPlaying? mediaPaused? brightTheme? "../images/ic_play_dark.png":"../images/ic_play.png" : brightTheme?"../images/ic_pause_dark.png":"../images/ic_pause.png" : brightTheme?"../images/ic_play_dark.png":"../images/ic_play.png"
                    onClicked: {
                        engine.playPauseAudio();
                    }
                
                }
              
            }
            Container{
                visible: closingVisuals?false:true

                rightPadding:passport? 210: 100
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Center
                ImageButton {
                    visible: nextTrackEnabled
                    defaultImageSource: brightTheme? "../images/skip_dark.png": "../images/skip.png"
                    onClicked: {
                        nextMediaTrack();
                    }
                }}
            
            Container{
                visible: closingVisuals?false:true
                leftPadding:passport? 210: 100
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Center
                ImageButton {
                    visible: previousTrackEnabled
                    defaultImageSource: brightTheme? "../images/previous_dark.png": "../images/previous.png"
                    onClicked: {
                        previousMediaTrack();
                    }
                }}
            }
            
        
            eventHandlers: [
                TouchKeyboardHandler {
                    property int downX: 0
                    property int downY: 0
                    onTouch: {
                        /*
                         0 = down
                         1= move
                         2= up
                         3= cancel
                         */ 
                        
                        //toast.showText("TouchKeyboard: " + event.touchType + "Y:" + event.screenY + " X: " +event.screenX)
                        console.log("TouchKeyboard: " + event.touchType + "Y:" + event.screenY + " X: " +event.screenX)
                        if(passportTrackKeyboard===true){
                            if (event.touchType===0) {
                                
                                
                                downX = event.screenX;
                                
                                downY = event.screenY;
                            
                            } else if (event.touchType===2) {
                                console.log(event.screenY)
                                var yDiff = downY - event.screenY;
                                
                                // take absolute value of yDiff
                                
                                if (yDiff < 0) yDiff = -1 * yDiff;
                                
                                // I check if the minimum y movement is less than 200.  Don't want to move left or right if 
                                
                                // the user is actually want to move up or down.
                                
                                if ((yDiff) < 150) {
                                    
                                    if ((downX - event.screenX) > 150) {
                                        console.log("RIGHT SWIPE")
                                        engine.loadNextVisualisation();
                                    
                                    } else if ((event.screenX - downX) > 150) {
                                        
                                        console.log("LEFT SWIPE")
                                        engine.loadPreviousVisualisation();
                                    
                                    
                                    }
                                
                                }
                            
                            }
                        }
                    }
                
                }
            
            ]
   
            
        
        
        onTouch: {
            if(closingVisuals===false){
                
            if (event.isDown()) {
                
                downX = event.windowX;
                
                downY = event.windowY;
            
            } else if (event.isUp()) {
                console.log(event.windowY)
                var yDiff = downY - event.windowY;
                
                // take absolute value of yDiff
                
                if (yDiff < 0) yDiff = -1 * yDiff;
                
                // I check if the minimum y movement is less than 200.  Don't want to move left or right if 
                // the user actually wants to move up or down.
                
                if ((yDiff) < 200) {
                    
                    if ((downX - event.windowX) > 320) {
                        console.log("RIGHT SWIPE")
                        engine.loadNextVisualisation();
                        
                    } else if ((event.windowX - downX) > 320) {
                        console.log("LEFT SWIPE")
                        engine.loadPreviousVisualisation();
                    }
                
                }
            
            }
        
        }
            
     
        }
        }
    }
}