import QtQuick 1.0
import bb.cascades 1.4

import timer 1.0


Container {
    property int circleCount 
    id: roote
    signal killCircles
    property bool circleKillFired
    property int visualisationNumber: 6
    gestureHandlers: TapHandler {
        onTapped: {
            engine.toggleMenu();
        }
    }
    layout: DockLayout {  
    }
    attachedObjects:[
        Connections {
            target: engine
            onForceStop:{visible=false;circleCreatorTimer.stop();killCircles();} //obviously program these as we go along
            onStop:{ opacity=0;circleCreatorTimer.stop();killCircles();}//obviously program these as we go along
        },
        SystemTimer{id: circleCreatorTimer; interval: 450; onTimeout: {
                
                if(circleCount===15){killCircles();}
                else{
                    
                    var createdControl =circler.createQMLObject("Circle.qml")
                    roote.add(createdControl);
                }
        }},
    ComponentDefinition {
        id: circler
        onError: {
            toast.showTextWithButton(errorMessage, "OK", "")
        }
        
        function createQMLObject(sourceUrl) {
            source = sourceUrl;
            return circler.createObject()
        
        }
    }

]

opacity: 0
function start(){opacity=1.0; console.log("Circle Vis loaded"); circleCreatorTimer.start();currentVisualisation=visualisationNumber}
background: brightTheme? Color.White: Color.Black
minHeight:_app.screenHeight();
minWidth: _app.screenWidth();


}
