import bb.cascades 1.3

Sheet{
    onCreationCompleted: { open(); }
Page {
    titleBar: TitleBar {
        visibility: appUpdateInProgress? ChromeVisibility.Hidden:ChromeVisibility.Visible
        appearance: TitleBarAppearance.Branded
        title: qsTr("Downloads")
        
        dismissAction: ActionItem {
            title: qsTr("Close") 
            onTriggered: {
                close();
            }
        
            
        }
    }
    actions: [
        
        ActionItem {
            enabled: downloadActive? true:false
            title:downloadPaused?qsTr("Resume Download"): qsTr("Pause Download")
            imageSource: downloadPaused?"images/ic_download.png": "images/ic_pause.png"
            ActionBar.placement: ActionBarPlacement.Signature
            onTriggered: {
                if(downloadPaused) downloadManager.resume();
                else downloadManager.pause(); 
            }
        },
        ActionItem {
                        enabled: downloadActive? true:false
                        title:qsTr("Cancel Download")
                        imageSource: "images/ic_stop.png"
                        ActionBar.placement: ActionBarPlacement.OnBar
                        onTriggered: {creator.createQMLObject("DownloadCancelDialog.qml")        
}
        }
    ]
    Container {
    StandardListItem {
        visible: downloadActive? true:false
        title:qsTr( "Downloading.." )+ downloadPercentage+"%"
        function bytesToSize(downloadedbytes) {
            var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
            if (downloadedbytes == 0) return 'n/a';
            var i = parseInt(Math.floor(Math.log(downloadedbytes) / Math.log(1024)));
            if (i == 0) return downloadedbytes + ' ' + sizes[i];
            return (downloadedbytes / Math.pow(1024, i)).toFixed(1) + ' ' + sizes[i];
        }
        description:bytesToSize(downloadedbytes);

            
  
    }
    }
}
}
