import QtQuick 1.0
import bb.cascades 1.4
import bb.multimedia 1.4
import timer 1.0
import "Custom"
Sheet {
    
id:sheet
Page {
    onCreationCompleted: {
        sheet.open();
    }
    titleBar: TitleBar {
        title:  qsTr("Equaliser")
        dismissAction: ActionItem {
            title:  qsTr("Back")
            onTriggered: {
                eqtester.stop();
                sheet.close();
                
                appsettings.saveSystemSetting("EQValueIndex", radiogroup_qml.selectedIndex)
                appsettings.saveSystemSetting("EQValue", radiogroup_qml.selectedValue)
                appsettings.saveSystemSetting("EQValueName", radiogroup_qml.selectedOption.text)
                
                eQChanged();
            }
        }
    }
    attachedObjects:[ MediaPlayer {
        id: eqtester;
        sourceUrl: audioSource
        Component.onCompleted:{}
        onMediaStateChanged: {
            if(mediaState==2){
                console.log("should be playing?")
                seekTime(videoProgress);}
        }
    },
    SystemTimer{
        id: eqTesterTimer; interval:10000; onTimeout:{eqTesterTimer.stop();eqtester.stop();}
    }
    ]
    Container{
        UserInfoBanner{minHeight:65;visible: mediaPaused?true:false;text: "Tap each Preset for a short preview"}

        ScrollView {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
        
        RadioGroup {
            onCreationCompleted: {
                if(appsettings.getSystemSetting("EQValueIndex", "")==="")selectedIndex=0
                else{
                    selectedIndex= parseInt(appsettings.getSystemSetting("EQValueIndex", ""))
                }
            }
            onSelectedIndexChanged: {
                if(sheet.opened){
                    eqtester.stop();eqTesterTimer.stop();
                if(mediaPaused===false){ appsettings.saveSystemSetting("EQValueIndex", selectedIndex)
                    appsettings.saveSystemSetting("EQValue", selectedValue)
                    appsettings.saveSystemSetting("EQValueName", selectedOption.text)
                    console.log("Changing EQ")
                    eQChanged();}
                
                else{
                console.log("EQ Preview")
                console.log(selectedValue)
                if(selectedValue==0) {eqtester.equalizerPreset= EqualizerPreset.Off}
                else if(selectedValue==1) {eqtester.equalizerPreset= EqualizerPreset.Airplane}
                else if(selectedValue==2) {eqtester.equalizerPreset= EqualizerPreset.BassBoost}
                else if(selectedValue==3) {eqtester.equalizerPreset= EqualizerPreset.TrebleBoost}
                else if(selectedValue==4) {eqtester.equalizerPreset= EqualizerPreset.VoiceBoost}
                else if(selectedValue==5) {eqtester.equalizerPreset= EqualizerPreset.BassLower}
                else if(selectedValue==6) {eqtester.equalizerPreset= EqualizerPreset.TrebleLower}
                else if(selectedValue==7) {eqtester.equalizerPreset= EqualizerPreset.VoiceLower}
                else if(selectedValue==8) {eqtester.equalizerPreset= EqualizerPreset.Acoustic}
                else if(selectedValue==9) {eqtester.equalizerPreset= EqualizerPreset.Dance}
                else if(selectedValue==10) {eqtester.equalizerPreset= EqualizerPreset.Electronic}
                else if(selectedValue==11) {eqtester.equalizerPreset= EqualizerPreset.HipHop}
                else if(selectedValue==12) {eqtester.equalizerPreset= EqualizerPreset.Jazz}
                else if(selectedValue==13) {eqtester.equalizerPreset= EqualizerPreset.Lounge}
                else if(selectedValue==14) {eqtester.equalizerPreset= EqualizerPreset.Piano}
                else if(selectedValue==15) {eqtester.equalizerPreset= EqualizerPreset.RhythmAndBlues}
                else if(selectedValue==16) {eqtester.equalizerPreset= EqualizerPreset.Rock}
                else if(selectedValue==17) {eqtester.equalizerPreset= EqualizerPreset.SpokenWord}
                console.log(eqtester.equalizerPreset)
                if(eqtester.mediaState===2){eqtester.stop();eqTesterTimer.stop();}
                else {eqtester.play();eqTesterTimer.start();}}
                
           }
            }
            dividersVisible: true
            id: radiogroup_qml
            Option {
                text: qsTr("Off")
                value:"0"
            }
            Option {
                text: qsTr("Airplane")
                value:"1"
            }
            Option {
                text: qsTr("Bass Boost")
                value:"2"
            }
            Option {
                text: qsTr("Treble Boost")
                value:"3"
            }
            Option {
                text:qsTr( "Voice Boost")
                value:"4"
            }
            Option {
                text: qsTr("Bass Lower")
                value:"5"
            }
            Option {
                text: qsTr("Treble Lower")
                value:"6"
            }
            Option {
                text: qsTr("Voice Lower")
                value:"7"
            }
            Option {
                text:qsTr( "Acoustic")
                value:"8"
            }
            Option {
                text: qsTr("Dance")
                value:"9"
            }
            Option {
                text: qsTr("Electronic")
                value:"10"
            }
            Option {
                text: qsTr("HipHop")
                value:"11"
            }
            Option {
                text:qsTr( "Jazz")
                value:"12"
            }
            Option {
                text: qsTr("Lounge")
                value:"13"
            }
            Option {
                text: qsTr("Piano")
                value:"14"
            }
            Option {
                text: qsTr("Rhythm And Blues")
                value:"15"
            }
            Option {
                text:qsTr( "Rock")
                value:"16"
            }
            Option {
                text:qsTr( "Spoken Word")
                value:"17"
            }
        }
    }
}


    
}
}