import bb.cascades 1.4
import bb.platform 1.0
import bb.system 1.2
import bb.cascades.pickers 1.0
import QtQuick 1.0
import "Custom"

Sheet {
onCreationCompleted: open();    
id: details
Page {
    id: page
    property string oldName
    property string fileFormat
    property string bob
    property string bob2

    titleBar: TitleBar {
        appearance: TitleBarAppearance.Branded
        title:qsTr( "Details")
        dismissAction: ActionItem {
            title: qsTr("Close") 
            onTriggered: {
                close();details.destroy();
            }
        
        }

    }
    actions: [
        InvokeActionItem {
            id: shareItem
            onCreationCompleted: {
                if (mediaFormat==="Stream")page.removeAction(shareItem)
            }
            ActionBar.placement: ActionBarPlacement.OnBar
            title: qsTr("Share")
            query {
                mimeType: "text/plain"
                invokeActionId: "bb.action.SHARE"
            }
            onTriggered: {
                metaDataTitle===""? data = qsTr("Is listening to: ") +metaDataFileName+"\n\nVia Star Player for BlackBerry 10":  data =qsTr( "Is listening to: " )+metaDataTitle+ " by " + metaDataArtist +"\n\nVia Star Player for BlackBerry 10"
            }
        },
        ActionItem {
            id: searchBut
            onCreationCompleted: {
                if(mediaFormat==="Audio"===false){page.removeAction(searchBut)}
            }
            ActionBar.placement: ActionBarPlacement.Signature
            imageSource: "images/search.png"
            onTriggered: {
                _app.openWebBrowserLink("https://www.google.co.uk/search?q="+metaDataTitle + "+-+" + metaDataArtist)
            }
            
            
        },
        ActionItem{
            id: renamer
            onCreationCompleted: {
                if(sourceStreamed){page.removeAction(renamer)}
                else if(sourceInvoked){page.removeAction(renamer)}
                else if(playlistMode){page.removeAction(renamer)}
            }
            ActionBar.placement: ActionBarPlacement.OnBar
            attachedObjects: ComponentDefinition {
                id: promptt
                
                content: Container {
                    onCreationCompleted: { prompt.show();}
                    attachedObjects: SystemPrompt {
                        id: prompt
                        autoUpdateEnabled: true
                        dismissAutomatically: false
                        inputField.inputMode: SystemUiInputMode.Default
                        title:qsTr( "New File Name")
                        inputField.defaultText:page.oldName
                        inputField.emptyText: qsTr( "Enter New Name Here")
                        confirmButton.label:qsTr( "Save")
                        cancelButton.label:qsTr( "Cancel")
                        property string bob3
                        onFinished: {
                            if(result== SystemUiResult.ConfirmButtonSelection) {
                                newVideoProgress=videoProgress;
                                if(carMode){
                                closePlayer();}
                                console.log(originalSource)
                                var bob4=page.bob + inputFieldTextEntry() + "."+ page.fileFormat
                                bob3=bob4.replace("file://", "");
                                
                                console.log(bob3)
                                _app.moveFile(page.bob2, bob3);
                                details.close();
                                prompt.cancel();
                                toast.showText("File renamed, note that any shortcuts to this file will need to be created again");
                                renamingFile=false;
                                newAudioSource= "file://"+bob3;
                                console.log(newAudioSource+ "- " +newVideoProgress)
                                videoSourceUpdated();

                            }
                            else{prompt.cancel();}
                        }
                    }
                }
            }
            title: "Rename File"
            imageSource: "images/ic_rename.png"
            onTriggered: {
                renamingFile=true;
               page.oldName=metaDataFileName;
                page.fileFormat=getFileType(audioSource);
                console.log( page.oldName)
                console.log(page.fileFormat)
                var bob0= audioSource
                var bob1= metaDataFileName
                var bob2= getFileType(bob0);
                var bob3 = bob1 + "." +bob2
                page.bob=bob0.replace(bob3, "")
                console.log(page.bob)
                page.bob2= audioSource.replace("file://", "");
                promptt.createObject();;
                
            }
        }
        /*
       
        ActionItem {
          
            imageSource: ""
            title: "Share To Face10"
            onTriggered: {
                _app.shareToFace10("face10://test")
            }
            
            
        }*/
    ]

    Container{
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        UserInfoBanner{minHeight:65;visible: artWorkURI===""? false:true;text: "Tap the Art Work to save to your device"}
        Container{
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Top
            topPadding: artWorkURI===""?5:10
            opacity: nightMode?0.8:1
            attachedObjects: [
                ComponentDefinition {
                    id: saver
                    content: FilePicker{
                        Component.onCompleted:{open();}
                        title: "Save Album Art"
                        defaultSaveFileNames: metaDataFileName+ ".png"
                        mode: FilePickerMode.Saver
                        onFileSelected: {
                            var bob = artWorkURI.replace("file://", "");
                            console.log(bob);
                            _app.copyFile(bob, selectedFiles[0].toString());
                            toast.showText("Art Work Saved")
                        }
                        
                    }
                }
            ]
            
            
            gestureHandlers: TapHandler {
                onTapped: {
                    if(artWorkURI===""){}
                    else {saver.createObject();}
                }
            }
            ImageView {
                maxHeight:passport?400: 300
                maxWidth: passport?400: 300
                imageSource: artWorkURI===""?  mediaFormat==="Video"? "images/filmstrip_filedetails.png": "images/audio_filedetails.png": artWorkURI
            
            }
        }
   ScrollView {
       scrollRole: ScrollRole.Main

       Container {
           topPadding: 2
           horizontalAlignment: HorizontalAlignment.Fill
           verticalAlignment: VerticalAlignment.Fill
           layout: StackLayout {}
         StandardListItem {
             title: qsTr("Title")
             opacity: nightMode?0.8:1
             id: title
             contextActions:   ActionSet {
                 title:   title.description
                 actions:[
                     ActionItem {
                         enabled:  metaDataTitle===""? false: true
                         imageSource: "images/ic_copy.png"
                         title:qsTr("Copy to clipboard")
                         onTriggered: {_app.copyToClipboard(title.description)}
                     }
                 ]
             }
             description: metaDataTitle===""? qsTr("File has no Title MetaData"): metaDataTitle
         }
         StandardListItem {
             title: qsTr("Artist")
             opacity: nightMode?0.8:1
             id: artist
             visible: mediaFormat==="Video"? false:true

             contextActions:   ActionSet {
                 title:   artist.description
                 actions:[
                     ActionItem {
                         enabled:  metaDataArtist===""? false: true
                         imageSource: "images/ic_copy.png"
                         title:qsTr("Copy to clipboard")
                         onTriggered: {_app.copyToClipboard(artist.description)}
                     }
                 ]
             }
             description: metaDataTitle===""? qsTr("File has no Artist MetaData"): metaDataArtist
         }
		 
		 StandardListItem {
             title:qsTr( "Album")
             opacity: nightMode?0.8:1
             id: album
             visible: mediaFormat==="Video"? false:true
             
             contextActions:   ActionSet {
                 title:   album.description
                 actions:[
                     ActionItem {
                         enabled:  metaDataAlbum===""? false: true
                         imageSource: "images/ic_copy.png"
                         title:qsTr("Copy to clipboard")
                         onTriggered: {_app.copyToClipboard(album.description)}
                     }
                 ]
             }
             description: metaDataAlbum===""? qsTr("File has no Album MetaData"): metaDataAlbum
         }
         StandardListItem {
             title: qsTr("Genre")
             opacity: nightMode?0.8:1
             id: genre
             visible: mediaFormat==="Video"? false:true
             
             contextActions:   ActionSet {
                 title:   genre.description
                 actions:[
                     ActionItem {
                         enabled:  metaDataGenre===""? false: true
                         imageSource: "images/ic_copy.png"
                         title:qsTr("Copy to clipboard")
                         onTriggered: {_app.copyToClipboard(genre.description)}
                     }
                 ]
             }
             description: metaDataGenre===""?qsTr( "File has no Genre MetaData"): metaDataGenre
         }
         StandardListItem {
             id: filename
             opacity: nightMode?0.8:1
             title: qsTr("File Name")
             description: metaDataFileName
             contextActions:   ActionSet {
                 title:   filename.description
                 actions:[
                     ActionItem {
                         imageSource: "images/ic_copy.png"
                         title:qsTr("Copy to clipboard")
                         onTriggered: {_app.copyToClipboard( filename.description)}
                     }
                 ]
             }
         }
         StandardListItem {
             id: fileloc
             opacity: nightMode?0.8:1
             title: qsTr("File Location")
             description: metaDataFileLocation
             contextActions:   ActionSet {
                 title:  fileloc.description
                 actions:[
                     ActionItem {
                         imageSource: "images/ic_copy.png"
                         title:qsTr("Copy to clipboard")
                         onTriggered: {_app.copyToClipboard( fileloc.description)}
                     }
                 ]
             }
         }

         StandardListItem {
             visible: sourceStreamed?false:true
             opacity: nightMode?0.8:1
             title: qsTr("Creation Date")
             id: crtd
             description: _app.getFileModifiedDate(metaDataFileLocation)
         }

         StandardListItem {
             opacity: nightMode?0.8:1
             title: qsTr("Sample Rate")
             id: sr
             description: metaDataSampleRate + "Hz"
         }
         StandardListItem {
             opacity: nightMode?0.8:1
             visible: sourceStreamed?false:true
             title: qsTr("File Format")
             id: formatt
             description: getFileType(audioSource)
         }
         StandardListItem {
            visible: mediaFormat==="Video"? false:true
             opacity: nightMode?0.8:1
             title: qsTr("Bitrate")
             id: btr
             description: metaDataBitRate===""? qsTr("File has no Bitrate MetaData"): metaDataBitRate + "Kbps"
                 
         }
         StandardListItem {
             opacity: nightMode?0.8:1
             visible: mediaFormat==="Video"? true:false
             title:qsTr( "Height & Width")
             id:hw
             description: metaDataHeight +"px" + " - " + metaDataWidth + "px"
         }
         StandardListItem {
             opacity: nightMode?0.8:1
             title: qsTr("Duration")
             id: dur
             description: metaDataDuration
             contextActions:   ActionSet {
                 title:  dur.description
                 actions:[
                     ActionItem {
                         imageSource: "images/ic_copy.png"
                         title:qsTr("Copy to clipboard")
                         onTriggered: {_app.copyToClipboard( dur.description)}
                     }
                 ]
             }
         }
         StandardListItem {
             visible: sourceStreamed?false:inAppRecordingPlaying?false:true
             opacity: nightMode?0.8:1
             title: qsTr("File Size")
             id: fs
             description: metaDataFileSize
        
         }
       
       }
   }
}
}
}