import bb.cascades 1.4

Sheet{
    id: night
    onCreationCompleted: {open(); }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title: qsTr("Car Mode")
            
            dismissAction: ActionItem {
                title: qsTr("Close") 
                onTriggered: {
                    close();night.destroy();
                }
            }
        }
        ScrollView {
            
            Container{
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                layout: StackLayout {
                
                }
                Container {
                    topPadding: 20
                    
                    horizontalAlignment: HorizontalAlignment.Center
                    ImageView {
                        filterColor: brightTheme? Color.Black: undefined

                        opacity: nightMode?0.8:1
                        imageSource: "../images/CarMode/CarMode_passport.png"
                    }
                }
                Container {
                    topPadding: 25;  leftPadding: 5;rightPadding: 5
                    Label {
                        opacity: nightMode?0.8:1
                        multiline: true
                        text: qsTr("Car Mode allows you to use Star Player while Driving, it offers large controls with Volume Control, Playlist Access, Rewind/Forward Buttons, Bluetooth Detection, Auto Resume and more.")
                        textStyle{
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7
                            base: SystemDefaults.TextStyles.PrimaryText
                        }
                    }
                }
                Container {
                    topPadding: 50;  leftPadding: 5;rightPadding: 5
                    Label {
                        opacity: nightMode?0.8:1
                        multiline: true
                        text:qsTr(displayInfo.displayTechnology==2? "Your safety should always be the number one priority, please obey all local laws and remember that using a mobile device while driving may be prohibited.\n\nYour device uses OLED Technology for the display, keeping the screen on for long periods of time without movement may cause screen damage; we recommend that the 'Always Keep Screen On' option from Car Mode Settings is disabled to allow the screen to turn itself off.": "Your safety should always be the number one priority, please obey all local laws and remember that using a mobile device while driving may be prohibited.")
                        textStyle{
                            fontSize: FontSize.PointValue
                            fontSizeValue: 6
                            base: SystemDefaults.TextStyles.PrimaryText
                            color: Color.create("#FF0000")
                        }
                    }
                }
             
                Container {
                    topPadding: 20
                    horizontalAlignment: HorizontalAlignment.Center
                    Button {
                        opacity: nightMode?0.8:1
                        color: Color.create(getAppColour())

                        text: qsTr("Car Mode Settings")
                        onClicked:{close(); creator.createQMLObject("CarModeSettings.qml")}
                    }
                }
            }
        }
    }

}