import bb.cascades 1.4

Sheet{
id: help
onCreationCompleted: {open(); }
property bool finished:false
content:Page {
titleBar: TitleBar {
appearance: TitleBarAppearance.Branded
title: qsTr("Help")

dismissAction: ActionItem {
    title: qsTr("Close") 
onTriggered: {
close();help.destroy();
}
}
}
ScrollView {
id: scroller
scrollRole: ScrollRole.Main

content: Container {
horizontalAlignment: HorizontalAlignment.Fill
verticalAlignment: VerticalAlignment.Center
id: conter
topPadding: 5
bottomPadding: 5
layout: StackLayout { }

StandardListItem {
    opacity: nightMode?0.8:1
visible: hardwareInfo.isPhysicalKeyboardDevice
title: qsTr("Keyboard Shortcuts")
description:qsTr( "List of supported Keyboard Shortcuts")
    gestureHandlers: [
        TapHandler {
            onTapped:{  creator.createQMLObject("Help/QWERTYKeyboardShortcuts.qml")

            }
        }
    ]
    
    
}
StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Night Mode")
    description:qsTr( "Information About Night Mode")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/NightMode.qml")

            }
        }
    ]
    
}

StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Show Art Work On Lockscreen")
    description: qsTr("Help Regarding the 'Show Art Work On Lockscreen' Feature")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/ArtWorkOnLockscreen.qml")
            
            }
        }
    ]
}
StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Managing The Player Menu")
    description: qsTr("Help Regarding the 'Manage Player Menu' Settings")
    gestureHandlers: [
        TapHandler {
            onTapped: {
               creator.createQMLObject("Help/ManagePlayerMenu.qml")
            }
        }
    ]
}
StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Network Proxy")
    description:qsTr( "Help Regarding the Network Proxy Settings")
    gestureHandlers: [
        TapHandler {
            onTapped: {
              creator.createQMLObject("Help/NetworkProxy.qml")

            }
        }
    ]

}

StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Sleep Timer")
    description:qsTr( "Help Regarding the Sleep Timer feature")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/SleepTimer.qml")
            
            }
        }
    ]

}
StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Pinned Media")
    description:qsTr( "Help Regarding the Media feature")
    gestureHandlers: [
        TapHandler {
            onTapped: {
               creator.createQMLObject("Help/PinnedVideos.qml")

            }
        }
    ]

}
StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Lyrics Search")
    description: qsTr("Help Regarding Lyrics Search")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/LyricsSearchOffline.qml")
               /* if( online.visible){
                    online.setVisible(false);
                    offline.setVisible(false);
                
                }
                
                else {
                    online.setVisible(true);
                    offline.setVisible(true);
                    }*/
            }
        }
    ]
}
Container {
    leftPadding: 20
    
    StandardListItem {
        visible: false
        id: online
        opacity: nightMode?0.8:1
        title: qsTr("Online Lyrics Search")
        description:qsTr( "Help Regarding The Online Lyrics Search")
        gestureHandlers: [
            TapHandler {
                onTapped: {
                    creator.createQMLObject("Help/LyricsSearchOnline.qml")
                }
            }
        ]
    }
}
Container {
    leftPadding: 20
    
    StandardListItem {
        visible: false
        id: offline
        opacity: nightMode?0.8:1
        title: qsTr("Local Lyrics Search")
        description:qsTr( "Help Regarding Local Lyrics Search")
        gestureHandlers: [
            TapHandler {
                onTapped: {
                    creator.createQMLObject("Help/LyricsSearchOffline.qml")
                }
            }
        ]
    }
}

StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Star Player Password")
    description:qsTr( "Help Regarding the Password Protection options")
    gestureHandlers: [
        TapHandler {
            onTapped: {
              creator.createQMLObject("Help/PasswordSec.qml")

            }
        }
    ]
  
}
StandardListItem {
    opacity: nightMode?0.8:1
    visible: miniSquareDevice===true?false:true
    title: "Car Mode"
    description: "Help Regarding the Driving Mode"
    gestureHandlers: TapHandler {
        onTapped: {
            creator.createQMLObject("Help/CarMode.qml")
        }
    }
}
StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Playlist")
    description: qsTr("Help Regarding the Playlist Feature")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                if( playlistm.visible){
                    playlistm.setVisible(false);
                    folderplay.setVisible(false);

                }
                
                else {
                    playlistm.setVisible(true);
                    folderplay.setVisible(true);
                    }
            }
        }
    ]
}

Container {
    leftPadding: 20
    
    StandardListItem {
        visible: false
        id: playlistm
        opacity: nightMode?0.8:1
        title: qsTr("Playlists")
        description:qsTr( "Help Regarding The Playlists Area")
        gestureHandlers: [
            TapHandler {
                onTapped: {
                    creator.createQMLObject("Help/PlayListEditor.qml")
                }
            }
        ]
    }
}
Container {
    leftPadding: 20
    
    StandardListItem {
        visible: false
        id: folderplay
        opacity: nightMode?0.8:1
        title: qsTr("Folder Play")
        description:qsTr( "Help Regarding The Folder Play Feature")
        gestureHandlers: [
            TapHandler {
                onTapped: {
                    creator.createQMLObject("Help/FolderPlay.qml")
                }
            }
        ]
    }
}
StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Internet Radio")
    description: qsTr("Help Regarding the Internet Radio")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                if( internetRadioStation.visible){
                    internetRadioStation.setVisible(false);
                internetRadioPlayer.setVisible(false);
                internetRadioRec.setVisible(false);
                }
                
                else {
               internetRadioStation.setVisible(true);
               internetRadioPlayer.setVisible(true);
               internetRadioRec.setVisible(true);}
            }
        }
    ]
}
Container {
    leftPadding: 20

StandardListItem {
    visible: false
    
    id: internetRadioStation
    opacity: nightMode?0.8:1
    title: qsTr("Internet Radio Stations")
    description:qsTr( "Help Regarding Internet Radio Stations")
    gestureHandlers: [
        TapHandler {
            onTapped: {
            creator.createQMLObject("Help/InternetRadioStations.qml")
            }
        }
    ]
}
}
Container {
    leftPadding: 20
    
    StandardListItem {
        visible: false
        
        id: internetRadioPlayer
        opacity: nightMode?0.8:1
        title: qsTr("Internet Radio Player")
        description: qsTr("Help Regarding the Internet Radio Player")
        gestureHandlers: [
            TapHandler {
                onTapped: {
                    creator.createQMLObject("Help/InternetRadioPlayer.qml")
                }
            }
        ]
    }
}
Container {
    leftPadding: 20
    
    StandardListItem {
        visible: false
        
        id: internetRadioRec
        opacity: nightMode?0.8:1
        title:qsTr( "Recording Internet Radio")
        description: qsTr("Help Regarding Recording Internet Radio")
        gestureHandlers: [
            TapHandler {
                onTapped: {
                    creator.createQMLObject("Help/InternetRadioRecorder.qml")
                }
            }
        ]
    }
}
StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Audio Recorder")
    description: qsTr("Help Regarding the built in Audio Recorder")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/AudioRecorder.qml")
            
            }
        }
    ]

}
StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Visualisations")
    description:qsTr( "Help Regarding Visualisations")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/Visualisations.qml")
            
            }
        }
    ]

}
StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Internet Streaming")
    description: qsTr("Help Regarding the 'Web Stream' option")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/WebStream.qml")
            
            }
        }
    ]
}
StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Launch into Do Not Disturb Mode")
    description: qsTr("Help Regarding Launch into Do Not Disturb Mode option")
    gestureHandlers: [
        TapHandler {
            onTapped: {
               creator.createQMLObject("Help/LaunchDoNotDisturb.qml")

            }
        }
    ]
}
StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Fancy Indicators")
    description:qsTr( "Help Regarding the Fancy Indicators option")
    gestureHandlers: [
        TapHandler {
            onTapped: {
               creator.createQMLObject("Help/FancyIndicators.qml")
            
            }
        }
    ]

}
StandardListItem {
    opacity: nightMode?0.8:1
    title:qsTr( "Home Signature Action")
    description:qsTr( "Help Regarding the Home Signature Action Setting")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                creator.createQMLObject("Help/HomeSignatureAction.qml")
            
            }
        }
    ]

}
StandardListItem {
    opacity: nightMode?0.8:1
    title: qsTr("Application Permissions")
    description: qsTr("Star Player Permissions Screen")
    gestureHandlers: [
        TapHandler {
            onTapped: {
                _app.openPermsScreen();

            }
        },
        LongPressHandler {
            onLongPressed: {
                if(appsettings.getSystemSetting("logToFile", "")===""){
                    appsettings.saveSystemSetting("logToFile", "true"); _app.showGlobalToast("Debugging enabled, App will save logs to Device Memory/Documents/starplayerlog.txt\nRestart App to take effect")
                }
                else{ appsettings.saveSystemSetting("logToFile", "");_app.showGlobalToast("Debugging disabled, Restart to apply changes\nLog file will be automatically removed."); _app.deleteFile("/accounts/1000/shared/documents/starplayerlog.txt")}
            }
        }
        
    ]

}

}
}
}
}