import bb.cascades 1.4

Sheet{
    id: night
    onCreationCompleted: {open(); }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title: qsTr("Password Protection")
            
            dismissAction: ActionItem {
                title: qsTr("Close") 
                onTriggered: {
                    close();night.destroy();
                }
            }
        }
        ScrollView {
         
            
            Container{
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                layout: StackLayout {
                
                }
                Container {
                    horizontalAlignment: HorizontalAlignment.Center
                    ImageView {
                        opacity: nightMode?0.8:1
                        filterColor: brightTheme? Color.Black: undefined

                        imageSource: "lock.png"
                    }
                }
                Container {
                    leftPadding: 5;rightPadding: 5
                    
                    Label {
                        opacity: nightMode?0.8:1
                        multiline: true
                        text:qsTr( "With Star Player you can Password Protect your Last Played, Favourites list, In App Recordings and also Password Protect Star Player itself when opened.")
                        textStyle{
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7
                            base: SystemDefaults.TextStyles.PrimaryText
                        }
                    }
                }
                Container {
                    topPadding: 50;  leftPadding: 5;rightPadding: 5
                    Label {
                        opacity: nightMode?0.8:1
                        multiline: true
                        text:qsTr( "Note: This password cannot be recovered without the re-installation or an App Reset, both will result in the removal of the Apps databases, keep this in mind when choosing your password.\nThe Password is stored in plain text in a database that only Star Player can access.")
                        textStyle{
                            fontSize: FontSize.PointValue
                            fontSizeValue: 6
                            base: SystemDefaults.TextStyles.PrimaryText
                            color: Color.create("#FF0000")
                        }
                    }
                }
               
                Container {
                    topPadding: 20
                    horizontalAlignment: HorizontalAlignment.Center
                    Button {
                        color: Color.create(getAppColour())

                        opacity: nightMode?0.8:1
                        text: qsTr("Manage Security Settings")
                        onClicked:{if(appsettings.getSystemSetting("passwordprotectionPS", "")===""){creator.createQMLObject("NewSecurityPassword.qml");close();}
                        else creator.createQMLObject("EnterPasswordProtection.qml");close();}
                    }
                }
            
            }
        }
    }

}