import bb.cascades 1.4
import QtQuick 1.0

Container {
    id: root
    opacity: 0
    property bool smallMode:false
    attachedObjects:   Connections{target: mainnav; onNightModeChanged:{if(nightMode===true){opacity=0.6} else{ opacity=1}}}
    enabled: buttonEnabled
    function show(){fadeIn.play();}
    
    function hide(){fadeOut.play();}
    animations:[ FadeTransition {
        id: fadeIn
        fromOpacity: 0
        toOpacity: nightMode? 0.6:1
        duration: 250
        onEnded: {
        }},
    FadeTransition {
        id: fadeOut
        fromOpacity: nightMode? 0.6:1
        toOpacity: 0
        duration: 50
        onEnded: { 
        }
    }
   
]
    layout: DockLayout {}
    property bool buttonEnabled
    signal pressed
    property alias defaultSource: img.defaultImageSource
    property alias disabledSource: img.disabledImageSource
   property alias pressedSource: img.pressedImageSource

    property alias title: label.text
    preferredHeight: smallMode?device768? 295: passport? 290:90: device768? 295: passport? 290:230

    ImageButton {
        id: img
        
        horizontalAlignment: HorizontalAlignment.Center
        preferredHeight: 90
        preferredWidth:90
        opacity: buttonEnabled? 1: 0.6
        onClicked: {
            if(buttonEnabled)pressed();
        }
        
    }
    Container {
        id: labelcont
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Bottom
    Label {
        textStyle{
            fontSize: FontSize.PointValue
            fontSizeValue: 5 }
        opacity: buttonEnabled? 0.8: 0.6
        id: label
    }
}
}
