import QtQuick 1.0
import bb.cascades 1.4
import bb.system 1.0

Sheet{
    id: sheet
    Page {
        id:page
        titleBar: TitleBar {
            title: qsTr("In App Recordings")
            
            dismissAction: ActionItem {
                title:qsTr( "Close")
                onTriggered: {
                    sheet.close() 
                }
            }
        
        }
      /*  attachedObjects: Connections{
            target: mainnav
            onCloseFavourites:{sheet.close();}
            }*/
        actionBarVisibility: ChromeVisibility.Compact
        actions: [
            ActionItem {
                imageSource: "asset:///images/ic_to_bottom.png"
                enabled:  view.dataModel.size() > 0? true: false
                title: "To Bottom"
                onTriggered: {
                    var dataModelSize = view.dataModel.size(); // or listViewId.dataModel.childCount(0)
                    if (dataModelSize > 0)
                    {
                        var lastRowNumber = dataModelSize - 1
                        view.scrollToItem([0, lastRowNumber], ScrollAnimation.Default);
                    }
                
                }  
            },
            ActionItem {
                title:qsTr( "Delete All")
                imageSource: "images/ic_delete.png"
                ActionBar.placement: ActionBarPlacement.Signature
                enabled:_inAppRecordings.dataModel.childCount(0)===0? false: true
                onTriggered: {
                    creator.createQMLObject("InAppRecordingsDeleteAllDialog.qml");                
                }
            }
        ]
        onCreationCompleted: {open();_inAppRecordings.updateRecordingDataModel(); console.log(_inAppRecordings.dataModel.size()) }   
        
        
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: DockLayout {}
            bottomPadding: 90
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                Label {
                    visible:_inAppRecordings.dataModel.childCount(0) === 0 ? true : false
                    text: qsTr("No Recordings")
                    textStyle.color:brightTheme? Color.Black: Color.White
                    opacity: nightMode ? 0.6 : 0.8
                    textStyle {
                        fontSize: FontSize.PointValue
                        fontSizeValue: 16
                        base: SystemDefaults.TextStyles.BigText
                    }
                }
            }
            ListView {
                scrollRole: ScrollRole.Main

                opacity: nightMode?0.8:1
                function remove(indexPath) {_inAppRecordings.removeFromJson(indexPath);}
                id: view
                dataModel: _inAppRecordings.dataModel
                scrollIndicatorMode: ScrollIndicatorMode.ProportionalBar
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            title: _inAppRecordings.dataModel.size() + " Recording(s)"
                        }  
                    },
                    ListItemComponent {
                        type: "item"
                        
                        Container {
                            id: rootListItemContainer
                            property string pathIndex
                            property string title
                            property string urle
                            property string icon
                            function bob(){dio.show();}
                            function updateFav(indexPath, titlle, urrle, icone){
                                console.log(indexPath, titlle, urrle, icone)
                                pathIndex= indexPath.toString();
                                title= titlle;
                                urle= urrle;
                                icon= icone;
                                prompt.show();}
                            attachedObjects:[  SystemDialog{
                                    id: dio
                                    title:qsTr( "Delete")
                                    body: qsTr("Delete Recording? (") +ListItemData.videoTitle + ")"
                                    buttonAreaLimit: 2
                                    confirmButton.label: qsTr("Yes")
                                    confirmButton.enabled: true
                                    cancelButton.label: qsTr("Cancel")
                                    cancelButton.enabled: true
                                    property string boberr: ListItemData.audioURL.toString()
                                    onFinished: {
                                        if(result == SystemUiResult.ConfirmButtonSelection) {_app.deleteFile(boberr.replace("file:///", ""));remove(rootListItemContainer.ListItem.view.remove(rootListItemContainer.ListItem.indexPath));
                                        }
                                        else if (result == SystemUiResult.CancelButtonSelection) {
                                           dio.cancel();
                                        }
                                    }
                            }]
                        StandardListItem {
                            contextActions:   ActionSet {
                                title:  ListItemData.videoTitle
                            //    subtitle: ListItemData.audioURL
                                actions:[
                                   ActionItem {
                                       
                                        id: moveItem
                                        property bool created: false
                                        property string modifiedOriginalURL
                                        attachedObjects: [
                                      
                                            SystemListDialog {
                                                id: listDialog
                                                title:qsTr( "Move Recording")
                                                confirmButton.label: qsTr("Move")
                                                cancelButton.label: qsTr("Cancel")
                                                
                                                onFinished: {
                                                    if(result == SystemUiResult.ConfirmButtonSelection) {
                                                       console.log(selectedIndices)
                                                       var bob= ListItemData.audioURL;
                                                       var filename= _app.withoutExtension(ListItemData.audioURL) + ".m4a"
                                                       console.log( "Original URL " + moveItem.original)
                                                       moveItem.modifiedOriginalURL= moveItem.original.replace("file:///", "");
                                                       moveItem.original=  moveItem.modifiedOriginalURL;
                                                       console.log("FILENAME: " + filename)
                                                    //   console.log(bob)
                                                       if(selectedIndices==0){moveItem.targetURL= "/accounts/1000/shared/voice/" + filename; console.log("Target: " + moveItem.targetURL)}
                                                       else if(selectedIndices==1){moveItem.targetURL= "/accounts/1000/removable/sdcard/voice/" +filename; console.log("Target: " + moveItem.targetURL)}
                                                       _app.moveFile(moveItem.original, moveItem.targetURL);
                                                      remove(rootListItemContainer.ListItem.view.remove(rootListItemContainer.ListItem.indexPath))
                                                      _app.deleteFile(moveItem.original);
                                                    }

                                                       
                                                    else if (result == SystemUiResult.CancelButtonSelection) {
                                                        listDialog.cancel();
                                                    }
                                                   
                                                }
                                            }
                                            
                                        ]
                                        title: qsTr("Move Recording")
                                        property string original
                                        imageSource: "images/ic_doctype_music.png"
                                        property string targetURL:""
                                        onTriggered: {
                                            original= ListItemData.audioURL.toString();
                                            
                                            if(!created)
                                            {  
                                                listDialog.appendItem("Device Memory", true, true)
                                                if(_app.checkSDCard()) listDialog.appendItem("SD Card")
                                               
                                                created = true
                                            }
                                            
                                            listDialog.show()
                                            
                                        }
                                    },
                                 
                                    DeleteActionItem{
                                        imageSource: "images/ic_delete.png"
                                        title:qsTr("Delete Recording")
                                        onTriggered: {rootListItemContainer.bob(); }
                                    }
                                ]
                            }
                           
                            
                            title: ListItemData.videoTitle
                          //  description: ListItemData.audioURL
                            imageSource: ListItemData.videoIconURL
                            status: ListItemData.videoDuration
                        
                        }     
                    
                        }
                    }
                ]
                onTriggered: {
                    var data= dataModel.data(indexPath);
                    audioSource= data.audioURL; activity.running = true;
                    activity.visible = true;inAppRecordingPlaying=true; 
                    _inAppRecordings.audioRecordingRequested();
                    sheet.close();sheet.destroy(1000); lastrecentPlay.start();
                }
            }
        }
    
    }
}
