import QtQuick 1.0
import bb.cascades 1.4
import bb.system 1.0

Sheet{
    
    id: sheeter
    Page {
        id:pagee
        titleBar: TitleBar {
            title: qsTr("In App Recordings")
            
            dismissAction: ActionItem {
                title:qsTr( "Close")
                onTriggered: {
                    sheeter.close() 
                }
            }
        
        }
        
        actionBarVisibility: ChromeVisibility.Compact
        
        onCreationCompleted: {sheeter.open();_inAppRecordings.updateRecordingDataModel(); console.log(_inAppRecordings.dataModel.size()+ "dddddddddd") }   
        
        
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: DockLayout {}
            bottomPadding: 90
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                Label {
                    visible:_inAppRecordings.dataModel.childCount(0) === 0 ? true : false
                    text: qsTr("No Recordings")
                    textStyle.color: brightTheme? Color.Black: Color.White
                    opacity: nightMode ? 0.6 : 0.8
                    textStyle {
                        fontSize: FontSize.PointValue
                        fontSizeValue: 16
                        base: SystemDefaults.TextStyles.BigText
                    }
                }
            }
            ListView {
                scrollRole: ScrollRole.Main
                
                opacity: nightMode?0.8:1
                id: viewe
                dataModel: _inAppRecordings.dataModel
                scrollIndicatorMode: ScrollIndicatorMode.ProportionalBar
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            title: _inAppRecordings.dataModel.size() + " Recording(s)"
                        }  
                    },
                    ListItemComponent {
                        type: "item"
                        
                        Container {
                            id: rootListItemContainer
                            property string pathIndex
                            property string title
                            property string urle
                            property string icon
                            function bob(){dio.show();}
                            function updateFav(indexPath, titlle, urrle, icone){
                                console.log(indexPath, titlle, urrle, icone)
                                pathIndex= indexPath.toString();
                                title= titlle;
                                urle= urrle;
                                icon= icone;
                                prompt.show();}
                            
                            StandardListItem {
                                contextActions:   ActionSet {
                                    title:  ListItemData.videoTitle
                                
                                }
                            
                            
                            }     
                        
                        }
                    }
                ]
                onTriggered: {
                    var data= dataModel.data(indexPath);
                    audioSource= data.audioURL; 
                
                }
            }
        }
    
    }
}
