import bb.system 1.2
import bb.cascades 1.4
import timer 1.0

Container {
    id: cont
    onCreationCompleted: {dio.show();}
    function close(){cont.destroy();}
    function reset() {
        _app.removeDir(_app.homePath()+ "/InternetRadioImages");
        appsettings.dropInternetRadioSettings();
        toast.showText(qsTr("Internet Station Images Removed"))
        dio.cancel();
        cont.close();
    }
    attachedObjects: [
        SystemTimer {
            id: resetTimer
            interval: 500;
            onTimeout: {
                resetTimer.stop();
                reset();
            }  
        },
        SystemDialog{
            id: dio
            title: qsTr("Internet Station Images")
            autoUpdateEnabled: true
            body:qsTr( "Are you sure you want to remove all Internet Station Images?")
            buttonAreaLimit: 2
            confirmButton.label: qsTr("Yes")
            confirmButton.enabled: true
            cancelButton.label: qsTr("Cancel")
            cancelButton.enabled: true
            dismissAutomatically: false
            onFinished: {
                if(result == SystemUiResult.ConfirmButtonSelection) {
                    activityIndicatorVisible=true;
                    dio.body= qsTr("Removing Internet Station Images..");
                    dio.cancelButton.enabled=false;
                    dio.cancelButton.label= undefined
                    dio.confirmButton.label= undefined
                    dio.confirmButton.enabled=false;
                    
                    resetTimer.start();
                }
                else if (result == SystemUiResult.CancelButtonSelection) {
                    dio.cancel();cont.destroy();
                }
            }
        }
    ]
}