import QtQuick 1.0
import bb.cascades 1.4
import bb.multimedia 1.4
import timer 1.0
import ImageDownloader 1.0
import bb.system 1.2
import "Custom"

Page {
    id: page
    property int audioBufferProgress
    property int duratione: 1
    property bool sleepTimerPopup:false
    property int positione: 1
    property string eqName:appsettings.getSystemSetting("EQValueName", "Off")
    property bool stationListShowing:false
    property int minutes: Math.floor(positione/1000/60)
    property int seconds: Math.floor(positione/1000%60)
    onCreationCompleted: {_app.dirCheckOrCreate(_app.homePath()+ "/InternetRadioImages");internetRadioActive=true; eQChanged(); console.log("SOURCE "+mainnav.internetRadioSource );player.play();mediaFormat="InternetRadioStation"}
    onActionMenuVisualStateChanged: {vol.update();}
    function playPauseMedia(){if(player.mediaState==2){player.pause();}
    else if(player.mediaState==3){ player.play();}}
    actionBarVisibility: ChromeVisibility.Overlay
    actionBarAutoHideBehavior: ActionBarAutoHideBehavior.Disabled
    property int eqValue;
    shortcuts: [
        Shortcut {
            key: qsTr("i")
            onTriggered: { _app.increaseMediaVolume();}
        },
        Shortcut {
            key: qsTr("d")
            // triggerMode: ShortcutTriggerMode.LongPress
            onTriggered: {_app.decreaseMediaVolume();}
        
        }
    ]
    
    function loadStationImage(){
        if(appsettings.getSystemSetting("internetRadioUseStationImage", "")===""){
            console.log("Internet Radio Station Image Enabled")
            
            if(appsettings.getInternetRadioSetting(metaDataTitle, "")===""){imgDown.setUrl(artWorkURI) ;imgDown.startDownload();
                if(artWorkURI===""){}
                else{
                    if(appsettings.getSystemSetting("albumArtActiveFrame", "")==="true"){ albumArtActiveFrame=true;updateCoverImage();}}
            }
        
            else{artView.imageSource="file:///" +appsettings.getInternetRadioSetting(metaDataTitle, ""); artWorkURI= artView.imageSource;console.log("Value Found, using local")
            if(artWorkURI===""){}
            else{
                if(appsettings.getSystemSetting("albumArtActiveFrame", "")==="true"){ albumArtActiveFrame=true; updateCoverImage();}}}}
        
    }
    attachedObjects: [LayoutUpdateHandler {
            id: layout  
    },
  SystemTimer {
      id:stationIMGDelay; interval: 500; onTimeout: {stationIMGDelay.stop();loadStationImage();
      }
  },
    
    Connections {
        target: mainnav 
        onInternetRadioStationChanged:{metaDataBitRate="";player.play();}
        onPlayPause:{playPauseMedia();}

        onPlayMedia:{playPauseMedia();}
        onPauseMedia:{playPauseMedia();}
        onClosePlayer:{mainnav.pop();}
        onEQChanged:{
            eqValue = parseInt(appsettings.getSystemSetting("EQValue", ""));
            if(eqValue===0) {player.equalizerPreset= EqualizerPreset.Off}
            else if(eqValue===1) {player.equalizerPreset= EqualizerPreset.Airplane}
            else if(eqValue===2) {player.equalizerPreset= EqualizerPreset.BassBoost}
            else if(eqValue===3) {player.equalizerPreset= EqualizerPreset.TrebleBoost}
            else if(eqValue===4) {player.equalizerPreset= EqualizerPreset.VoiceBoost}
            else if(eqValue===5) {player.equalizerPreset= EqualizerPreset.BassLower}
            else if(eqValue===6) {player.equalizerPreset= EqualizerPreset.TrebleLower}
            else if(eqValue===7) {player.equalizerPreset= EqualizerPreset.VoiceLower}
            else if(eqValue===8) {player.equalizerPreset= EqualizerPreset.Acoustic}
            else if(eqValue===9) {player.equalizerPreset= EqualizerPreset.Dance}
            else if(eqValue===10) {player.equalizerPreset= EqualizerPreset.Electronic}
            else if(eqValue===11) {player.equalizerPreset= EqualizerPreset.HipHop}
            else if(eqValue===12) {player.equalizerPreset= EqualizerPreset.Jazz}
            else if(eqValue===13) {player.equalizerPreset= EqualizerPreset.Lounge}
            else if(eqValue===14) {player.equalizerPreset= EqualizerPreset.Piano}
            else if(eqValue===15) {player.equalizerPreset= EqualizerPreset.RhythmAndBlues}
            else if(eqValue===16) {player.equalizerPreset= EqualizerPreset.Rock}
            else if(eqValue===17) {player.equalizerPreset= EqualizerPreset.SpokenWord}
            eqName= appsettings.getSystemSetting("EQValueName", "Off")
        }
    },
    OrientationHandler {
        onOrientationChanged: {
            console.log(_app.screenWidth())
            if(OrientationSupport.orientation == UIOrientation.Landscape){artView.maxHeight=pixelHeight-245}
            else{artView.maxHeight=artView.maxHeight=pixelHeight}
        }
    
    },
            /* NowPlayingController {
                id: playerController
            
             },*/
            NowPlayingConnection {
                 id: nowPlaying
                 priorityLevel: PriorityLevel.Low
                 overlayStyle: thumbnailed==true?OverlayStyle.Fancy: OverlayStyle.Plain  
                 onOverlayStyleChanged: {
                     var metaData = { "track": elapsedTime, "artist" : player.bob };  
                     nowPlaying.setMetaData(metaData)
                 }    
               //  duration: player.duration
                 position: player.position
                 iconUrl: artWorkURI==="" ?"asset:///images/video_blue.png": artWorkURI
                 mediaState: player.mediaState
                 connectionName: "StarPlayer"
                 nextEnabled: false
                 previousEnabled: false
                 
                 onAcquired: {
                     var metadata = { "track":elapsedTime, "artist" : player.bob};  
                     playPauseMedia();
                     nowPlaying.mediaState = MediaState.Started ;  
                     nowPlaying.setMetaData(metadata);
                 }
                 
                 onPause: {
                     playPauseMedia();nowPlaying.mediaState= player.mediaState;
                 }
                 
                 onPlay: {
                     if(phoneCallActive===false){
                         console.log("Started Anyway")
                     playPauseMedia(); nowPlaying.mediaState= player.mediaState;}
                 }
                 onRevoked: {
                     player.stop();
                     nowPlaying.mediaState= player.mediaState;
                 }},
             
             MediaPlayer {
                 id: player
                 volume: 1.0
                 autoPause:autoPausePlayer
                 sourceUrl:internetRadioSource
                 property string bob: metaDataTitle==="" ? _app.withoutExtension(metaData.uri).toString(): metaDataTitle
                 audioManagerHandle: AudioChannelConfiguration.Stereo
                 function bytesTosize(bytes) {                        
                     if(bytes == 0) return 'Undefined';
                     var k = 1000;
                     var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
                     var i = Math.floor(Math.log(bytes) / Math.log(k));
                     return (bytes / Math.pow(k, i)).toPrecision(3) + ' ' + sizes[i];
                 }
                 function getTimeFromMSec(msec) {
                     if (msec <= 0 || msec == undefined) {
                         return "0:00"
                     
                     } else {
                         var sec = "" + Math.floor(msec / 1000) % 60
                         if (sec.length == 1)
                             sec = "0" + sec
                         
                         var hour = Math.floor(msec / 3600000)
                         if (hour < 1) {
                             return Math.floor(msec / 60000) + ":" + sec
                         } else {
                             var min = "" + Math.floor(msec / 60000) % 60
                             if (min.length == 1)
                                 min = "0" + min
                             
                             return hour + ":" + min + ":" + sec
                         }
                     }
                 }
                 onMetaDataChanged: {

                     console.log("player onMetaDataChanged");
                     console.log("--------------------------------bit_rate=" + metaData.bit_rate);
                     metaDataBitRate= Math.round(metaData.bit_rate/1000)
                     //console.log("-----------------------------------duration=" + metaData.duration);
                     console.log("-----------------------------------title=" + metaData.title);
                     console.log("-----------------------------------uri=" + metaData.uri);
                     metaDataFileLocation= metaData.uri.toString();   
                     if(metaDataTitle==="") { metaDataTitle= player.metaData.title.toString();}              
                     if(player.bob===" "){player.bob= metaData.title; metaDataTitle= player.bob;}
                   
                     var metaDataa = { "track": elapsedTime, "artist" : player.bob };  
                     nowPlaying.setMetaData(metaDataa)
                     
                 }
                 
                 onError: {
                     console.log("Error: " + mediaError)
      
                 }
                 
                 onBufferStatusChanged: {audioBufferProgress=bufferStatus}
                 
                 onPositionChanged: {
                     
                     videoProgress= position
                    // duratione= nowPlaying.duration
                     positione= nowPlaying.position
                     elapsedTime= player.getTimeFromMSec(player.position)
                     
                     //.arg(seconds < 10 ? "0" + seconds : "" + seconds)
                    // playerDuration= duration
                     playerProgress=position
                     var metaData = { "track": elapsedTime, "artist" : player.bob };  
                     nowPlaying.setMetaData(metaData)
                 }                 
                 onMediaStateChanged: {
                     console.log(mediaState)
                     
                     if(mediaState==0){
                         console.log("UnPrepared")
                     }
                     else if(mediaState==1){
                         nowPlaying.acquire();
                         console.log("Prepared")
                     }
                     else if(mediaState==2){
                         console.log("Started")
                         mediaPlaying=true;
                         mediaPaused=false;
                        // metaDataDuration= controlsCont.getTimeFromMSec(player.duration);
                         var metaData = { "track": elapsedTime, "artist" :player.bob };  
                         nowPlaying.setMetaData(metaData)
                     }
                     else if(mediaState==3){
                         console.log("Paused")
                         mediaPaused=true;
                     }
                     else if(mediaState==4){
                         mediaPlaying=false;
                     }
                 }
             }
]
    actions: [
        ActionItem {
            id:playItem
            
            shortcuts: [
                Shortcut {
                    id:playpause
                    key: qsTr("p")
                }
            ]
            title:player.mediaState==2?qsTr("Pause"): qsTr("Play")
            imageSource:player.mediaState==2?"asset:///images/ic_pause.png": "asset:///images/ic_play.png"
            ActionBar.placement:ActionBarPlacement.Signature
            onTriggered: {playPauseMedia();
            }
        
        },
       
        ActionItem {
            id:vol
            shortcuts: [
                Shortcut {
                    id: muteShort
                    key: qsTr("m")
                }
            ]
            function update(){title=_app.checkMute()===false? qsTr("Mute Audio"): qsTr("Unmute Audio")
                imageSource= _app.checkMute()===false? "images/ic_speaker_mute.png": "images/ic_speaker.png"}
            title:_app.checkMute()===false? qsTr("Mute Audio"): qsTr("Unmute Audio")
            imageSource:_app.checkMute()===false? "images/ic_speaker_mute.png": "images/ic_speaker.png"
            ActionBar.placement:ActionBarPlacement.InOverflow
            onCreationCompleted: {
                if(appsettings.getSystemSetting("toggleAudioMuteMenu", "")==="false"){page.removeAction(vol);muteInd.destroy();}
            }
            onTriggered: {
                _app.muteOutputVolume();
                console.log(_app.checkMute());
            }
        
        }, 
        ActionItem {
            id: vismen
            
            title: "Visualisations"  
            imageSource: "images/visualisation_menu.png"
            onCreationCompleted: {if(appsettings.getSystemSetting("VisualisationOptionMenu", "")==="false"){page.removeAction(vismen)}                    
            }
            onTriggered: {
                if(appsettings.getSystemSetting("VisualisationViewerTutorial", "")===""){creator.createQMLObject("VisualisationTutorial.qml")}
                else creator.createQMLObject("Custom/VisualisationViewer.qml")
            
            }
        },   ActionItem {
            id:eq
            enabled: true
            shortcuts: [
                Shortcut {
                    id: eqshort
                    key: qsTr("e")
                }
            ]
            title:eqValue===15? "EQ " + "(" + eqName+")":"Equaliser " + "(" + eqName+")"

            imageSource:"asset:///images/ic_eq.png"
            ActionBar.placement:if(inAppRecordingPlaying){ActionBarPlacement.OnBar} else{ActionBarPlacement.InOverflow}
            onCreationCompleted: {
                if(appsettings.getSystemSetting("EqualiserMenu", "")==="false")page.removeAction(eq)
            
            }
            onTriggered: {
                creator.createQMLObject("EqualiserPresetPage.qml")
            }
        },
       
        ActionItem {
            id: sleepTi
            shortcuts: [
                Shortcut {
                    key: qsTr("t")
                }
            ]
            imageSource: sleepTimerEnabled? "images/sleep_time_active.png": "images/sleep_timer.png"

            title:qsTr( "Sleep Timer")
            onCreationCompleted: {
                if(appsettings.getSystemSetting("sleepTimerMenu", "")==="false")page.removeAction(sleepTi);
            } 
            onTriggered: {
                if(sleepTimerPopup){sleepTimerPopup=false; }
                else{ sleepTimerPopup=true;}
            
            }}
            ,
            
           ActionItem {
               enabled: appsettings.getSystemSetting("PinnedMediaViewer", "")===""? pinnedCount >=15? false: true: pinnedCount >=5? false: true
              title: qsTr("Pin Station To Home"  )
              onTriggered: {
                  var fileTitle= metaDataTitle==="" ?player.bob: metaDataTitle
                  _pinnedVideos.addToJson(fileTitle,  internetRadioSource, "", metaDataBitRate + "Kbps", "InternetRadioStation", artWorkURI, "0");toast.showText("Internet Radio Station Pinned To Home");
                  console.log(pinnedCount)
              }
              imageSource: "asset:///images/pin_actionItem.png"
            },
        ActionItem {
           id: stationListA
           shortcuts: [
               Shortcut {
                   
                   key: qsTr("l")
               }
           ]
           imageSource: "images/ic_view_list.png"
          title: stationListShowing? "Hide Station List":"Show Station List"
          onTriggered:{if(stationListShowing)stationListShowing=false;else stationListShowing=true}  
          onCreationCompleted: {
              if(_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelUS.xml" )===false){page.removeAction(stationListA)}
          }
        },
        ActionItem{
            id: cma
            title: "Open In Car Mode"
            imageSource: "images/CarModeAction.png"
            onTriggered: {aboutToLoadCarMode=true;closePlayer(); carModedelay.start(); activity.running = true;
                activity.visible = true;
            
            }
            onCreationCompleted: {
                if(appsettings.getSystemSetting("CarModeMenu", "")==""){page.removeAction(cma)}
            }
        
        },
        ActionItem {
          id:addToHS
          title:qsTr( "Add To Homescreen"  )
          imageSource: "images/ic_add_home.png"
          ActionBar.placement: ActionBarPlacement.InOverflow
          onCreationCompleted: {
              if(internetRadioInvokedHS===true){page.removeAction(addToHS)}
          }
          onTriggered: {
              creator.createQMLObject("InternetRadioAddToHomescreen.qml")
          }
        },
        
        ActionItem {
            id:download
            enabled:internetRadioScheduledRecording?false:true
            title:webRecordingActive?qsTr("Stop Recording"):qsTr("Record Station")
            imageSource:webRecordingActive? "images/stop_recording.png":"images/record_radio.png"
            ActionBar.placement:ActionBarPlacement.OnBar
            onTriggered: {
                if(webRecordingActive){stopRecordingInternetRadio();}
                else{
                if(connectionOnline){
             creator.createQMLObject("InternetRadioRecordWarning.qml")
            }}
            }
        
        },
        ActionItem {
            title: "Scheduled Recording"  
            imageSource: internetRadioScheduledRecording? "images/sched_active.png":"images/sched.png"
            onTriggered: {
                creator.createQMLObject("ScheduledRecording.qml");
            }
        },
        ActionItem {
            id:fa
            shortcuts: [
                Shortcut {
                    id: favshort
                    key: qsTr("f")
                }
            
            ]
            title:qsTr("Add Favourite")
            enabled: true
            imageSource:"asset:///images/ic_add_bookmarks.png"
            ActionBar.placement:ActionBarPlacement.OnBar
            onTriggered: {creator.createQMLObject("FavouritesSaveDialog.qml")}
        },
        ActionItem {
            id:nm
            title:qsTr("Night Mode")
            enabled: true
            imageSource:nightMode? "asset:///images/night_active.png":"asset:///images/night.png"
            ActionBar.placement:ActionBarPlacement.InOverflow
            onCreationCompleted: {
                if(appsettings.getSystemSetting("NightModeMenu", "")==="false")page.removeAction(nm)
            }
            onTriggered: { if(nightMode===true){page.removeAction(nms);nightMode=false;toast.showText(qsTr("Night Mode Disabled")); }
            else{nightMode=true;toast.showText(qsTr("Night Mode Enabled"))}
                nightModeChanged();page.addAction(nms)}
        },  ActionItem {
            id:nms
            title:qsTr("Night Mode Settings")
            imageSource:""
            ActionBar.placement:ActionBarPlacement.InOverflow
            onCreationCompleted: {
                if(nightMode===false)page.removeAction(nms)
            }
            onTriggered: {creator.createQMLObject("NightModeSettings.qml")}
        }
    ]
    Container {
        id: mainCont
        layout: DockLayout {}
        

        Container {
            id: bufferCont
            layout: DockLayout {}
            horizontalAlignment:HorizontalAlignment.Fill
            background: Color.Transparent
            verticalAlignment: VerticalAlignment.Fill
            visible: true
            opacity: audioBufferProgress===1? 0.8:0
            Container {
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                
                ActivityIndicator {
                    id: bufferInd
                    preferredHeight: passport? 170:150
                    preferredWidth:  passport? 170:150
                    running: audioBufferProgress===1? true:false
                }
            }
        
        }
Container {
    background:brightTheme? Color.White: Color.Black
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Top
    minHeight: passport? 135:115
    opacity: nightMode? 0.8:1
    layout: DockLayout {}
    Container {
        leftPadding: 5
        horizontalAlignment: HorizontalAlignment.Left
        verticalAlignment: VerticalAlignment.Top
        maxWidth:  pixelWidth==""? originalPixelWidth-50: pixelWidth-50

        Label {
            textStyle{
                fontSize: FontSize.PointValue
                fontSizeValue: 8
                color: brightTheme? Color.Black: Color.White
                base: SystemDefaults.TextStyles.BigText
            }
            onTextChanged: {
                stationIMGDelay.start();
            }
            text: player.bob
        }
    }
    Container {
        opacity: 0.8
        leftPadding: 5
        preferredWidth: 170
        horizontalAlignment: HorizontalAlignment.Right
        verticalAlignment: VerticalAlignment.Top
        layout: DockLayout {
            
        }
        Container {
            horizontalAlignment: HorizontalAlignment.Left
            verticalAlignment: VerticalAlignment.Center
           ImageFader {
               visible: webRecordingActive
               onVisibleChanged: {
                   if(visible)flash();
                   else stopFlash();
               }
                preferredHeight: 45
                preferredWidth: 45
                imageSource: "asset:///images/record_radio.png"
            }
        }
        Container {
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center

        
        Label {
            visible: webRecordingActive
            attachedObjects: [
                ImplicitAnimationController {
                    enabled: false
                }
            ]
            textStyle{
                fontSize: FontSize.PointValue
                fontSizeValue: 7
                color: brightTheme? Color.Black: Color.White

                base: SystemDefaults.TextStyles.SmallText
            }
            text: recordedFileSize
        }
    }
    }
    Container {
        opacity: 0.8
        leftPadding: 5
        horizontalAlignment: HorizontalAlignment.Left
        verticalAlignment: VerticalAlignment.Bottom
        maxWidth:  pixelWidth==""? originalPixelWidth-50: pixelWidth-50
        
        Label {
            textStyle{
                fontSize: FontSize.PointValue
                fontSizeValue: 7
                base: SystemDefaults.TextStyles.SmallText
            }
            text: elapsedTime
        }
    }
    Container {
        opacity: 0.8
        leftPadding: 5
        horizontalAlignment: HorizontalAlignment.Right
        verticalAlignment: VerticalAlignment.Bottom
     
        
        Label {
            id: bitrateLabel
            textStyle{
                fontSize: FontSize.PointValue
                fontSizeValue: 7
                color: brightTheme? Color.Black: Color.White

                base: SystemDefaults.TextStyles.SmallText
            }
            text:metaDataBitRate===""? "":qsTr("Bit Rate: ") +metaDataBitRate + "Kbps"
        }
    }
 
    
}

Container {
    id: artCont
 
    opacity:sleepTimerPopup? 0: audioBufferProgress===1? 0:nightMode? stationListShowing? 0:0.8 :stationListShowing?0:1
    layout: DockLayout { }
    horizontalAlignment: HorizontalAlignment.Center
 
    verticalAlignment: VerticalAlignment.Center
    gestureHandlers: TapHandler {
        onTapped: {if(_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelUS.xml" ) ===true){stationListShowing=true;}}
    }
    ImageView {
        id: artView
        opacity: nightMode?0.8:1
        verticalAlignment: VerticalAlignment.Top
        filterColor:artWorkURI===""? nightMode? Color.DarkGray:  Color.create(getAppColour()): undefined
        function defaultIMG(){ 
            if(passport) {  return "images/InternetRadio/radioImage_default_passport.png"} else{ return "images/InternetRadio/radioImage_default_normal.png"; }

        }
        attachedObjects: ImageDownloader {
            id: imgDown
            //url:  artWorkURI
            onImageChanged: {                 
                if (imgDown.isVaid) {
                    artView.imageSource="";
                    artView.imageSource= "file:///" + target;
                    nowPlaying.iconUrl= artView.imageSource;
                    artWorkURI= artView.imageSource;
                    
                    _app.contentsCheck(_app.homePath()+"/");
                    console.log("QMLLLLLLL   "+ target);
                    appsettings.saveInternetRadioSetting(metaDataTitle, target);
                    console.log("IMG SETTING", appsettings.getInternetRadioSetting(metaDataTitle, ""));
                    if(artWorkURI===""){}
                    else{
                        if(appsettings.getSystemSetting("albumArtActiveFrame", "")==="true"){ albumArtActiveFrame=true;updateCoverImage();}}
                    
                }
            }
        }
        imageSource:defaultIMG()
            
  
    
    }
    Container {
       id: stationTap
       visible: false
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Bottom
        bottomPadding: device768?2:2
        
    
    Label {
        textStyle {
            fontSize: FontSize.PointValue
            color: brightTheme? Color.Black: Color.White

            fontSizeValue: device768?5:6
            base: SystemDefaults.TextStyles.SmallText
        }
        opacity: 0.9
        text: qsTr("Tap to change Station")
    }
}
}
Container {
    visible: hardwareInfo.isPhysicalKeyboardDevice?false: stationListShowing?false:true
    horizontalAlignment:HorizontalAlignment.Right
    verticalAlignment: VerticalAlignment.Center
    opacity: touchVolumeControls?stationListShowing? 0: nightMode?0.6:0.80: 0
    minWidth: 95
    maxWidth: 95
    id: volumeControls
    background:brightTheme? Color.White: Color.Black
    
    layout: StackLayout {}
    Container {
        id:up
        topPadding: 20
        bottomPadding: 15
        // verticalAlignment: VerticalAlignment.Top
        horizontalAlignment: HorizontalAlignment.Center
        
        ImageButton {
            defaultImageSource:brightTheme? "images/volumeUp_dark.png": "images/volumeUp.png"
            onClicked: {
                if(mediaFormat==="Video")autoHideTimer.restart();
                _app.increaseMediaVolume()
            }
        }
    }
    Divider {
        
        verticalAlignment: VerticalAlignment.Center
    }
    Container {
        id: down
        topPadding: 15
        bottomPadding: 20
        //  verticalAlignment: VerticalAlignment.Bottom
        horizontalAlignment: HorizontalAlignment.Center
        
        ImageButton {
            defaultImageSource: brightTheme? "images/volumeDown_dark.png": "images/volumeDown.png"
            onClicked: {
                if(mediaFormat==="Video")autoHideTimer.restart();
                
                _app.decreaseMediaVolume()
            }
        
        }
    }
}

Container {
    horizontalAlignment: HorizontalAlignment.Center
    verticalAlignment: VerticalAlignment.Center
    
    bottomPadding: 90
    id: stationListCont
    opacity: sleepTimerPopup? 1:nightMode?stationListShowing?0.8:0: stationListShowing?1:0
    Container {
        opacity:sleepTimerPopup?1:0
        visible: sleepTimerPopup?true:false
        topPadding: 150

        Divider {}
        layout: StackLayout { }
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        Container {
            topPadding: 10; leftPadding: 15;rightPadding: 20
            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Top
            Label {
                opacity: nightMode?0.8:1
                text:qsTr("Enable Sleep Timer")
                verticalAlignment: VerticalAlignment.Center
                horizontalAlignment: HorizontalAlignment.Left
                textStyle {
                    base: SystemDefaults.TextStyles.BodyText
                    fontSize: FontSize.PointValue
                    color: brightTheme? Color.Black: Color.White

                    fontSizeValue: miniSquareDevice?7:8
                }
            }
            
            ToggleButton {
                opacity: nightMode?0.8:1
                enabled: true
                id: togglebutton
                horizontalAlignment: HorizontalAlignment.Right
                checked:sleepTimerEnabled
                onCheckedChanged: {if(sleepTimerEnabled==true){sleepTimerEnabled=false;sleepTimer.stop();}
                else{sleepTimerEnabled=true;sleepTimer.start();console.log(sleepTimer.interval)}
                
                }
            }
        
        
        }
        Container {
            topPadding: 15
            layout: DockLayout {
            
            }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Bottom
            Button {
                color: Color.create(getAppColour())
                text: qsTr("Set Up Sleep Timer")
                onClicked:{creator.createQMLObject("SleepTimerSettings.qml")}
            }
        }
    }
    Container{
        topPadding:sleepTimerPopup?10: passport? 140:130
        opacity: stationListShowing? 1: sleepTimerPopup?0:0
        DropDown {
            id: stationListDrop
            onCreationCompleted: {
                var bob= appsettings.getSystemSetting("DefaultRadioListCountry", "")
                if(bob==="Last Selected Country"){selectedIndex=parseInt(appsettings.getSystemSetting("RadioLastSelectedCountry", ""))}
                else if(bob==="Custom Stations"){selectedIndex=0;}

                else if(bob==="UK Stations"){selectedIndex=1;}
                else if(bob==="German Stations"){selectedIndex=2;}
                else if(bob==="French Stations"){selectedIndex=3;}
                else if(bob==="Spanish Stations"){selectedIndex=4;}
                else if(bob==="Canadian Stations"){selectedIndex=5;}
                else if(bob==="Italian Stations"){selectedIndex=6;}
                else if(bob==="US Stations"){selectedIndex=7;}
            }
            title: "Select A Country"
            
            
            onSelectedIndexChanged: {
                
                if(selectedIndex===0){stationListHeaderName="Custom Stations";
                    customStationsView=true;_customStations.updateHistoryDataModel();
                }
                else{
                    customStationsView=false;
                    modelURL= selectedValue;
                    if(selectedIndex===1)stationListHeaderName="UK";
                    else if(selectedIndex===2)stationListHeaderName="German";
                    else if(selectedIndex===3)stationListHeaderName="French";
                    else if(selectedIndex===4)stationListHeaderName="Spanish";
                    else if(selectedIndex===5)stationListHeaderName="Canadian";
                    else if(selectedIndex===6)stationListHeaderName="Italian";
                    else if(selectedIndex===7)stationListHeaderName="US";}
                if(appsettings.getSystemSetting("DefaultRadioListCountry", "")==="Last Selected Country"){
                    appsettings.saveSystemSetting("RadioLastSelectedCountry", selectedIndex);}
            }
            Option {id: option1; enabled:true ;text: "Custom Stations";  value:"custom"}

            Option {id: option2; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelUK.xml" )  ;text: "UK Stations";  value: "file://" +_app.homePath()+"/InternetRadioStationsModelUK.xml" }
            Option { id: option3; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelGermany.xml" )  ;text: "German Stations" ;value: "file://" +_app.homePath()+"/InternetRadioStationsModelGermany.xml" }
            Option { id: option4; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelFrance.xml" )  ;text: "French Stations" ;value: "file://" +_app.homePath()+"/InternetRadioStationsModelFrance.xml" }
            Option { id: option5; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelSpain.xml" )  ;text: "Spanish Stations";value: "file://" +_app.homePath()+"/InternetRadioStationsModelSpain.xml"  }
            Option { id: option6; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelCanada.xml" )  ;text: "Canadian Stations"; value: "file://" +_app.homePath()+"/InternetRadioStationsModelCanada.xml" }
            Option { id: option7; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelItalian.xml" )  ;text: "Italian Stations"; value: "file://" +_app.homePath()+"/InternetRadioStationsModelItalian.xml" }
            Option { id: option8;enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelUS.xml" )  ; text: "US Stations" ;value:"file://" +_app.homePath()+ "/InternetRadioStationsModelUS.xml" }
        }
    }
    Header {
        title: qsTr("Station List: ")+ stationListHeaderName 
        opacity: stationListShowing? 1: sleepTimerPopup?0:0
    }
    ListView{
        id: view
        visible:  customStationsView?true:false
        dataModel: _customStations.dataModel
        
        opacity: stationListShowing? nightMode?0.8:1.0: sleepTimerPopup?0:0
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        scrollRole: ScrollRole.Main
        function remove(indexPath) { _recentlyPlayed.removeFromJson(indexPath);}
        
        function sched(title, url){console.log("Recieved"+ title + url); scheduledRecModelStationURL=url; scheduledRecModelStationName=title; creator.createQMLObject("ScheduledRecording.qml")}
        scrollIndicatorMode: ScrollIndicatorMode.ProportionalBar
        layout: StackListLayout {
            headerMode: ListHeaderMode.Sticky
        }
        onTriggered: {
            
            var data = _customStations.dataModel.data(indexPath);
            if(data.url===""){}
            else{
                
                if(webRecordingActive){stopRecordingInternetRadio();}
                artView.imageSource=artView.defaultIMG();
                
                internetRadioSource= data.url;metaDataTitle= data.title ;
                metaDataBitRate="";player.play();             
        }
        }
        listItemComponents: [
            ListItemComponent {
                type: "header"
                Header {
                    visible: false
                }  
            },
            
            ListItemComponent {
                type: "item"
                
                Container {
                    id: rootListItemContainerr
                    property string pathIndex
                    property string title
                    property string urle
                    property string icon
                    function bob(){dio.show();}
                 
                StandardListItem {
                    contextActions:   ActionSet {
                        title:  ListItemData.title
                        subtitle: ListItemData.url
                        actions:[
                            ActionItem{
                                imageSource: "images/sched.png"
                                title:qsTr("Schedule Recording")
                                onTriggered: {rootListItemContainer.ListItem.view.sched(ListItemData.title, ListItemData.url); }
                            }
                        ]
                    }
                    
                    
                    title: ListItemData.title
                    description: ListItemData.url
                }     
            
                }
            }
        ]
    }
    ListView {
        visible: customStationsView?false:true
        opacity: stationListShowing? 1: sleepTimerPopup?0:0
        id: listView
        scrollRole: ScrollRole.Main
        function sched(title, url){console.log("Recieved"+ title + url); scheduledRecModelStationURL=url; scheduledRecModelStationName=title; creator.createQMLObject("ScheduledRecording.qml")}

        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        layout: StackListLayout {
            headerMode: ListHeaderMode.Sticky
        }
        dataModel: XmlDataModel {
            id: modelr
            source: modelURL
        }
        onTriggered: {
            var data= modelr.data(indexPath)
            if(data.url===""){}
            else{

            if(webRecordingActive){stopRecordingInternetRadio();}
            artView.imageSource=artView.defaultIMG();
             
             internetRadioSource= data.url;metaDataTitle= data.title;artWorkURI= data.image ;
             metaDataBitRate="";player.play();             
             //_app.openInternetRadioStation(data.url, data.title, data.image, data.backupUrl, data.comments, data.image, data.bitrate, data.fileFormat)
        }}
        listItemComponents: [
            ListItemComponent {
                type: "header"
                Header {
                    title:""
                }  
            },
            ListItemComponent {
                type: "item"
                
                Container {
                    id: rootListItemContainer
                    
                    
                    StandardListItem {
                        contextActions:   ActionSet {
                            title:  ListItemData.title
                            actions:[
                                ActionItem{
                                    imageSource: "images/sched.png"
                                    title:qsTr("Schedule Recording")
                                    onTriggered: {rootListItemContainer.ListItem.view.sched(ListItemData.title, ListItemData.url); }
                                },
                                ActionItem {
                                    title: "Use Alternative Stream"
                                    enabled: ListItemData.backupUrl===""?false:true
                                    imageSource: "images/internet_radio_icon.png"
                                    onTriggered: {
                                        if(ListItemData.url===""){}
                                        else{
                                            _app.openInternetRadioStation(ListItemData.backupUrl, ListItemData.title, ListItemData.image, ListItemData.backupUrl, ListItemData.comments, ListItemData.image, ListItemData.bitrate, ListItemData.fileFormat);
                                            console.log(ListItemData.url, ListItemData.title,  ListItemData.image, ListItemData.backupUrl, ListItemData.comments, ListItemData.image, ListItemData.bitrate, ListItemData.fileFormat);}
                                    }
                                }
                            ]
                        }
                        id: stationChangeListItem
                       /* attachedObjects: ImageDownloader {
                            id: imgDowner
                           // url:  ListItemData.image
                            onImageChanged: {                 
                                if (imgDowner.isVaid) {
                                    stationChangeListItem.image = imgDowner.image
                                }
                            }
                        }*/
                        
                        
                        title: ListItemData.title
                        description: ListItemData.comments
                      
                        status: ListItemData.bitrate
                    
                    }     
                
                }
            }
        ]
    }

    }
}
}
