import bb.cascades 1.4
import bb.system 1.2
import bb.platform 1.3
import bb.cascades.pickers 1.0
import bb.device 1.4
import timer 1.0

Sheet{
    id: settings
    property bool valueChanged:false
    onCreationCompleted: {
        open(); toggler.start();
    }
    attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true;toggler.destroy();}}

    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title:qsTr( "Internet Radio Settings")
            
            dismissAction: ActionItem {
                title: qsTr("Close") 
                onTriggered: {
                    close();settings.destroy();
                }

            }
        }
        ScrollView {
            id: scroller
            content: Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Center
                id: conter
                topPadding: 5
                bottomPadding: 5
                navigation.focusPolicy: NavigationFocusPolicy.Focusable            
                layout: StackLayout { }
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Download & Show Radio Station Images")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("internetRadioUseStationImage", "")===""?true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("internetRadioUseStationImage", "")==="false"){ appsettings.saveSystemSetting("internetRadioUseStationImage", "");  toast.showTextWithButton("Note: If a Station Image is not available a default Image will show in its place.", "Ok", "")}
                                else{ appsettings.saveSystemSetting("internetRadioUseStationImage", "false")}

                            
                            }
                            console.log(appsettings.getSystemSetting("internetRadioUseStationImage", ""))
                        }
                    }
                } 
                
                DropDown {
                    title: qsTr("Default Country")
                    onCreationCompleted: {
                        if(_app.checkRemoteFeature(_app.homePath() + "/AlternativeStationsEnabledCheck.txt")===false){remove(alt)}
                        if(appsettings.getSystemSetting("DefaultRadioListCountryIndex", "")==="")selectedIndex=0;
                        else{selectedIndex= parseInt(appsettings.getSystemSetting("DefaultRadioListCountryIndex", ""));}
                    }
                    onSelectedIndexChanged: {
                        appsettings.saveSystemSetting("DefaultRadioListCountry", selectedValue);
                        appsettings.saveSystemSetting("DefaultRadioListCountryIndex", selectedIndex);
                    }
                    Option {
                        text: qsTr("Last Selected Country")
                        value: text
                    }
                    Option {
                        text: qsTr("Custom Stations")
                        value: text
                    }
                    Option {
                        text:"Alternative Stations"
                        value: text
                        id: alt
                    }
                    Option {
                        text: "UK Stations"
                        value: text
                    }
                    Option {
                        text: "German Stations"
                        value: text
                    }
                    Option {
                        text: "French Stations"
                        value: text
                    }
                    Option {
                        text: "Spanish Stations"
                        value: text
                    }
                    Option {
                        text: "Canadian Stations"
                        value: text
                    }
                    Option {
                        text: "Italian Stations"
                        value: text
                    }
                    
                }
                Container {
                    
                    DropDown {
                        id: recordLocationDrop
                        onCreationCompleted: {if(appsettings.getSystemSetting("InternetRecordingLocationIndex", "")==="")selectedIndex=0
                        else selectedIndex= parseInt(appsettings.getSystemSetting("InternetRecordingLocationIndex", ""))
                        }
                        onSelectedIndexChanged: {
                            appsettings.saveSystemSetting("InternetRecordingLocation", selectedValue);
                            appsettings.saveSystemSetting("InternetRecordingLocationIndex", selectedIndex);
                        }
                        title: qsTr("Station Recording Location")
                        Option {
                            text: "Device Memory"
                            value: "/accounts/1000/shared/music/"
                            description: qsTr("Located in the Music Folder")

                        }
                        Option {
                            text: "SD Card"
                            value: "/accounts/1000/removable/sdcard/music/"
                            enabled: _app.checkSDCard()
                            description:qsTr( "Located in the Music Folder")
                            onCreationCompleted: {_app.dirCheckOrCreate(value);}
                        }
                    }
                }
                Container {
                    topPadding: 10
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Fill
                   Button{
                       color: Color.create(getAppColour())
                       text: qsTr("Clear Station Images")
                        onClicked: {
                            creator.createQMLObject("InternetRadioImagesClearDialog.qml")
                        }  
                    }
                }
         
            }
        }
    }
}
