import QtQuick 1.0
import bb.cascades 1.4
import bb.system 1.0

Sheet{
    id: sheet
    Page {
        id:page
        titleBar: TitleBar {
            title:  qsTr("Favourite Lyrics")

            dismissAction: ActionItem {
                title: "Close"
                onTriggered: {
                    sheet.close() 
                }
            }
        }
        attachedObjects: Connections {
            target:_app
            onCloseLyricsBookmarksPage:{sheet.close();}
        }

        actionBarVisibility: ChromeVisibility.Compact
        actions: [
            ActionItem {
                imageSource: "asset:///images/ic_to_bottom.png"
                enabled:  view.dataModel.size() > 0? true: false
                title:  qsTr("To Bottom")
                onTriggered: {
                    var dataModelSize = view.dataModel.size(); // or listViewId.dataModel.childCount(0)
                    if (dataModelSize > 0)
                    {
                        var lastRowNumber = dataModelSize - 1
                        view.scrollToItem([0, lastRowNumber], ScrollAnimation.Default);
                    }
                
                }  
            },
            ActionItem {
                title: qsTr("Delete All")
                imageSource: "images/ic_delete.png"
                ActionBar.placement: ActionBarPlacement.Signature
                enabled:true
                    //_lyricsBookmarks.m_dataModelLyrics.childCount(0)===0? false: true
                onTriggered: {creator.createQMLObject("FavouritesLyricsDeleteAllDialog.qml"); }
            }

        ]
        onCreationCompleted: {open();_lyricsBookmarks.updateLyricsBookmarksModel(); console.log(_lyricsBookmarks.m_dataModelLyrics.size()) }   
        
        
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: DockLayout {}
            bottomPadding: 90
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                Label {
                    visible:_lyricsBookmarks.m_dataModelLyrics.childCount(0) === 0 ? true : false
                    text:  qsTr("No Favourite Lyrics")
                    textStyle.color:brightTheme? Color.Black:  Color.White
                    opacity: nightMode ? 0.6 : 0.8
                    textStyle {
                        fontSize: FontSize.PointValue
                        fontSizeValue: 16
                        base: SystemDefaults.TextStyles.BigText
                    }
                }
            }
            ListView {
                scrollRole: ScrollRole.Main

                opacity: nightMode?0.8:1
                function remove(indexPath) { _lyricsBookmarks.removeFromJson(indexPath); }
                id: view
                dataModel: _lyricsBookmarks.m_dataModelLyrics
                scrollIndicatorMode: ScrollIndicatorMode.ProportionalBar
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            title: _lyricsBookmarks.m_dataModelLyrics.size() + " Favourite Lyrics"
                        }  
                    },
                    ListItemComponent {
                        type: "item"
                        
                        Container {
                            id: rootListItemContainer
                            property string pathIndex
                            property string title
                            property string urle
                            property string icon
                            function bob(){dio.show();}
                            function updateFav(indexPath, titlle, urrle, icone){
                                console.log(indexPath, titlle, urrle, icone)
                                pathIndex= indexPath.toString();
                                title= titlle;
                                urle= urrle;
                                icon= icone;
                                prompt.show();}
                            attachedObjects:[  SystemDialog{
                                    id: dio
                                    title: "Delete"
                                    body: "Delete Favourite?"
                                    buttonAreaLimit: 2
                                    confirmButton.label: qsTr("Yes")
                                    confirmButton.enabled: true
                                    cancelButton.label: qsTr("Cancel")
                                    cancelButton.enabled: true
                                    onFinished: {
                                        if(result == SystemUiResult.ConfirmButtonSelection) {_app.deleteFile(ListItemData.lyricsUrl);remove(rootListItemContainer.ListItem.view.remove(rootListItemContainer.ListItem.indexPath))
                                        }
                                        else if (result == SystemUiResult.CancelButtonSelection) {
                                            close();
                                        }
                                    }
                            }]
                        StandardListItem {
                            contextActions:   ActionSet {
                                title:  ListItemData.title
                                actions:[
                                    DeleteActionItem {
                                        imageSource: "images/ic_delete.png"
                                        title: qsTr("Delete Favourite")
                                        onTriggered: {rootListItemContainer.bob(); }
                                    }
                                ]
                            }
                            gestureHandlers: TapHandler {
                                property bool clicked:false
                                onTapped: {
                                    if(clicked===false){
                                    clicked=true;
                                _app.closeLyricsBookmarks();
                                   _lyricsBookmarks.lyricsBookmarksRequested(ListItemData.title, ListItemData.lyricsUrl, ListItemData.videoIconURL) }

                                }
                            }
                           
                            title: ListItemData.title
                          //  description: ListItemData.lyricsUrl
                            imageSource: ListItemData.videoIconURL                        
                        }     
                    
                        }
                    }
                ]
            }
        }
    
    }
}
