import QtQuick 1.0
import bb.cascades 1.4
import timer 1.0

Sheet {
    
    id: lyricss
    onCreationCompleted:{open();lyricsSearchOpen=true;if(appsettings.getSystemSetting("screenTimeoutLyrics", "")==="") {_app.setScreenIdle("KeepAwake")}
        console.log(lyricsSearchOpen)
        fileDelay.start()
 }
    onClosed: {
        lyricsSearchOpen=false;
        console.log(lyricsSearchOpen)
    }
 attachedObjects:[ Connections {
     target: mainnav
     onCloseLyrics:{ 
         console.log("Close requested")
         resultsModel.clear();
         lyricsOpen=false;
         lyricss.close();
     }
 },
 SystemTimer {
   id: fileDelay
   interval: 50
   onTimeout: {
    fileDelay.stop()
       if(fileSystemLyricsFound){fileSystemLyricsPopup();}

   }  
 },
 Connections {
     target:  _lyricsBookmarks
     onLyricsBookmarksRequested:{
         lyricsDataArtist="";
         lyricsURL="file:///"+lyricsurl;
         viewingOfflineLyrics=true;
         lyricsDataSong= title;
         console.log(lyricsurl)
         creator.createQMLObject("LyricsWebView.qml")}
 }
 
 ,
 Connections{
     target: _app
     onPlayerInvoked:{ console.log("Close requested")
         resultsModel.clear();
         lyricss.close();}
 }
]
function fileSystemLyricsPopup(){
creator.createQMLObject("FileSystemLyricsViewer.qml")
}
Page {
    id: page
    actionBarVisibility: ChromeVisibility.Compact
    actions:[ ActionItem {
            title:  qsTr("Favourites")
        ActionBar.placement: ActionBarPlacement.Signature
        imageSource: "asset:///images/ic_favorite.png"
        onTriggered: {
            creator.createQMLObject("LyricsFavourites.qml")
        }
    },
    ActionItem {
        id: local
        title:  qsTr("Local Lyrics")
      onCreationCompleted: {
          if(fileSystemLyricsFound===false)page.removeAction(local)
      }
      imageSource: "asset:///images/ic_search_blue.png"
      onTriggered: {
          fileSystemLyricsPopup();
      }  
    },
    ActionItem {
        imageSource: "asset:///images/ic_add_home.png"
        title: qsTr( "Add Lyrics Search to Home")
        ActionBar.placement: ActionBarPlacement.InOverflow
        onTriggered: {
            creator.createQMLObject("Custom/HSLyrics.qml")
        }  }]
    titleBar: TitleBar {
        appearance: TitleBarAppearance.Branded
        title: qsTr( "Search For Lyrics")
        dismissAction: ActionItem {
            title: ("Close") 
            onTriggered: {
                resultsModel.clear();
                close();
                lyricsOpen=false;
                if(mediaFormat==="Video"){_app.setScreenIdle("KeepAwake")}
                else{_app.setScreenIdle("Normal")}
            
            }
        }
    }
    attachedObjects: [Connections{target: _app; onNoResultsFound:{}  onActivityEnded:{ind.visible=false; ind.running=false; if(searchResultsListView.dataModel.empty)nofound.visible=true;}
    
    }
]
 
    property string lyricsWords
        Container {
            id: maincont
            layout: StackLayout { orientation: LayoutOrientation.TopToBottom }
            topPadding: 20
            rightPadding: 20
            leftPadding: 20
            bottomPadding: 20
            
            TextField {
                visible: connectionOnline? true:false
                opacity: nightMode?0.8:1
                id: songField
                text: metaDataTitle
                hintText: qsTr( "Song Title")
            }
            TextField {
                id: albumField
                visible: connectionOnline? true:false
                opacity: nightMode?0.8:1
                text: metaDataAlbum
                hintText: "Album"
            }
            TextField {
                visible: connectionOnline? true:false
                opacity: nightMode?0.8:1
                id: artistField
                hintText: qsTr( "Artist")
                text: metaDataArtist
                onTextChanged: {
                    warningLabel.visible=false
                }
            }
            Label {
                opacity: nightMode?0.8:1
                id: warningLabel
                text:  qsTr("Artist required")
                textStyle.color: Color.Red
                visible: false
            }
            Label {
                
                opacity: nightMode?0.8:1
                id: nofound
                textStyle.color: brightTheme? Color.Black: Color.White
                text:  qsTr("No Lyrics Found")
                

                visible:false
            }
   
            Button {
                color: Color.create(getAppColour())
                id: searchButton
                visible: connectionOnline? true:false
                opacity: nightMode?0.8:1
                text: qsTr( "Search")
                verticalAlignment: VerticalAlignment.Center
                horizontalAlignment: HorizontalAlignment.Center
                onClicked: {
                    if (artistField.text == "") {
                        warningLabel.visible = true;
                        return;
                    } else {
                        warningLabel.visible = false;
                    }
                    nofound.visible=false;
                    ind.visible=true;ind.running=true
                    var query = {};
                    query.song = songField.text;
                    query.album = albumField.text;
                    query.artist = artistField.text; 
                  _app.search(query);
                  
                }
            }
        
            
            
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                ActivityIndicator {
                    opacity: nightMode?0.8:1
                    preferredHeight: 150
                    preferredWidth: 150
                    id: ind
                    running: false
                    visible: false
                }
            }
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                id: noConn
                Label {
                    visible:connectionOnline? false:true
                    text:  qsTr("No Internet Access")
                    textStyle.color: brightTheme? Color.Black: Color.White
                    opacity: nightMode ? 0.6 : 0.8
                    textStyle {
                        fontSize: FontSize.PointValue
                        fontSizeValue: 16
                        base: SystemDefaults.TextStyles.BigText
                    }
                }
            }
            Button {
                color: Color.create(getAppColour())
                id: netSet
                opacity: nightMode?0.8:1

                horizontalAlignment: HorizontalAlignment.Center
                visible:connectionOnline? false:true
                text: qsTr( "Network Settings")
                onClicked: {_app.openNetworkSettingsScreen();
                }
            }
            ListView {
                visible: connectionOnline? true:false
                scrollRole: ScrollRole.Main

                opacity: nightMode?0.8:1

                function subtitleText(data) {
                    if (data.lyrics) {
                        if (data.lyrics.indexOf("\n") > -1) {
                            return data.lyrics.substring(0, data.lyrics.indexOf("\n")) + "...";
                            page.lyricsWords= data.lyrics
                        } else {
                            return data.lyrics;
                            page.lyricsWords= data.lyrics
                        }
                      
                    }
                }

                id: searchResultsListView
                objectName: "searchResultsListView"
                layout: StackListLayout { headerMode: ListHeaderMode.Sticky }
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
               dataModel:resultsModel
                listItemComponents: [
                    ListItemComponent {
                        type: "item"
                        Container {
                            id: itemContainer
                            StandardListItem {
                                title: ListItemData.song
                                description: itemContainer.ListItem.view.subtitleText(ListItemData)
                            }
                        }
                    }
                ]
                onTriggered: {
                    
                    var data = dataModel.data(indexPath);
                    page.lyricsWords= data.lyrics;
                    lyricsURL = data.url;
                   lyricsDataArtist= data.artist;
                   lyricsDataSong = data.song;
                   console.log("logged " +data.url);
                   lyricsEntryTitle= artistField.text+ " - "+ songField.text
                   creator.createQMLObject("LyricsWebView.qml")
           }
            }
            
           
        }
            
       
        }  

}