import bb.cascades 1.4
import bb.cascades.pickers 1.0
import timer 1.0

Sheet{
    id: settingslyrics
    onCreationCompleted: { open(); toggler.start(); }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title: qsTr( "Lyrics Search Settings")
            
            dismissAction: ActionItem {
               title:  qsTr("Close") 
                onTriggered: {
                    close();settingslyrics.destroy();
                }
            }
        }
        attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true;togglebutton3.enabled=true;toggler.destroy();}}
        ScrollView {
            id: scroller
            content: Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Center
                id: conter
                topPadding: 5
                bottomPadding: 5
                
                layout: StackLayout { }
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Search For Local Audio Lyrics")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton3
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("localLyricsSearch", "")===""? true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("localLyricsSearch", "")===""){ appsettings.saveSystemSetting("localLyricsSearch", "false")}
                                else{ appsettings.saveSystemSetting("localLyricsSearch", "")}
                            
                            }
                            console.log(appsettings.getSystemSetting("localLyricsSearch", ""))
                        }
                    }
                } 
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Keep Screen on when viewing Audio Lyrics")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("screenTimeoutLyrics", "")===""? true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("screenTimeoutLyrics", "")===""){ appsettings.saveSystemSetting("screenTimeoutLyrics", "false")}
                                else{ appsettings.saveSystemSetting("screenTimeoutLyrics", "")}
                            
                            }
                            console.log(appsettings.getSystemSetting("screenTimeoutLyrics", ""))
                        }
                    }
                } 
               /* Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Align Web Lyrics To Center")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton1
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("centerLyricText", "")===""? false:true
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("centerLyricText", "")===""){ appsettings.saveSystemSetting("centerLyricText", "true");toast.showText("Close And re-open Lyrics to take effect")}
                                
                                else{ appsettings.saveSystemSetting("centerLyricText", ""); toast.showText("Close And re-open Lyrics to take effect")}
                            
                            }
                            console.log(appsettings.getSystemSetting("centerLyricText", ""))
                        }
                    }
                } 
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Clear Web Lyrics Cache On Close")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton2
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("ClearLyricsCacheOnClose", "")===""? false:true
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("ClearLyricsCacheOnClose", "")==="true"){ appsettings.saveSystemSetting("ClearLyricsCacheOnClose", "");clearCacheOnClose=false}
                                
                                else{ appsettings.saveSystemSetting("ClearLyricsCacheOnClose", "true");clearCacheOnClose=true }
                            
                            }
                        }
                    }
                } */
                
                Container {
                    topPadding: 25
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    Button {
                        text:  qsTr("Clear Legacy Cache")
                        color: Color.create(getAppColour())
                        onClicked: {
                            _app.clearCache();
                            toast.showText( qsTr("Cache Cleared"))
                        }
                    }
                }
             
            
            }
        }
    }
}