
import bb.cascades 1.4
import timer 1.0
import QtQuick 1.0
Sheet {
    id: lyricsweb
    onClosed: { }
    function showLoadingLongMessage(){tooLongMessageCont.opacity=1;}
    function hideLoadingLongMessage(){tooLongMessageCont.opacity=0;}
    property bool fullscreen:false
    onCreationCompleted: {
        console.log("Lyrics  created")
        if(lyricsOpen===false){open();lyricsOpen=true}
 }
attachedObjects:[ SystemTimer {
    id: showTimer;
    interval: 800
    onTimeout: {
        
        webView.opacity=1
    }
    
}, 
Connections{
    target:mainnav
   onNightModeChanged:{webView.reload();}
    onCloseLyrics:{close();lyricsOpen=false;lyricsweb.destroy();}
},
SystemTimer{
    id:loadingToLongTimer
    interval: 50000
    onTimeout: {showLoadingLongMessage();loadingToLongTimer.stop();}
}]

Page {
    id: page
    actionBarVisibility: fullscreen? ChromeVisibility.Hidden : ChromeVisibility.Visible
        titleBar: TitleBar {
        appearance: TitleBarAppearance.Branded
        title:  qsTr("Lyrics")
        visibility: fullscreen?  ChromeVisibility.Hidden: ChromeVisibility.Visible 
        dismissAction: ActionItem {
            title:  qsTr("Close") 
            onTriggered: {close();lyricsOpen=false;viewingOfflineLyrics=false;lyricsweb.destroy();}
        }
    }
    property alias lyricsUrl: webView.url
    actions: [
        
        ActionItem {
            ActionBar.placement: ActionBarPlacement.Signature
            title:mediaPlaying? mediaPaused? "Play"  : "Pause" : "play"
            imageSource: mediaPlaying? mediaPaused? "images/ic_play.png" : "images/ic_pause.png" : "images/ic_play.png"
            onTriggered: {
                if(mediaPaused===true) playMedia()
                else pauseMedia();
            }
        },
        ActionItem {
          ActionBar.placement: ActionBarPlacement.OnBar
          imageSource: "asset:///images/full_screen.png"
          title:  qsTr("Fullscreen")
          onTriggered: {
              fullscreen=true;
              toast.showTextWithButton("Double Tap Screen To Return", "OK", "lyricsFullscreenNotif")
          }
        },
        
        ActionItem {
            title:  qsTr("Reload")
           ActionBar.placement: ActionBarPlacement.OnBar
            imageSource: "asset:///images/ic_reload.png"
            onTriggered: {webView.opacity=0; webView.reload()}
        },
        ActionItem {
            title:  qsTr("Increase Font Size")
            ActionBar.placement: ActionBarPlacement.InOverflow
            imageSource: "asset:///images/ic_increase.png"
            onTriggered: {webView.settings.defaultFontSize +=2}
        },
        ActionItem {
            title:  qsTr("Decrease Font Size")
            ActionBar.placement: ActionBarPlacement.InOverflow
            imageSource: "asset:///images/ic_decrease.png"
            onTriggered: {webView.settings.defaultFontSize -=2}
        },
        ActionItem {
            title:  qsTr("Lyrics Settings")
          onTriggered: {
              creator.createQMLObject("LyricsSettings.qml")
          }  
        },
        ActionItem {
            id:nm
            title: qsTr("Night Mode")
            enabled: true
            imageSource:nightMode? "asset:///images/night_active.png":"asset:///images/night.png"
            ActionBar.placement:ActionBarPlacement.InOverflow
            onTriggered: { if(nightMode===true){nightMode=false;toast.showText("Night Mode Disabled")}
            else{nightMode=true;toast.showText("Night Mode Enabled")}
                nightModeChanged();page.addAction(nms)}
        },
        ActionItem {
            id:nms
            title: qsTr("Night Mode Settings")
            imageSource:""
            ActionBar.placement:ActionBarPlacement.InOverflow
            onCreationCompleted: {
                if(nightMode===false)page.removeAction(nms)
            }
            onTriggered: {creator.createQMLObject("NightModeSettings.qml")}
        },
        ActionItem {
            id: addFav
            enabled: connectionOnline
            imageSource: "asset:///images/ic_add_bookmarks.png"
            title:  qsTr("Add To Offline Favourites")
            onCreationCompleted: {
                if(viewingOfflineLyrics)page.removeAction(addFav);
            }
            onTriggered: {
                requestedDownloadURL= webView.url;
                creator.createQMLObject("LyricsDownloader.qml")
            }
        }
  
    ]
    
    Container {
        layout: DockLayout {}
        bottomPadding:fullscreen? 0 :40
        gestureHandlers: DoubleTapHandler {
            onDoubleTapped: {
                fullscreen=false;
            }
        }
        ScrollView {
            scrollRole: ScrollRole.Main
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            id: scrollView
            objectName: "scrollView"
            scrollViewProperties {
                scrollMode: ScrollMode.Vertical
                pinchToZoomEnabled: false
            }
            
            WebView {
                id: webView
                opacity: 0
                shareImageAction.enabled: false
                saveImageAction.enabled: false
                shareTextAction.enabled: true
                property bool centered:appsettings.getSystemSetting("centerLyricText", "")===""?false:true
                url: lyricsURL
                settings.credentialAutoFillEnabled: false
                openLinkInNewTabAction.enabled: false
                settings.imageDownloadingEnabled: false
                settings.cookiesEnabled: false
                settings.binaryFontDownloadingEnabled: false
                settings.webInspectorEnabled: false
                settings.userAgent: "Mozilla/5.0 (Windows NT 6.3; WOW64; rv:46.0) Gecko/20100101 Firefox/46.0"
                onMessageReceived: {
                  //globalBob= message.data
                //   console.log(message.data)
                   // creator.createQMLObject("test.qml")
                }

 
                onLoadingChanged: {
              
                    if (loadRequest.status == WebLoadStatus.Started) {
                        progressCont.show();
                        loadingToLongTimer.start();
                    } else if (loadRequest.status == WebLoadStatus.Succeeded) {
                        
                        loadingToLongTimer.stop();
                        if(brightTheme){
                            if(centered){
                                webView.evaluateJavaScript(
                                "var content = document.getElementById('mw-content-text');" +
                                "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                                "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                                "var header = document.createElement('h1');" + 
                                "header.style.textAlign = ('center'); "+
                                "header.style.color = ('black');"+
                                "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                                "document.body.appendChild(header);" + 
                                "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                                "document.body.appendChild(lyrics);"+
                                "lyrics.style.textAlign = ('center'); "+
                                "lyrics.style.color = ('black');"+
                                "document.body.style.background = ('white');"
                                );
                                showTimer.start();
                            
                            
                            }
                            else{
                                webView.evaluateJavaScript(
                                "var content = document.getElementById('mw-content-text');" +
                                "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                                "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                                "var header = document.createElement('h1');" + 
                                "header.style.color = ('black');"+
                                "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                                "document.body.appendChild(header);" + 
                                "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                                "document.body.appendChild(lyrics);"+
                                "lyrics.style.color = ('black');"+
                                "document.body.style.background = ('white');" + 
                                "navigator.cascades.postMessage(lyrics.innerHTML);"
                                );
                                //"var bob = lyrics.innerHTML;" +
                                
                                //  "alert(bob);"
                                showTimer.start();
                            }
                            
                        }
                        else{
                        
                     if(centered){
                        webView.evaluateJavaScript(
                        "var content = document.getElementById('mw-content-text');" +
                        "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                        "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                        "var header = document.createElement('h1');" + 
                        "header.style.textAlign = ('center'); "+
                        "header.style.color = ('white');"+
                        "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                        "document.body.appendChild(header);" + 
                        "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                        "document.body.appendChild(lyrics);"+
                      "lyrics.style.textAlign = ('center'); "+
                        "lyrics.style.color = ('white');"+
                        "document.body.style.background = ('black');"
                        );
                      showTimer.start();
                      

                    }
                     else{
                         webView.evaluateJavaScript(
                         "var content = document.getElementById('mw-content-text');" +
                         "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                         "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                         "var header = document.createElement('h1');" + 
                         "header.style.color = ('white');"+
                         "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                         "document.body.appendChild(header);" + 
                         "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                         "document.body.appendChild(lyrics);"+
                         "lyrics.style.color = ('white');"+
                         "document.body.style.background = ('black');" + 
                         "navigator.cascades.postMessage(lyrics.innerHTML);"
                         );
                       //"var bob = lyrics.innerHTML;" +
                         
                     //  "alert(bob);"
                         showTimer.start();
                     }
                 }
                     progressCont.hide();
                     hideLoadingLongMessage();
                 }
                    
                else if(loadRequest.status == WebLoadStatus.Failed){
                        progressCont.hide();
                        hideLoadingLongMessage();
                        if(brightTheme){
                            if(centered){
                                webView.evaluateJavaScript(
                                "var content = document.getElementById('mw-content-text');" +
                                "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                                "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                                "var header = document.createElement('h1');" + 
                                "header.style.textAlign = ('center'); "+
                                "header.style.color = ('black');"+
                                "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                                "document.body.appendChild(header);" + 
                                "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                                "document.body.appendChild(lyrics);"+
                                "lyrics.style.textAlign = ('center'); "+
                                "lyrics.style.color = ('black');"+
                                "document.body.style.background = ('white');"
                                );
                                showTimer.start();
                            
                            
                            }
                            else{
                                webView.evaluateJavaScript(
                                "var content = document.getElementById('mw-content-text');" +
                                "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                                "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                                "var header = document.createElement('h1');" + 
                                "header.style.color = ('black');"+
                                "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                                "document.body.appendChild(header);" + 
                                "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                                "document.body.appendChild(lyrics);"+
                                "lyrics.style.color = ('black');"+
                                "document.body.style.background = ('white');" + 
                                "navigator.cascades.postMessage(lyrics.innerHTML);"
                                );
                                //"var bob = lyrics.innerHTML;" +
                                
                                //  "alert(bob);"
                                showTimer.start();
                            }
                        
                        }
                        else{
                        
                        if(centered){
                            webView.evaluateJavaScript(
                            "var content = document.getElementById('mw-content-text');" +
                            "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                            "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                            "var header = document.createElement('h1');" + 
                            "header.style.color = ('white');"+
                            "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                            "document.body.appendChild(header);" + 
                            "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                            "document.body.appendChild(lyrics);"+
                            "lyrics.style.textAlign = ('center'); "+
                            "lyrics.style.color = ('white');"+
                            "document.body.style.background = ('black');"
                            );
                            showTimer.start();
                        
                        }
                        else{
                            webView.evaluateJavaScript(
                            "var content = document.getElementById('mw-content-text');" +
                            "while (document.head.firstChild) { document.head.removeChild(document.head.firstChild); }" +
                            "while (document.body.firstChild) { document.body.removeChild(document.body.firstChild); }" +
                            "var header = document.createElement('h1');" + 
                            "header.style.color = ('white');"+
                            "header.innerHTML = '" +  lyricsDataArtist+ " " +  lyricsDataSong + " Lyrics';" + 
                            "document.body.appendChild(header);" + 
                            "var lyrics = content.getElementsByClassName('lyricbox')[0];" +
                            "document.body.appendChild(lyrics);"+
                            "lyrics.style.color = ('white');"+
                            "document.body.style.background = ('black');"
                            );
                            showTimer.start();
                        }
                        
                    }
                    }
                }
               
            }
        }
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            opacity: nightModeOverLayBrightness
            background: Color.Black
            overlapTouchPolicy: OverlapTouchPolicy.Allow
            visible: nightModeOverLay? nightMode?true:false: false
        }
        
        Container {
            function show() {opacity=1.0;activity1.start();}
            function hide () {opacity=0; activity1.stop();}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        background: brightTheme? Color.White: Color.Black
        id: progressCont
        opacity: 0
        layout: DockLayout {}
        Container {
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
        
        ActivityIndicator {
            id: activity1
            visible: true
            running: true
            minHeight: 150
            minWidth: 150   
        }
    }
        Container {
            id: tooLongMessageCont
            opacity: 0
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            topPadding: 200
            Label{
                text: qsTr( "This is taking longer than expected...")
                textStyle{
                    color: Color.White
                    
                }
                
            }        }
        }
    }
}
}