import bb.cascades 1.4
import timer 1.0
import bb.system 1.0


Sheet {
    id: proxysheet
    property bool finished
    property bool valueChanged:false
    onCreationCompleted: {open();toggler.start();}
    attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true;toggler.destroy();}}

   content: Page {
       titleBar: TitleBar {
           appearance: TitleBarAppearance.Branded
           title: qsTr( "Proxy Settings")
           
           dismissAction: ActionItem {
               title: "Close"
               onTriggered: {
                   if(valueChanged===true){ toast.showTextWithButton( qsTr("Please restart Star Player to Apply saved changes"), "OK", "restart")}
               
                   close();proxysheet.destroy();
               }
           }
       }
       
            ScrollView {
                Container {
                    layout: StackLayout {
                        
                    }
            Container {
                topPadding: 10; leftPadding: 15;rightPadding: 20
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                Label {
                    opacity: nightMode?0.8:1
                    text: qsTr("Network Proxy")
                    verticalAlignment: VerticalAlignment.Center
                    horizontalAlignment: HorizontalAlignment.Left
                    textStyle {
                        base: SystemDefaults.TextStyles.BodyText
                        fontSize: FontSize.PointValue
                        fontSizeValue: miniSquareDevice?7:8
                    }
                }
                
                ToggleButton {
                    opacity: nightMode?0.8:1
                    enabled: false
                    id: togglebutton
                    horizontalAlignment: HorizontalAlignment.Right
                    checked:appsettings.getSystemSetting("proxyEnabled", "false");
                    onCheckedChanged: {
                        if(finished===false){console.log("Denied checked changed");}
                 else{
                     if(appsettings.getSystemSetting("proxyEnabled", "false")==="true"){
                         appsettings.saveSystemSetting("proxyEnabled", "false"); valueChanged=true;
                     }
                     else{appsettings.saveSystemSetting("proxyEnabled", "true"); valueChanged=true;
 
                 }
                    }
                }
            }  
        }
        TextField {
            opacity: nightMode?0.8:1
            id: hostfield
            horizontalAlignment: HorizontalAlignment.Fill
            clearButtonVisible: true
            text: appsettings.getSystemSetting("proxyHostName", "")
            inputMode: TextFieldInputMode.Text
            hintText: qsTr("Host Name")
            onTextChanged: {
                appsettings.saveSystemSetting("proxyHostName",text);
                if(finished){valueChanged=true;}
            }
        }
        TextField {
            opacity: nightMode?0.8:1
            id: usernamefield
            horizontalAlignment: HorizontalAlignment.Fill
            clearButtonVisible: true
            text: appsettings.getSystemSetting("proxyUser", "")
            inputMode: TextFieldInputMode.Text
            hintText: qsTr("Username")
            onTextChanged: {
                appsettings.saveSystemSetting("proxyUser",text);
                if(finished){valueChanged=true;}

            }
        }
        TextField {
            opacity: nightMode?0.8:1
            id: passwordfield
            horizontalAlignment: HorizontalAlignment.Fill
            clearButtonVisible: true
            text: appsettings.getSystemSetting("proxyPassword", "")
            inputMode: TextFieldInputMode.Password
            hintText: qsTr("Password")
            onTextChanged: {
                appsettings.saveSystemSetting("proxyPassword",text);
                if(finished){valueChanged=true;}

            }
        }
            TextField {
                opacity: nightMode?0.8:1
                hintText: qsTr( "Proxy Port")
                id: portfield
                horizontalAlignment: HorizontalAlignment.Fill
                clearButtonVisible: true
                text: appsettings.getnetworkProxyPort();
                inputMode: TextFieldInputMode.PhoneNumber
                onTextChanged: {
                    appsettings.setNetworkProxyPort(text);
                    if(finished){valueChanged=true;}

                }
            }
            Container{
                topPadding: 10
                horizontalAlignment: HorizontalAlignment.Center
            Label {
                opacity: nightMode?0.8:1
                text:  qsTr("Changes take effect after Star Player has closed.")
                 multiline: true
                 
            }
        }
    }
}
    }
}