import bb.system 1.0
import bb.cascades 1.0
import timer 1.0

Container {
    id: cont
    onCreationCompleted: {dio.show(); closeTimer.start();}
    
    attachedObjects: [
        SystemTimer{
            id: closeTimer;
            interval: 300000
            onTimeout: {
                dio.cancel(); cont.destroy(1000);
            }
        },
        
        SystemDialog{
            id: dio
            
            title:  qsTr("New Announcement")
            body:  qsTr("There is a new Star Player Announcement available!")
            buttonAreaLimit: 2
            confirmButton.label: qsTr("Show")
            confirmButton.enabled: true
            cancelButton.label: qsTr("Announcement Settings")
            cancelButton.enabled: true
            
            customButton.enabled: true
            customButton.label: qsTr("Hide")
            onFinished: {
                if(result == SystemUiResult.ConfirmButtonSelection) {dio.cancel(); cont.destroy(1000); creator.createQMLObject("Announcements.qml");}
                else if (result == SystemUiResult.CancelButtonSelection) {
                    creator.createQMLObject("AnnouncementSettings.qml")
                    dio.cancel();cont.destroy(1000);
                }
                else if(result== SystemUiResult.CustomButtonSelection){
                    dio.cancel();cont.destroy(1000);
                }
            }
        }]
}