import bb.cascades 1.4
import bb.cascades.pickers 1.0
import timer 1.0

Sheet{
id: settingsnm
onCreationCompleted: {
open(); toggler.start();
}
property bool finished:false
content:Page {
titleBar: TitleBar {
appearance: TitleBarAppearance.Branded
title:  qsTr("Night Mode Settings")

dismissAction: ActionItem {
    title:  qsTr("Close") 
onTriggered: {
close();settingsnm.destroy();
}

}

}
attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true;togglebutton3.enabled=true; toggler.destroy();}}
ScrollView {
id: scroller
content: Container {
horizontalAlignment: HorizontalAlignment.Fill
verticalAlignment: VerticalAlignment.Center
id: conter
topPadding: 5
bottomPadding: 5

layout: StackLayout { }
Container {
    
    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    Label {
        opacity: nightMode?0.8:1
        text: qsTr("Ask to enable Night Mode when it's late")
        verticalAlignment: VerticalAlignment.Center
        horizontalAlignment: HorizontalAlignment.Left
        textStyle {
            base: SystemDefaults.TextStyles.BodyText
            fontSize: FontSize.PointValue
            fontSizeValue: device768?6.5: miniSquareDevice?7:8
        }
    }
    
    ToggleButton {
        opacity: nightMode?0.8:1
        enabled: false
        id: togglebutton3
        horizontalAlignment: HorizontalAlignment.Right
        checked:appsettings.getSystemSetting("nightModeTimeCheck", "")===""? true:false
        onCheckedChanged: {
            if(finished===false){console.log("Denied checked changed");}
            else if (finished===true){
                if(appsettings.getSystemSetting("nightModeTimeCheck", "")===""){ stopNightModeTimeChecker();  }
                else{startNightModeTimeChecker()}
            
            }
        }
    }
} 
Container {
    
    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    Label {
        opacity: nightMode?0.8:1
        text: qsTr("Overlay Videos/Lyrics")
        verticalAlignment: VerticalAlignment.Center
        horizontalAlignment: HorizontalAlignment.Left
        textStyle {
            base: SystemDefaults.TextStyles.BodyText
            fontSize: FontSize.PointValue
            fontSizeValue:  device768?6.5:miniSquareDevice?7:8
        }
    }
    
    ToggleButton {
        opacity: nightMode?0.8:1
        enabled: false
        id: togglebutton
        horizontalAlignment: HorizontalAlignment.Right
        checked:nightModeOverLay
        onCheckedChanged: {
            if(finished===false){console.log("Denied checked changed");}
            else if (finished===true){if(nightModeOverLay===true){nightModeOverLay=false;appsettings.saveSystemSetting("nightModeOverLay", "false")}
            else{nightModeOverLay=true; appsettings.saveSystemSetting("nightModeOverLay", "");}
            
            }
        }
    }
  
}  
Container {
    leftPadding: 20;rightPadding: 20; topPadding: 15
    layout: DockLayout {}
    opacity: nightModeOverLay?1:0
    minHeight: nightModeOverLay?120:0
    horizontalAlignment: HorizontalAlignment.Fill
    Label {
        opacity: nightMode?0.8:1
        text: qsTr("Overlay Darkness:")
        verticalAlignment: VerticalAlignment.Top
        horizontalAlignment: HorizontalAlignment.Left
        textStyle {
            base: SystemDefaults.TextStyles.BodyText
            fontSize: FontSize.PointValue
            fontSizeValue: 7
        }
    }
    Label {
        opacity: nightMode?0.8:1
        text:Math.round(nightModeOverLayBrightness*100)+ "%"
        verticalAlignment: VerticalAlignment.Top
        horizontalAlignment: HorizontalAlignment.Right
        textStyle {
            base: SystemDefaults.TextStyles.BodyText
            fontSize: FontSize.PointValue
            fontSizeValue: 6
        }
    }
    Slider {
        opacity: nightMode?0.8:1
        id:slider
        verticalAlignment: VerticalAlignment.Bottom
        horizontalAlignment: HorizontalAlignment.Fill
        value: nightModeOverLayBrightness
        toValue:0.85
        fromValue: 0.2
        onValueChanged: {nightModeOverLayBrightness=slider.immediateValue;appsettings.saveSystemSetting("nightModeOverLayBrightness", immediateValue)}
    }
}
Container {
    opacity: nightModeOverLay?1:0
    minHeight: nightModeOverLay?120:0
    topPadding: 15
DropDown {
    onCreationCompleted: {
        if(appsettings.getSystemSetting("videoOverlayValueIndex", "")==="")selectedIndex=0
        else{
            selectedIndex= parseInt(appsettings.getSystemSetting("videoOverlayValueIndex", ""));
        }
    }
    onSelectedIndexChanged: {
        if(expanded){
            if(selectedIndex===0){ videoOverlayValue= selectedValue;appsettings.saveSystemSetting("videoOverlayValue", selectedValue)}
            else if(selectedIndex===1){creator.createQMLObject("CustomOverlayColourSelector.qml")}
            else if(selectedIndex===2){videoOverlayValue= selectedValue;appsettings.saveSystemSetting("videoOverlayValue", selectedValue)}
            else if(selectedIndex===3){videoOverlayValue= selectedValue;appsettings.saveSystemSetting("videoOverlayValue", selectedValue)}
            else if(selectedIndex===4){videoOverlayValue= selectedValue;appsettings.saveSystemSetting("videoOverlayValue", selectedValue)}
            else if(selectedIndex===5){videoOverlayValue= selectedValue;appsettings.saveSystemSetting("videoOverlayValue", selectedValue)}
            else if(selectedIndex===6){videoOverlayValue= selectedValue;appsettings.saveSystemSetting("videoOverlayValue", selectedValue)}
            appsettings.saveSystemSetting("videoOverlayValueIndex", selectedIndex);


            
        }
    }
    title: "Overlay Colour"
    Option {text: "Default"; value: "#000000" }
    Option {text: "Custom"; value: "custom" }
    Option {text: "Dim Grey"; value: "#696969" }
    Option { text: "Red"; value: "#FF0000"}
    Option {text: "Lower Blue Gradient"; value: "#efc0a0" }
    Option {text: "Green"; value: "#008000" }
    Option {text: "Brown"; value: "#663300" }

}
}
Container {
    opacity: nightModeOverLay? 1:0
    verticalAlignment: VerticalAlignment.Fill
    topMargin: 10
    horizontalAlignment: HorizontalAlignment.Center
    
    Button {
        color: Color.create(getAppColour())
        opacity: nightMode?0.8:1
        text: qsTr( "Reset Overlay Darkness")
        onClicked: {
            nightModeOverLayBrightness=0.4; appsettings.saveSystemSetting("nightModeOverLayBrightNess", nightModeOverLayBrightness)
        }
    }
}


}
}
}
}