import QtQuick 1.0
import bb.cascades 1.4
import bb.system 1.0

Sheet{
    id: sheet
    Page {
        id:page
        titleBar: TitleBar {
            title:  qsTr("Pinned Media")
            
            dismissAction: ActionItem {
                title:  qsTr("Close")
                onTriggered: {
                    sheet.close() 
                }
            }
        
        }
        actionBarVisibility: ChromeVisibility.Compact

        
        actions: [
            
            ActionItem {
                title: qsTr( "Delete All")
                imageSource: "images/ic_delete.png"
                ActionBar.placement: ActionBarPlacement.Signature
                enabled:_pinnedVideos.dataModel.childCount(0)===0? false: true
                onTriggered: {
                    creator.createQMLObject("PinnedDeleteAllDialog.qml");                
                }
            },
            ActionItem {
                title: "Settings"
                ActionBar.placement: ActionBarPlacement.OnBar

                onTriggered: {
                    creator.createQMLObject("PinnedMediaSettings.qml")
                }
            }
        ]
        onCreationCompleted: {
            open(); console.log(_pinnedVideos.dataModel.childCount(0))
        }   
        
        
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: DockLayout {}
         
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                Label {
                    visible:_pinnedVideos.dataModel.childCount(0) === 0 ? true : false
                    text:  qsTr("No Pinned Media")
                    textStyle.color:brightTheme? Color.Black: Color.White
                    opacity: nightMode ? 0.6 : 0.8
                    textStyle {
                        fontSize: FontSize.PointValue
                        fontSizeValue: 16
                        base: SystemDefaults.TextStyles.BigText
                    }
                }
            }
            ListView {
                function remove(indexPath) {
                    _pinnedVideos.removeFromJson(indexPath);  pinnedCount= _pinnedVideos.dataModel.size()
                }
                scrollRole: ScrollRole.Main

                id: view
                dataModel: _pinnedVideos.dataModel
                scrollIndicatorMode: ScrollIndicatorMode.ProportionalBar
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            title: _pinnedVideos.dataModel.size() + qsTr( " Pinned Item(s)")
                        }  
                    },
                    ListItemComponent {
                        type: "item"
                        
                        Container {
                            id: rootListItemContainer
                            property string pathIndex
                            property string title
                            property string urle
                            property string icon
                            function bob(){dio.show();}

                            attachedObjects:[  SystemDialog{
                                    id: dio
                                    title:  qsTr("Pinned Item")
                                    body: qsTr( "Remove Pinned Item ") +"(" + ListItemData.videoTitle +") ?"
                                    buttonAreaLimit: 2
                                    confirmButton.label: qsTr("Yes")
                                    confirmButton.enabled: true
                                    cancelButton.label: qsTr("Cancel")
                                    cancelButton.enabled: true
                                    onFinished: {
                                        if(result == SystemUiResult.ConfirmButtonSelection) {if(_app.checkFileSandboxed(ListItemData.artWork)==true){;var u= ListItemData.artWork.replace("file://", "");_app.deleteFile(u)}; remove(rootListItemContainer.ListItem.view.remove(rootListItemContainer.ListItem.indexPath))
                                        }
                                        else if (result == SystemUiResult.CancelButtonSelection) {
                                            close();
                                        }
                                    }
                            }
                          ]
                        StandardListItem {
                            contextActions:   ActionSet {
                                title:  ListItemData.videoTitle
                                subtitle: ListItemData.videoURL
                                actions:[
                                    DeleteActionItem {
                                        imageSource: "images/ic_delete.png"
                                        title: qsTr("Remove Pinned Item")
                                        onTriggered: {rootListItemContainer.bob(); }
                                    }
                                
                                ]
                            }
                            status: ListItemData.videoDuration

                            title: ListItemData.videoTitle
                            description: ListItemData.itemType==="Playlist"? "": ListItemData.videoURL
                            imageSource: ListItemData.artWork
                        
                        }     
                    
                        }
                    }
                ]
            }
        }
    
    }
}
