import QtQuick 1.0
import bb.cascades 1.4
import bb.multimedia 1.4
import timer 1.0
import bb.cascades.pickers 1.0
import bb.system 1.2
import "Custom"
import AppSettings 1.0
import bb.device 1.3

Page {
    property bool showPlaylist:false
    onActionMenuVisualStateChanged: {vol.update();}
    Component.onDestruction: {console.log("PLAYER DESTROYED")}
     id: page
     shortcuts: [
         Shortcut {
             key: qsTr("i")
             onTriggered: { _app.increaseMediaVolume();}
         },
         Shortcut {
             key: qsTr("d")
             onTriggered: {_app.decreaseMediaVolume();}
         
         }
     ]
     property bool shuffling
     property bool changeButtonsEnabled:true
     property int audioBufferProgress
     property int duratione: 1
     property bool sleepTimerPopup:false
     property bool videoDimensionsChanged:false
     property double changedVideoScale
     property int stoppedProgress
     property int positione: 1
     property double playerVolume: 0.0
     property string eqName:appsettings.getSystemSetting("EQValueName", "Off")
     property bool showControls: true
     property int minutes: Math.floor(positione/1000/60)
     property int seconds: Math.floor(positione/1000%60)
     property bool alreadyRecentlyAdded:false
 

     function playPauseMedia(){ if(mainnav.playbackCompleted){player.play();if(fadeInAudio===true){volFade.start();} else{playerVolume=1.0} playbackEndedCont.hide();}
     else  if(player.mediaState==2){player.pause(); fancyInd.show("Pause");}
     else if(player.mediaState==3){player.play();fancyInd.show("Play");if(fadeInAudio===true){volFade.start();} }
     else if(player.mediaState==4){ player.seekTime(videoProgress);player.play(); player.play();fancyInd.show("Play");}
     }
     function rewindPosition(){
     var pos= player.position;
          pos-=rewindInterval;
         player.seekTime(pos);
         
     }
     function forwardPosition(){
         var pos= player.position;
         pos+=forwardInterval;
         player.seekTime(pos);
     }
     property int propertyToSaveIndexPathAsNumber
     function nextTrack(){
        /* if(playlistMode){
             if(shuffleMode){propertyToSaveIndexPathAsNumber= Math.random() * (playQueue.size()-1)
              //   console.log(propertyToSaveIndexPathAsNumber)
                 var bob= propertyToSaveIndexPathAsNumber
                 console.log(globalIndexPath)
                 console.log(playQueue.after(globalIndexPath))
                 console.log(propertyToSaveIndexPathAsNumber)
                 console.log(bob)
                 
                 //console.log(bob)
               playListView.triggered(playQueue.after(bob));
                 
             }
             
            // */
             
            console.log(globalIndexPath);playListView.triggered(playQueue.after(globalIndexPath))
      
         }
     function previousTrack(){ 
         if(playlistMode){playListView.triggered(playQueue.before(globalIndexPath))}

    }
    property string originalFileType
    property string originalFileTypeNew

     function checkForFileLyrics(){
         if(appsettings.getSystemSetting("localLyricsSearch", "")===""){
         console.log("Original File Type: "+getFileType(originalSource))
         originalFileType= getFileType(originalSource)
         originalFileTypeNew= originalSource.replace(originalFileType, "")
         console.log("CUT " + originalFileTypeNew)
        if( _app.checkFileExists(originalFileTypeNew + "txt")){
            console.log("File Found");
            fileSystemLyrics=_app.tester(originalFileTypeNew + "txt")
            lyrcs.setImageSource("asset:///images/ic_search_blue.png");
            fileSystemLyricsFound=true;
        }
        else{

        }
         
}
     }
     
     /*function nextTrack(){
         
         if(playlistMode){
             console.log("Index Path int before add" + propertyToSaveIndexPathAsNumber)
             
             if(shuffleMode){propertyToSaveIndexPathAsNumber= Math.random() * (_playlist.dataModell.size() - 1)}
             else{propertyToSaveIndexPathAsNumber++}
             
             console.log("Index Path int after add " + propertyToSaveIndexPathAsNumber)
             var data = _playlist.dataModell.data(["0", propertyToSaveIndexPathAsNumber])
             console.log(data.videoTitle)
             console.log(data.videoURL); playListView.triggered(["0", propertyToSaveIndexPathAsNumber])}}
     function previousTrack(){ 
         if(playlistMode){
             console.log("Index Path int before add" + propertyToSaveIndexPathAsNumber)
             if(shuffleMode){propertyToSaveIndexPathAsNumber= Math.random() * (_playlist.dataModell.size() - 1)}
             else{propertyToSaveIndexPathAsNumber--}
             console.log("Index Path int after add " + propertyToSaveIndexPathAsNumber)
             var data = _playlist.dataModell.data(["0", propertyToSaveIndexPathAsNumber])
             console.log(data.videoTitle)
             console.log(data.videoURL);playListView.triggered(["0", propertyToSaveIndexPathAsNumber])}}
     */
     
     
     function checkForFileSubtitles(){
             console.log("Original File Type: "+getFileType(originalSource))
             originalFileType= getFileType(originalSource)
             originalFileTypeNew= originalSource.replace(originalFileType, "")
             console.log("CUT " + originalFileTypeNew)
             if( _app.checkFileExists(originalFileTypeNew + "scc")){
                 console.log("File Found" + originalFileTypeNew + "scc");
                 console.log("MEDIA PLAYER TRACK: " + player.track)
                 player.setClosedCaptionIndex("file://"+originalFileTypeNew + "scc")
                 player.setClosedCaptionUrl(1, "file://"+originalFileTypeNew + "scc")
                 player.setClosedCaptionEnabled(true);
                 
               }
             else{
             console.log("No File SubTitles found")
             }
         
         
     }
     property int pwidth

    
     
     function autoVideoResize(){
         console.log("Auto Resize Function Fired")
     
         if(autoResizeAttempted===false){
             autoResizeAttempted=true;
             if(thumbnailed===false){
             if(mediaFormat==="Video") {
                 if(appsettings.getSystemSetting("autoVideoResize", "")===""){
                     console.log("Auto Resize Function Setting Correct")
                     if(OrientationSupport.orientation == UIOrientation.Portrait) {
                         console.log("Portrait")
                         if(customPickerUsed===false){
                         player.pause(); player.play(); }
                         //this is needed to make the MediaPlayer actually give me the width, yeah BB really broke it that badly
                         
                        
                         
                       
                         if(customPickerUsed){fwcVideoSurface.scaleX = _app.screenWidth() / metaDataWidth;}
                         else fwcVideoSurface.scaleX = _app.screenWidth() / player.videoDimensions.width;


                         fwcVideoSurface.scaleY = fwcVideoSurface.scaleX;
                         fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleX;
                         fwcVideoSurface.initialScale=fwcVideoSurface.scaleX;
                        
                         //attempt to stop the stupid blackscreen when fails to get width/height
                         if(metaDataWidth===0){fwcVideoSurface.newScaleVal=1.0;fwcVideoSurface.initialScale=1.0;}
                         //attempt to stop the stupid blackscreen when fails to get width/height
                         else{
                         
                         
                         
                          if (fwcVideoSurface.scaleY * player.videoDimensions.height > _app.screenHeight()) {
                              if(customPickerUsed){ fwcVideoSurface.scaleY = _app.screenHeight() / metaDataHeight;}
                              
                              else fwcVideoSurface.scaleY = _app.screenHeight() / player.videoDimensions.height;
                             fwcVideoSurface.scaleX = fwcVideoSurface.scaleY;
                             
                             fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleY;
                             fwcVideoSurface.initialScale=fwcVideoSurface.scaleY;
                         }
                     
                         else{ fwcVideoSurface.newScaleVal=1.0;fwcVideoSurface.initialScale=1.0; }}

                         
                         console.log("scale should have changed");
                         videoDimensionsChanged = true;
                         changedVideoScale = fwcVideoSurface.newScaleVal;
                         console.log("Changed Scale " + changedVideoScale);
                     }
                     if(OrientationSupport.orientation == UIOrientation.Landscape) {
                         console.log("Landscape")
                         if(customPickerUsed){player.pause(); player.play(); }
                         //this is needed to make the MediaPlayer actually give me the width, yeah BB really broke it that badly
                         
                         if(player.videoDimensions.width===0){fwcVideoSurface.newScaleVal=1.0;fwcVideoSurface.initialScale=1.0;}
                         //attempt to stop the stupid blackscreen when fails to get width/height
                         else{
                       
                             if(customPickerUsed){fwcVideoSurface.scaleX = _app.screenHeight() / metaDataHeight;}
                             else fwcVideoSurface.scaleX = _app.screenHeight() / player.videoDimensions.height;
                         
                         fwcVideoSurface.scaleX = _app.screenHeight() / player.videoDimensions.height;
                         fwcVideoSurface.scaleY = fwcVideoSurface.scaleX;
                         fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleX;
                         fwcVideoSurface.initialScale=fwcVideoSurface.scaleX;
                         
                         if (fwcVideoSurface.scaleY * player.videoDimensions.width > _app.screenWidth()) {
                             fwcVideoSurface.scaleY = _app.screenWidth() / player.videoDimensions.width;
                             fwcVideoSurface.scaleX = fwcVideoSurface.scaleY;
                             
                             fwcVideoSurface.newScaleVal =fwcVideoSurface.scaleY;
                             fwcVideoSurface.initialScale=fwcVideoSurface.scaleY;
                         }
                         else{ fwcVideoSurface.newScaleVal=1.0;fwcVideoSurface.initialScale=1.0; }

                     }
                         console.log("scale should have changed");
                         videoDimensionsChanged = true;
                         changedVideoScale = fwcVideoSurface.newScaleVal;
                         console.log("Changed Scale " + changedVideoScale);
                     }
                 }
             }
         }
         }
     }
     
     actionBarVisibility: ChromeVisibility.Overlay
     actionBarAutoHideBehavior: ActionBarAutoHideBehavior.Disabled
     property bool repeatModeEnabled:false
     onRepeatModeEnabledChanged: { mediaRepeat= repeatModeEnabled; }
     property int eqValue;
     attachedObjects:[
         SystemTimer {
             id: volFade
             interval: parseInt(appsettings.getSystemSetting("audioFadeSpeed", ""))
           onTimeout: {
               //  console.log(playerVolume)
                 if(playerVolume>1.0){volFade.stop();}
                 else{
                     playerVolume +=0.010}
             }
         },
       LayoutUpdateHandler { id: layout  },
        SystemTimer {
            id: seekDelay;interval: 1000;  onTimeout: {
                seekDelay.stop(); console.log("New Seek Progress: " +newVideoProgress );player.seekTime(newVideoProgress)
            }
        },
         Connections {
             target: mainnav 
             onPlaybackCompletedSignal:{ 
                     if(mainnav.playbackCompleted===true){
                         if(shuffleMode){
                             if(playQueue.after(globalIndexPath)==""){
                                 console.log("Should Be End of list" ); playListView.triggered(playQueue.first());}
                             else{
                             
                             nextTrack();}}
                         else if(playlistMode){ 
                             if(playQueue.after(globalIndexPath)==""){
                                 if(shuffleMode){nextTrack();}
                                 else{
                                     
                                     console.log("End of list");playbackEndedCont.show();}}
                                     else{
                                 if(repeatModeEnabled===false){nextTrack();}}
                         }
                         else{showPlaylist=false; if(mediaFormat==="Video"){autoHideTimer.stop();} playbackEndedCont.show();mediaPlaying=false;}
                         
                         
                         albumArtActiveFrame=false;
                     }
             }
             onVideoSourceUpdated:{audioSource= newAudioSource; player.prepare(); player.play(); seekDelay.start();}
             onResetVideoPanning:{mainCont.xDown=0; mainCont.yDown=0; fwcVideoSurface.translationX=0; fwcVideoSurface.translationY=0;}
             onResetTouchZoom:{ fwcVideoSurface.scaleX=1.0;fwcVideoSurface.scaleY=1.0;fwcVideoSurface.newScaleVal = 1.0; fwcVideoSurface.initialScale=1.0}
             onPlayMedia:{playPauseMedia();}
             onPauseMedia:{playPauseMedia();}
             onPlayPause:{playPauseMedia();}
             onStopMedia:{player.stop();}
             onClosePlayer:{mainnav.pop();}
             onNextMediaTrack:{nextTrack();}
             onPreviousMediaTrack:{previousTrack();}
             onShowActionBar:{actionBarVisibility= ChromeVisibility.Overlay; showControls=true;}
             onEQChanged:{
               eqValue = parseInt(appsettings.getSystemSetting("EQValue", ""));
              if(eqValue===0) {player.equalizerPreset= EqualizerPreset.Off}
              else if(eqValue===1) {player.equalizerPreset= EqualizerPreset.Airplane}
              else if(eqValue===2) {player.equalizerPreset= EqualizerPreset.BassBoost}
              else if(eqValue===3) {player.equalizerPreset= EqualizerPreset.TrebleBoost}
              else if(eqValue===4) {player.equalizerPreset= EqualizerPreset.VoiceBoost}
              else if(eqValue===5) {player.equalizerPreset= EqualizerPreset.BassLower}
              else if(eqValue===6) {player.equalizerPreset= EqualizerPreset.TrebleLower}
              else if(eqValue===7) {player.equalizerPreset= EqualizerPreset.VoiceLower}
              else if(eqValue===8) {player.equalizerPreset= EqualizerPreset.Acoustic}
              else if(eqValue===9) {player.equalizerPreset= EqualizerPreset.Dance}
              else if(eqValue===10) {player.equalizerPreset= EqualizerPreset.Electronic}
              else if(eqValue===11) {player.equalizerPreset= EqualizerPreset.HipHop}
              else if(eqValue===12) {player.equalizerPreset= EqualizerPreset.Jazz}
              else if(eqValue===13) {player.equalizerPreset= EqualizerPreset.Lounge}
              else if(eqValue===14) {player.equalizerPreset= EqualizerPreset.Piano}
              else if(eqValue===15) {player.equalizerPreset= EqualizerPreset.RhythmAndBlues}
              else if(eqValue===16) {player.equalizerPreset= EqualizerPreset.Rock}
              else if(eqValue===17) {player.equalizerPreset= EqualizerPreset.SpokenWord}
              eqName= appsettings.getSystemSetting("EQValueName", "Off");

             }
         },
         SystemTimer {
             id: autoHideTimer
             interval: videoControlsTimeout
           onTimeout: {
               actionBarVisibility= ChromeVisibility.Hidden
               showControls=false;
               autoHideTimer.stop();
           }  
         },
         SystemTimer {
           id:autoResizeDelay; interval: playlistMode?700:250
           onTimeout: {
             autoResizeDelay.stop();  autoVideoResize();
           }  
         },
         
                     OrientationHandler {
                         onOrientationChanged: {
                             console.log(_app.screenWidth())
                             fwcVideoSurface.preferredHeight= player.videoDimensions.height
                             fwcVideoSurface.preferredWidth= player.videoDimensions.width
                             artIMG.updateSize();
                             if (OrientationSupport.orientation == UIOrientation.Landscape) {
                                 if(miniSquareDevice){}
                                 else if (passport){}
                                 else{
                                 if(videoDimensionsChanged){resetTouchZoom();
                                     fwcVideoSurface.scaleX= originalPixelWidth/player.videoDimensions.height
                                     fwcVideoSurface.scaleY= originalPixelHeight/player.videoDimensions.width}
                         }
                         }
                         else if (OrientationSupport.orientation == UIOrientation.Portrait) {
                             if(miniSquareDevice){}
                             else if (passport){}
                             else{
                                 if(videoDimensionsChanged){console.log("Changed Scale " +changedVideoScale); fwcVideoSurface.scaleX=changedVideoScale; ;fwcVideoSurface.scaleY=changedVideoScale ;fwcVideoSurface.newScaleVal = changedVideoScale; fwcVideoSurface.initialScale=changedVideoScale }   
                         
                         else {autoVideoResize(); }}
                     }
                     touchAnimSwipeTut.hide();

                     }
                     },
                     ComponentDefinition {
                         id: fileDidNotCompleteDio
                         content: FileDidNotCompleteDialog {}
                     },
                     SystemTimer {
                         id:shuffleTimer; interval:500; onTimeout:{shuffleTimer.stop();playListView.triggered( playQueue.first())}
                     }
                 ]
                 
     
     onCreationCompleted: {
         eQChanged();
         if(playAllMode){playListView.triggered(playQueue.first())}
         else {
         if(playlistMode==false){
         if(appsettings.getSystemSetting("fileDidNotComplete", "")===""){
         if(audioSource===appsettings.getSystemSetting("fileDidNotCompleteURL", "")){ var bobe= fileDidNotCompleteDio.createObject(); player.prepare();}
         else{player.prepare();player.play(); if(fadeInAudio===true){volFade.start();}} }
         else{player.prepare();player.play(); if(fadeInAudio===true){volFade.start();}}
     
     }
 
     else{
         player.play(); if(fadeInAudio===true){volFade.start();}}
         
     }
         console.log("SOURCE "+mainnav.audioSource );autoHideTimer.start();_app.setScreenIdle("KeepAwake");
         if(mediaFormat==="Audio"){autoHideTimer.stop();_app.setScreenIdle("Normal");} 
		 videoOpening=false;
         setLockScreenArt();
         if(shuffleMode===true){shuffleTimer.start();}
         if (aboutToLoadCarMode){
             player.seekTime(videoProgress);aboutToLoadCarMode=false;
             appsettings.saveSystemSetting("fileDidNotCompletePosition", "");
             appsettings.saveSystemSetting("fileDidNotCompleteURL", "");
             console.log("Video Height" + player.videoDimensions.height)
             console.log("Video Width" + player.videoDimensions.width);
            // autoResizeDelay.start();
         }
 }
        actions: [
         
            ActionItem {
                id:fillScreen
                property bool active:false
                title:  qsTr("Fill Video To Screen")
                property int scaleValx
                property int scaleValy
               imageSource:active? "images/full_screen_active.png": "images/full_screen.png"
                ActionBar.placement:ActionBarPlacement.InOverflow
                onCreationCompleted: {
                    if(hardwareInfo.isPhysicalKeyboardDevice){
                       if(appsettings.getSystemSetting("fillScreenPlayerMenu", "")==="false")page.removeAction(fillScreen)  
                         else if(mediaFormat === "Audio"){page.removeAction(fillScreen)  }
                    }
                  else{page.removeAction(fillScreen);} 
                }
                onTriggered: {
                    if(active){active=false;fwcVideoSurface.scaleX=scaleValx; fwcVideoSurface.scaleY=scaleValy; fwcVideoSurface.newScaleVal=scaleValx; fwcVideoSurface.initialScale= scaleValx;autoResizeAttempted=false;autoVideoResize();}
                    else {scaleValx=fwcVideoSurface.scaleX; scaleValy=fwcVideoSurface.scaleY;active=true;
                        fwcVideoSurface.newScaleVal = fwcVideoSurface.scaleX; 
                        fwcVideoSurface.initialScale=fwcVideoSurface.scaleX;
                        fwcVideoSurface.scaleX= _app.screenWidth()/player.videoDimensions.width
                        fwcVideoSurface.scaleY= _app.screenHeight()/player.videoDimensions.height   
                        }
                    }
                
            
            },
           
            ActionItem {
                id:rew
                title: qsTr("Rewind")
                ActionBar.placement:ActionBarPlacement.InOverflow
                onTriggered: {rewindPosition();}  
                onCreationCompleted: {if(appsettings.getSystemSetting("RewindOptionMenu", "")===""){page.removeAction(rew)}                    
                }
                imageSource: "asset:///images/rewind.png"
            },
          ActionItem {
                id:prev
                shortcuts: [
                    Shortcut {
                        key: qsTr("b")
                    }
                ]
                title: qsTr("Previous")
                enabled:playQueue.before(globalIndexPath)==""?false:true
                imageSource:"asset:///images/previous.png"
                ActionBar.placement:ActionBarPlacement.OnBar
                onTriggered: {changeButtonsEnabled=false;page.previousTrack();}
                onCreationCompleted: { if(playlistMode===false)page.removeAction(prev); if(shuffleMode){enabled=false;}

                }
                }, 
            ActionItem {
                id:playItem
               
                shortcuts: [
                    Shortcut {
                        id:playpause
                        key: qsTr("p")
                    }
                ]
                title:player.mediaState==2? qsTr("Pause"):  qsTr("Play")
                imageSource:player.mediaState==2?"asset:///images/ic_pause.png": "asset:///images/ic_play.png"
                ActionBar.placement:ActionBarPlacement.Signature
                onTriggered: {playPauseMedia();
                }
            
            },
            
            ActionItem {
                id:next
                shortcuts: [
                    Shortcut {
                        key: qsTr("n")
                    }
                ]
                title: qsTr("Next")
                
                enabled:playQueue.after(globalIndexPath)==""?false:true
                imageSource:"asset:///images/skip.png"
                ActionBar.placement:ActionBarPlacement.OnBar
                onTriggered: {changeButtonsEnabled=false; page.nextTrack();}
                onCreationCompleted: {if(playlistMode===false)page.removeAction(next);
                }
            },
            ActionItem {
                id:forw
                title: qsTr("Forward")
              ActionBar.placement:ActionBarPlacement.InOverflow
              onCreationCompleted: {if(appsettings.getSystemSetting("ForwardOptionMenu", "")===""){page.removeAction(forw)}                    
              }
              onTriggered: {
                  forwardPosition();
              }  
              imageSource: "asset:///images/forward.png"
            },
          
                ActionItem {
                    id:vol
                    shortcuts: [
                        Shortcut {
                            id: muteShort
                            key: qsTr("m")
                        }
                    ]
                    function update(){title=_app.checkMute()===false? "Mute Audio": "Unmute Audio"
                        imageSource= _app.checkMute()===false? "images/ic_speaker_mute.png": "images/ic_speaker.png"}
                    title:_app.checkMute()===false?  qsTr("Mute Audio"):  qsTr("Unmute Audio")
                    imageSource:_app.checkMute()===false? "images/ic_speaker_mute.png": "images/ic_speaker.png"
                    ActionBar.placement:ActionBarPlacement.InOverflow
                    onCreationCompleted: {
                        if(appsettings.getSystemSetting("toggleAudioMuteMenu", "")==="false"){page.removeAction(vol);muteInd.destroy();}
                    }
                    onTriggered: {
                        _app.muteOutputVolume();
                        _app.checkMute()===true? muteInd.show("Muted"): muteInd.show("Unmuted");
                        console.log(_app.checkMute());
                        update();
                    }
                
                },
                
                
                ActionItem {
                    id: vismen
                    title: "Visualisations"  
                    imageSource: "images/visualisation_menu.png"
                    onCreationCompleted: {if(appsettings.getSystemSetting("VisualisationOptionMenu", "")==="false"){page.removeAction(vismen)}                    
                    }
                    onTriggered: {
                        if(appsettings.getSystemSetting("VisualisationViewerTutorial", "")===""){creator.createQMLObject("VisualisationTutorial.qml")}
                        else creator.createQMLObject("Custom/VisualisationViewer.qml")
                    }
                },
                ActionItem {
                    id:ed
                    title:  qsTr("Edit Video")
                    imageSource:"asset:///images/ic_edit.png"
                    ActionBar.placement:ActionBarPlacement.InOverflow
                    onCreationCompleted: {
                        if(playlistMode){page.removeAction(ed);}
                        if(mediaFormat==="Video"){}
                        else {page.removeAction(ed);}
                        if(appsettings.getSystemSetting("editVideoPlayerMenu", "")==="false")page.removeAction(ed)   
                    }
                    onTriggered: {_app.openVideoEditor(audioSource)}
                
                },
                ActionItem {
                    id:settt
                    shortcuts: [
                    Shortcut {
                    id: pshort
                    key: qsTr("t")
                    }
                    ]
                    title:  qsTr("Player Settings")
                    imageSource:""
                    ActionBar.placement:ActionBarPlacement.InOverflow
                    onTriggered: { creator.createQMLObject("PlayerSettings.qml")
                    }
                },
            
                ActionItem {
                    id: sleepTi
                    imageSource: sleepTimerEnabled? "images/sleep_time_active.png": "images/sleep_timer.png"
                    title:  qsTr("Sleep Timer") 
                    onCreationCompleted: {
                        if(appsettings.getSystemSetting("sleepTimerMenu", "")==="false")page.removeAction(sleepTi);
                    } 
                    onTriggered: {
                        if(sleepTimerPopup){sleepTimerPopup=false; if(mediaFormat==="Video"){if(showPlaylist===false){autoHideTimer.start();}}}
                        else{ sleepTimerPopup=true;if(mediaFormat==="Video"){autoHideTimer.stop();showControls=true;page.actionBarVisibility=ChromeVisibility.Overlay} }
 
                    }},
                ActionItem{
                    id: addtoplay
                    title:  qsTr("Add To Playlist")
                    imageSource: "images/ic_add.png"
                    property string art
                    onCreationCompleted: {
                        if(sourceStreamed){page.removeAction(addtoplay)}
                       else if(playlistMode){page.removeAction(addtoplay)}
                       else{
                            art=artWorkURI.replace("file://", "");}
                    }  
                    onTriggered: {
                        fileTitleToBeAddedToList=metaDataTitle===""? metaDataFileName:metaDataTitle;
                        fileURLToBeAddedToList=originalSource;
                        creator.createQMLObject("AddToPlaylistPopup.qml");
                        //_playlist.addToJson(metaDataTitle===""? metaDataFileName:metaDataTitle, originalSource, art);
                      //  toast.showText(metaDataTitle===""? metaDataFileName+ " Added To Playlist":metaDataTitle+ " Added To Playlist")
                    }

                },
                ActionItem {
                  id: playlistShowAction
                  shortcuts: [
                      Shortcut {
                          key: qsTr("l")
                      }
                  ]
                  title: showPlaylist?  qsTr("Hide Play Queue"):  qsTr("Show Play Queue")
                  imageSource: "images/playlist.png"
                  onCreationCompleted: {
                      if(playlistMode===false)page.removeAction(playlistShowAction)
                  }  
                  onTriggered: {
                      if(showPlaylist===false){autoHideTimer.stop(); showPlaylist=true;showControls=true; 
                          if(_playlist.dataModell.size()>170){  playListView.scrollToItem(["0",propertyToSaveIndexPathAsNumber], ScrollAnimation.None)}
                          else{playListView.scrollToItem(globalIndexPath, ScrollAnimation.Smooth)}
                      }
                      else {showPlaylist=false;if(mediaFormat==="Video") {autoHideTimer.start();}} 
                  }
                },
                
                ActionItem {
                    id:eq
                    enabled: true
                    shortcuts: [
                        Shortcut {
                            id: eqshort
                            key: qsTr("e")
                        }
                    ]

                    title:eqValue===15? "EQ " + "(" + eqName+")": qsTr("Equaliser " )+ "(" + eqName+")"
                    imageSource:"asset:///images/ic_eq.png"
                    ActionBar.placement:if(inAppRecordingPlaying){ActionBarPlacement.OnBar} else{ActionBarPlacement.InOverflow}
                    onCreationCompleted: {
                        if(appsettings.getSystemSetting("EqualiserMenu", "")==="false")page.removeAction(eq);
                    }
                    onTriggered: {
                        creator.createQMLObject("EqualiserPresetPage.qml")
                    }
                },
            
                ActionItem {
                    id:homescreen
                    enabled: sourceInvoked? false:true
                    title: qsTr("Add To Homescreen")
                    imageSource:"asset:///images/ic_add_home.png"
                    ActionBar.placement:if(inAppRecordingPlaying){ActionBarPlacement.OnBar} else{ActionBarPlacement.InOverflow}
                    onCreationCompleted: {
                        if(appsettings.getSystemSetting("AddToHomescreenMenu", "")==="false")page.removeAction(homescreen);
                    }
                    onTriggered: {
                        originalSource= player.metaData.uri
                       creator.createQMLObject("AddToHomescreen.qml")
                        }
                    },
                ActionItem {
                    title:  qsTr("Search For Lyrics")
                  id: lyrcs
                  enabled: fileSystemLyricsFound
                  imageSource: "asset:///images/ic_search.png"  
                  ActionBar.placement:ActionBarPlacement.OnBar
                  onCreationCompleted: {if (inAppRecordingPlaying)page.removeAction(lyrcs)}
                  onTriggered: {
                      //if(appsettings.getSystemSetting("lyricsSearchTut", "")===""){creator.createQMLObject("LyricsSearchTutorial.qml")}
                //  else
                // force fileystem lyrics cause of broken web lyrics
                      creator.createQMLObject("FileSystemLyricsViewer.qml")
                  }
                },
                    ActionItem {
                                id:download
                                enabled:sourceStreamed? true:false
                                title: qsTr("Download")
                                imageSource:"asset:///images/ic_download.png"
                               // ActionBar.placement:ActionBarPlacement.InOverflow
                                ActionBar.placement:ActionBarPlacement.OnBar

                                onCreationCompleted: {
                                    if(sourceStreamed==false) {page.removeAction(download)}
                                }
                                onTriggered: {
                                    if(connectionOnline){
                                        requestedDownloadURL=audioSource;
                                    creator.createQMLObject("DownloadPage.qml")}
                                    else{toast.showText("Internet Connection Unavailable")}
                                }
                            
                    },
                    ActionItem {
                        id:fa
                        shortcuts: [
                            Shortcut {
                                id: favshort
                                key: qsTr("f")
                            }      
                        ]
                        title: qsTr("Add Favourite")
                        enabled: true
                        onCreationCompleted: {if (inAppRecordingPlaying)page.removeAction(fa);}
                        imageSource:"asset:///images/ic_add_bookmarks.png"
                     //   ActionBar.placement:ActionBarPlacement.InOverflow
                        ActionBar.placement:ActionBarPlacement.OnBar
                        onTriggered: {creator.createQMLObject("FavouritesSaveDialog.qml")}
                    },
                    ActionItem{
                        id: cma
                        title: "Open In Car Mode"
                        imageSource: "images/CarModeAction.png"
                        onTriggered: { closePlayer();if(playlistMode){inheritPlaylistMode=true;} aboutToLoadCarMode=true;
                     //   carModedelay.start(); activity.running = true;activity.visible = true;
                            
                        }
                        onCreationCompleted: {
                            if(appsettings.getSystemSetting("CarModeMenu", "")==""){page.removeAction(cma)}
                        }
                        
                    },
                    ActionItem {
                        id: pinner
                        enabled: appsettings.getSystemSetting("PinnedMediaViewer", "")===""? pinnedCount >=15? false: true: pinnedCount >=5? false: true
                        title: qsTr("Pin To Home")
                        onCreationCompleted: {
                            if(playlistMode){page.removeAction(pinner)}
                        }
                        property string neww:artWorkURI
                        onTriggered: {
                        var art;
                        var bobe= neww.replace("file://", "");
                        
                        if(artWorkURI===""){art=""
                        bob= pinnedCount+=1
                        var fileTitle= metaDataTitle==="" ?metaDataFileName: metaDataTitle
                        _pinnedVideos.addToJson( fileTitle,  audioSource, "", controlsCont.getTimeFromMSec(player.duration), sourceStreamed?"WebStream":mediaFormat, art, bob); mediaFormat==="Audio"?toast.showText("Audio File Pinned To Home") :  toast.showText("Video Pinned To Home")
                        console.log(pinnedCount)
                        enabled=false;
                        }
                        
                        else if(_app.checkFileExists(bobe)==true){
                        console.log("Exists")
                        _app.dirCheckOrCreate(_app.homePath()+ "/pinnedArt")
                        art= _app.homePath()+ "/pinnedArt/" + metaDataFileName+".jpg";
                        console.log(art)
                        console.log("DOES IT INITIALLY EXIST? " + _app.checkFileExists(bobe))

                        _app.copyFile(bobe, art);
                        console.log("SOURCE: " + bobe)
                        console.log("DOES IT STILL EXIST? " + _app.checkFileExists(bobe))
                        bob= pinnedCount+=1
                        var fileTitle= metaDataTitle==="" ?metaDataFileName: metaDataTitle
                        _pinnedVideos.addToJson( fileTitle,  audioSource, "", controlsCont.getTimeFromMSec(player.duration), sourceStreamed?"WebStream":mediaFormat, "file://"+art, bob); mediaFormat==="Audio"?toast.showText("Audio File Pinned To Home") :  toast.showText("Video Pinned To Home")
                        console.log(pinnedCount)
                        neww=artWorkURI;
                        
                        enabled=false; 
                        }
                        else{
                        bob= pinnedCount+=1
                        var fileTitle= metaDataTitle==="" ?metaDataFileName: metaDataTitle
                        _pinnedVideos.addToJson( fileTitle,  audioSource, "", controlsCont.getTimeFromMSec(player.duration), sourceStreamed?"WebStream":mediaFormat, "", bob); mediaFormat==="Audio"?toast.showText("Audio File Pinned To Home") :  toast.showText("Video Pinned To Home")
                        console.log(pinnedCount)
                        enabled=false;
                        }
                        
                        }
                        imageSource: "asset:///images/pin_actionItem.png"
                    },
                    ActionItem {
                        id:nm
                        title: qsTr("Night Mode")
                        enabled: true
                        imageSource:nightMode? "asset:///images/night_active.png":"asset:///images/night.png"
                        ActionBar.placement:ActionBarPlacement.InOverflow
                        onCreationCompleted: {
                            if(appsettings.getSystemSetting("NightModeMenu", "")==="false")page.removeAction(nm)
                        }
                        onTriggered: { if(nightMode===true){page.removeAction(nms);nightMode=false;toast.showText( qsTr("Night Mode Disabled")); }
                        else{nightMode=true;toast.showText( qsTr("Night Mode Enabled"))}
                            nightModeChanged();page.addAction(nms)}
                            },
                   
                    
                            ActionItem {
                                id:nms
                                title: qsTr("Night Mode Settings")
                                imageSource:""
                                ActionBar.placement:ActionBarPlacement.InOverflow
                                onCreationCompleted: {
                                  if(nightMode===false)page.removeAction(nms)
                                }
                                onTriggered: {creator.createQMLObject("NightModeSettings.qml")}
                            },
                     


                    ActionItem {
                        id:pr
                        title: qsTr("Properties")
                        enabled: true
                        imageSource:"asset:///images/ic_properties.png"
                        ActionBar.placement:ActionBarPlacement.InOverflow
                        onCreationCompleted: {
                            if(appsettings.getSystemSetting("PropertiesMenu", "")==="false")page.removeAction(pr)
                            else if(inAppRecordingPlaying)page.removeAction(pr)
                        }
                        onTriggered: {
                            if(mediaPaused===true){creator.createQMLObject("FileDetails.qml")}
                            else if(videoDimensionsChanged){creator.createQMLObject("FileDetails.qml")}
                           else if(mainnav.playbackCompleted===true){player.pause();creator.createQMLObject("FileDetails.qml")
                            } 
                           
                            else{
                                if(customPickerUsed){creator.createQMLObject("FileDetails.qml")}
                                else{player.pause();player.play();creator.createQMLObject("FileDetails.qml")}
                                }
                           
                           }
                    },
                
                    ActionItem {
                        id:repeat
                        shortcuts: [
                            Shortcut {
                                id: repshort
                                key: qsTr("r")
                             
                            }
                        ]
                        
                        title:repeatModeEnabled?  qsTr("Disable Repeat"):  qsTr("Enable Repeat")
                        imageSource:repeatModeEnabled? "images/repeat_active_green.png":"asset:///images/repeat.png"
                        ActionBar.placement:ActionBarPlacement.InOverflow
                        onCreationCompleted: { if(appsettings.getSystemSetting("RepeatMenu", "")==="false"){page.removeAction(repeat);fancyRepeatInd.destroy();  }  }
                        onTriggered: {if(repeatModeEnabled===true){repeatModeEnabled=false;
                            
                                if(appsettings.getSystemSetting("fancyIndicators", "true")==="")toast.showText( qsTr("Repeat Disabled"))
                                else fancyRepeatInd.show("RepeatOFF")
                                }
                                else{repeatModeEnabled=true; 
                                    if(appsettings.getSystemSetting("fancyIndicators", "true")==="")toast.showText( qsTr("Repeat Enabled"))
                                    else fancyRepeatInd.show("RepeatON")}
                           
                        }
                    
                    },
                    
                    ActionItem {
                        id:shuffle
                        shortcuts: [
                            Shortcut {
                                id:shuffleshort 
                                key: qsTr("s")
                            
                            }
                        ]
                        
                        title:shuffleMode?  qsTr("Disable Shuffle"):  qsTr("Enable Shuffle")
                        imageSource:shuffleMode?"asset:///images/shuffle_on_green.png":"asset:///images/shuffle_off.png"
                        ActionBar.placement:ActionBarPlacement.InOverflow
                        onCreationCompleted: {if(playlistMode==false){page.removeAction(shuffle)}  }

                        onTriggered: {
                            if(shuffleMode===true){shuffleMode=false;shuffling=true;playQueue.setSortingKeys(["number", "title", "sourceUrl"]);playListView.triggered(globalIndexPath);_app.firePlaylistChanged()}
                            else{shuffleMode=true;shuffling=true;playQueue.setSortingKeys([""]);playListView.triggered(globalIndexPath);_app.firePlaylistChanged();
}
                    }
                    }
                    
               
        ]
        Container {
         id: mainCont
         layout: DockLayout {}
         property double minScreenScale: 0.2
         property double maxScreenScale: 3.0 
         property double initialScreenScale: 1.0
         property int xDown
         property int yDown
         property int startingX
         property int startingY
         overlapTouchPolicy: OverlapTouchPolicy.Allow
         eventHandlers: [
             TouchKeyboardHandler {
                 property int downX: 0
                 property int downY: 0
                 onTouch: {
                    /*
                     0 = down
                     1= move
                     2= up
                     3= cancel
                     */ 
                    
                     //toast.showText("TouchKeyboard: " + event.touchType + "Y:" + event.screenY + " X: " +event.screenX)
                     console.log("TouchKeyboard: " + event.touchType + "Y:" + event.screenY + " X: " +event.screenX)
                     if(passportTrackKeyboard===true){
                     if (event.touchType===0) {
                         
                         
                         downX = event.screenX;
                         
                         downY = event.screenY;
                     
                     } else if (event.touchType===2) {
                         console.log(event.screenY)
                         var yDiff = downY - event.screenY;
                         
                         // take absolute value of yDiff
                         
                         if (yDiff < 0) yDiff = -1 * yDiff;
                         
                         // I check if the minimum y movement is less than 200.  Don't want to move left or right if 
                         
                         // the user is actually want to move up or down.
                         
                         if ((yDiff) < 150) {
                             
                             if ((downX - event.screenX) > 150) {
                                 
                                 console.log("RIGHT SWIPE")
                                 if(playlistMode){
                                 page.nextTrack();}
                                 else forwardPosition();
                             
                             } else if ((event.screenX - downX) > 150) {
                                 
                                 console.log("LEFT SWIPE")
                                 if(playlistMode){
                                 page.previousTrack();}
                                 else rewindPosition()
                             
                             
                             }
                         
                         }
                     
                     }
                 }
                 }
                 
        }
             
         ]
     
onTouch: {
 //  console.log("Screen Touched: " + event.touchType + " Y:" + event.windowY + " X: " +event.windowX)

  if(showPlaylist===false){
    if(sleepTimerPopup===false){
    if(touchPan===true){
    if (event.isDown()) {
        xDown = event.localX;
        yDown = event.localY;
        startingX =  fwcVideoSurface.translationX;
        startingY =  fwcVideoSurface.translationY;
    } else if (event.isMove()) {
        fwcVideoSurface.translationX = event.localX - xDown + startingX;
        fwcVideoSurface.translationY = event.localY - yDown + startingY;
    } 
}

    if(event.isUp()) {
        if(mediaFormat==="Video"){
        if(actionBarVisibility===ChromeVisibility.Hidden){actionBarVisibility=ChromeVisibility.Overlay; autoHideTimer.start(); showControls=true;}
        else{actionBarVisibility=ChromeVisibility.Hidden; showControls=false}}
    }
}
}
}
gestureHandlers: [
    
    PinchHandler {
        onPinchStarted: {
            if(touchZoom===true){
            console.log("onPinchStart: .scaleX = " + fwcVideoSurface.scaleX);
            fwcVideoSurface.initialScale = fwcVideoSurface.scaleX;fillScreen.active=false;}
        }
        
   
        onPinchUpdated: {
            if(touchZoom===true){

            console.log("onPinchUpdate");
            
            if(responsiveZoom===true){
            fwcVideoSurface.newScaleVal = fwcVideoSurface.initialScale + ((event.pinchRatio -1) * fwcVideoSurface.scaleFactor*6);}
        else{fwcVideoSurface.newScaleVal = fwcVideoSurface.initialScale + ((event.pinchRatio -1) * fwcVideoSurface.scaleFactor);}
            console.log ("onPinchUpdate: fwcVideoSurface.initialScale = " + fwcVideoSurface.initialScale + ": event.pinchRatio-1= " + event.pinchRatio-1 + " : newScaleVal = " + fwcVideoSurface.newScaleVal);
            
            if ( fwcVideoSurface.newScaleVal < mainCont.maxScreenScale &&  fwcVideoSurface.newScaleVal > mainCont.minScreenScale ) {
                fwcVideoSurface.scaleX = fwcVideoSurface.newScaleVal;
                fwcVideoSurface.scaleY = fwcVideoSurface.newScaleVal;
            }
        }
        }
    }
]


            attachedObjects: [
              /*  NowPlayingController {
                  id: playerController
                },*/
                NowPlayingConnection {
                    id: nowPlaying
                   repeatMode: player.repeatMode
                    priorityLevel: PriorityLevel.Low
                    
                    function getIcon(){  
                       if(mediaFormat==="Audio"){
                         
                           if(nightMode===true){
                               return "../images/FancyControls/nightMode_music.png"
                           }
                           else if (themeValue === "") {
                               return "../images/FancyControls/default_music.png"
                           } else if (themeValue === "#0092cc") {
                               return "../images/FancyControls/default_music.png"
                           } else if (themeValue === "#0000ff") {
                               return "../images/FancyControls/blue_music.png"
                           }
                           else if (themeValue === "#F52887") {
                               return "../images/FancyControls/deeppink_music.png"
                           }
                           else if (themeValue === "red") {
                               return "../images/FancyControls/red_music.png"
                           } else if (themeValue === "#ff00ff") {
                               return "../images/FancyControls/magenta_music.png"
                           } else if (themeValue === "#9900ff") {
                               return "../images/FancyControls/purple_music.png"
                           }
                           
                       }
                       else if(mediaFormat==="Video"){  if(nightMode===true){
                               return "../images/FancyControls/nightMode_video.png"
                       }
                       else if (themeValue === "") {
                           return "../images/FancyControls/default_video.png"
                       } else if (themeValue === "#0092cc") {
                           return "../images/FancyControls/default_video.png"
                       } else if (themeValue === "#0000ff") {
                           return "../images/FancyControls/blue_video.png"
                       }
                       else if (themeValue === "#F52887") {
                           return "../images/FancyControls/deeppink_video.png"
                       }
                       else if (themeValue === "red") {
                           return "../images/FancyControls/red_video.png"
                       } else if (themeValue === "#ff00ff") {
                           return "../images/FancyControls/magenta_video.png"
                       } else if (themeValue === "#9900ff") {
                           return "../images/FancyControls/purple_video.png"
                       }}}
                    overlayStyle: thumbnailed==true?OverlayStyle.Fancy: OverlayStyle.Plain  
                    onOverlayStyleChanged: {
                        var metaData = { "track": player.addiInfo, "artist" : player.bob };  
                        nowPlaying.setMetaData(metaData)
                    }    
                    duration: player.duration
                    position: player.position
                    iconUrl: artWorkURI==="" ?getIcon(): artWorkURI
                    mediaState: player.mediaState
                    connectionName: "StarPlayer"
                    nextEnabled: playlistMode?playQueue.after(globalIndexPath)==""?false:true:false
                    previousEnabled:playlistMode?playQueue.before(globalIndexPath)==""?false:true: false
                    onNext: {
                        if(playlistMode){
                           nextTrack();}
                           else{forwardPosition();}
                        
                    }
                    onPrevious: {
                        if(playlistMode){
                            previousTrack()}
                            else{rewindPosition();}
                    }
                    onAcquired: {
                        var metadata = { "track":player.addiInfo, "artist" : player.bob};  
                        playPauseMedia();
                        nowPlaying.mediaState = MediaState.Started ;  
                        nowPlaying.setMetaData(metadata);
                    }
                    onRewind: {
                        rewindPosition();
                    }
                    onForward: {
                        forwardPosition();
                    }
                    
                    
                    onPause: {
                        playPauseMedia();nowPlaying.mediaState= player.mediaState;
                        if(mediaFormat==="Video"){  actionBarVisibility=ChromeVisibility.Overlay; autoHideTimer.start(); showControls=true;}
                        console.log(controllerActive)
                    }
                    
                    onPlay: {
                        if(phoneCallActive===false){
                        playPauseMedia(); nowPlaying.mediaState= player.mediaState;
                        if(mediaFormat==="Video"){  actionBarVisibility=ChromeVisibility.Overlay; if(showPlaylist===false) {autoHideTimer.start();} showControls=true;}}
                    }
                    onRevoked: {
                        player.stop();
                        nowPlaying.mediaState= player.mediaState;
                        mediaStopped=true;
                        console.log("Now Playing Connection Revoked")

                    }},
                
                MediaPlayer {
                    id: player
                    volume: fadeInAudio? playerVolume: 1.0
                    autoPause:autoPausePlayer
                    sourceUrl:audioSource
                    property string addiInfo: metaDataArtist==="" ? getTimeFromMSec(player.position): metaDataArtist
                    property string bob: metaDataTitle==="" ?  _app.withoutExtension(metaData.uri).toString(): metaDataTitle
                 //   audioManagerHandle:_audioControl.m_dtmfAudioManager
                    repeatMode: repeatModeEnabled? RepeatMode.Track: RepeatMode.None
                    videoOutput: VideoOutput.PrimaryDisplay
                    windowId: fwcVideoSurface.windowId
                   // closedCaptionWindowId: fwcCaptionSurface.windowId
                   // closedCaptionEnabled: true
                    onVideoDimensionsChanged: {
                        fwcVideoSurface.preferredWidth= videoDimensions.width
                        fwcVideoSurface.maxWidth=  layout.layoutFrame.width
                    }
                    function bytesTosize(bytes) {                        
                        if(bytes == 0) return 'Undefined';
                        var k = 1000;
                        var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
                        var i = Math.floor(Math.log(bytes) / Math.log(k));
                        return (bytes / Math.pow(k, i)).toPrecision(3) + ' ' + sizes[i];
                    
                    }
                    function getTimeFromMSec(msec) {
                        if (msec <= 0 || msec == undefined) {
                            return "0:00"
                        
                        } else {
                            var sec = "" + Math.floor(msec / 1000) % 60
                            if (sec.length == 1)
                                sec = "0" + sec
                            
                            var hour = Math.floor(msec / 3600000)
                            if (hour < 1) {
                                return Math.floor(msec / 60000) + ":" + sec
                            } else {
                                var min = "" + Math.floor(msec / 60000) % 60
                                if (min.length == 1)
                                    min = "0" + min
                                
                                return hour + ":" + min + ":" + sec
                            }
                        }
                    }
                    onMetaDataChanged: {
                        if(artWorkURI===""){}
                        else{ if(appsettings.getSystemSetting("albumArtActiveFrame", "")==="true"){ albumArtActiveFrame=true;updateCoverImage();}}
                        
                        console.log("player onMetaDataChanged");
                        
                        console.log("--------------------------------bit_rate=" + metaData.bit_rate);
                        console.log("-----------------------------------genre=" + metaData.genre);
                        console.log("-----------------------------------duration=" + metaData.duration);
                        console.log("-----------------------------sample_rate=" + metaData.sample_rate);
                        console.log("-----------------------------------title=" + metaData.title);
                        console.log("-----------------------------------uri=" + metaData.uri);
                        console.log("-----------------------------------art=" + metaData.artwork_uri);
                        console.log("-----------------------------------height=" + metaData.pixel_height);
                        console.log("-----------------------------------album=" + metaData.album);

                        metaDataFileName= _app.withoutExtension(metaData.uri);
                        metaDataFileLocation= metaData.uri.toString();
                        metaDataSampleRate= metaData.sample_rate.toString();
                        if(mediaFormat==="Audio")metaDataArtist= metaData.artist.toString();
                        
                        metaDataFileSize= bytesTosize(_app.getFileSize(metaData.uri));
                        console.log(metaDataFileSize)
                        metaDataDuration= getTimeFromMSec(player.duration)
                       
                        if(player.metaData.title==undefined){}
                        else{ metaDataTitle= player.metaData.title;}
                       
                        if(player.metaData.album==undefined){}
                        else{ metaDataAlbum= player.metaData.album;}
                      
                        if(player.metaData.genre==undefined){}
                        else{ metaDataGenre= player.metaData.genre;}
                        
                        metaDataBitRate= Math.round(metaData.bit_rate/1000);
                        var metaDataa = { "track": addiInfo, "artist" : bob };  
                        nowPlaying.setMetaData(metaDataa)
                    }
                
                    onError: {
                        console.log("Error: " + mediaError)
                       
                    }
                    onBufferStatusChanged: {audioBufferProgress=bufferStatus}

                    onPositionChanged: {
                        videoProgress= position
                        duratione= nowPlaying.duration
                        positione= nowPlaying.position
                        elapsedTime= controlsCont.getTimeFromMSec(position)
                     
                        playerDuration= duration
                        playerProgress=position
                        var metaData = { "track": player.addiInfo, "artist" : player.bob };  
                        nowPlaying.setMetaData(metaData)
                    }
                    onPlaybackCompleted: {mainnav.playbackCompleted=true;autoHideTimer.stop(); actionBarVisibility= ChromeVisibility.Overlay; if(playlistMode===false){mediaPlaying=false;}   mediaPaused=false;playerProgress=0;}
                    
                    onMediaStateChanged: {
                    console.log(mediaState)
                    nowPlaying.mediaState=player.mediaState
                    
                    if(mediaState==0){
                        console.log("UnPrepared")
                    }
                    else if(mediaState==1){
                        nowPlaying.acquire();
                        console.log("Prepared")
                    }
                    else if(mediaState==2){
                        console.log("Started")
                        nowPlaying.acquire();
                        playbackEndedCont.hide();
                        mainnav.playbackCompleted=false;
                        console.log("Video Height" + videoDimensions.height)
                        console.log("Video Width" + videoDimensions.width)
                        if(mediaFormat==="Video"){if(showPlaylist===false)autoHideTimer.start();}
                        else{autoHideTimer.stop(); showControls=true}
                        mediaPlaying=true;
                        mediaPaused=false;
                        mediaStopped=false;
                        metaDataDuration= controlsCont.getTimeFromMSec(player.duration);
                        var metaData = { "track": addiInfo, "artist" : bob };  
                        nowPlaying.setMetaData(metaData)
                        autoResizeDelay.start();
                        if(mediaFormat==="Audio"){checkForFileLyrics();}
                        

                    }
                    else if(mediaState==3){
                        metaDataHeight= videoDimensions.height;
                        metaDataWidth= videoDimensions.width;
                        console.log("Paused")
                        if(mediaFormat==="Video"){ actionBarVisibility= ChromeVisibility.Overlay;autoHideTimer.stop();}
                        mediaPaused=true;
                        
                    }
                    else if(mediaState==4){
                        if(mediaFormat==="Video"){console.log(videoProgress);console.log("Stopped");actionBarVisibility= ChromeVisibility.Overlay; autoHideTimer.stop();}
                        mediaPlaying=false;
                        mediaStopped=true;
                        console.log(nowPlaying.lastRevokingConnectionName)
                    }
                    }
                }
            ]
            
            ForeignWindowControl {
                id: fwcVideoSurface
                windowId: "myVideoSurface"
                visible: showPlaylist? false: sleepTimerPopup?false:true
                property double initialScale: mainCont.initialScreenScale
                property double scaleFactor: 0.1
                property double newScaleVal  
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                preferredWidth:player.videoDimensions.width
                preferredHeight: player.videoDimensions.height
                minWidth: player.videoDimensions.width
                updatedProperties: WindowProperty.Size |
                WindowProperty.Position |
                WindowProperty.Visible
                
            }
           /* ForeignWindowControl {
                id: fwcCaptionSurface
                windowId: "myCaptionSurface"
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                updatedProperties: WindowProperty.Size |
                WindowProperty.Position |
                WindowProperty.Visible
                preferredWidth: player.videoDimensions.width
                preferredHeight: player.videoDimensions.height
            }*/
            
            
           PlayPauseIndicator{id: fancyInd}
           MuteIndicator {id: muteInd }
           RepeatIndicator {id: fancyRepeatInd} 
           
            Container{
                background: brightTheme? Color.White: Color.Black
                layout: DockLayout {}
                onCreationCompleted: {
                    if(miniSquareDevice){touchAnimSwipeTut.destroy();}
                    else if( passport){touchAnimSwipeTut.destory();}
                    else if(OrientationSupport.orientation==UIOrientation.Landscape){touchAnimSwipeTut.destroy();}
                    else{
                    if(appsettings.getSystemSetting("FullTouchPlayerSwipeAnim", "")===""){
                        if(playlistMode){
                            if(OrientationSupport.orientation==UIOrientation.Portrait){
                            fullTouchPlayerSwipeAnimTimer.start();}
                           
                        }
                    }
                }}
          
                attachedObjects:[
                    ComponentDefinition {
                        id: touchAnimSwipeTut
                        property variant bob
                        function show(){bob = touchAnimSwipeTut.createObject(); artCont.add(bob); }
                        function hide(){artCont.remove(bob); volumeControls.opacity=touchVolumeControls?showPlaylist? 0: nightMode?0.6:0.80: 0}
                        content:FullTouchPlayerSwipeAnim {
                            id: touchAnimSwipeTutt
                            horizontalAlignment: HorizontalAlignment.Fill
                            verticalAlignment: VerticalAlignment.Fill
                        }},
                    SystemTimer {
                        id: fullTouchPlayerSwipeAnimTimer; interval:2000;onTimeout: {
                            fullTouchPlayerSwipeAnimTimer.stop();
                            artIMG.opacity=0;
                            volumeControls.opacity=0;
                            touchAnimSwipeTut.show();
                        }
                    },
                    Connections {
                        target:orientationH
                        onOrientationAboutToChange:{artIMG.opacity=0; 
                            if(sleepTimerPopup===false){fwcVideoSurface.visible=false;}mainCont.opacity=0;}
                        onOrientationChanged:{reOpacity.start();}
                },
                SystemTimer{
                    id: reOpacity
                    interval: 500
                    onTimeout: {
                        if(sleepTimerPopup===false){fwcVideoSurface.visible=true;}
                        reOpacity.stop();
                        artIMG.opacity=1;
                        mainCont.opacity=1;
                    }
                }
            ]
                id: artCont
                topPadding: 100
                bottomPadding: 100
                leftPadding: 5
                rightPadding: 5
                
                visible:mediaFormat==="Audio"?true:false
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                property int downX: 0
                property int downY: 0
              
             
                
                onTouch: {
                    
                    //console.log(event.windowX + " - " + event.windowY)
                    if (event.isDown()) {
                        
                        downX = event.windowX;
                        
                        downY = event.windowY;
                    
                    } else if (event.isUp()) {
                        console.log(event.windowY)
                        var yDiff = downY - event.windowY;
                        
                        // take absolute value of yDiff
                        
                        if (yDiff < 0) yDiff = -1 * yDiff;
                        
                        // I check if the minimum y movement is less than 200.  Don't want to move left or right if 
                        
                        // the user is actually want to move up or down.
                        
                        if ((yDiff) < 200) {
                            
                            if ((downX - event.windowX) > 320) {
                                
                                console.log("RIGHT SWIPE")
                                if(playlistMode){
                                page.nextTrack();}
                                else forwardPosition();
                            
                            } else if ((event.windowX - downX) > 320) {
                                
                                if(playlistMode){
                                    page.previousTrack();}
                                    else rewindPosition();
                            
                            
                            }
                        
                        }
                    
                    }
                
                }
               
            
                ImageView {
                gestureHandlers: TapHandler {
                        onTapped: {
                            if(mediaFormat==="Audio"){
                                if(playlistMode){
                                    playlistShowAction.triggered();
                                    
                                }
                                
                            }
                        }
                    }
                 
                    opacity: nightMode? 0.8:1.0
                    id: artIMG
                    
                    function updateSize() {}
                    maxWidth: miniSquareDevice? 370: OrientationSupport.orientation == UIOrientation.Portrait?pixelWidth==""? originalPixelWidth -15: pixelWidth -15:390
                    maxHeight:  miniSquareDevice?370: OrientationSupport.orientation == UIOrientation.Portrait?pixelHeight==""? originalPixelHeight -190: pixelHeight -190: 390
                    
                    function decideArtIMG(){if(passport===true){    
                            if (themeValue === "") {
                                return "images/PlayerAudioArts/default_passport.png"
                            } else if (themeValue === "#0092cc") {
                                return "images/PlayerAudioArts/default_passport.png"
                            } else if (themeValue === "#0000ff") {
                                return "images/PlayerAudioArts/blue_passport.png"
                            }
                            else if (themeValue === "#F52887") {
                                return "images/PlayerAudioArts/deeppink_passport.png"
                            }
                            
                            else if (themeValue === "red") {
                                return "images/PlayerAudioArts/red_passport.png"
                            } else if (themeValue === "#ff00ff") {
                                return "images/PlayerAudioArts/magenta_passport.png"
                            } else if (themeValue === "#9900ff") {
                                return "images/PlayerAudioArts/purple_passport.png"
                            }
                    }
                    else if(miniSquareDevice===true){
                        if(nightMode===true){
                            return "images/PlayerAudioArts/nightmode_720.png";
                        }
                        else if (themeValue === "") {
                            return "images/PlayerAudioArts/default_720.png"
                        } else if (themeValue === "#0092cc") {
                            return "images/PlayerAudioArts/default_720.png"
                        } else if (themeValue === "#0000ff") {
                            return "images/PlayerAudioArts/blue_720.png"
                        }
                        else if (themeValue === "#F52887") {
                            return "images/PlayerAudioArts/deeppink_720.png"
                        }
                        else if (themeValue === "red") {
                            return "images/PlayerAudioArts/red_720.png"
                        } else if (themeValue === "#ff00ff") {
                            return "images/PlayerAudioArts/magenta_720.png"
                        } else if (themeValue === "#9900ff") {
                            return "images/PlayerAudioArts/purple_720.png"
                        }
                    }
                    else{ 
                        if(pixelHeight===768){
                            
                            if(nightMode===true){
                                return "images/PlayerAudioArts/nightmode_768.png";
                            }
                            else if (themeValue === "") {
                                return "images/PlayerAudioArts/default_768.png"
                            } else if (themeValue === "#0092cc") {
                                return "images/PlayerAudioArts/default_768.png"
                            } else if (themeValue === "#0000ff") {
                                return "images/PlayerAudioArts/blue_768.png"
                            }
                            else if (themeValue === "#F52887") {
                                return "images/PlayerAudioArts/deeppink_768.png"
                            }
                            else if (themeValue === "red") {
                                return "images/PlayerAudioArts/red_768.png"
                            } else if (themeValue === "#ff00ff") {
                                return "images/PlayerAudioArts/magenta_768.png"
                            } else if (themeValue === "#9900ff") {
                                return "images/PlayerAudioArts/purple_768.png"
                            }
                        
                        }
                        if(pixelHeight===720){
                            
                            if(nightMode===true){
                                return "images/PlayerAudioArts/nightmode_720.png";
                            }
                            else if (themeValue === "") {
                                return "images/PlayerAudioArts/default_720.png"
                            } else if (themeValue === "#0092cc") {
                                return "images/PlayerAudioArts/default_720.png"
                            } else if (themeValue === "#0000ff") {
                                return "images/PlayerAudioArts/blue_720.png"
                            }
                            else if (themeValue === "#F52887") {
                                return "images/PlayerAudioArts/deeppink_720.png"
                            }
                            else if (themeValue === "red") {
                                return "images/PlayerAudioArts/red_720.png"
                            } else if (themeValue === "#ff00ff") {
                                return "images/PlayerAudioArts/magenta_720.png"
                            } else if (themeValue === "#9900ff") {
                                return "images/PlayerAudioArts/purple_720.png"
                            }
                        
                        }
                        
                        else{
                            
                            if(nightMode===true){
                                return "images/PlayerAudioArts/nightmode_normal.png";
                            }
                            else if (themeValue === "") {
                                return "images/PlayerAudioArts/default_normal.png"
                            } else if (themeValue === "#0092cc") {
                                return "images/PlayerAudioArts/default_normal.png"
                            } else if (themeValue === "#0000ff") {
                                return "images/PlayerAudioArts/blue_normal.png"
                            }
                            else if (themeValue === "#F52887") {
                                return "images/PlayerAudioArts/deeppink_normal.png"
                            }
                            
                            else if (themeValue === "red") {
                                return "images/PlayerAudioArts/red_normal.png"
                            } else if (themeValue === "#ff00ff") {
                                return "images/PlayerAudioArts/magenta_normal.png"
                            } else if (themeValue === "#9900ff") {
                                return "images/PlayerAudioArts/purple_normal.png"
                            }}
                    }}
                  visible: showPlaylist? false: sleepTimerPopup?false:true
                    imageSource: if(artWorkURI==="") {decideArtIMG();} else{if(showArtWorkWhenPossible===true){return artWorkURI} else{decideArtIMG();}}


                }
              
             
            }
          
            Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                opacity: nightModeOverLayBrightness
                background: videoOverlayValue===""?Color.Black: Color.create(videoOverlayValue)
                visible: nightModeOverLay? nightMode?true:false: false
            }
            Container {
                horizontalAlignment:HorizontalAlignment.Fill
                background:brightTheme? Color.White: Color.Black
                layout: DockLayout {}
                id: topControlsCont
                minHeight: passport?mediaFormat==="Audio"?200: 105: mediaFormat==="Audio"?180: 90
                verticalAlignment: VerticalAlignment.Top
                visible: showControls
                opacity:mediaFormat==="Video"?0.75:1.0
                
                Container {
                    id: titleCont
                    horizontalAlignment: HorizontalAlignment.Left
                    verticalAlignment:mediaFormat==="Audio"?VerticalAlignment.Top: VerticalAlignment.Center
                    leftPadding: 5
                    maxWidth:  repeatModeEnabled===true?pixelWidth==""? originalPixelWidth-115: pixelWidth-115:  pixelWidth==""? originalPixelWidth-50: pixelWidth-50
                    layout: DockLayout {}
                    
                     Label {
                     
                         opacity: nightMode? 0.8:1
                         onTextChanged: {if(alreadyRecentlyAdded===false){_recentlyPlayed.addToJson(metaDataFileName, audioSource,artWorkUriNonMod, controlsCont.getTimeFromMSec(player.duration), _app.checkIsHttp(audioSource)?"Stream": mediaFormat ); alreadyRecentlyAdded=true;}}
                        textStyle{
                            fontSize: FontSize.PointValue
                            fontSizeValue:mediaFormat==="Audio"? 9:8 }
                            text: metaDataTitle===""?metaDataFileName : metaDataTitle
                    }
 
                }
                Container {
                    id: artistCont
                    horizontalAlignment: HorizontalAlignment.Left
                    verticalAlignment:mediaFormat==="Audio"?VerticalAlignment.Top: VerticalAlignment.Center
                    leftPadding: 5
                    topPadding: mediaFormat==="Audio"?passport? 70:52:0
                    maxWidth:  repeatModeEnabled===true?pixelWidth==""? originalPixelWidth-115: pixelWidth-115:  pixelWidth==""? originalPixelWidth-50: pixelWidth-50
                    layout: DockLayout {}
                    
                    Label {
                        opacity:0.8
                        textStyle{
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7
                            color: brightTheme? Color.Black: Color.White
                            }
                        text: metaDataArtist
                    }
                   

                }
                Container {
                    
                    verticalAlignment: VerticalAlignment.Center
                    horizontalAlignment: HorizontalAlignment.Right
                    rightPadding: 2
                    opacity: nightMode?0.8:1
                    visible: mediaFormat==="Audio"? false:true
                    ImageView{
                        opacity: nightMode? 0.8:1
                        preferredHeight: 80
                        preferredWidth: 83
                        visible: repeatModeEnabled
                        imageSource: "asset:///images/repeat.png"
                    }
                }
                
                    Container {
                        id: albumCont
                        visible: mediaFormat==="Audio"?true:false
                        
                        horizontalAlignment: HorizontalAlignment.Left
                        verticalAlignment: VerticalAlignment.Bottom
                        leftPadding: 5
                        bottomPadding: 5
                        maxWidth: showPlaylist? pixelWidth==""? originalPixelWidth-10: pixelWidth-10: pixelWidth==""? originalPixelWidth-200: pixelWidth-200
                        layout: DockLayout {}
                        
                        Label {
                            opacity: nightMode? 0.8:1
                            textStyle{
                                fontSize: FontSize.PointValue
                                fontSizeValue: 7 }
                            text: metaDataAlbum===""?  qsTr("Unknown Album"):metaDataAlbum
                        }
                    }
                    Container {
                        layout: DockLayout {}
                        horizontalAlignment: HorizontalAlignment.Right
                        verticalAlignment: VerticalAlignment.Bottom
                    minWidth: 160
                    Container {
                        horizontalAlignment: HorizontalAlignment.Right
                        verticalAlignment: VerticalAlignment.Center
                        bottomPadding: 1
                        opacity: nightMode?0.8:1
                        visible: showPlaylist?false: mediaFormat==="Audio"?true:false
                    
                    ImageButton {
                        preferredHeight:70
                        preferredWidth: 70
                        defaultImageSource: repeatModeEnabled? "asset:///images/repeat_active_blue.png" : brightTheme? "asset:///images/repeat_dark.png":"asset:///images/repeat.png"
                        pressedImageSource: repeatModeEnabled? "asset:///images/repeat_active_blue_pressed.png" : brightTheme? "asset:///images/repeat_dark_pressed.png": "asset:///images/repeat_pressed.png"
                        onClicked: {
                               if(enabled){
                                   if(repeatModeEnabled===true){repeatModeEnabled=false;
                                       
                                       if(appsettings.getSystemSetting("fancyIndicators", "true")==="")toast.showText(qsTr("Repeat Disabled"))
                                       else fancyRepeatInd.show("RepeatOFF")
                                   }
                                   else{repeatModeEnabled=true; 
                                       if(appsettings.getSystemSetting("fancyIndicators", "true")==="")toast.showText(qsTr("Repeat Enabled"))
                                       else fancyRepeatInd.show("RepeatON")}
                                   
                               }
                           
                       }
                    }
                }
                Container {
                    horizontalAlignment: HorizontalAlignment.Left
                    verticalAlignment: VerticalAlignment.Center
                    bottomPadding: 1
                    id: shuffleButton
                    opacity: nightMode?0.8:1
                    visible: playlistMode? showPlaylist?false: mediaFormat==="Audio"?true:false : false
                    
                    ImageButton {
                        preferredHeight:58
                        preferredWidth: 60
                        defaultImageSource: shuffleMode? "asset:///images/shuffle_on_blue.png" :brightTheme? "asset:///images/shuffle_off_dark.png":"asset:///images/shuffle_off.png"
                        pressedImageSource: shuffleMode? "asset:///images/shuffle_on_blue_pressed.png" : brightTheme? "asset:///images/shuffle_off_dark_pressed.png": "asset:///images/shuffle_off_pressed.png"
                        onClicked: {
                            shuffle.triggered();
                        
                        }
                    }
                }
            }
                 
            
            }
            
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                bottomPadding: 90
                id: playlistCont
               // background: brightTheme?Color.White: Color.Black
                opacity: sleepTimerPopup? 1 :nightMode?showPlaylist?0.8:0: showPlaylist?1:0
                Container {
                 //   opacity:sleepTimerPopup?1:0
                    visible: sleepTimerPopup?true:false
                    topPadding:mediaFormat==="Audio"? 178: 100
                    
                    Divider {}
                    layout: StackLayout { }
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    Container {
                        topPadding: 10; leftPadding: 15;rightPadding: 20
                        layout: DockLayout {}
                        horizontalAlignment: HorizontalAlignment.Fill
                        verticalAlignment: VerticalAlignment.Top
                        Label {
                            opacity: nightMode?0.8:1
                            text:qsTr("Enable Sleep Timer")
                            verticalAlignment: VerticalAlignment.Center
                            horizontalAlignment: HorizontalAlignment.Left
                            textStyle {
                                base: SystemDefaults.TextStyles.BodyText
                                fontSize: FontSize.PointValue
                                fontSizeValue: miniSquareDevice?7:8
                            }
                        }
                        
                        ToggleButton {
                            opacity: nightMode?0.8:1
                            enabled: true
                            id: togglebutton
                            horizontalAlignment: HorizontalAlignment.Right
                            checked:sleepTimerEnabled
                            onCheckedChanged: {if(sleepTimerEnabled==true){sleepTimerEnabled=false;sleepTimer.stop();}
                                else{sleepTimerEnabled=true;sleepTimer.start();console.log(sleepTimer.interval)}
                            
                            }
                        }
                    
                    }
                    Container {
                        topPadding: 15
                        layout: DockLayout {
                        
                        }
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Bottom
                        Button {
                            color: Color.create(getAppColour())
                        
                            text: qsTr("Set Up Sleep Timer")
                            onClicked:{creator.createQMLObject("SleepTimerSettings.qml")}
                        }
                    }
                }
                Container{
                    topPadding:mediaFormat==="Audio"? sleepTimerPopup?10: passport? 140:190: sleepTimerPopup?10: passport? 140:110
                    opacity: showPlaylist? 1: sleepTimerPopup?0:0

                Header {
                    id:header
                    property int bob3: propertyToSaveIndexPathAsNumber
                    property int bob2 : bob3 +=1

                   property string bob: playQueue.size()
                   title: bob + " Item(s)"
                
                }
                
                
                ListView {
                    id: playListView
                    bottomPadding: controlsCont.minHeight/2
                    scrollRole: ScrollRole.Main
                    onCreationCompleted: {
                        path=  globalIndexPath;
                    }
                    property variant path
                    layout: StackListLayout { headerMode: ListHeaderMode.Sticky}
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    dataModel: playlistMode?playQueue: undefined
                    function editPlaylist(){creator.createQMLObject("PlaylistEdit.qml")}

                    listItemComponents: [
                       ListItemComponent {
                           type:"header"
                           Header {
                               visible: false
                           }
                       },
                        ListItemComponent {
                            type: "item"
                            CustomListItem {
                                
                                id: customItem
                                dividerVisible: false
                                highlightAppearance: HighlightAppearance.Frame
                          
                            Container {
                                id: itemContainer
                                
                            
                                PlaylistItem {
                                    id: itemr
                                    
                                    onCreationCompleted: {}
                                    attachedObjects: Connections{target: _app; onPlaylistTrackChanged:{console.log("SIGNALLLLLL");itemr.one=customItem.ListItem.indexPath.toString(); itemr.two=customItem.ListItem.view.path.toString();;itemr.selected=itemr.isItemSelected()}
                                    }
                                   
                                   property string one
                                   property string two
                                   function isItemSelected(){

                                       if(one === two){return true;}
                                       
                                       else{return false;}

                                    }
                                   onSelectedChanged: {
                                       console.log(one + " - "+ two + " - " +selected)
                                   }
                                   
                                    title: ListItemData.title
                                    img: ""
                                    imageEnabled: false
                                    allowQuickDelete: false
                                   
                                    contextActions:   ActionSet {
                                        title:  ListItemData.title
                                        subtitle: ListItemData.sourceUrl
                                        actions:[
                                            ActionItem {
                                     
                                              title: "Edit Playlist" 
                                              imageSource:"images/ic_edit_list.png"
                                              onTriggered: { customItem.ListItem.view.editPlaylist();}
                                            }
                                           
                                        ]
                                    }

                                }
                            }
                      
                            }
                        }
                    
                    ]
                    onTriggered: {
                        console.log("Triggered: " + indexPath)
                    
                       globalIndexPath=indexPath;
                       path=indexPath;
                       console.log(globalIndexPath)
                        
                       if(shuffling===false){
                           
                        var data = playQueue.data(indexPath)
                     //   console.log("Title: " + data.title)
                      //  console.log("Source URL: " + data.sourceUrl)
                       
                      
                      
                        originalSource= data.sourceUrl;
                        
                        player.stop();
                        clearMetaData();
                        autoResizeAttempted=false;
                      //  originalSource= _app.removeURLEncoding(data.sourceUrl);
                      
                        if( _app.checkIsHttp(data.sourceUrl)==true){ audioSource=  data.sourceUrl}
                        else{
                            audioSource= "file://" + data.sourceUrl}
                        player.play();
                        setFileFormat();
                        getFileArtWork();
                        updateCoverImage();
                        next.enabled=playQueue.after(indexPath)==""?false:true
                        prev.enabled=playQueue.before(indexPath)==""?false:true
                        autoResizeDelay.start();
                        showControls=true;
                       // header.bob3=  propertyToSaveIndexPathAsNumber
                        _app.firePlaylistChanged();
                        playListView.scrollToItem(indexPath)
                        changeButtonsEnabled=true;
                        fileSystemLyricsFound=false;
                        lyrcs.setImageSource("asset:///images/ic_search.png");
                        checkForFileLyrics();
                       setLockScreenArt();
                    }
                  
                    shuffling=false;
                    }
                }
        }
            }
            
          Container {
              visible: hardwareInfo.isPhysicalKeyboardDevice?false: showControls
              horizontalAlignment:HorizontalAlignment.Right
              verticalAlignment: VerticalAlignment.Center
              opacity: touchVolumeControls?showPlaylist? 0: nightMode?0.6:0.80: 0
              minWidth: 95
              maxWidth: 95
              id: volumeControls
              background: brightTheme? Color.White: Color.Black
            
              layout: StackLayout {}
              Container {
                  id:up
                  topPadding: 20
                  bottomPadding: 15
                 // verticalAlignment: VerticalAlignment.Top
                  horizontalAlignment: HorizontalAlignment.Center
                  
                  ImageButton {
                      defaultImageSource:brightTheme? "images/volumeUp_dark.png": "images/volumeUp.png"
                      onClicked: {
                          if(mediaFormat==="Video")autoHideTimer.restart();
                          _app.increaseMediaVolume()
                      }
                  }
              }
              Divider {
                  
                  verticalAlignment: VerticalAlignment.Center
              }
              Container {
                  id: down
                  topPadding: 15
                  bottomPadding: 20
                //  verticalAlignment: VerticalAlignment.Bottom
                  horizontalAlignment: HorizontalAlignment.Center
                  
                  ImageButton {
                      defaultImageSource: brightTheme? "images/volumeDown_dark.png": "images/volumeDown.png"
                      onClicked: {
                          if(mediaFormat==="Video")autoHideTimer.restart();

                          _app.decreaseMediaVolume()
                      }
                     
                  }
              }
          }
            
            Container {
                id: controlsCont
                layout: DockLayout {}
                function getTimeFromMSec(msec) {
                    
                    if (msec <= 0 || msec == undefined) {
                        return "0:00"
                    
                    } else {
                        var sec = "" + Math.floor(msec / 1000) % 60
                        if (sec.length == 1)
                            sec = "0" + sec
                        
                        var hour = Math.floor(msec / 3600000)
                        if (hour < 1) {
                            return Math.floor(msec / 60000) + ":" + sec
                        } else {
                            var min = "" + Math.floor(msec / 60000) % 60
                            if (min.length == 1)
                                min = "0" + min
                            
                            return hour + ":" + min + ":" + sec
                        }
                    }
                }
                horizontalAlignment:HorizontalAlignment.Fill
                background:brightTheme? Color.White: Color.Black
                minHeight: if(passport===true){return 300}
                else if(device768===true){return 235}
                else if(miniSquareDevice===true){return 200}
                else{return 195;}
                
                verticalAlignment: VerticalAlignment.Bottom
                visible: showControls
                opacity: mediaFormat==="Audio" ? 1: 0.75
                Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Top    
                leftPadding: 15
                rightPadding: 15
                
                Slider {
                    opacity: nightMode? 0.8:1
                    enabled: player.seekable
                    fromValue: 0
                    toValue: player.duration
                  value: player.position
                  property bool touchh
                  property bool sliderUpdatedByTouch
                  eventHandlers: [
                      NavigationHandler {
                          onNavigation: {
                              // Prints out the type of event that occurs. You can use
                              // this value to determine where to navigate in the app
                              console.log("NavigationEvent: " + event.navigationEventType)
                          }                    
                      } 
                  ]
                
                  onImmediateValueChanged: {
                      elapsedLabel.text= controlsCont.getTimeFromMSec(immediateValue)
                  }
                  onTouch: {
                      if (event.isUp()) sliderUpdatedByTouch=true; 
                      if(OrientationSupport.orientation == UIOrientation.Portrait){player.pause();}
                   //   console.log("UPDATED BY TOUCH")
                   
                  }
                
                    onValueChanged: {
                            if (sliderUpdatedByTouch == true) {
                        player.seek(player.track, value)
                            sliderUpdatedByTouch = false;
                          
                            player.play();
                            }
                    }
                }
                
            }
            Container {
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Center
                leftPadding: 15
                bottomPadding: 42
                
                Label {
                    id: elapsedLabel
                    opacity: nightMode? 0.8:1
                    textStyle{
                        fontSize: FontSize.PointValue
                        fontSizeValue: 6 }
                    text: elapsedTime
                }
            }
            Container {
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Center
                rightPadding: 15
                bottomPadding: 42
                
                Label {
                    opacity: nightMode? 0.8:1
                    textStyle{
                        fontSize: FontSize.PointValue
                        fontSizeValue: 6 }
                    text:controlsCont.getTimeFromMSec(player.duration)
                    
                }
            }
            
            }
            
          
            Container {
                id: bufferCont
                layout: DockLayout {}
                horizontalAlignment:HorizontalAlignment.Fill
                background: brightTheme? Color.White: Color.Black
                verticalAlignment: VerticalAlignment.Fill
                visible: true
                opacity: audioBufferProgress===1? 0.7:0
                Container {
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                
                ActivityIndicator {
                    id: bufferInd
                    preferredHeight: 150
                    preferredWidth: 150
                    running: audioBufferProgress===1? true:false
                }
            }
            
            }
            Container {
                id: playbackEndedCont
                layout: DockLayout { }
                horizontalAlignment:HorizontalAlignment.Fill
                background: brightTheme? Color.White: Color.Black
                verticalAlignment: VerticalAlignment.Fill
                visible: true
                opacity: 0
                property variant bob
                function hide() {opacity=0; playbackEndedCont.remove(bob)}
                function show(){ opacity=mediaFormat==="Audio"?1: brightTheme? 0.9:0.8; bob = ended.createObject(); playbackEndedCont.add(bob)}
                attachedObjects: ComponentDefinition {
                    id: ended
                    content: Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        StandardListItem {
                            opacity: nightMode? 0.8:1
                            title: playlistMode? qsTr("Replay Playlist"): mediaFormat==="Audio"? qsTr("Replay Audio File") :qsTr("Replay Video")
                            description: playlistMode?"": metaDataTitle===""? metaDataFileName: metaDataTitle
                            imageSource:brightTheme? "asset:///images/ic_play_dark.png": "asset:///images/ic_play.png"
                            gestureHandlers: [
                                TapHandler {
                                    onTapped: {
                                        if(playlistMode){
                                            playListView.triggered( playQueue.first())
                                        }
                                        
                                  else{ 
                                      if(mainnav.playbackCompleted)playPauseMedia(); playbackEndedCont.opacity=0;}
                                    }
                                }
                        ]
                        }
                    
                        StandardListItem {
                            enabled:true
                            opacity: nightMode? 0.8:1

                            visible: playlistMode?true:false
                            title: "Show Playlist"
                            imageSource: brightTheme? "images/playlist_dark.png": "images/playlist.png"    
                            gestureHandlers: TapHandler {
                                onTapped: {
                                    playbackEndedCont.hide();autoHideTimer.stop(); showPlaylist=true;showControls=true; playListView.scrollToItem(globalIndexPath)
                                }
                            }
                            }
                            StandardListItem {
                                opacity: nightMode? 0.8:1
                                visible: playlistMode?true:false
                                title:  mediaFormat==="Audio"? qsTr("Replay Track"):qsTr("Replay Video")
                                description: metaDataTitle===""? metaDataFileName: metaDataTitle
                                imageSource: brightTheme ? "asset:///images/ic_play_dark.png": "asset:///images/ic_play.png"
                                gestureHandlers: [
                                    TapHandler {
                                        onTapped: {
                                            if(mainnav.playbackCompleted)playPauseMedia(); playbackEndedCont.hide();}
                                    }
                                ]
                            }
                            StandardListItem {
                                enabled:true
                                opacity: nightMode? 0.8:1

                                visible: playlistMode?true:false
                                title: "Open Playlists"
                                imageSource: brightTheme? "images/playlist_dark.png": "images/playlist.png"    
                                gestureHandlers: TapHandler {
                                    onTapped: {playerClose();playlistMode=false;enabled=false; creator.createQMLObject("PlaylistEditor.qml")
                                    }
                                }
                            }
                            StandardListItem {
                                enabled:true
                                opacity: nightMode? 0.8:1
                                
                                visible: playlistMode?true:false
                                title: "Edit Playlist"
                                imageSource: brightTheme? "images/ic_edit_dark.png": "images/ic_edit.png"    
                                gestureHandlers: TapHandler {
                                    onTapped: {creator.createQMLObject("PlaylistEdit.qml")
                                    
                                    }
                                }
                            }
                        StandardListItem {
                            enabled: true
                            visible: playlistMode?false: inAppRecordingPlaying?false:true
                            opacity: nightMode? 0.8:1
                            title: mediaFormat==="Audio" ? qsTr("Choose Another Audio File" ): qsTr("Choose Another Video")
                            imageSource: mediaFormat==="Audio"? brightTheme?"images/music_small_dark.png":"images/music_small.png"  : brightTheme? "asset:///images/video_dark.png":"asset:///images/video.png"
                            gestureHandlers: [
                                TapHandler {
                                    onTapped: {
                                        activity.running=true;activity.visible=true;
                                        playerClose();
                                       
                                       if(mediaFormat==="Audio"){pickerAudio.createObject();}
                                       else{ 
                                           if(customPickerUsed)creator.createQMLObject("VideoPicker.qml")
                                           else{
                                           picker.createObject();}}
                                      enabled=false;
                                    }
                                }
                            ]

                        }
                        StandardListItem {
                            enabled: true
                            opacity: nightMode? 0.8:1
                            title: qsTr("Last Played")
                            imageSource: brightTheme? "images/ic_history_dark.png":"images/ic_history.png"
                            gestureHandlers: [
                                TapHandler {
                                    onTapped: {
                                        playerClose();                                     
                                        if (protectedMode) {
                                            creator.createQMLObject("ProtectedModeRec.qml")
                                        } else {
                                            creator.createQMLObject("RecentlyPlayed.qml")
                                        }
                                    }
                                }
                            ]
                    
                        }
                        StandardListItem {
                            enabled: appsettings.getSystemSetting("PinnedMediaViewer", "")===""? pinnedCount >=15? false: true: pinnedCount >=5? false: true

                            opacity: nightMode? 0.8:1
                            id: pinnedItem
                            visible:  inAppRecordingPlaying?false:true
                            description:appsettings.getSystemSetting("PinnedMediaViewer", "")===""?qsTr("You can Pin a Maximum of 15 items to Home"):  qsTr("You can Pin a Maximum of 5 items to Home")
                            title: mediaFormat=== "Audio"? qsTr("Pin Audio File To Home"):qsTr("Pin Video To Home")
                            imageSource:brightTheme? "asset:///images/pin_dark.png": "asset:///images/pin.png"
                            property int bob
                            property string neww:artWorkURI
                            gestureHandlers: [
                                
                                TapHandler {
                                    onTapped: {
                                        if(pinnedItem.enabled===true){
                                            var art;
                                            var bobe= neww.replace("file://", "");
                                            
                                            if(artWorkURI===""){art=""
                                                bob= pinnedCount+=1
                                                var fileTitle= metaDataTitle==="" ?metaDataFileName: metaDataTitle
                                                _pinnedVideos.addToJson( fileTitle,  audioSource, "", controlsCont.getTimeFromMSec(player.duration), sourceStreamed?"WebStream":mediaFormat, art, bob); mediaFormat==="Audio"?toast.showText("Audio File Pinned To Home") :  toast.showText("Video Pinned To Home")
                                                console.log(pinnedCount)
                                                enabled=false;
                                            }
                                            
                                            else if(_app.checkFileExists(bobe)==true){
                                                console.log("Exists")
                                                _app.dirCheckOrCreate(_app.homePath()+ "/pinnedArt")
                                                art= _app.homePath()+ "/pinnedArt/" + metaDataFileName+".jpg";
                                                console.log(art)
                                                console.log("DOES IT INITIALLY EXIST? " + _app.checkFileExists(bobe))
                                                
                                                _app.copyFile(bobe, art);
                                                console.log("SOURCE: " + bobe)
                                                console.log("DOES IT STILL EXIST? " + _app.checkFileExists(bobe))
                                                bob= pinnedCount+=1
                                                var fileTitle= metaDataTitle==="" ?metaDataFileName: metaDataTitle
                                                _pinnedVideos.addToJson( fileTitle,  audioSource, "", controlsCont.getTimeFromMSec(player.duration), sourceStreamed?"WebStream":mediaFormat, "file://"+art, bob); mediaFormat==="Audio"?toast.showText("Audio File Pinned To Home") :  toast.showText("Video Pinned To Home")
                                                console.log(pinnedCount)
                                                neww=artWorkURI;
                                                
                                                enabled=false; 
                                            }
                                            else{
                                                bob= pinnedCount+=1
                                                var fileTitle= metaDataTitle==="" ?metaDataFileName: metaDataTitle
                                                _pinnedVideos.addToJson( fileTitle,  audioSource, "", controlsCont.getTimeFromMSec(player.duration), sourceStreamed?"WebStream":mediaFormat, "", bob); mediaFormat==="Audio"?toast.showText("Audio File Pinned To Home") :  toast.showText("Video Pinned To Home")
                                                console.log(pinnedCount)
                                                enabled=false;
                                            }
                                           }
                                    }
                                }
                            ]
                            property int pinnedAmount
                        }
                    }
                }
          
        }
            
    }
    }

