import bb.cascades 1.4
import bb.cascades.pickers 1.0
import timer 1.0
import QtQuick 1.0
import "Custom"

Sheet{
    id: settingsp
    onCreationCompleted: {
        open(); toggler.start();
    }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title:qsTr( "Player Settings")
            
            dismissAction: ActionItem {
                title: qsTr("Close") 
                onTriggered: {
                    close();settingsp.destroy();
                }
            
            }
        }
        attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true; togglebutton1.enabled=true;togglebutton2.enabled=true; togglebutton5.enabled=true;togglebutton6.enabled=true;togglebutton7.enabled=true;togglebutton8.enabled=true;togglebutton9.enabled=true;togglebutton10.enabled=true;togglebutton11.enabled=true;togglebutton12.enabled=true;togglebutton13.enabled=true;if(mediaPlaying===false){togglebutton3.enabled=true};togglebutton4.enabled=true;}}
        ScrollView {
            attachedObjects: Connections {
                target: mainnav
                onShowPlayerSettingsUI:{eqbut.visible=true;vidcont.visible=true;fancyin.visible=true;touchCon.visible=true;tpcg.visible=true;rz.visible=true; pz.visible=true;  tp.visible=true; ftd.visible=true; fdt.visible=true; arts.visible=true;artl.visible=true;autor.visible=true;autop.visible=true;autor1.visible=true; autor2.visible=true; mopb.visible=true; }
            }
            id: scroller
            scrollRole: ScrollRole.Main

            content: Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Center
                id: conter
                topPadding: 5
                bottomPadding: 5
                layout: StackLayout { }
                UserInfoBanner{onClicked:{creator.createQMLObject("Help/SettingsDisabled.qml")} visible: mediaPlaying?true:false;text: "Some Player Settings are disabled because media is playing, tap to learn more"}

                Container {
                    id: mopb
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Minimise App When Playback Starts")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:autoHideAppOnPlay
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(autoHideAppOnPlay===true) {appsettings.saveSystemSetting("autoHideAppOnPlay", "");autoHideAppOnPlay=false;
                                }
                                else{appsettings.saveSystemSetting("autoHideAppOnPlay", "true"); autoHideAppOnPlay=true;
                                }
                            }
                        }
                    }
                }
                Container {
                    id: autor1
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Resume Playback Position")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton9
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("fileDidNotComplete", "")==""?true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("fileDidNotComplete", "")==="") {appsettings.saveSystemSetting("fileDidNotComplete", "false");
                                }
                                else{appsettings.saveSystemSetting("fileDidNotComplete", ""); 
                                }
                            }
                        }
                    }
                }
                Container {
                    id: autor2
                    visible: togglebutton9.checked?true:false
                    opacity: togglebutton9.checked? 1.0:0 
                    
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Show Resume Playback Popup")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton12
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("fileDidNotCompletePopup", "")==""?true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("fileDidNotCompletePopup", "")==="") {appsettings.saveSystemSetting("fileDidNotCompletePopup", "false");
                                }
                                else{appsettings.saveSystemSetting("fileDidNotCompletePopup", ""); 
                                }
                            }
                        }
                    }
                }
               
                Container {
                    id: autop
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Pause When Headphones Removed")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton1
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:autoPausePlayer
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(autoPausePlayer===true) {appsettings.saveSystemSetting("autoPausePlayer", "false");autoPausePlayer=false;
                                }
                                else{appsettings.saveSystemSetting("autoPausePlayer", ""); autoPausePlayer=true;
                                }
                            }
                        }
                    }
                }
                Container {
                    id:autor
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Automatically Resize Video")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton7
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("autoVideoResize", "")===""? true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("autoVideoResize", "")==="") {appsettings.saveSystemSetting("autoVideoResize", "false");
                                }
                                else{appsettings.saveSystemSetting("autoVideoResize", "");
                                }
                            }
                        }
                    }
                }
                Container {
                    id: arts
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Show Art Work When Possible")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton8
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("ShowArtWorkWhenPossible", "")===""? true:false
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(showArtWorkWhenPossible===true) {appsettings.saveSystemSetting("ShowArtWorkWhenPossible", "false"); showArtWorkWhenPossible=false
                                }
                                else{appsettings.saveSystemSetting("ShowArtWorkWhenPossible", ""); showArtWorkWhenPossible=true;
                                }
                            }
                        }
                    }
                }
                Container{
                    topPadding: 10;
                    leftPadding: 10; rightPadding: 10
                    id: artcirc
                    enabled: mediaPlaying?false:true
                    visible: showArtWorkWhenPossible?true:false
                    opacity: showArtWorkWhenPossible?1:0
                    DropDown {
                        opacity: nightMode?0.8:1
                        onCreationCompleted: {
                            if(appsettings.getSystemSetting("artworkShapeIndex", "")===""){selectedIndex=0}
                            else{selectedIndex=parseInt(appsettings.getSystemSetting("artworkShapeIndex", ""))}
                        }
                        onSelectedIndexChanged: {
                            appsettings.saveSystemSetting("artworkShape", selectedValue)
                            appsettings.saveSystemSetting("artworkShapeIndex", selectedIndex)
                        
                        }
                        title:qsTr( "Album Art Work Shape")
                        Option {
                            text: qsTr("Normal")
                            value: ""
                        }
                        
                        Option {
                            text:qsTr( "Curved Corners")
                            value: "curved"
                        }
                        Option {
                            text: qsTr("Round")
                            value: "circle"
                        }
                    }
                }
                Container {
                    id:artl
                    visible: showArtWorkWhenPossible===true?true:false
                    opacity: showArtWorkWhenPossible===true? 1.0:0
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    attachedObjects: FilePicker {
                        id: picker
                        onError: {
                            toast.showText(error)
                        }
                        Component.onCompleted: {}
                        type: FileType.Picture
                        mode: FilePickerMode.Picker
                        title:  qsTr("Select Default Wallpaper")
                        directories: ["/accounts/"]
                        filter: FileType.Picture
                        
                        onCanceled: {
                            if(appsettings.getSystemSetting("lockscreenartdefault", "")===""){
                            appsettings.saveSystemSetting("lockscreenart", ""); lockscreenart=false;}
                        }
                        onFileSelected: {
                            console.log("FileSelected signal received : " + selectedFiles);
                            appsettings.saveSystemSetting("lockscreenartdefault", selectedFiles[0].toString());
                            defaultPaperButton.imageSource="file://"+selectedFiles[0].toString()
                            toast.showTextWithButton("Default Wallpaper Set.\n This is used by Star Player when a Track doesn't have ArtWork and will be applied when you close Star Player\n\nPlease Note, we cannot prevent the 'Picture set as Wallpaper' Message from appearing.\n\nFor more info see Star Player Help", "OK", "")
                            
                        }
                    }
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Show Art Work On Lockscreen")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton10
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:lockscreenart
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(lockscreenart===true) {appsettings.saveSystemSetting("lockscreenart", ""); lockscreenart=false
                                }
                                else{appsettings.saveSystemSetting("lockscreenart", "true"); lockscreenart=true;if(appsettings.getSystemSetting("lockscreenartdefault", "")===""){picker.open();}
                                }
                            }
                        }
                    }
                }
               
                    
                    Button {
                        color: Color.create(getAppColour())
                        id: defaultPaperButton
                        enabled: mediaPlaying?false:true
                        visible: lockscreenart?true:false
                        opacity: lockscreenart?1:0
                        horizontalAlignment: HorizontalAlignment.Fill
                        verticalAlignment: VerticalAlignment.Fill
                        text: "Default Lockscreen Wallpaper"
                        imageSource: "file://" + appsettings.getSystemSetting("lockscreenartdefault", "")
                        onClicked: {
                            picker.open();
                        }
                    }
                
                Container {
                    id: fdt
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Fade In Audio")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton3
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:fadeInAudio
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(fadeInAudio===true) {appsettings.saveSystemSetting("fadeInAudio", "");fadeInAudio=false;
                                }
                                else{appsettings.saveSystemSetting("fadeInAudio", "true"); fadeInAudio=true;
                                }
                            }
                        }
                    }
                }
               Container {
                   topPadding: 10; leftPadding: 10; rightPadding: 10

                    id: ftd
                    enabled: mediaPlaying?false:true
                    visible: fadeInAudio?true:false
                    opacity: fadeInAudio?1:0
                    DropDown {
                        opacity: nightMode?0.8:1
                        onCreationCompleted: {
                            if(appsettings.getSystemSetting("audioFadeSpeedindex", "")===""){selectedIndex=1}
                            else{selectedIndex=parseInt(appsettings.getSystemSetting("audioFadeSpeedindex", ""))}
                        }
                        onSelectedIndexChanged: {
                            appsettings.saveSystemSetting("audioFadeSpeed", selectedValue)
                            appsettings.saveSystemSetting("audioFadeSpeedindex", selectedIndex)

                        }
                        title:qsTr( "Fade Speed")
                        Option {
                            text: qsTr("Slow")
                            value: "170"
                        }
                        
                        Option {
                            text:qsTr( "Medium")
                            value: "70"
                        }
                        Option {
                            text: qsTr("Fast")
                            value: "30"
                        }
                    }
                }
                Container {
                    
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    id: tp
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Touch Video Panning")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        opacity: nightMode?0.8:1
                        enabled: false
                        id: togglebutton2
                        horizontalAlignment: HorizontalAlignment.Right
                        checked: touchPan
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(touchPan===true) {appsettings.saveSystemSetting("touchPan", "");touchPan=false; resetVideoPanning();
                                }
                                else{appsettings.saveSystemSetting("touchPan", "true"); touchPan=true;
                                }
                            }
                        }
                    }
                }
                Container {
                    
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                id: pz
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Pinch To Zoom")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton4
                        horizontalAlignment: HorizontalAlignment.Right
                        checked: touchZoom
                          onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(touchZoom===false) {appsettings.saveSystemSetting("touchZoom", "");touchZoom=true;
                                }
                                else{appsettings.saveSystemSetting("touchZoom", "false"); touchZoom=false; if(autoResizeAttempted===false){resetTouchZoom();}
                                }
                            }
                        }
                    }
                }
                Container {
                    id: rz
                    visible: touchZoom===true?true:false
                    opacity: touchZoom===true? 1.0:0
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Responsive Pinch To Zoom")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton6
                        horizontalAlignment: HorizontalAlignment.Right
                        checked: responsiveZoom
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(responsiveZoom===true) {appsettings.saveSystemSetting("FasttouchZoom", "");responsiveZoom=false;
                                }
                                else{appsettings.saveSystemSetting("FasttouchZoom", "true");responsiveZoom=true;
                                }
                            }
                        }
                    }
                }
                
                Container {
                    visible: passport?true:false
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    id: tpcg
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Touch Keyboard Gestures")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton13
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:passportTrackKeyboard
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(passportTrackKeyboard===true) {appsettings.saveSystemSetting("passportTrackKeyboard", "");passportTrackKeyboard=false
                                }
                                else{appsettings.saveSystemSetting("passportTrackKeyboard", "true"); passportTrackKeyboard=true;eqbut.visible=false;vidcont.visible=false;fancyin.visible=false;touchCon.visible=false;tpcg.visible=false;rz.visible=false; pz.visible=false;  tp.visible=false; ftd.visible=false; fdt.visible=false; arts.visible=false;artl.visible=false;autor.visible=false;autop.visible=false;autor1.visible=false; autor2.visible=false; mopb.visible=false;  conter.add(creator.createQMLObject("Custom/PassportKeyboardSwipeAnim.qml"))
                                }
                            }
                        }
                    }
                }
                Container {
                    id: touchCon
                    visible: hardwareInfo.isPhysicalKeyboardDevice?false:true
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Touch Volume Controls")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        opacity: nightMode?0.8:1
                        enabled: false
                        id: togglebutton11
                        horizontalAlignment: HorizontalAlignment.Right
                        checked: touchVolumeControls
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(touchVolumeControls===true) {appsettings.saveSystemSetting("touchVolumeControls", "false");touchVolumeControls=false; 
                                }
                                else{appsettings.saveSystemSetting("touchVolumeControls", ""); touchVolumeControls=true;
                                }
                            }
                        }
                    }
                }
                Container {
                    
                    topPadding: 10; leftPadding: 20;rightPadding: 20
                    layout: DockLayout {}
                    id: fancyin
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Fancy Indicators")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: miniSquareDevice?7:8
                        }
                    }
                    
                    ToggleButton {
                        enabled: false
                        opacity: nightMode?0.8:1
                        id: togglebutton5
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:appsettings.getSystemSetting("fancyIndicators", "true")===""? false:true
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(appsettings.getSystemSetting("fancyIndicators", "")==="") {appsettings.saveSystemSetting("fancyIndicators", "true");
                                }
                                else{appsettings.saveSystemSetting("fancyIndicators", "");
                                }
                            }
                        }
                    }
                }
                Container {
                    leftPadding: 20;rightPadding: 20; topPadding: 15
                    layout: DockLayout {}
                    minHeight:120
                    id: vidcont
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Video Controls Timeout:")
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7
                        }
                    }
                    Label {
                        opacity: nightMode?0.8:1
                        text: Math.floor((slider.immediateValue/1000) % 60) + " Seconds"
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Right
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 6
                        }
                    }
                    Slider {
                        opacity: nightMode?0.8:1
                        id:slider
                        verticalAlignment: VerticalAlignment.Bottom
                        horizontalAlignment: HorizontalAlignment.Fill
                        value: videoControlsTimeout
                        toValue:59000
                        fromValue: 5000
                        onValueChanged: {videoControlsTimeout=slider.immediateValue;appsettings.saveSystemSetting("videoControlsTimeout", immediateValue)}
                    }
                }
                Container {
                    leftPadding: 10; rightPadding: 10;topMargin: 10
                    horizontalAlignment: HorizontalAlignment.Fill
                
               Button {
                   opacity: nightMode?0.8:1
                   id:eqbut
                   color: Color.create(getAppColour())
                   horizontalAlignment: HorizontalAlignment.Fill
                   verticalAlignment: VerticalAlignment.Fill
                   text: qsTr("Equaliser Present")
                   onClicked: {
                       creator.createQMLObject("EqualiserPresetPage.qml");
                   }
               }}
                
        
            }
        }
    }
}
