import QtQuick 1.0
import bb.cascades 1.4
import bb.cascades.pickers 1.0
import bb.system 1.2
import "Custom"
import bb.device 1.3
import timer 1.0
Sheet {
        property int propertyToSaveIndexPathAsNumberr: 0
        property variant listData
        property variant bib
        property bool triggeredBySave
        property int itemsCount
        property bool playlistCleared:true
        signal newPlaylistCreated
        onCreationCompleted: {
            if(playlistCreatorOpen){sheet.destroy();}
            else{playlistCreatorOpen=true; open();}
            if(playListCreatorFolderMode){folderClearDio.createObject();}
            if(playlistM3uImporting){importm3uDio.createObject();}
            if(incomingNewPlaylistAddition){ createListModel.insert({
                        "title": fileTitleToBeAddedToList,
                        "sourceUrl": fileURLToBeAddedToList
            });incomingNewPlaylistAddition=false;}
            }
    
            Component.onDestruction: {playlistCreatorOpen=false;playListCreatorFolderMode=false;playlistM3uImporting=false;}
    
    id: sheet
    signal savingCompleted
    attachedObjects:[
Connections {
  target: _app
  onMultipleFileImport:{console.log(b + d);  createListModel.insert({
              "title": b,
              "sourceUrl": d
  });   }
  
},
        ComponentDefinition {
          id: importm3uclear
          content: 
          Container {
              id: cont
              onCreationCompleted: {diocl.show();}
              attachedObjects: 
              SystemDialog{
                  id: diocl
                  title: qsTr("Import")
                  body: qsTr("Would you like to clear the Playlist before importing?")
                  buttonAreaLimit: 2
                  confirmButton.label: qsTr("Clear")
                  confirmButton.enabled: true
                  cancelButton.label: qsTr("No")
                  cancelButton.enabled: true
                  onFinished: {
                      if(result == SystemUiResult.ConfirmButtonSelection) {createListModel.clear();importm3uDio.createObject();diocl.cancel();
                      }
                      else if (result == SystemUiResult.CancelButtonSelection) {
                          importm3uDio.createObject(); diocl.cancel();
                      
                      }
                  }
              }
          }  
        },
        ComponentDefinition {
          id: importm3uDio
          content: 
          Container {
              id: conterr
              property string bob
              onCreationCompleted: {dioi.show(); dioi.cancelButton.enabled=false; dioi.cancelButton.label=undefined;
                  _app.importM3UPlaylist(importSource, false);
              }
              
              attachedObjects: [
                  SystemTimer{
                      id: closetimerr;
                      interval: 500
                      onTimeout: {
                          closetimerr.stop();
                          dioi.cancel();
                         // if(carMode){openCarModePlaylist();}
                         // else{
                          //    if(playlistEditorOpened){_playlist.updatePlaylistModel();}
                            //  else{
                              //    creator.createQMLObject("PlaylistEditor.qml");}}
                      }
                  },
                  Connections {
                      target:_app
                      onM3UImportFinished:{bob= qsTr("Finished Adding Files");dioi.body=bob; closetimerr.start();}
                      onM3UImportItem:{b.length>40? bob=b.substring(0,10):bob=b; dioi.body=bob;console.log(d);  createListModel.insert({
                                  "title": b,
                                  "sourceUrl": d
                      });
                      }
                  
                  },
                  SystemDialog{
                      id: dioi
                      title: qsTr("Importing")
                      body: qsTr("Importing Media, this may take a while..")
                      buttonAreaLimit: 2
                      autoUpdateEnabled: true
                      activityIndicatorVisible: true
                      confirmButton.label: undefined
                      cancelButton.label:undefined
                      cancelButton.enabled: false
                  
                  }
              ]
          }  
        },
        
        
        ComponentDefinition {
          id: savingPlaylistDio
          content: Container {
              onCreationCompleted: {
                  savelistdio.show();
              }
              attachedObjects:  [ 
                  Connections {
                    target: sheet
                    onSavingCompleted:{savelistdio.cancel();}  
                  },
                  SystemDialog{
                  id:savelistdio
                  title: qsTr("Saving Playlist")
                  body: qsTr("Saving Playlist, this may take a while..")
                  buttonAreaLimit: 2
                  autoUpdateEnabled: true
                  activityIndicatorVisible: true
                  confirmButton.label: undefined
                  cancelButton.label: undefined
                  cancelButton.enabled: false
              
              }]
          }   
        },
        ComponentDefinition {
          id: folderClearDio
          content: 
          Container {
              id: conttt
              onCreationCompleted: {diooo.show();}
              attachedObjects: 
              SystemDialog{
                  id: diooo
                  autoUpdateEnabled: true
                  title: qsTr("Folder Play")
                  body: createListModel.childCount(0,0)===0? "Would you like to include Sub Folders when searching for files?": qsTr("Would you like to clear the Playlist before using Folder Play?")
                  buttonAreaLimit: 2
                  confirmButton.label:  createListModel.childCount(0,0)===0? "Continue":qsTr("Clear")
                  confirmButton.enabled: true
                  cancelButton.label: createListModel.childCount(0,0)===0? undefined:qsTr("No")
                  cancelButton.enabled: true
                  includeRememberMe: true
                  rememberMeText: createListModel.childCount(0,0)===0? "Include Sub Folders": "Include Sub Folders?"
                  onFinished: {
                      if(result == SystemUiResult.ConfirmButtonSelection) {searchFolderPlaySubFolders= rememberMeSelection();createListModel.clear();folderDio.createObject(); diooo.cancel();
                      }
                      else if (result == SystemUiResult.CancelButtonSelection) {
                          folderDio.createObject(); diooo.cancel();
                      
                      }
                  }
              }
          }  
        },
        ComponentDefinition {
          id: folderDio
          content: 
              
          
          Container {
              id: contt
              property string bob
              onCreationCompleted: {dioo.show(); dioo.cancelButton.enabled=false; dioo.cancelButton.label=undefined;
                  _app.folderToPlaylist(folderToPlaylistURL, searchFolderPlaySubFolders);
              }
              
              attachedObjects: [
                  SystemTimer{
                      id: closetimer;
                      interval: 500
                      onTimeout: {
                          closetimer.stop();
                          dioo.cancel();
                      }
                  },
                  Connections {
                      target:_app
                      onFolderToPlaylistFinished:{bob= qsTr("Finished Adding Files");dioo.body=bob; closetimer.start();if(playlistCreatorOpen){}}
                      onFolderToPlaylistItem:{b.length>40? bob=b.substring(0,10):bob=b; dioo.body=bob;if(playlistCreatorOpen===true){ 
                              createListModel.insert({
                                      "title": b,
                                      "sourceUrl": d
                              });
                            
                      } 
                  
                      }
                  
                  },
                  SystemDialog{
                      id: dioo
                      title: qsTr("Adding Files")
                      body: qsTr("Adding Files From Folder, this may take a while..")
                      buttonAreaLimit: 2
                      autoUpdateEnabled: true
                      activityIndicatorVisible: true
                      confirmButton.label: undefined
                      cancelButton.label: undefined
                      cancelButton.enabled: false
                  
                  }
              ]
          }  
        },
        
        ComponentDefinition {
            id: create
            onError: {
                toast.showTextWithButton(errorMessage, "OK", "")
            }
            function createQMLObject(sourceUrl) {
                source = sourceUrl;
                return create.createObject()
            
            }
        },
        ComponentDefinition {
            id: addDialog
            content: SystemListDialog {
                id: listDialog
                Component.onCompleted: {
                    listDialog.appendItem(qsTr("Audio"))
                    listDialog.appendItem(qsTr("Video"))
                    listDialog.appendItem(qsTr("Web Stream"))
                    listDialog.appendItem(qsTr("Folder"))
                    listDialog.appendItem(qsTr("In App Recordings"))
                    
                    listDialog.se
                    listDialog.show();
                }
                title: qsTr("Choose Audio & Video")
                confirmButton.label:qsTr( "Choose")
                cancelButton.label: qsTr("Cancel")
                selectionIndicator: selectionIndicator.Highlight
                
                onFinished: {
                    if (result == SystemUiResult.ConfirmButtonSelection) {
                        console.log(selectedIndices)
                        if(selectedIndices==0){adderPickerAud.createObject();}
                        else if(selectedIndices==1){adderPicker.createObject();}
                        else if(selectedIndices==2){webstreamer.createObject();}
                        else if(selectedIndices==3){ 
                            folder.createObject();}
                            else if(selectedIndices==4){  if (protectedMode) {
                                prompter.show();
                            } else {
                              sheeter.open();
                            }}

                        
                    
                    }
                    else{listDialog.cancel();}
                }
            }
        
        },
        
        Container {
            id: contee
            attachedObjects: [SystemPrompt {
                    id: prompter
                    inputField.inputMode: SystemUiInputMode.Password
                    title: qsTr("Enter Password")
                    autoUpdateEnabled: true
                    dismissAutomatically: false
                    body: qsTr("Please enter your Star Player Password to continue")
                    buttonAreaLimit: 2
                    confirmButton.label: qsTr("Ok")
                    confirmButton.enabled: true
                    cancelButton.label: qsTr("Lost Password?")
                    cancelButton.enabled: true
                    customButton.enabled: true
                    customButton.label: qsTr("Cancel")
                    onFinished: {if(result == SystemUiResult.ConfirmButtonSelection) {if(_app.passwordCheck(inputFieldTextEntry())===true){prompter.cancel();sheeter.open();}
                    else {toast.showText(qsTr("Password Incorrect"))}
                    }
                    else if (result == SystemUiResult.CancelButtonSelection) {lostPasswordMode=true;creator.createQMLObject("ContactForm.qml"); prompter.cancel();
                    }
                    else if(result== SystemUiResult.CustomButtonSelection){
                        prompter.cancel();
                    }
                    }
            }]
        },
        
        Sheet{
            
            id: sheeter
            Page {
                id:pagee
                titleBar: TitleBar {
                    title: qsTr("In App Recordings")
                    
                    dismissAction: ActionItem {
                        title:qsTr( "Close")
                        onTriggered: {
                            sheeter.close() 
                        }
                    }
                
                }
                
                actionBarVisibility: ChromeVisibility.Compact
                
                onCreationCompleted: {_inAppRecordings.updateRecordingDataModel(); console.log(_inAppRecordings.dataModel.size()) }   
                
                
                Container {
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    layout: DockLayout {}
                    bottomPadding: 90
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        Label {
                            visible:_inAppRecordings.dataModel.childCount(0) === 0 ? true : false
                            text: qsTr("No Recordings")
                            textStyle.color: Color.White
                            opacity: nightMode ? 0.6 : 0.8
                            textStyle {
                                fontSize: FontSize.PointValue
                                fontSizeValue: 16
                                base: SystemDefaults.TextStyles.BigText
                            }
                        }
                    }
                    ListView {
                        scrollRole: ScrollRole.Main
                        
                        opacity: nightMode?0.8:1
                        id: viewe
                        dataModel: _inAppRecordings.dataModel
                        scrollIndicatorMode: ScrollIndicatorMode.ProportionalBar
                        layout: StackListLayout {
                            headerMode: ListHeaderMode.Sticky
                        }
                        listItemComponents: [
                            ListItemComponent {
                                type: "header"
                                Header {
                                    title: _inAppRecordings.dataModel.size() + " Recording(s)"
                                }  
                            },
                            ListItemComponent {
                                type: "item"
                                
                                Container {
                                    id: rootListItemContainer
                                    property string pathIndex
                                    property string title
                                    property string urle
                                    property string icon
                                    function bob(){dio.show();}
                                    function updateFav(indexPath, titlle, urrle, icone){
                                        console.log(indexPath, titlle, urrle, icone)
                                        pathIndex= indexPath.toString();
                                        title= titlle;
                                        urle= urrle;
                                        icon= icone;
                                        prompt.show();}
                                    
                                    StandardListItem {
                                            title:  ListItemData.videoTitle
                                    }     
                                
                                }
                            }
                        ]
                        onTriggered: {
                            var data= dataModel.data(indexPath);
                            var bob= data.audioURL.replace("file://", "");
                            createListModel.insert({
                                    "title": data.videoTitle,
                                    "sourceUrl": bob
                            });
                            sheeter.close();
                        }
                    }
                }
            
            }
        }
,
        ComponentDefinition {
            id: adderPicker
            content: FilePicker {
                id: adder
                Component.onCompleted: {open();}
                type:FileType.Video
                mode: FilePickerMode.PickerMultiple
                title: qsTr("Select Video")
                directories: [ "/accounts/" ]
                filter: FileType.Video
                
                onCanceled: {
                    activity.running = false;
                    activity.visible = false;
                }
                onFileSelected: {
                    if(getFileType(selectedFiles[0].toString())==="m3u"){canceled();importSource=selectedFiles[0].toString();importm3uclear.createObject();}
                    
                    else{_app.multipleFilesImport(selectedFiles)}

                /*    console.log("FileSelected signal received : " + selectedFiles);
                    if(getFileType(selectedFiles[0].toString())==="m3u"){canceled();importSource=selectedFiles[0].toString();importm3uclear.createObject();}
                    else{
                        var icon = _app.getVideoArtWork(selectedFiles[0].toString())
                        var url =selectedFiles[0].toString();
                        var title = _app.withoutExtension(url);
                        
                        console.log("URL: " + url);
                        console.log("Title: " +title);
                        createListModel.insert({
                                "title": title,
                                "sourceUrl": url
                        });}*/
                
                }
            }
        },
        ComponentDefinition {
            id: adderPickerAud
            content: FilePicker {
                id: adderaud
                
                Component.onCompleted: {open();}
                type:FileType.Music
                
                mode: FilePickerMode.PickerMultiple
                title: qsTr("Select Audio")
                directories: [ "/accounts/" ] 
                filter: FileType.Music
                property int bob
                
            
                onCanceled: {
                    activity.running = false;
                    activity.visible = false;
                }
                onFileSelected: {
                   // console.log("FileSelected signal received : " + selectedFiles);
                    
                    if(getFileType(selectedFiles[0].toString())==="m3u"){canceled();importSource=selectedFiles[0].toString();importm3uclear.createObject();}
                    
                    else{_app.multipleFilesImport(selectedFiles)}
                                        /*
                    if(getFileType(selectedFiles[0].toString())==="m3u"){canceled();importSource=selectedFiles[0].toString(); importm3uclear.createObject();}
                    else{
                     //   var icon = _app.getAudioArtWork(selectedFiles[0].toString())
                        var url =selectedFiles[0].toString();
                        var title = _app.withoutExtension(url)
                        console.log("URL: " + url)
                        console.log("Title: " +title)
                         bob = createListModel.size()
                        bob ++; 
                       createListModel.insert({
                              "title": title,
                              "sourceUrl": url, 
                              "number": bob
                     });
                     
                    
                    }*/
                
                }
            }
        },
        ComponentDefinition {
            id: deleteAllDio
            content:SystemDialog{
                id: dio
                Component.onCompleted: {
                    show();
                }
                title: qsTr("Delete All?")
                body:qsTr( "Delete All Playlist Items")
                buttonAreaLimit: 2
                confirmButton.label: qsTr("Yes")
                confirmButton.enabled: true
                cancelButton.label: qsTr("Cancel")
                cancelButton.enabled: true
                onFinished: {
                    if(result == SystemUiResult.ConfirmButtonSelection) { 
                      }
                        else if (result == SystemUiResult.CancelButtonSelection) {
                        cancel();
                        }
                }
            }
        },
        
        ComponentDefinition {
            id: webstreamer
            content: Container {
                id: contweb
                property string newURL
                property string type
                onCreationCompleted: {prompt.show();}
                function addStream(){
                    
                    newURL=prompt.inputFieldTextEntry();
                    console.log(newURL)
                    if(getFileType(newURL)==="m3u"){type="m3u";prompt.activityIndicatorVisible=true;
                        console.log("M3U detected" + newURL);downloadManager.download(newURL, _app.homePath()+"/m3ufile.m3u")
                    }
                    else if((getFileType(newURL)==="pls")){type="pls";
                        prompt.activityIndicatorVisible=true;
                        console.log("PLS detected" + newURL);downloadManager.download(newURL, _app.homePath()+"/plsfile.pls")
                    
                    }
                    else{
                        prompt.cancel(); createListModel.insert({
                                "title": prompt.inputFieldTextEntry(),
                                "sourceUrl": prompt.inputFieldTextEntry()
                        });
                    }
                
                }
                attachedObjects:[
                    Connections{
                        target: _app
                        onM3uFileData:{console.log("cccccccccccccc " + data); _app.deleteFile(_app.homePath()+"/m3ufile.m3u"); prompt.cancel(); createListModel.insert({
                                    "title": prompt.inputFieldTextEntry(),
                                    "sourceUrl": prompt.inputFieldTextEntry()
                            });
                        }
                        onMultipleFileImport:{console.log("Recieved Signal: " )}
                       
                    },
                    Connections {
                        target: downloadManager
                        onDownloadCompletedInternal:{
                            if(type==="m3u"){ _app.testU(_app.homePath()+"/m3ufile.m3u")}
                            else if(type==="pls"){var url= _app.plsFile(_app.homePath()+"/plsfile.pls"); console.log( _app.plsFile(_app.homePath()+"/plsfile.pls"));_app.deleteFile(_app.homePath()+"/plsfile.pls"); 
                                prompt.cancel(); createListModel.insert({
                                        "title": prompt.inputFieldTextEntry(),
                                        "sourceUrl": prompt.inputFieldTextEntry()
                                });
                            
                            }  }
                    },
                    
                    SystemPrompt {
                        id: prompt
                        autoUpdateEnabled: true
                        dismissAutomatically: false
                        inputField.inputMode: SystemUiInputMode.Url
                        title:qsTr( "Internet Stream")
                        inputField.emptyText: qsTr( "Enter Stream URL here")
                        confirmButton.label:qsTr( "Add")
                        cancelButton.label:qsTr( "Cancel")
                        onFinished: {
                            if(result== SystemUiResult.ConfirmButtonSelection) {
                                addStream();
                            }
                            else{prompt.cancel(); cont.destroy();}
                        }
                    }]
            }
        
        },
        Timer {
            id: delay;interval: 200; onTriggered: {
                console.log("TIMER TRIGGERED"); delay.stop(); openVideo();
            
            }
        },
        ComponentDefinition {
            id: folder
            signal bob
            content: FilePicker {
                id: filePicker2
                onError: {  toast.showText(error)}
                Component.onCompleted: {open();}
                mode: FilePickerMode.SaverMultiple
                title: "Select Folder Path"
                property string path: appsettings.getSystemSetting("filepickerDefaultPath", "/accounts/");
                directories: [ path]
                onFileSelected: {
                    console.log("FileSelected signal received : " + selectedFiles);
                    folderToPlaylistURL=selectedFiles[0].toString();
                    folderClearDio.createObject();
                
                }
            }
        }
    ]
    function next(){
        
        if(bib==""){console.log("Loop Completed");_playlist.addToJson(titleBar.kindProperties.textField.text, _app.homePath()+ "/Playlists/"+titleBar.kindProperties.textField.text+ ".m3u" , "") ;savingCompleted();_playlist.updatePlaylistModel();if(playListCreatorFolderMode){creator.createQMLObject("PlaylistEditor.qml");sheet.close();sheet.destroy(2000);}else{sheet.close();sheet.destroy(2000);} }
        else if(bib==createListModel.last()){console.log("Loop Completed");_playlist.addToJson(titleBar.kindProperties.textField.text, _app.homePath()+ "/Playlists/"+titleBar.kindProperties.textField.text+ ".m3u" , "") ;savingCompleted();_playlist.updatePlaylistModel();if(playListCreatorFolderMode){creator.createQMLObject("PlaylistEditor.qml");sheet.close();sheet.destroy(2000);}else{sheet.close();sheet.destroy(2000);} }
        
        else{playListView.triggered(createListModel.after(bib));next();}

    
    }
    
    
    function createNewPlaylist(){
        savingPlaylistDio.createObject();

        console.log(createListModel.last())
        playListView.triggered( createListModel.first())
        
        next();   
      
       
       }
    
    Page { 
        id:page
        titleBar: TitleBar {
        id: titleBar
            appearance: TitleBarAppearance.Branded
            kind: TitleBarKind.TextField
            kindProperties: TextFieldTitleBarKindProperties {
                textField.hintText: "Playlist Name"
                
            }
           
            title: qsTr("Playlist")
            
            dismissAction: ActionItem {
                title: qsTr("Save") 
                enabled: playlistCleared?false:true
                onTriggered: {
                    triggeredBySave=true;
                    
                    if(titleBar.kindProperties.textField.text==="" ===false){ 

                    if(_app.checkFileExists(_app.homePath()+ "/Playlists/" +titleBar.kindProperties.textField.text+ ".m3u")===true){toast.showText("Playlist '" + titleBar.kindProperties.textField.text + "' already exists, please choose another name")}
                   else{createNewPlaylist();}
                   }
                    else{toast.showText("Please Enter a Playlist Name"); titleBar.kindProperties.textField.requestFocus();}
                    }
            }
            acceptAction: ActionItem {
                title: "Discard"
                onTriggered: {
                playlistCreatorOpen=false;  sheet.close();sheet.destroy(1000);
                }
            }
        
    }
    actionBarVisibility: actionBarVisibility.Compact
    
    actions:[
       
        ActionItem {
            ActionBar.placement: ActionBarPlacement.Signature
            title:qsTr( "Add")
            imageSource: "asset:///images/ic_add.png"
            onTriggered: {
                addDialog.createObject();
            }
        
    },
    ActionItem {
        title:qsTr("Quick Delete")
        id: quickd
        enabled: playlistCleared?false:true

        ActionBar.placement: ActionBarPlacement.OnBar
        imageSource: "images/ic_delete.png"
        onTriggered: {
            _app.playistItemQuickDeleteSwitch();
        }  
    },
    DeleteActionItem {
        id: clear
        title: qsTr("Clear Playlist")
        imageSource: "images/ic_clear_list.png"
        enabled: playlistCleared?false:true
        onTriggered: {createListModel.clear();playlistCleared=true;}  
    }]
    
    content: Container {
        opacity: nightMode?0.8:1
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        layout: DockLayout {
            
        }

    
Container {
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    opacity: nightMode?0.8:1
    layout: DockLayout {}
    bottomPadding: 10
    
    
    Container {
        id: noItemsCont
        visible: itemsCount===0?true:false
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
        Label {
            
            text: qsTr("No Items")
            textStyle.color: Color.White
            opacity: nightMode ? 0.6 : 0.8
            textStyle {
                fontSize: FontSize.PointValue
                fontSizeValue: 16
                base: SystemDefaults.TextStyles.BigText
            }
        }
    }
    
    
    ListView {
        scrollRole: ScrollRole.Main
        
        property variant list
        id: playListView
        
        layout: StackListLayout { headerMode: ListHeaderMode.Sticky }
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        dataModel:  GroupDataModel {
            
            onItemAdded: {
                itemsCount++;
            playlistCleared=false;
            
            }
            onItemRemoved: {
                itemsCount--;
                
            }
            
            id: createListModel;
            sortedAscending: true
        
        sortingKeys: ["number", "title", "sourceUrl"]
        } 
        
        function remove(indexPath) { createListModel.removeAt(indexPath); if(createListModel.size()===0)playlistCleared=true;
        }
        
        
        listItemComponents: [
            ListItemComponent {
                type: "header"
                Header {
                    visible: false
                }  
            },
            ListItemComponent {
                
                type: "item"
                Container {
                    id: itemContainer
                    function bob(){diodelete.show();}
                    
                    PlaylistItem {
                        
                        
                        attachedObjects:[ 
                            
                            SystemDialog{
                                id: diodelete
                                title: qsTr("Delete")
                                body: qsTr("Delete Playlist Item? (") +ListItemData.title + ")"
                                buttonAreaLimit: 2
                                confirmButton.label: qsTr("Yes")
                                confirmButton.enabled: true
                                cancelButton.label: qsTr("Cancel")
                                cancelButton.enabled: true
                                onFinished: {
                                    if(result == SystemUiResult.ConfirmButtonSelection) {remove(itemContainer.ListItem.view.remove(itemContainer.ListItem.indexPath))
                                       
                                    }
                                    else if (result == SystemUiResult.CancelButtonSelection) {
                                        cancel();
                                    }
                                }
                            }]
                        onQuickDeleteClicked: {
                            remove(itemContainer.ListItem.view.remove(itemContainer.ListItem.indexPath)); 
                           
                        }
                        title: ListItemData.title
                        
                        imageEnabled:false
                        
                        contextActions:   ActionSet {
                            title:  ListItemData.title 
                            subtitle: ListItemData.sourceUrl
                            actions:[
                             
                                DeleteActionItem{
                                    imageSource: "images/ic_delete.png"
                                    title:qsTr("Delete Playlist Item")
                                    onTriggered: {itemContainer.bob(); }
                                }
                            ]
                        }
                    }
                }
            }
        ]
        onTriggered: {
            if(triggeredBySave){
            bib=indexPath;
            
            console.log(indexPath)
            var data = createListModel.data(indexPath)
           
        //   console.log("Title: " + data.title)
           console.log("Source URL: " + data.sourceUrl)
           _app.generatePlaylist(titleBar.kindProperties.textField.text, data.sourceUrl)
    // if(indexPath==="") {sheet.close()}
            console.log("INDEX PATH VARIANT " + bib)
        }
          /*  indexPathNonConvert=indexPath.toString();
            console.debug("indexPathNonConvert=" + indexPathNonConvert);
            if(indexPathNonConvert.length===3){
                console.log("indexPathNonConvert SPLIT=" +indexPathNonConvert.substring(3, 2))
                indexPathNonConvertFinal=indexPathNonConvert.substring(3, 2)
                //single
            }
            else if(indexPathNonConvert.length===4){
                console.log("indexPathNonConvert SPLIT=" +indexPathNonConvert.substring(4, 2))
                indexPathNonConvertFinal=indexPathNonConvert.substring(4, 2)
                // double
            }else if(indexPathNonConvert.length===5){
                console.log("indexPathNonConvert SPLIT=" +indexPathNonConvert.substring(5, 2))
                indexPathNonConvertFinal=indexPathNonConvert.substring(5, 2)
                //triple
            }
            else if(indexPathNonConvert.length===6){
                console.log("indexPathNonConvert SPLIT=" +indexPathNonConvert.substring(6, 2))
                indexPathNonConvertFinal=indexPathNonConvert.substring(6, 2) 
                //quad
            }
            if(shuffleMode){propertyToSaveIndexPathAsNumber= Math.random() * (_playlist.dataModell.size() - 1)}
            else{
                propertyToSaveIndexPathAsNumber= _app.valueToInt(indexPathNonConvertFinal);}
            console.log("Current Index Path as int " + propertyToSaveIndexPathAsNumber)
            console.log(indexPath)
            var data = _playlist.dataModell.data(["0", propertyToSaveIndexPathAsNumber])
            console.log(data.videoTitle)
            console.log("Stored Video URL: " +data.videoURL)
            playlistMode=true;
            playlistEditorOpened=false
            if(data.videoIconURL===""){}
            else{
                artWorkURI= "file://" +data.videoIconURL;}
            activity.running=true;activity.visible=true;
            originalSource= data.videoURL;
            if( _app.checkIsHttp(data.videoURL)==true){ audioSource=  data.videoURL}
            else{
                audioSource= "file://" + data.videoURL}
            appsettings.saveSystemSetting("currentIndexPath", propertyToSaveIndexPathAsNumber.toString())
            delay.start();
            sheet.close(); */
        }
    
    }
}
    }
}
}