import QtQuick 1.0
import bb.cascades 1.4
import bb.cascades.pickers 1.0
import bb.system 1.2
import "Custom"
import bb.device 1.3
import bb.platform 1.3
import timer 1.0
Sheet {
    property variant listData
    signal newPlaylistCreated
    onCreationCompleted: {
        if (playlistViewerOpen) {
           // sheet.destroy();
        } else {
            playlistViewerOpen = true;
            open();    
            importSource = playlistURL;
            titleBar.title = playlistName;
            importm3uDio.createObject();

        }

     
    }

    Component.onDestruction: {playlistViewerOpen = false;}

    id: sheet
    signal savingCompleted
    attachedObjects: [
       
        ComponentDefinition {
            id: importm3uDio
            content: Container {
                id: conterr
                property string bob
                property string bob1
                onCreationCompleted: {

                    dioi.show();
                    dioi.cancelButton.enabled = false;
                    dioi.cancelButton.label = undefined;
                    playQueue.clear();
                    _app.importM3UPlaylist(importSource, false);
                }

                attachedObjects: [
                    SystemTimer {
                        id: closetimerr
                        interval: 500
                        onTimeout: {
                            closetimerr.stop();
                            dioi.cancel();
                            playlistViewerOpen=false;
                            // if(carMode){openCarModePlaylist();}
                            // else{
                            //    if(playlistEditorOpened){_playlist.updatePlaylistModel();}
                            //  else{
                            //    creator.createQMLObject("PlaylistEditor.qml");}}
                        }
                    },
                    Connections {
                        target: _app
                        onM3UImportFinished: {
                            dioi.cancel();
                        }
                        onM3UImportItem: {
                           
                            b.length > 40 ? bob = b.substring(0, 10) : bob = b;
                            dioi.body = bob;
                            
                            playQueue.insert({
                                    "title": b,
                                    "sourceUrl": d
                                });
                                
                                console.log("Item Imported: " + b)
                        }
                        

                    },
                    SystemDialog {
                        id: dioi
                        title: "Loading Playlist"
                        body: "Loading Playlist, please wait.." 
                        buttonAreaLimit: 2
                        autoUpdateEnabled: true
                        activityIndicatorVisible: true
                        confirmButton.label: undefined
                        cancelButton.label: undefined
                        cancelButton.enabled: false

                    }
                ]
            }
        },

     
        
        Timer {
            id: delay
            interval: 200
            
            onTriggered: {
                playlistViewerOpen = false;
                console.log("TIMER TRIGGERED");
                delay.stop();
                openVideo();

            }
        }
    ]
 

    Page {
        id: page
        titleBar: TitleBar {
            id: titleBar
            appearance: TitleBarAppearance.Branded
            kind: TitleBarKind.Default
            kindProperties: TextFieldTitleBarKindProperties {
                textField.hintText: "Playlist Name"

            }

           // title: qsTr("Playlist")

           dismissAction: ActionItem {
                title: "Close"
                onTriggered: {
                    sheet.close();
                    sheet.destroy(500);
                }
            }

        }
        actionBarVisibility: ChromeVisibility.Visible

        actions: [
         /*
           ActionItem {
             onTriggered: {
                 viewerList.rearrangeHandler.setActive(true)
             }  
           },*/
            ActionItem {
                            title: "Play"
                            imageSource: "images/ic_play.png"
                            ActionBar.placement: ActionBarPlacement.Signature
                            onTriggered: {viewerList.triggered(playQueue.first())
                                
                            }
            },
        
            ActionItem {
                title: "Edit"
                imageSource: "images/ic_edit_list.png"
                ActionBar.placement: ActionBarPlacement.OnBar
                onTriggered: {creator.createQMLObject("PlaylistEdit.qml")
                }
            },
            ActionItem {
               // enabled: playQueue.size() <5?false:true
                title:qsTr( "Shuffle")
                imageSource: "asset:///images/shuffle_off.png"
                ActionBar.placement: ActionBarPlacement.OnBar
                property variant bobe
                onTriggered: {
                    shuffleMode=true;
                    playlistMode=true;
                   playQueue.setSortingKeys([""]);
                    closePlaylistEditor();
                    activity.running=true;activity.visible=true;
                    bypassFormatCheck=true;
                    delay.start();sheet.close();
                }
            },
            ActionItem {
                            enabled: appsettings.getSystemSetting("PinnedMediaViewer", "")===""? pinnedCount >=15? false: true: pinnedCount >=5? false: true
                            ActionBar.placement: ActionBarPlacement.InOverflow
                            title: "Pin To Home"
                            imageSource: "asset:///images/pin_actionItem.png"
                            onTriggered: {
                                var bob= pinnedCount+=1;
                                _pinnedVideos.addToJson(playlistName, playlistURL, "", "", "Playlist", "", bob);
                                toast.showText("Playlist ('" +playlistName  +"') Pinned To Home");
                            
                            }
            },
            ActionItem {
                            title: "Add To Homescreen"
                            imageSource: "asset:///images/ic_add_home.png"
                            attachedObjects: ComponentDefinition {
                                id: hsad
                                content:    Container {
                                    id: cont
                                    property string imageURL:"asset:///images/playlist_hs.png"
                                    property string title:playlistName
                                    onCreationCompleted: {hs.addShortcut(imageURL, title, "starplayer://playlist/" +playlistURL ); toast.showText(metaDataTitle +qsTr("Playlist Added To Homescreen"));cont.removeAll();}
                                    attachedObjects: HomeScreen {id: hs }   
                                }
                            }
                            
                            onTriggered: {
                                hsad.createObject();
                            }  
            }
        ]

        content: Container {
            opacity: nightMode?0.8:1
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: DockLayout {
                
            }
            Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                opacity: nightMode ? 0.8 : 1
                layout: DockLayout {
                }
                
               
                bottomPadding: 10

                Container {
                    id: noItemsCont
                    visible:  playlistItemsCount===0?true:false
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    Label {

                        text: qsTr("Playlist Empty")
                        textStyle.color: Color.White
                        opacity: nightMode ? 0.6 : 0.8
                        textStyle {
                            fontSize: FontSize.PointValue
                            fontSizeValue: 16
                            base: SystemDefaults.TextStyles.BigText
                        }
                    }
                }

                ListView {
                    scrollRole: ScrollRole.Main
                    property variant list
                    id: viewerList
                    property int itemOrigin: -1
                    property int lastItemDestination: -1
                    layout: StackListLayout { headerMode: ListHeaderMode.Standard}
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    dataModel: playQueue
                  /*  rearrangeHandler {
                        // Do not activate the handler here. It
                        // will be forcefully deactivated when 
                        // the data model is assigned.
                        onMoveStarted: {
                            console.log("onMoveStarted: " + event.startIndexPath);
                            viewerList.itemOrigin = event.startIndexPath[0];
                        }
                        onMoveEnded: {
                            console.log("onMoveEnded: " + event.endIndexPath);
                        }
                        onMoveUpdated: {
                            // Always call denyMove() before initiating 
                            // the move. Without first denying the move
                            // the list item will only move 1 spot 
                            // regardless of how many spots it's
                            // dragged.
                            event.denyMove();
                            playQueue.updateItem(event.fromIndexPath[0], event.toIndexPath[0]);
                            console.log("onMoveUpdated: " + event.fromIndexPath[0] + " -> " + event.toIndexPath[0]);
                        }
                        onMoveAborted: {
                            console.log("onMoveAborted: " + event.endIndexPath);
                            viewerList.undoItemMove();
                        }
                        onActiveChanged: {
                            console.log("active changed: " + active);
                        }
                    }*/
                    listItemComponents: [
                        ListItemComponent {
                            type: "header"
                            Header {
                                visible: true
                                title: playQueue.size() + " Item(s)"
                            }
                        },
                        ListItemComponent {

                            type: "item"
                            Container {
                                id: itemContainer
                               
                                PlaylistItem {
                                    allowQuickDelete: false
                                    title: ListItemData.title
                                    imageEnabled: false

                                }
                            }
                        }
                    ]
                    onTriggered: {
                        playlistMode=true;
                        console.log(indexPath);
                            globalIndexPath=indexPath;   
                          closePlaylistEditor();
                            activity.running=true;activity.visible=true;

                       var dataa = playQueue.data(indexPath);
                       console.log("Title: " + dataa.title);
                       console.log("Source URL: " + dataa.sourceUrl);
                        originalSource= dataa.sourceUrl;
                         
                       if( _app.checkIsHttp(dataa.sourceUrl)==true){ audioSource=  dataa.sourceUrl}
                       else{
                           audioSource= "file://" + dataa.sourceUrl}
                         playlistViewerOpen=false;
                         //playlistURL="";
                         //playlistName="";
                       delay.start();
                       sheet.close();
                       sheet.destroy(500);
                    }

                }
            }
        }
    }
}