import bb.system 1.0
import bb.cascades 1.0
import timer 1.0

Container {
    id: cont
    onCreationCompleted: {dio.show(); closeTimer.start();}
    
    attachedObjects: [
        SystemTimer{
            id: closeTimer;
            interval: 300000
            onTimeout: {
                dio.cancel(); cont.destroy(1000);
            }
        },
        Invocation
        {
            id: invoke
            query: InvokeQuery
            {
                id: query
                mimeType: "text/html"
                uri: "appworld://content/59976942"
                invokeActionId: "bb.action.OPEN"
            }
        },
        
        SystemDialog{
            id: dio
            
            title: qsTr("Rate Star Player")
            body:  qsTr("How is Star Player?\nIf you are satisfied please leave us a review")
            buttonAreaLimit: 2
            confirmButton.label: qsTr("Review")
            confirmButton.enabled: true
            cancelButton.label: qsTr("Don't Show Again")
            cancelButton.enabled: true
            customButton.enabled: true
            customButton.label: qsTr("Report Issue")
            onFinished: {
                if(result == SystemUiResult.ConfirmButtonSelection) {invoke.trigger("bb.action.OPEN");
}
                else if (result == SystemUiResult.CancelButtonSelection) {
                    cancel(); 
                }
                else if(result== SystemUiResult.CustomButtonSelection){
                    cancel();openBugReport();
                }
            }
        }]
}