import bb.cascades 1.4
import "Custom"
import timer 1.0
import bb.system 1.2
Sheet{
    id: sheet
    peekEnabled: false
    onCreationCompleted: {
        sheet.open()
    }
    function runReset(){
        if(box1.checked){appsettings.dropSettings();_app.removeDir(_app.homePath()+ "/Settings");}
        if(box2.checked){_app.clearJsonFile();}
        if(box3.checked){_recentlyPlayed.clearJsonFile();}
        if(box4.checked){_inAppRecordings.clearJsonFile(); _app.removeDir(_app.homePath()+ "/voice");}
        if(box5.checked){_customStations.clearJsonFile();}
        if(box6.checked){_playlist.clearJsonFile(); _app.removeDir(_app.homePath()+ "/Playlists");}
        //if(box7.checked){_lyricsBookmarks.clearJsonFile(); _app.removeLyricsFiles();}
        if(box8.checked){_pinnedVideos.clearJsonFile();_app.removeDir(_app.homePath()+ "/pinnedArt");}
        if(box9.checked){_app.removeDir(_app.homePath()+ "/InternetRadioImages");}
        var urll= _app.homePath() + "/";
        _app.deleteFile(urll+ "InternetRadioStationsModelUK.xml")
        _app.deleteFile(urll+ "InternetRadioStationsModelGermany.xml")
        _app.deleteFile(urll+ "InternetRadioStationsModelFrance.xml")
        _app.deleteFile(urll+ "InternetRadioStationsModelSpain.xml")
        _app.deleteFile(urll+ "InternetRadioStationsModelItalian.xml")
        _app.deleteFile(urll+ "InternetRadioStationsModelCanada.xml")
        _app.deleteFile(urll+ "InternetRadioStationsModelAlternative.xml")
        _app.clearCache();
        
        Application.quit();
        //_app.removeDir(_app.homePath());
    }
    
    attachedObjects:  [
    SystemTimer {
        id: resetTimer
        interval: 500;
        onTimeout: {
            resetTimer.stop();
            runReset();
        }  
    },
        SystemDialog{
        id: confirmDialog
        title: qsTr("Reset")
        autoUpdateEnabled: true
        body: qsTr("Are you sure you want to reset Star Player?")
        buttonAreaLimit: 2
        confirmButton.label: qsTr("Yes")
        confirmButton.enabled: true
        cancelButton.label: qsTr("Cancel")
        cancelButton.enabled: true
        dismissAutomatically: false
        onFinished: {
            if(result == SystemUiResult.ConfirmButtonSelection) {
                activityIndicatorVisible=true;
                confirmDialog.body= qsTr("Resetting Star Player\nStar Player will close once completed");
                confirmDialog.cancelButton.enabled=false;
                confirmDialog.cancelButton.label= undefined
                confirmDialog.confirmButton.label= undefined
                confirmDialog.confirmButton.enabled=false;
                
                resetTimer.start();
            }
            else if (result == SystemUiResult.CancelButtonSelection) {
                confirmDialog.cancel();
            }
        }
    }]
Page {
    titleBar: TitleBar {
        title: "Reset Star Player"
        dismissAction: ActionItem {
            title: "Cancel"
            onTriggered: {
                sheet.close(); sheet.destroy(500)
            }
        }
        acceptAction: ActionItem {
            title: "Reset"
            onTriggered: {
                confirmDialog.show();

            }
        }
    } ScrollView {
  
    Container {
        horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    UserInfoBanner {
        text: "Warning: An Application Reset cannot be reversed!"
    }
    
   
        
    
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("Star Player User Settings")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box1
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
        }
    }
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("Favourites List")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box2
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
              
            }
        }
    }
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("Last Played List")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box3
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
            console.log(checked)
            }
        }
    }
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("In-App Audio Recordings")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box4
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
            
            }
        }
    }
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("Custom Internet Radio Stations")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box5
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
            
            }
        }
    }
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("User Playlists")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box6
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
            
            }
        }
    }
   /* Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("Offline/Favourite Lyrics")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box7
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
            
            }
        }
    }   */  
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("Pinned Media")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box8
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
            
            }
        }
    } 
    Container {
        
        topPadding: 30; leftPadding: 15;rightPadding: 20
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        Label {
            text: qsTr("Internet Radio Station Images")
            verticalAlignment: VerticalAlignment.Center
            horizontalAlignment: HorizontalAlignment.Left
            textStyle {
                base: SystemDefaults.TextStyles.BodyText
                fontSize: FontSize.PointValue
                fontSizeValue: 8
            }
        }
        
        CheckBox {
            enabled: true
            id: box9
            horizontalAlignment: HorizontalAlignment.Right
            verticalAlignment: VerticalAlignment.Center
            checked:true
            onCheckedChanged: {
            
            }
        }
    }
}           
  }
    }
}


