import bb.cascades 1.4
import bb.cascades.pickers 1.0
import timer 1.0

Sheet{
    id: settingsschedrec
    property string modelURL
    onCreationCompleted: {
        open(); toggler.start();
    }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded;
            title:  qsTr("Scheduled Recording");
            dismissAction: ActionItem {
                title:  qsTr("Close") 
                onTriggered: { close();settingsschedrec.destroy();}
            }
        }
        attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true; toggler.destroy();}}
        ScrollView {
            id: scroller
            content: Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Center
                id: conter
                topPadding: 5
                bottomPadding: 5
                
                layout: StackLayout { }
                Container {
                    
                    topPadding: 10; leftPadding: device768? 5:15;rightPadding:device768?10: 20
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text: qsTr("Scheduled Recording")
                        verticalAlignment: VerticalAlignment.Center
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: device768?6.5: miniSquareDevice?7:8
                        }
                    }
                    ToggleButton {
                        opacity: nightMode?0.8:1
                        enabled: false
                        id: togglebutton
                        horizontalAlignment: HorizontalAlignment.Right
                        checked:internetRadioScheduledRecording
                        onCheckedChanged: {
                            if(finished===false){console.log("Denied checked changed");}
                            else if (finished===true){
                                if(internetRadioScheduledRecording===false){
                                if(autoRecordingTimeStart===""){setChecked(false);toast.showText("No Start Time Set")}

                                    else if(autoRecordingTimeEnd===""){setChecked(false);toast.showText("No End Time Set")}
                                    else if(scheduledRecModelStationURL===""){setChecked(false);toast.showText("No Station Set")}
                                    else{
                                    internetRadioSource=scheduledRecModelStationURL; metaDataTitle=scheduledRecModelStationName===""?"Unknown": scheduledRecModelStationName

                                    internetRadioScheduledRecording=true; autoRecordingTimer.start();}}
                                else{internetRadioScheduledRecording=false; autoRecordingTimer.stop();}
                            
                            }
                        }
                    }
                }
                
               
                    Header {
                        topMargin: 20  
                        title: "When to start Recording (24 Hours)"
                    }
                    Picker {
                        topMargin: 20   
                        id: timePicker
                        property string myValue: ""
                        kind: PickerKind.Expandable
                        title: "Record Start Time "
                        description:autoRecordingTimeStart
                        dataModel: XmlDataModel {source: "schedRecordTimes.xml"}
                        
                        pickerItemComponents: [
                            
                            PickerItemComponent {
                                type: "hour"
                                
                                id: hourPicker
                                Container {
                                    leftPadding: OrientationSupport.orientation == UIOrientation.Portrait? 165: 300
                                    id: hourPickerCont
                                    horizontalAlignment: HorizontalAlignment.Center;verticalAlignment: VerticalAlignment.Center
                                    layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                                    Label {text: pickerItemData.value}
                                }
                            }, 
                            PickerItemComponent {
                                type: "min"
                                id: minPicker
                                
                                Container {
                                    leftPadding: OrientationSupport.orientation == UIOrientation.Portrait? 165: 300
                                    horizontalAlignment: HorizontalAlignment.Center
                                    verticalAlignment: VerticalAlignment.Center
                                    layout: StackLayout { orientation: LayoutOrientation.LeftToRight  }
                                    
                                    Label {
                                        text: pickerItemData.value
                                        horizontalAlignment: HorizontalAlignment.Center
                                        verticalAlignment: VerticalAlignment.Center
                                    }
                                }
                            }
                        ]
                        onSelectedValueChanged: {
                            var hour
                            
                            switch (timePicker.selectedIndex(0)) {
                                case 0:
                                    hour="00"
                                    break;
                                case 1:
                                    hour="01"
                                    break;
                                case 2:
                                    hour="02"
                                    break;
                                case 3:
                                    hour="03"
                                    break;
                                case 4:
                                    hour="04"
                                    break;
                                case 5:
                                    hour="05"
                                    break;
                                case 6:
                                    hour="06"
                                    break;
                                case 7:
                                    hour="07"
                                    break;
                                case 8:
                                    hour="08"
                                    break;
                                case 9:
                                    hour="09"
                                    break;
                                case 10:
                                    hour="10"
                                    break;
                                case 11:
                                    hour="11"
                                    break;
                                
                                case 12:
                                    hour="12"
                                    break;
                                case 13:
                                    hour="13"
                                    break;
                                case 14:
                                    hour="14"
                                    break;
                                case 15:
                                    hour="15"
                                    break;
                                case 16:
                                    hour="16"
                                    break;
                                case 17:
                                    hour="17"
                                    break;
                                case 18:
                                    hour="18"
                                    break;
                                case 19:
                                    hour="19"
                                    break;
                                case 20:
                                    hour="20"
                                    break;
                                case 21:
                                    hour="21"
                                    break;
                                case 22:
                                    hour="22"
                                    break;
                                case 23:
                                    hour="23"
                                    break;
                            }
                            var min
                            switch (timePicker.selectedIndex(1)) {
                                case 0:
                                    min="00"
                                    break;
                                case 1:
                                    min="01"
                                    break;
                                case 2:
                                    min="02"
                                    break;
                                case 3:
                                    min="03"
                                    break;
                                case 4:
                                    min="04"
                                    break;
                                case 5:
                                    min="05"
                                    break;
                                case 6:
                                    min="06"
                                    break;
                                case 7:
                                    min="07"
                                    break;
                                case 8:
                                    min="08"
                                    break;
                                case 9:
                                    min="09"
                                    break;
                                case 10:
                                    min="10"
                                    break;
                                case 11:
                                    min="11"
                                    break;
                                case 12:
                                    min="12"
                                    break;
                                case 13:
                                    min="13"
                                    break;
                                case 14:
                                    min="14"
                                    break;
                                case 15:
                                    min="15"
                                    break;
                                case 16:
                                    min="16"
                                    break;
                                case 17:
                                    min="17"
                                    break;
                                case 18:
                                    min="18"
                                    break;
                                case 19:
                                    min="19"
                                    break;
                                case 20:
                                    min="20"
                                    break;
                                case 21:
                                    min="21"
                                    break;
                                case 22:
                                    min="22"
                                    break;
                                case 23:
                                    min="23"
                                    break;
                                case 24:
                                    min="24"
                                    break;
                                case 25:
                                    min="25"
                                    break;
                                case 26:
                                    min="26"
                                    break;
                                case 27:
                                    min="27"
                                    break;
                                case 28:
                                    min="28"
                                    break;
                                case 29:
                                    min="29"
                                    break;
                                case 30:
                                    min="30"
                                    break;
                                case 31:
                                    min="31"
                                    break;
                                case 32:
                                    min="32"
                                    break;
                                case 33:
                                    min="33"
                                    break;
                                case 34:
                                    min="34"
                                    break;
                                case 35:
                                    min="35"
                                    break;
                                case 36:
                                    min="36"
                                    break;
                                case 37:
                                    min="37"
                                    break;
                                case 38:
                                    min="38"
                                    break;
                                case 39:
                                    min="39"
                                    break;
                                case 40:
                                    min="40"
                                    break;
                                case 41:
                                    min="41"
                                    break;
                                case 42:
                                    min="42"
                                    break;
                                case 43:
                                    min="43"
                                    break;
                                case 44:
                                    min="44"
                                    break;
                                case 45:
                                    min="45"
                                    break;
                                case 46:
                                    min="46"
                                    break;
                                case 47:
                                    min="47"
                                    break;             
                                case 48:
                                    min="48"
                                    break;
                                case 49:
                                    min="49"
                                    break;
                                case 50:
                                    min="50"
                                    break;
                                case 51:
                                    min="51"
                                    break;
                                case 52:
                                    min="52"
                                    break;
                                case 53:
                                    min="53"
                                    break;
                                case 54:
                                    min="54"
                                    break;
                                case 55:
                                    min="55"
                                    break;
                                case 56:
                                    min="56"
                                    break;
                                case 57:
                                    min="57"
                                    break;
                                case 58:
                                    min="58"
                                    break;
                                case 59:
                                    min="59"
                                    break;
                            }
                            
                            autoRecordingTimeStart= hour + ":" + min + ":" + "00"; 
                            timePicker.description= autoRecordingTimeStart;
                            console.log("String " + autoRecordingTimeStart)
                        }         
                    }  
                    
                    Header {
                        topMargin: 20  
                        title: "When to Finish Recording (24 Hour)"
                    }
                    Picker {
                        topMargin: 20   
                        id: timePicker1
                        property string myValue: ""
                        kind: PickerKind.Expandable
                        title: "Record End Time "
                      description: autoRecordingTimeEnd
                        dataModel: XmlDataModel {source: "schedRecordTimes.xml"}
                        
                        pickerItemComponents: [
                            
                            PickerItemComponent {
                                type: "hour"
                                
                                id: hourPicker1
                                Container {
                                    leftPadding: OrientationSupport.orientation == UIOrientation.Portrait? 165: 300
                                    id: hourPickerCont1
                                    horizontalAlignment: HorizontalAlignment.Center;verticalAlignment: VerticalAlignment.Center
                                    layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                                    Label {text: pickerItemData.value}
                                }
                            }, 
                            PickerItemComponent {
                                type: "min"
                                id: minPicker1
                                
                                Container {
                                    leftPadding: OrientationSupport.orientation == UIOrientation.Portrait? 165: 300
                                    horizontalAlignment: HorizontalAlignment.Center
                                    verticalAlignment: VerticalAlignment.Center
                                    layout: StackLayout { orientation: LayoutOrientation.LeftToRight  }
                                    
                                    Label {
                                        text: pickerItemData.value
                                        horizontalAlignment: HorizontalAlignment.Center
                                        verticalAlignment: VerticalAlignment.Center
                                    }
                                }
                            }
                        ]
                        onSelectedValueChanged: {
                            var hour
                            
                            switch (timePicker1.selectedIndex(0)) {
                                case 0:
                                    hour="00"
                                    break;
                                case 1:
                                    hour="01"
                                    break;
                                case 2:
                                    hour="02"
                                    break;
                                case 3:
                                    hour="03"
                                    break;
                                case 4:
                                    hour="04"
                                    break;
                                case 5:
                                    hour="05"
                                    break;
                                case 6:
                                    hour="06"
                                    break;
                                case 7:
                                    hour="07"
                                    break;
                                case 8:
                                    hour="08"
                                    break;
                                case 9:
                                    hour="09"
                                    break;
                                case 10:
                                    hour="10"
                                    break;
                                case 11:
                                    hour="11"
                                    break;
                                
                                case 12:
                                    hour="12"
                                    break;
                                case 13:
                                    hour="13"
                                    break;
                                case 14:
                                    hour="14"
                                    break;
                                case 15:
                                    hour="15"
                                    break;
                                case 16:
                                    hour="16"
                                    break;
                                case 17:
                                    hour="17"
                                    break;
                                case 18:
                                    hour="18"
                                    break;
                                case 19:
                                    hour="19"
                                    break;
                                case 20:
                                    hour="20"
                                    break;
                                case 21:
                                    hour="21"
                                    break;
                                case 22:
                                    hour="22"
                                    break;
                                case 23:
                                    hour="23"
                                    break;
                            }
                            var min
                            switch (timePicker1.selectedIndex(1)) {
                                case 0:
                                    min="00"
                                    break;
                                case 1:
                                    min="01"
                                    break;
                                case 2:
                                    min="02"
                                    break;
                                case 3:
                                    min="03"
                                    break;
                                case 4:
                                    min="04"
                                    break;
                                case 5:
                                    min="05"
                                    break;
                                case 6:
                                    min="06"
                                    break;
                                case 7:
                                    min="07"
                                    break;
                                case 8:
                                    min="08"
                                    break;
                                case 9:
                                    min="09"
                                    break;
                                case 10:
                                    min="10"
                                    break;
                                case 11:
                                    min="11"
                                    break;
                                case 12:
                                    min="12"
                                    break;
                                case 13:
                                    min="13"
                                    break;
                                case 14:
                                    min="14"
                                    break;
                                case 15:
                                    min="15"
                                    break;
                                case 16:
                                    min="16"
                                    break;
                                case 17:
                                    min="17"
                                    break;
                                case 18:
                                    min="18"
                                    break;
                                case 19:
                                    min="19"
                                    break;
                                case 20:
                                    min="20"
                                    break;
                                case 21:
                                    min="21"
                                    break;
                                case 22:
                                    min="22"
                                    break;
                                case 23:
                                    min="23"
                                    break;
                                case 24:
                                    min="24"
                                    break;
                                case 25:
                                    min="25"
                                    break;
                                case 26:
                                    min="26"
                                    break;
                                case 27:
                                    min="27"
                                    break;
                                case 28:
                                    min="28"
                                    break;
                                case 29:
                                    min="29"
                                    break;
                                case 30:
                                    min="30"
                                    break;
                                case 31:
                                    min="31"
                                    break;
                                case 32:
                                    min="32"
                                    break;
                                case 33:
                                    min="33"
                                    break;
                                case 34:
                                    min="34"
                                    break;
                                case 35:
                                    min="35"
                                    break;
                                case 36:
                                    min="36"
                                    break;
                                case 37:
                                    min="37"
                                    break;
                                case 38:
                                    min="38"
                                    break;
                                case 39:
                                    min="39"
                                    break;
                                case 40:
                                    min="40"
                                    break;
                                case 41:
                                    min="41"
                                    break;
                                case 42:
                                    min="42"
                                    break;
                                case 43:
                                    min="43"
                                    break;
                                case 44:
                                    min="44"
                                    break;
                                case 45:
                                    min="45"
                                    break;
                                case 46:
                                    min="46"
                                    break;
                                case 47:
                                    min="47"
                                    break;             
                                case 48:
                                    min="48"
                                    break;
                                case 49:
                                    min="49"
                                    break;
                                case 50:
                                    min="50"
                                    break;
                                case 51:
                                    min="51"
                                    break;
                                case 52:
                                    min="52"
                                    break;
                                case 53:
                                    min="53"
                                    break;
                                case 54:
                                    min="54"
                                    break;
                                case 55:
                                    min="55"
                                    break;
                                case 56:
                                    min="56"
                                    break;
                                case 57:
                                    min="57"
                                    break;
                                case 58:
                                    min="58"
                                    break;
                                case 59:
                                    min="59"
                                    break;
                            }
                            
                            autoRecordingTimeEnd= hour + ":" + min + ":" + "00"; 
                            
                            timePicker1.description= autoRecordingTimeEnd;
                            
                            //console.log( "ALARM TIME SETTINGS "+ appsettings.getSystemSetting("alarmTime", "")) 
                            // alarmTime=appsettings.getSystemSetting("alarmTime", "")
                            console.log("String " + autoRecordingTimeEnd);
                        }         
                } 
                Header {
                    topMargin: 20  
                    title: "Select A Internet Radio Station To Record"
                }
                    DropDown {
                        id: stationListDrop
                        onCreationCompleted: {
                            if(_app.checkRemoteFeature(_app.homePath() + "/AlternativeStationsEnabledCheck.txt")===false){ remove(option2);   
                            }
                        }
                        title: "Select A Country"
                        onSelectedIndexChanged: {
                            if(selectedIndex===0){stationListHeaderName="Custom Stations";customStationsView=true;}
                            else{
                             modelURL= selectedValue;
                             customStationsView=false;
                            if(selectedIndex===1)stationListHeaderName="Alternative Stations";
                            else if(selectedIndex===2)stationListHeaderName="UK";
                            else if(selectedIndex===3)stationListHeaderName="German";
                            else if(selectedIndex===4)stationListHeaderName="French";
                            else if(selectedIndex===5)stationListHeaderName="Spanish";
                            else if(selectedIndex===6)stationListHeaderName="Canadian";
                            else if(selectedIndex===7)stationListHeaderName="Italian";
                            
                            scheduledRecModelURL=selectedValue}
                            if(expanded){
                            creator.createQMLObject("ScheduledRecordingStationSelect.qml");}
                        }
                        Option {id: option1; enabled:true;text: "Custom Stations";  value:"custom"}
                        Option {id: option2; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelAlternative.xml" )  ;text: "Alternative Stations";  value: "file://" +_app.homePath()+"/InternetRadioStationsModelAlternative.xml" }
                        Option {id: option3; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelUK.xml" )  ;text: "UK Stations";  value: "file://" +_app.homePath()+"/InternetRadioStationsModelUK.xml" }
                        Option { id: option4; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelGermany.xml" )  ;text: "German Stations" ;value: "file://" +_app.homePath()+"/InternetRadioStationsModelGermany.xml" }
                        Option { id: option5; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelFrance.xml" )  ;text: "French Stations" ;value: "file://" +_app.homePath()+"/InternetRadioStationsModelFrance.xml" }
                        Option { id: option6; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelSpain.xml" )  ;text: "Spanish Stations";value: "file://" +_app.homePath()+"/InternetRadioStationsModelSpain.xml"  }
                        Option { id: option7; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelCanada.xml" )  ;text: "Canadian Stations"; value: "file://" +_app.homePath()+"/InternetRadioStationsModelCanada.xml" }
                        Option { id: option8; enabled:_app.checkFileExists(_app.homePath()+"/InternetRadioStationsModelItalian.xml" )  ;text: "Italian Stations"; value: "file://" +_app.homePath()+"/InternetRadioStationsModelItalian.xml" }
                    }
                    StandardListItem {
                        visible: scheduledRecModelStationName===""?false:true
                        title: scheduledRecModelStationName
                        
                    }
                   
            }
                
                
            } 
        
                    
                
     
     
            
        
    

}

}