import bb.cascades 1.4
import bb.system 1.2
import bb.platform 1.3
import bb.cascades.pickers 1.0
import bb.device 1.4
import timer 1.0
import "Custom"

Sheet{
    id: settings
    onCreationCompleted: { open(); toggler.start();}
    property bool finished:false
content:Page {
    titleBar: TitleBar {
        appearance: TitleBarAppearance.Branded
        title: qsTr("Settings")
        
        dismissAction: ActionItem {
            title: qsTr("Close") 
            id: closeAction
            onTriggered: {close();settings.destroy();}
        }
        acceptAction: ActionItem {
            id: resetAction
            title: qsTr("Reset App")
            onTriggered: {
                creator.createQMLObject("ResetStarPlayer.qml")
            }
        }
    }
    attachedObjects:SystemTimer{id:toggler; interval: 500; onTimeout:{finished=true;togglebutton.enabled=true;togglebutton1.enabled=true;toggler.destroy();}}
    ScrollView {
        scrollRole: ScrollRole.Main
        id: scroller
        content: Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Center
            id: conter
            topPadding: 5
            bottomPadding: 5
            
            navigation.focusPolicy: NavigationFocusPolicy.Focusable            
            layout: StackLayout { }
            UserInfoBanner{onClicked:{creator.createQMLObject("Help/SettingsDisabled.qml")} visible: mediaPlaying?true:false;text: "Some App Settings are disabled because media is playing, tap to learn more"}
       
           StandardListItem {
               opacity: nightMode?0.8:1
               navigation.focusPolicy: NavigationFocusPolicy.Focusable
                textFormat: TextFormat.Plain
                navigation.rightAllowed: false
                title: qsTr("Player Settings")
                description: qsTr("Settings for the Media Player")
                gestureHandlers: [
                    TapHandler {
                        onTapped: {
                            creator.createQMLObject("PlayerSettings.qml")
                        }
                    }
                ]

       }
            StandardListItem {
                opacity: nightMode?0.8:1
                navigation.focusPolicy: NavigationFocusPolicy.Focusable
                textFormat: TextFormat.Plain
                navigation.rightAllowed: false
                title: qsTr("Network Proxy Settings")
                description: qsTr("Set and Modify a Network Proxy")
                gestureHandlers: [
                    TapHandler {
                        onTapped: { creator.createQMLObject("NetworkProxySettings.qml");}
                    }
                ]
            }
            StandardListItem {
                opacity: nightMode?0.8:1
                navigation.focusPolicy: NavigationFocusPolicy.Focusable
                textFormat: TextFormat.Plain
                navigation.rightAllowed: false
                title:qsTr( "Security Settings")
                
                description: qsTr("Manage Security Settings")
                gestureHandlers: [
                    TapHandler {
                        onTapped: {
                            if(appsettings.getSystemSetting("passwordprotectionPS", "")==="")creator.createQMLObject("NewSecurityPassword.qml")
                            else creator.createQMLObject("EnterPasswordProtection.qml")
                        }
                    }
                ]
            }
            StandardListItem {
                opacity: nightMode?0.8:1
                navigation.focusPolicy: NavigationFocusPolicy.Focusable
                textFormat: TextFormat.Plain
                navigation.rightAllowed: false
                title: qsTr("Pinned Media")
                description: qsTr("Manage Pinned Media")
                gestureHandlers: [
                    TapHandler {
                        onTapped: {
                            creator.createQMLObject("PinnedVideosManage.qml")

                        }
                    }
                ]

            }
            StandardListItem {
                opacity: nightMode?0.8:1
                navigation.focusPolicy: NavigationFocusPolicy.Focusable
                navigation.rightAllowed: false
                enabled: mediaPlaying? false:true
                textFormat: TextFormat.Plain
                title: qsTr("Manage Player Menu")
                id: mngpl
                description:qsTr( "Select which options show on the Player Menu")
                gestureHandlers: [
                    TapHandler {
                        onTapped: {
                            if(mngpl.enabled===true){
                            creator.createQMLObject("PlayerMenuActionItemsSett.qml")}
                        }
                    }
                ]

            }
            StandardListItem {
                opacity: nightMode?0.8:1
                navigation.focusPolicy: NavigationFocusPolicy.Focusable
                textFormat: TextFormat.Plain
                navigation.rightAllowed: false
                title: qsTr("Night Mode")
                description: qsTr("Manage Night Mode Settings")
                gestureHandlers: [
                    TapHandler {
                        onTapped: {
                            creator.createQMLObject("NightModeSettings.qml")

                        }
                    }
                ]

            }
            StandardListItem {
                opacity: nightMode?0.8:1
                navigation.focusPolicy: NavigationFocusPolicy.Focusable
                textFormat: TextFormat.Plain
                navigation.rightAllowed: false
                title:qsTr( "Lyrics Search Settings")
                description: qsTr("Manage Lyrics Search Settings")
                gestureHandlers: [
                    TapHandler {
                        onTapped: {
                            creator.createQMLObject("LyricsSettings.qml")
                        
                        }
                    }
                ]
            
            }
            

            Container {
                
                topPadding: 10; leftPadding: 15;rightPadding: 20
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                Label {
                    opacity: nightMode?0.8:1
                    text:qsTr("Notify when a download has finished")
                    verticalAlignment: VerticalAlignment.Center
                    horizontalAlignment: HorizontalAlignment.Left
                    textStyle {
                        base: SystemDefaults.TextStyles.BodyText
                        fontSize: FontSize.PointValue
                        fontSizeValue: miniSquareDevice?7:8
                    }
                }
                
                ToggleButton {
                    opacity: nightMode?0.8:1
                    enabled: false
                    id: togglebutton
                    horizontalAlignment: HorizontalAlignment.Right
                    checked:notifyOnDownloadComplete
                    onCheckedChanged: {
                        if(finished===false){console.log("Denied checked changed");}
                        else if (finished===true){if(notifyOnDownloadComplete===true){notifyOnDownloadComplete=false;appsettings.saveSystemSetting("notifyOnDownloadComplete", "")}
                        else{notifyOnDownloadComplete=true; appsettings.saveSystemSetting("notifyOnDownloadComplete", "true");}
                        
                        }
                    }
                }
            }  
            Container {
                
                topPadding: 10; leftPadding: 15;rightPadding: 20
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                Label {
                    opacity: nightMode?0.8:1
                    text:qsTr("Launch into Do Not Disturb mode")
                    verticalAlignment: VerticalAlignment.Center
                    horizontalAlignment: HorizontalAlignment.Left
                    textStyle {
                        base: SystemDefaults.TextStyles.BodyText
                        fontSize: FontSize.PointValue
                        fontSizeValue: miniSquareDevice?7:8
                    }
                }
                
                ToggleButton {
                    enabled: false
                    opacity: nightMode?0.8:1
                    id: togglebutton1
                    horizontalAlignment: HorizontalAlignment.Right
                    checked:appsettings.getSystemSetting("launchDoNotDisturb", "")===""? false:true
                    onCheckedChanged: {
                        if(finished===false){console.log("Denied checked changed");}
                        else if (finished===true){if(appsettings.getSystemSetting("launchDoNotDisturb", "")==="true"){appsettings.saveSystemSetting("launchDoNotDisturb", "")}
                        else{appsettings.saveSystemSetting("launchDoNotDisturb", "true");}
                        
                        }
                    }
                }
            } 
            
           Container{
               topPadding:10;leftPadding: 10; rightPadding: 10
           
            DropDown {
            
                opacity: nightMode?0.8:1
                enabled: mediaPlaying?false:true
                title: qsTr("Active Frame")
                onCreationCompleted: {
                    if(appsettings.getSystemSetting("liveActiveFrameDropDownIndex", "")==="")selectedIndex=1
                    else{
                        selectedIndex= parseInt(appsettings.getSystemSetting("liveActiveFrameDropDownIndex", ""));
                    }
                }
                onSelectedIndexChanged: {
                    if(selectedIndex===0){liveActiveFrame=true; appsettings.saveSystemSetting("liveActiveFrame", "");albumArtActiveFrame=false; appsettings.saveSystemSetting("albumArtActiveFrame", "");}
                    else if (selectedIndex===1){albumArtActiveFrame=true;liveActiveFrame=true; appsettings.saveSystemSetting("liveActiveFrame", "");  appsettings.saveSystemSetting("albumArtActiveFrame", "true");}
                    else if (selectedIndex===2){liveActiveFrame=false; appsettings.saveSystemSetting("liveActiveFrame", "false");albumArtActiveFrame=false; appsettings.saveSystemSetting("albumArtActiveFrame", "");}
                    appsettings.saveSystemSetting("liveActiveFrameDropDownIndex", selectedIndex);
                }
                Option {
                    text:qsTr( "Live Active Frame")
                }
                Option {
                    text: qsTr("Live Active Frame (Show Art Work)")
                }
                Option {
                    text: qsTr("Static Active Frame")
                }
            }
        }
        Container{
            topPadding:10;  leftPadding: 10; rightPadding: 10
            
            DropDown{
                opacity: nightMode?0.8:1
                visible: if(hardwareInfo.isPhysicalKeyboardDevice===true){if(passport===true){return true;}else{return false;}}
                else{return true;}
                title:qsTr( "App Orientation")
                onCreationCompleted: {
                    if(appsettings.getSystemSetting("orientationDropDownIndex", "")==="")selectedIndex=0
                    else{
                        selectedIndex= parseInt(appsettings.getSystemSetting("orientationDropDownIndex", ""));
                    }
                }
                onSelectedIndexChanged: {
                    appsettings.saveSystemSetting("orientation", selectedValue)
                    appsettings.saveSystemSetting("orientationDropDownIndex", selectedIndex);
                    console.log(appsettings.getSystemSetting("orientation", ""))
                    if(selectedValue==="Automatic"){OrientationSupport.supportedDisplayOrientation =SupportedDisplayOrientation.All}
                    else if(selectedValue==="Portrait"){OrientationSupport.supportedDisplayOrientation =SupportedDisplayOrientation.DisplayPortrait}
                    else if(selectedValue==="Landscape"){OrientationSupport.supportedDisplayOrientation =SupportedDisplayOrientation.DisplayLandscape}
                }
                Option{
                    text: qsTr("Automatic")
                    value: "Automatic"
                }
                Option {
                    text:qsTr( "Portrait")
                    value: "Portrait"
                    
                }
                Option {
                    text: qsTr("Landscape")
                    value: "Landscape"
                }
                
            }
        }
        Container{
            topPadding:10; leftPadding: 10; rightPadding: 10

DropDown {
    title: "Application Theme"
    opacity: nightMode?0.8:1
    enabled: nightMode? false:true
    onCreationCompleted: {
        if(nightMode){}
        else{
            selectedIndex= parseInt(appsettings.getSystemSetting("appthemeIndex", ""))}
    }
onSelectedIndexChanged: {
    appsettings.saveSystemSetting("appthemeIndex", selectedIndex)
    if(selectedIndex===0){Application.themeSupport.setVisualStyle(VisualStyle.Dark);appsettings.saveSystemSetting("BrightTheme", "")}
    else {Application.themeSupport.setVisualStyle(VisualStyle.Bright);appsettings.saveSystemSetting("BrightTheme", "true")}
}
Option {
    text: "Dark Theme (Default)"
}
Option{
    text: "Bright Theme"
    description: displayInfo.displayTechnology==2?"Will use more battery on your OLED screen": ""
}
}
        }
        Container{
            topPadding:10; leftPadding: 10; rightPadding: 10
            
            DropDown {
                opacity: nightMode?0.8:1
                enabled: nightMode? false:true
                title: qsTr("Application Colour Scheme")
                onCreationCompleted: {
                    if(nightMode){}
                    else{
                    selectedIndex= parseInt(appsettings.getSystemSetting("themeIndex", ""))}
                }
                onSelectedIndexChanged: {
                    
                    if(selectedIndex===0){Application.themeSupport.setPrimaryColor(Color.create("#0092cc")); appsettings.saveSystemSetting("themes", "#0092cc")}
                    else if (selectedIndex===1){Application.themeSupport.setPrimaryColor(Color.create("#0000ff")); appsettings.saveSystemSetting("themes", "#0000ff") }
                    else if (selectedIndex===2){Application.themeSupport.setPrimaryColor(Color.Red); appsettings.saveSystemSetting("themes", "red") }
                    else if (selectedIndex===3){Application.themeSupport.setPrimaryColor(Color.create("#F52887")); appsettings.saveSystemSetting("themes", "#F52887") }

                    else if (selectedIndex===4){Application.themeSupport.setPrimaryColor(Color.create("#ff00ff")); appsettings.saveSystemSetting("themes", "#ff00ff")}
                    else if (selectedIndex===5){Application.themeSupport.setPrimaryColor(Color.create("#9900ff")); appsettings.saveSystemSetting("themes", "#9900ff")}
                    appsettings.saveSystemSetting("themeIndex", selectedIndex)  
                    themeValue=appsettings.getSystemSetting("themes", "");
                    
                    themeChanged();   
                }
                Option {
                    imageSource: "images/theme_indicator_bblue.png"
                    text: "BlackBerry Blue"
                    value: "#0092cc"
                }
            Option{
                imageSource: "images/theme_indicator_blue.png"
                text: "Blue"
                value: "#0000ff"
            }
                Option {
                    imageSource: "images/theme_indicator_red.png"
                    text: "Red"
                    value:"red"
                }
                Option {
                    imageSource: "images/theme_indicator_deeppink.png"
                    text: "Deep Pink"
                    value: "#F52887"
                }
                
                Option {
                    imageSource: "images/theme_indicator_magenta.png"
                    text: "Magenta"
                    value: "#ff00ff" 
                }
           Option {
               imageSource: "images/theme_indicator_purple.png"
               text: "Purple"
               value: "#9900ff" 
                }
            }
        }
        Container{
            topPadding:10;  leftPadding: 10; rightPadding: 10
            
            DropDown {
                opacity: nightMode?0.8:1
                property bool wasExpanded:false
                title:qsTr( "Home Signature Action")
                onSelectedIndexChanged: {
                    appsettings.saveSystemSetting("homeSigAction", selectedValue);
                    appsettings.saveSystemSetting("homeSigActionIndex", selectedIndex)  
                    if(wasExpanded===true)  toast.showTextWithButton("Please restart Star Player to Apply changes", "Ok", "restart");
                    if(selectedIndex===1){appsettings.saveSystemSetting("homeSigActionPicker", "clean")}
                    else{appsettings.saveSystemSetting("homeSigActionPicker", "")}

                }
                onCreationCompleted: {
                    if(appsettings.getSystemSetting("homeSigActionIndex", "")==="")selectedIndex=1
                    else{selectedIndex= parseInt(appsettings.getSystemSetting("homeSigActionIndex", ""));}
                }
                onExpandedChanged: {if(expanded)wasExpanded=true;}

                Option {
                    text: qsTr("Choose Video")
                    value: "Vid"
                }
                Option {
                    text: qsTr("Choose Video & Audio (Clean Picker)")
                    value: "Vid"
                }
                Option {
                    text: qsTr("Choose Audio")
                    value: "Aud"
                }
            }
        }
        Container{
            visible: appsettings.getSystemSetting("homeSigActionPicker", "")==="clean"? false:true
            topPadding:10; leftPadding: 10; rightPadding: 10
            
            DropDown {
                opacity: nightMode?0.8:1
                visible:  _app.checkSDCard();
                property bool wasExpanded:false
                onExpandedChanged: {if(expanded)wasExpanded=true;}
                title: qsTr("Video/Audio Picker Default Directory")
                onCreationCompleted: {
                    if(appsettings.getSystemSetting("filepickerDefaultPathIndex", "")==="")selectedIndex=0
                    else{
                        selectedIndex= parseInt(appsettings.getSystemSetting("filepickerDefaultPathIndex", ""));
                    }
                }
                onSelectedIndexChanged: {
                    if(selectedValue==="last"){appsettings.saveSystemSetting("filepickerDefaultPathLast", "true");appsettings.saveSystemSetting("filepickerDefaultPath", "")}
                    else{ appsettings.saveSystemSetting("filepickerDefaultPath", ""); appsettings.saveSystemSetting("filepickerDefaultPath", selectedValue)}
                    appsettings.saveSystemSetting("filepickerDefaultPathIndex", selectedIndex);
                }
                
                Option {
                    text:qsTr( "Device Memory")
                    value: "/accounts/"
                }
                Option {
                    enabled: _app.checkSDCard()
                    text: qsTr("SD/Media Card")
                    value:"/accounts/1000/removable/sdcard/"
                }
                Option {
                    text: "Last Directory"
                    value:"last"
                }
                Option {
                    text:qsTr( "Suggested Directory")
                    value:""
                }
            }
        }
        
        Container{
            topPadding:10;  leftPadding: 10; rightPadding: 10
            
            DropDown {
                onSelectedIndexChanged: {
                    appsettings.saveSystemSetting("LaunchAppInto", selectedValue);
                    appsettings.saveSystemSetting("LaunchAppIntoIndexx", selectedIndex)                  
                }
                onCreationCompleted: {
                    if(appsettings.getSystemSetting("LaunchAppIntoIndexx", "")==="")selectedIndex=0
                    else{selectedIndex= parseInt(appsettings.getSystemSetting("LaunchAppIntoIndexx", ""));}
                }
                opacity: nightMode? 0.8:1
                title: qsTr("Launch App Into")
                Option {
                    text: qsTr("Homepage")
                    value:text
                }
                Option {enabled: _app.checkSDCard();text: "Play All"; value: text}
                Option {
                    text: qsTr("Video Chooser")
                    value: text
                }
                Option {
                    text: qsTr("Audio Chooser")
                    value: text
                }
                Option {
                    text: qsTr("Clean Picker")
                    value: text
                }
                
                Option {
                    text: qsTr("Favourites")
                    value: text
                }
                Option {
                    text:qsTr( "Last Played")
                    value: text
                }
                Option {
                    text: qsTr("Internet Radio")
                    value: text
                }
                Option {
                    text: qsTr("Audio Recorder")
                    value: text
                }
                Option {
                    text: qsTr("Playlists")
                    value: text
                }
                Option {
                    text: qsTr("Lyrics Search")
                    value: text
                }
            }
        }
   
           /* Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Fill
            Button {
                text: "Backup & Restore"
                onClicked:{stopMedia();creator.createQMLObject("BackupAndRestore.qml");}
            }
        }*/

}
    }
}
}
