import bb.cascades 1.4
import bb.system 1.2
import bb.platform 1.3
import bb.cascades.pickers 1.0
import bb.device 1.4

import timer 1.0

Sheet{
    id: settings
    onCreationCompleted: {
        open(); 
    }
    property bool finished:false
    content:Page {
        titleBar: TitleBar {
            appearance: TitleBarAppearance.Branded
            title: qsTr("Sleep Timer")
            
            dismissAction: ActionItem {
                title: qsTr("Close") 
                onTriggered: {
                    close();settings.destroy();
                }
            
            }

        
        }
        ScrollView {
            id: scroller
            content: Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Center
                id: conter
                topPadding: 5
                bottomPadding: 5
                navigation.focusPolicy: NavigationFocusPolicy.Focusable            
                layout: StackLayout { }
           
                DropDown {
                    onCreationCompleted: {
                        if(appsettings.getSystemSetting("sleepTimerFunctionIndex", "")==="")selectedIndex=0
                        else selectedIndex= parseInt(appsettings.getSystemSetting("sleepTimerFunctionIndex", ""))
                    }
                    onSelectedIndexChanged: {
                        appsettings.saveSystemSetting("sleepTimerFunction", selectedValue)
                        console.log(appsettings.getSystemSetting("sleepTimerFunction", ""))
                        appsettings.saveSystemSetting("sleepTimerFunctionIndex", selectedIndex)
                        
                    }
                    title: qsTr("Sleep Timer Function")
                    Option {
                        text: qsTr("Pause Player")
                        value: "pause"
                    }
                    Option {
                        text: qsTr("Fully Stop Player")
                        value:"stop"
                    }
                    Option {
                        text: qsTr("Close Star Player")
                        value: "close"
                    }
                    Option {
                        text:qsTr( "Stop Internet Radio Recording")
                        value: "stoprecord"
                    }
                }
                
                
                Container {
                    leftPadding: 25;rightPadding: 25; topPadding: 25
                    layout: DockLayout {}
                    minHeight:120
                    id: slidercont
                    horizontalAlignment: HorizontalAlignment.Fill
                    Label {
                        opacity: nightMode?0.8:1
                        text:qsTr("Sleep Timer Timeout:")
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Left
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 7
                        }
                    }
                    Label {
                        function convertMS( milliseconds ) {
                            var date = new Date(milliseconds);
                            var str = '';
                         //   str += date.getUTCDate()-1 + " days, ";
                           if(date.getUTCHours()=="0"){} else {str += date.getUTCHours() + " hours, ";}
                            str += date.getUTCMinutes() + " minutes, ";
                            if(date.getUTCSeconds()=="0"){} else { str += date.getUTCSeconds() + " seconds ";}
                           // str += date.getUTCMilliseconds() + " millis";
                           // console.log(str);

                            return str;
                        }
                        opacity: nightMode?0.8:1
                        text: convertMS(parseInt(slider.immediateValue))
                        verticalAlignment: VerticalAlignment.Top
                        horizontalAlignment: HorizontalAlignment.Right
                        textStyle {
                            base: SystemDefaults.TextStyles.BodyText
                            fontSize: FontSize.PointValue
                            fontSizeValue: 6
                        }
                    }
                    Slider {
                        opacity: nightMode?0.8:1
                        id:slider
                        verticalAlignment: VerticalAlignment.Bottom
                        horizontalAlignment: HorizontalAlignment.Fill
                        value:  sleepTimer.interval
                        toValue:18000000
                        fromValue: 300000
                        
                        
                        onValueChanged: {sleepTimer.interval=parseInt(slider.immediateValue);appsettings.saveSystemSetting("sleepTimerInterval", immediateValue)}
                    }
                }
                Container {
                    topPadding: 25
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    Button {
                        text:  qsTr("Reset Timeout")
                        color: Color.create(getAppColour())
                        onClicked: {
                            sleepTimer.interval=slider.fromValue;
                        }
                    }
                }
            }
        }
    }
}
