import bb.cascades 1.4

Container {
    id: thinkingState
    property string imageSourcee: decideSplashIMG();
    function decideSplashIMG(){
        if(passport===true){
            
            if (themeValue === "") {
                return "images/icon_splash_passport.png"
            } else if (themeValue === "#0092cc") {
                return "images/icon_splash_passport.png"
            } else if (themeValue === "#0000ff") {
                return "images/icon_splash_blue_passport.png"
            }
            else if (themeValue === "#F52887") {
                return "images/icon_splash_deep_pink_passport.png"
            }
            
            else if (themeValue === "red") {
                return "images/icon_splash_red_passport.png"
            } else if (themeValue === "#ff00ff") {
                return "images/icon_splash_magenta_passport.png"
            } else if (themeValue === "#9900ff") {
                return "images/icon_splash_purple_passport.png"
            }
        
        } 
        else{
            if (themeValue === "") {
                return "images/icon_splash.png"
            } else if (themeValue === "#0092cc") {
                return "images/icon_splash.png"
            } else if (themeValue === "#0000ff") {
                return "images/icon_splash_blue.png"
            }
            else if (themeValue === "#F52887") {
                return "images/icon_splash_deep_pink.png"
            }
            
            else if (themeValue === "red") {
                return "images/icon_splash_red.png"
            } else if (themeValue === "#ff00ff") {
                return "images/icon_splash_magenta.png"
            } else if (themeValue === "#9900ff") {
                return "images/icon_splash_purple.png"
            }
        }
    }
    horizontalAlignment: HorizontalAlignment.Center
    verticalAlignment: VerticalAlignment.Center
onCreationCompleted: {
    start();
}    
    property bool thinkingPlaying: (
    thinkingAnimation.state == AnimationState.Playing || 
    thinkingEnding.state == AnimationState.Playing ||
    thinkingAnimation.state == AnimationState.Started || 
    thinkingEnding.state == AnimationState.Started
    )
        
        
        layout: DockLayout {
        }
        
          
        //Start the thinking animation
        function start() {
                thinkingAnimation.play();
        }
        
        //End the animation with an animation finale
        function stop() {

            thinkingAnimation.stop();
            thinkingCircle1.scaleX = 0;
            thinkingCircle1.scaleY = 0;
            thinkingCircle2.scaleX = 0;
            thinkingCircle2.scaleY = 0;
            thinkingDomainIcon.scaleX = 0;
            thinkingDomainIcon.scaleY = 0;
            thinkingDomainIcon.opacity = 0.0;
            thinkingCircle1.opacity=0.0;
            thinkingCircle2.opacity=0.0;
        }

        
        animations: [
            //Thinking/pulsing animation
            ParallelAnimation {
                id: thinkingAnimation
                repeatCount: 0
                    //AnimationRepeatCount.Forever
                property int transitionTime: 600
                
                onStarted: {
                    thinkingDomainIcon.scaleX = 0.65;
                    thinkingDomainIcon.scaleY = 0.65;
                    thinkingDomainIcon.opacity = 1.0;
                }
                
              onStateChanged: {
                    if (state == AnimationState.Stopping || state == AnimationState.Stopped) {
                        if (!thinkingEnding.isPlaying() && !thinkingEnding.isStarted()) {
                           thinkingEnding.play();
                        }
                    }
                }
                
                ScaleTransition {
                    target: thinkingCircle1
                    fromX: 0.0
                    fromY: 0.0
                    toX: 1.0
                    toY: 1.0
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                   
                }
                FadeTransition {
                    target: thinkingCircle1
                    fromOpacity: 0.0
                    toOpacity: 1.0
                    duration: thinkingAnimation.transitionTime/2
                    easingCurve: StockCurve.Linear
                }
                ScaleTransition {
                    target: thinkingCircle1
                    fromX: 1.0
                    fromY: 1.0
                    toX: 0.6
                    toY: 0.6
                    delay: thinkingAnimation.transitionTime
                    duration: thinkingAnimation.transitionTime*2
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle1
                    fromOpacity: 1.0
                    toOpacity: 0.2
                    delay: thinkingAnimation.transitionTime
                    duration: thinkingAnimation.transitionTime*2
                    easingCurve: StockCurve.Linear
                }
                //Circle 2 fading out while circle 1 is fading in to make it more fluid
                ScaleTransition {
                    target: thinkingCircle2
                    fromX: 0.85
                    fromY: 0.85
                    toX: 0.6
                    toY: 0.6
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle2
                    fromOpacity: 0.6
                    toOpacity: 0.2
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }
                
                ScaleTransition {
                    target: thinkingCircle2
                    fromX: 0.0
                    fromY: 0.0
                    toX: 0.9
                    toY: 0.9
                    delay: thinkingAnimation.transitionTime*2
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle2
                    fromOpacity: 0.0
                    toOpacity: 1.0
                    delay: thinkingAnimation.transitionTime*2
                    duration: thinkingAnimation.transitionTime/2
                    easingCurve: StockCurve.Linear
                }
                ScaleTransition {
                    target: thinkingCircle2
                    fromX: 1.0
                    fromY: 1.0
                    toX: 0.85
                    toY: 0.85
                    delay: thinkingAnimation.transitionTime*3
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle2
                    fromOpacity: 1.0
                    toOpacity: 0.0 //hide in the way second img
                    delay: thinkingAnimation.transitionTime*3
                    duration: thinkingAnimation.transitionTime
                    easingCurve: StockCurve.Linear
                    onEnded: {
                        thinkingState.stop();
                    }
                   
                }
            },
            
            //Ending expand and fade animation
           ParallelAnimation {
                id: thinkingEnding
                repeatCount: 0
                property int transitionTime: 400
                
                onEnded: {
                   // thinkingCircle1.scaleX = 0;
                   // thinkingCircle1.scaleY = 0;
                   // thinkingCircle2.scaleX = 0;
                   // thinkingCircle2.scaleY = 0;
                    //thinkingDomainIcon.scaleX = 0;
                 //   thinkingDomainIcon.scaleY = 0;
                  //  thinkingDomainIcon.opacity = 0.0;
                   
                 
                }
                ScaleTransition {
                    target: thinkingCircle1
                    fromX: 1.0
                    fromY: 1.0
                    toX: 1.5
                    toY: 1.5
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle1
                    fromOpacity: 1.0
                    toOpacity: 0.0
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                    
                }
                ScaleTransition {
                    target: thinkingCircle2
                    fromX: 1.0
                    fromY: 1.0
                    toX: 1.5
                    toY:1.5
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingCircle2
                    fromOpacity: 1.0
                    toOpacity: 0.0
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                ScaleTransition {
                    target: thinkingDomainIcon
                    fromX: 0.75
                    fromY: 0.75
                    toX: 1.5
                    toY: 1.5
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                }
                FadeTransition {
                    target: thinkingDomainIcon
                    fromOpacity: 1.0
                    toOpacity: 0.0
                    duration: thinkingEnding.transitionTime
                    easingCurve: StockCurve.Linear
                    onEnded: {
                        thinkingState.stop()
                        console.log("Ended")

                    }
                }
            }
        ]
        
        ImageView {
            preferredHeight: passport? 500:350
            preferredWidth:  passport? 500:350
            id: thinkingCircle1
            touchPropagationMode: TouchPropagationMode.None
            overlapTouchPolicy: OverlapTouchPolicy.Allow
            imageSource: imageSourcee
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            scaleX: 0
            scaleY: 0
        }
        
        ImageView {
            preferredHeight: passport? 500:350
            preferredWidth:  passport? 500:350
            id: thinkingCircle2
            touchPropagationMode: TouchPropagationMode.None
            overlapTouchPolicy: OverlapTouchPolicy.Allow
            imageSource:  imageSourcee
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            scaleX: 0
            scaleY: 0
        }
        
        ImageView {
            preferredHeight: passport? 500:350
            preferredWidth:  passport? 500:350
            id: thinkingDomainIcon
            touchPropagationMode: TouchPropagationMode.None
            overlapTouchPolicy: OverlapTouchPolicy.Allow
            imageSource:  imageSourcee
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            scaleX: 0
            scaleY: 0
        }
}


