import QtQuick 1.0
import bb.cascades 1.4

Sheet{
    id: sheet
    property bool audioMode:false
    property bool listVisible:appsettings.getSystemSetting("videoPickerListChoice", "")===""?true:false
    attachedObjects:[
    Connections {
        target: mainnav
        onClosePicker:{sheet.close(); _systemMedia.terminate();}

    },
    Connections {
      target: _app
      onMediaChangeDetected:{
          if(listViewContAudio.opacity===1){ listViewAudio.dataModel.clear();activityInd.running=true;_systemMedia.getAudio(); }
          else if(listViewContAudio2.opacity===1){listViewAudio2.dataModel.clear();activityInd.running=true;_systemMedia.getAudio(); }
          else if(listViewContVideo.opacity===1){listViewVideo.dataModel.clear();activityInd.running=true; _systemMedia.getVideos();}
          else if(listViewContVideo2.opacity===""){listViewVideo2.dataModel.clear(); activityInd.running=true; _systemMedia.getVideos();}
          }
    },
    Timer {
        id: delay;interval: 50; onTriggered: {
            console.log("TIMER TRIGGERED"); delay.stop(); openVideo();videoOpening=true;_systemMedia.terminate();

        }
    }
    ]
    function toggleView(){
        if(listVisible===true){listVisible=false; appsettings.saveSystemSetting("videoPickerListChoice", "true");}
        else{ listVisible=true;appsettings.saveSystemSetting("videoPickerListChoice", "")   }     
    }
    
Page {
   id: page
    onCreationCompleted: {
    sheet.open()
    activityInd.running=true;
 
    }
    function onNoMediaFound() {
        console.log("No media found")
    }
    
    function onGotThumbVideo(list) {
        // insert thumbnails received
       listViewVideo.dataModel.insertList(list);
        listViewVideo2.dataModel.insertList(list);

       activityInd.running=false
    
    }
    function onFinishedVideos() {
        console.log("*************QML onFinishedVideos FINISHED", listViewVideo.dataModel.size());
        
        activityInd.running=false

    }
    

    function onThumbImage(list) {
        // insert thumbnails received
       // listView.dataModel.insertList(list);
     //   listView2.dataModel.insertList(list);

        activityInd.running=false


    }
    function onFinishedImages() {
        console.log("*************QML onFinishedImages FINISHED", listView.dataModel.size());
        activityInd.running=false
    }
    
    
    function onGotThumbAudio(list) {
        // insert thumbnails received
       listViewAudio.dataModel.insertList(list);
       listViewAudio2.dataModel.insertList(list);

        activityInd.running=false

    }
    function onFinishedAudio() {
        console.log("*************QML onFinishedAudio FINISHED", listViewAudio.dataModel.size());

        activityInd.running=false

    }
    
   
   actionBarVisibility: ChromeVisibility.Compact
    actionBarAutoHideBehavior: ActionBarAutoHideBehavior.HideOnScroll
    actions: [
        ActionItem {
        enabled: false
        id: actiona
        title: qsTr("To Top")
        ActionBar.placement: ActionBarPlacement.Signature
        imageSource: "asset:///images/ic_to_top.png"
        onTriggered: {
            listViewAudio.scrollToItem([0, 0], ScrollAnimation.Default);
            listViewAudio2.scrollToItem([0, 0], ScrollAnimation.Default);

            listViewVideo.scrollToItem([0, 0], ScrollAnimation.Default);
            listViewVideo2.scrollToItem([0, 0], ScrollAnimation.Default);


        }
    },
       
   /* ActionItem{
      title: "Play All Audio"  
      onTriggered: {
          // some long winded shit to add the lot to the play queue 
          
          
      }
    },*/
    ActionItem {
      title: "Back"
      imageSource: "images/ic_previous.png"  
      onTriggered: {
          _systemMedia.terminate();

          _systemMedia.finishedVideos.disconnect(page.onFinishedVideos);
          _systemMedia.gotThumbVideo.disconnect(page.onGotThumbVideo);
          _systemMedia.finishedAudio.disconnect(page.onFinishedAudio);
          _systemMedia.gotThumbAudio.disconnect(page.onGotThumbAudio);
          
          _systemMedia.noAudioFound.disconnect(page.onNoMediaFound);    
          _systemMedia.noVideosFound.disconnect(page.onNoMediaFound);
          listViewAudio.dataModel.clear(); listViewAudio2.dataModel.clear();listViewVideo.dataModel.clear();listViewVideo2.dataModel.clear();
          sheet.close();
      }
    },
    
    ActionItem {
        title:qsTr( "Switch View")
        ActionBar.placement: ActionBarPlacement.OnBar
        imageSource: sheet.listVisible? "images/ic_view_grid.png":"images/ic_view_list.png"
        onTriggered: {
            toggleView();
        }
    }
]
titleBar: TitleBar {
    kind: TitleBarKind.Segmented
    scrollBehavior: TitleBarScrollBehavior.NonSticky
    onSelectedIndexChanged: {
        console.log("SELECTED INDEX CHANGED: " + selectedIndex)
    }
    onSelectedValueChanged: {
        console.log("VALUE CHANGED : " + selectedValue);
        if(selectedValue==="video"){
           
            _systemMedia.terminate();
            _systemMedia.finishedVideos.disconnect(page.onFinishedVideos);
            _systemMedia.gotThumbVideo.disconnect(page.onGotThumbVideo);
            _systemMedia.finishedAudio.disconnect(page.onFinishedAudio);
            _systemMedia.gotThumbAudio.disconnect(page.onGotThumbAudio);
            
            _systemMedia.noAudioFound.disconnect(page.onNoMediaFound);    
            _systemMedia.noVideosFound.disconnect(page.onNoMediaFound);
            audioMode=false;

            listViewAudio.dataModel.clear(); listViewAudio2.dataModel.clear();
            activityInd.running=true;
        
            _systemMedia.finishedVideos.connect(page.onFinishedVideos);
            _systemMedia.gotThumbVideo.connect(page.onGotThumbVideo);
            _systemMedia.finishedAudio.connect(page.onFinishedAudio);
            _systemMedia.gotThumbAudio.connect(page.onGotThumbAudio);
            
            _systemMedia.noAudioFound.connect(page.onNoMediaFound);    
            _systemMedia.noVideosFound.connect(page.onNoMediaFound);
           _systemMedia.getVideos();
        }
        else if (selectedValue==="audio"){
            activityInd.running=true;

            _systemMedia.terminate();
            _systemMedia.finishedVideos.disconnect(page.onFinishedVideos);
            _systemMedia.gotThumbVideo.disconnect(page.onGotThumbVideo);
            _systemMedia.finishedAudio.disconnect(page.onFinishedAudio);
            _systemMedia.gotThumbAudio.disconnect(page.onGotThumbAudio);
            
            _systemMedia.noAudioFound.disconnect(page.onNoMediaFound);    
            _systemMedia.noVideosFound.disconnect(page.onNoMediaFound);
            audioMode=true;

            listViewVideo.dataModel.clear(); listViewVideo2.dataModel.clear();
            
            _systemMedia.finishedVideos.connect(page.onFinishedVideos);
            _systemMedia.gotThumbVideo.connect(page.onGotThumbVideo);
            _systemMedia.finishedAudio.connect(page.onFinishedAudio);
            _systemMedia.gotThumbAudio.connect(page.onGotThumbAudio);
            
            _systemMedia.noAudioFound.connect(page.onNoMediaFound);    
            _systemMedia.noVideosFound.connect(page.onNoMediaFound);
            _systemMedia.getAudio();
            
        }
    }
   
    options: [
        Option {
            text: "Videos"
            value: "video"
        },
        Option {
            text: "Audio"
            value: "audio"
        }
    ]
}
    Container {
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        DropDown {
            opacity: nightMode? 0.8:1

            id: dropDownSorting
            title: "Order"
            property bool opened
            onCreationCompleted: {
            if(appsettings.getSystemSetting("cleanPickerOrder", "")===""){}
            else selectedIndex= parseInt(appsettings.getSystemSetting("cleanPickerOrder", ""))
            }
            onExpandedChanged: {
                if(expanded)opened=true;
                else opened=false
            }
            onSelectedIndexChanged: {
                if(selectedIndex===0){listViewModelVideo.setSortedAscending(true);listViewModelVideo2.setSortedAscending(true); listViewModelAudio.setSortedAscending(true);listViewModelAudio2.setSortedAscending(true); }
                else if (selectedIndex===1){listViewModelVideo.setSortedAscending(false);listViewModelVideo2.setSortedAscending(false); listViewModelAudio.setSortedAscending(false);listViewModelAudio2.setSortedAscending(false);}
              appsettings.saveSystemSetting("cleanPickerOrder", selectedIndex)
            }
            Option {
                text: "Ascending"
            }
            Option {
                text: "Descending"
            }
        }
        
        Container {
            opacity:audioMode? listVisible?1: 0: 0
            id: listViewContAudio2
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            translationY: dropDownSorting.opened? passport? 460:230: 90
            bottomPadding: 90
            
            
            ListView {
              //  rotationZ: 180
              function addToPlaylist(title, url){
                   fileTitleToBeAddedToList= title;
                     fileURLToBeAddedToList=url;
                  creator.createQMLObject("AddToPlaylistPopup.qml");
              }
              function deleteFile(title, url){
                  fileToBeDeletedTitle=title; 
                  fileToBeDeletedURL=url;
                  creator.createQMLObject("CleanPickerDeleteFile.qml")
              }
                attachedObjects:  [ ListScrollStateHandler {
                    id: scrollStateHandler2
                    
                    onScrollingChanged: {
                        if (scrolling) {
                            actiona.enabled=true;  
                        }
                    
                    }
                }
            ]
                onFocusedChanged: {
                    if(focused)scrollRole=ScrollRole.Main
                    else{scrollRole= ScrollRole.None}
                }
                scrollRole: ScrollRole.Main

                id: listViewAudio2
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                opacity: nightMode? 0.8:1
                
                dataModel: GroupDataModel {
                    id: listViewModelAudio2
                    sortingKeys: ["counter"]
                }
                layout: StackListLayout {
                    headerMode: ListHeaderMode.Sticky
                }
                
                listItemComponents: [
                    ListItemComponent {
                        type: "header"
                        Header {
                            visible: false
                        }
                    },
                    ListItemComponent {
                        type: "item"
                        
                        Container {
                            id: itemRoot2
                            Container {
                                topPadding: 5
                                visible: true
                                StandardListItem {
                                    function getTimeFromMSec(msec) {
                                        
                                        if (msec <= 0 || msec == undefined) {
                                            return "0:00"
                                        
                                        } else {
                                            var sec = "" + Math.floor(msec / 1000) % 60
                                            if (sec.length == 1)
                                                sec = "0" + sec
                                            
                                            var hour = Math.floor(msec / 3600000)
                                            if (hour < 1) {
                                                return Math.floor(msec / 60000) + ":" + sec
                                            } else {
                                                var min = "" + Math.floor(msec / 60000) % 60
                                                if (min.length == 1)
                                                    min = "0" + min
                                                
                                                return hour + ":" + min + ":" + sec
                                            }
                                        }
                                    }
                                    title: ListItemData.title
                                    status: getTimeFromMSec(ListItemData.duration)
                                    
                                    onCreationCompleted: {
                                     
                                    }
                                    function getArt(){
                                        var bob = _app.getAudioArtWork(ListItemData.fullAudioPath)
                                        if(bob===""){return "images/cleanPicker_NoArt.png"}
                                        else{return "file://"+ bob;}
                                    }                                   
                                    imageSource:getArt()
                                    description: ListItemData.fullAudioPath
                                    contextActions:  ActionSet {
                                        title:  ListItemData.title
                                        subtitle: ListItemData.fullAudioPath
                                        actions:[
                                         ActionItem {
                                             title:qsTr("Add To Playlist")
                                             imageSource: "images/ic_add.png"
                                             onTriggered: {
                                                 itemRoot2.ListItem.view.addToPlaylist(ListItemData.title, ListItemData.fullAudioPath)
                                             }
                                         },
                                         
                                         DeleteActionItem {
                                             title: "Delete File"
                                             onTriggered: {
                                                 itemRoot2.ListItem.view.deleteFile(ListItemData.title, ListItemData.fullAudioPath)
                                             }
                                         }
                                         
                                        ]
                                    }
                                
                                }

                            } 

                        } // itemRoot
                    } // ListItemComponent
                ]
            onTriggered: {
                var data= dataModel.data(indexPath);
                artWorkURI=_app.getAudioArtWork(data.fullAudioPath)===""?  "": "file://"+_app.getAudioArtWork(data.fullAudioPath)
                console.log(data.thumbUrl);
                audioSource= "file://"+ data.fullAudioPath;
               
                customPickerUsed=true; activity.running=true;activity.visible=true;
                originalSource=data.fullAudioPath;
                delay.start();
                sheet.close();
                _systemMedia.terminate();
                sheet.destroy(1000); 
            }
            }
        }
        
        

        Container {
            id: listViewContAudio
            opacity:audioMode? listVisible?0: 1: 0
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            bottomPadding: 90
            translationY: dropDownSorting.opened? passport? 460:230: 90
        
            
        
        ListView {
            scrollRole: ScrollRole.Main
            function addToPlaylist(title, url){
                fileTitleToBeAddedToList= title;
                fileURLToBeAddedToList=url;
                creator.createQMLObject("AddToPlaylistPopup.qml");
            }
            function deleteFile(title, url){
                fileToBeDeletedTitle=title; 
                fileToBeDeletedURL=url;
                creator.createQMLObject("CleanPickerDeleteFile.qml")
            }
          attachedObjects:   ListScrollStateHandler {
                id: scrollStateHandler
                
                onScrollingChanged: {
                    if (scrolling) {
                      actiona.enabled=true;  
                    }
                    
                }
            }
            onFocusedChanged: {
                if(focused)scrollRole=ScrollRole.Main
                else{scrollRole= ScrollRole.None}
            }
            id: listViewAudio
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            opacity: nightMode? 0.8:1
            
             dataModel: GroupDataModel {
                 id: listViewModelAudio
                sortingKeys: ["counter"]
                grouping: ItemGrouping.None
            }
            layout: GridListLayout {
}
            
            listItemComponents: [
                ListItemComponent {
                    type: "header"
                    Header {
                        visible: false
                    }
                },
                ListItemComponent {
                    type: "item"
                    
                    Container {
                        id: itemRoot
                 
                        Container {
                            visible: true
                            contextActions:  ActionSet {
                                title:  ListItemData.title
                                subtitle: ListItemData.fullAudioPath
                                actions:[
                                    ActionItem {
                                        title:qsTr( "Add To Playlist")
                                        imageSource: "asset:///images/playlist.png"
                                        onTriggered: {
                                            itemRoot.ListItem.view.addToPlaylist(ListItemData.title, ListItemData.fullAudioPath)

                                        }
                                    },
                                    
                                    DeleteActionItem {
                                        title: "Delete File"
                                        onTriggered: {
                                            itemRoot.ListItem.view.deleteFile(ListItemData.title, ListItemData.fullAudioPath)
                                        }
                                    }
                                ]
                                
                            }
                            ImageView {
                                maxWidth: 400
                                maxHeight: 240
                                minHeight: 150
                                minWidth: 150
                                function getArt(){
                                    var bob = _app.getAudioArtWork(ListItemData.fullAudioPath)
                                    if(bob===""){return "images/cleanPicker_NoArt.png"}
                                    else{return "file://"+ bob;}
                                }
                                onCreationCompleted: {
                                   
                                   // console.log("TESSSSTTTT " +getArt())

                                }
                              imageSource:getArt();
                                scalingMethod: ScalingMethod.AspectFill
                                
                        }
                            Container {
                                horizontalAlignment: HorizontalAlignment.Left
                                verticalAlignment: VerticalAlignment.Bottom
                                Label {text:ListItemData.title;textStyle.fontSize: FontSize.Small}}
                     
                        } 
                        
                        
                        
                        
                        Divider {}
                    } // itemRoot
                } // ListItemComponent
            ]
        onTriggered: {
            var data= dataModel.data(indexPath);
            
            artWorkURI=_app.getAudioArtWork(data.fullAudioPath)===""?  "": "file://"+_app.getAudioArtWork(data.fullAudioPath)
            console.log(data.thumbUrl);
            audioSource= "file://"+ data.fullAudioPath;
            customPickerUsed=true; activity.running=true;activity.visible=true;
            originalSource=data.fullAudioPath;
            delay.start();
            sheet.close();
            _systemMedia.terminate();
            sheet.destroy(1000); 
        }
        }
    }
    
    Container {
        opacity:audioMode?0: listVisible?1:0
        id: listViewContVideo2
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        translationY: dropDownSorting.opened? passport? 460:230: 90
        bottomPadding: 90
        
        
        ListView {
            //  rotationZ: 180
            function addToPlaylist(title, url){
                fileTitleToBeAddedToList= title;
                fileURLToBeAddedToList=url;
                creator.createQMLObject("AddToPlaylistPopup.qml");
            }
            function deleteFile(title, url){
                fileToBeDeletedTitle=title; 
                fileToBeDeletedURL=url;
                creator.createQMLObject("CleanPickerDeleteFile.qml")
            }
            attachedObjects:   ListScrollStateHandler {
                id: scrollStateHandlerVideo2
                
                onScrollingChanged: {
                    if (scrolling) {
                        actiona.enabled=true;  
                    }
                
                }
            }
            onFocusedChanged: {
                if(focused)scrollRole=ScrollRole.Main
                else{scrollRole= ScrollRole.None}
            }
            scrollRole: ScrollRole.Main
            
            id: listViewVideo2
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            opacity: nightMode? 0.8:1
            
            dataModel: GroupDataModel {
                id: listViewModelVideo2
                sortingKeys: ["counter"]
            }
            layout: StackListLayout {
                headerMode: ListHeaderMode.Sticky
            }
            
            listItemComponents: [
                ListItemComponent {
                    type: "header"
                    Header {
                        visible: false
                    }
                },
                ListItemComponent {
                    type: "item"
                    
                    Container {
                        id: itemRootVideo2
                        Container {
                            topPadding: 5
                            visible: true
                            StandardListItem {
                                function getTimeFromMSec(msec) {
                                    
                                    if (msec <= 0 || msec == undefined) {
                                        return "0:00"
                                    
                                    } else {
                                        var sec = "" + Math.floor(msec / 1000) % 60
                                        if (sec.length == 1)
                                            sec = "0" + sec
                                        
                                        var hour = Math.floor(msec / 3600000)
                                        if (hour < 1) {
                                            return Math.floor(msec / 60000) + ":" + sec
                                        } else {
                                            var min = "" + Math.floor(msec / 60000) % 60
                                            if (min.length == 1)
                                                min = "0" + min
                                            
                                            return hour + ":" + min + ":" + sec
                                        }
                                    }
                                }
                                title: ListItemData.title
                                status: getTimeFromMSec(ListItemData.duration)
                                property string bob
                                imageSource:"file://"+ ListItemData.thumbUrl
                                description: ListItemData.fullVideoPath
                                contextActions:  ActionSet {
                                    title:  ListItemData.title
                                    subtitle: ListItemData.fullVideoPath
                                    actions:[
                                        ActionItem {
                                            title:qsTr("Add To Playlist")
                                            imageSource: "images/ic_add.png"
                                            onTriggered: {
                                                itemRootVideo2.ListItem.view.addToPlaylist(ListItemData.title, ListItemData.fullVideoPath)
                                            }
                                        },
                                        
                                        DeleteActionItem {
                                            title: "Delete File"
                                            onTriggered: {
                                                itemRootVideo2.ListItem.view.deleteFile(ListItemData.title, ListItemData.fullVideoPath)
                                            }
                                        }
                                        
                                    ]
                                }
                            
                            }
                        
                        } 
                    
                    } // itemRoot
                } // ListItemComponent
            ]
            onTriggered: {
                var data= dataModel.data(indexPath);
                artWorkURI="file://"+ data.thumbUrl;
                console.log(data.thumbUrl);
                audioSource= "file://"+ data.fullVideoPath;
                metaDataWidth= data.videoWidth;
                metaDataHeight=data.videoHeight;
                customPickerUsed=true; activity.running=true;activity.visible=true;
                originalSource=data.fullVideoPath;
                delay.start();
                sheet.close();
                _systemMedia.terminate();
                sheet.destroy(1000); 
            }
        }
    }
    
    
    
    Container {
        id: listViewContVideo
          opacity:audioMode?0: listVisible?0:1

        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        bottomPadding: 90
        translationY: dropDownSorting.opened? passport? 460:230: 90
        
        
        
        ListView {
            scrollRole: ScrollRole.Main
            function addToPlaylist(title, url){
                fileTitleToBeAddedToList= title;
                fileURLToBeAddedToList=url;
                creator.createQMLObject("AddToPlaylistPopup.qml");
            }
            function deleteFile(title, url){
                fileToBeDeletedTitle=title; 
                fileToBeDeletedURL=url;
                creator.createQMLObject("CleanPickerDeleteFile.qml")
            }
            attachedObjects:   ListScrollStateHandler {
                id: scrollStateVideoHandler
                
                onScrollingChanged: {
                    if (scrolling) {
                        actiona.enabled=true;  
                    }
                
                }
            }
            onFocusedChanged: {
                if(focused)scrollRole=ScrollRole.Main
                else{scrollRole= ScrollRole.None}
            }
            id: listViewVideo
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            opacity: nightMode? 0.8:1
            
            dataModel: GroupDataModel {
                id: listViewModelVideo
              sortingKeys: ["counter"]
              grouping: ItemGrouping.None
            }
            layout: GridListLayout {
            }
            
            listItemComponents: [
                ListItemComponent {
                    type: "header"
                    Header {
                        visible: false
                    }
                },
                ListItemComponent {
                    type: "item"
                    
                    Container {
                        id: itemRootVideo
                        
                        Container {
                            visible: true
                            contextActions:  ActionSet {
                                title:  ListItemData.title
                                subtitle: ListItemData.fullVideoPath
                                actions:[
                                    ActionItem {
                                        title:qsTr( "Add To Playlist")
                                        imageSource: "asset:///images/playlist.png"
                                        onTriggered: {
                                            itemRootVideo.ListItem.view.addToPlaylist(ListItemData.title, ListItemData.fullVideoPath)
                                        
                                        }
                                    }, DeleteActionItem {
                                        title: "Delete File"
                                        onTriggered: {
                                            itemRootVideo.ListItem.view.deleteFile(ListItemData.title, ListItemData.fullVideoPath)
                                        }
                                    }
                                ]
                            }
                            ImageView {
                                maxWidth: 400
                                maxHeight: 240
                                minHeight: 150
                                minWidth: 150
                               
                                property string bob
                                imageSource:"file://" +ListItemData.thumbUrl
                                scalingMethod: ScalingMethod.AspectFill
                            
                            }
                            Container {
                                horizontalAlignment: HorizontalAlignment.Left
                                verticalAlignment: VerticalAlignment.Bottom
                                Label {text:ListItemData.title;textStyle.fontSize: FontSize.Small}}
                        
                        } 
                        
                        
                        
                        
                        Divider {}
                    } // itemRoot
                } // ListItemComponent
            ]
            onTriggered: {
                var data= dataModel.data(indexPath);
                
                artWorkURI="file://"+ data.thumbUrl
                console.log(data.thumbUrl);
                audioSource= "file://"+ data.fullVideoPath;
                metaDataWidth= data.videoWidth;
                metaDataHeight=data.videoHeight;
                customPickerUsed=true; activity.running=true;activity.visible=true;
                originalSource=data.fullVideoPath;
                delay.start();
                sheet.close();
                _systemMedia.terminate();
                sheet.destroy(1000); 
            }
        }
    }
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: DockLayout {
            }
            background: Color.Black
            opacity: activityInd.running ? 0.8 : 0
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                
                ActivityIndicator {
                    id: activityInd
                    visible: true
                    running: false
                    minHeight:  passport? 170:150
                    minWidth:  passport? 170:150
                }
            }
        }
    }
}

}
