import QtQuick 1.0
import bb.cascades 1.4
import bb.cascades.pickers 1.0
import bb.system 1.2
import AppSettings 1.0
import timer 1.0
import DownloadManager 1.0
import bb.platform 1.3
import bb.device 1.4
import WebRadioDownloader 1.0
import bb.data 1.0
import "Custom"
import bb.cascades.datamanager 1.2
import bb 1.0



NavigationPane {
    property bool playAllMode
    property bool brightTheme: Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright?true:false
    property bool customStationsView
    property int lastAnnouncementsCount
    property bool downloadingAnnouncements
    signal resetCarModeUI
    signal previousMediaTrack
    signal nextMediaTrack
    signal mediaPlayChanged
    signal announcementsDownloaded
    property int rewindInterval
    property int forwardInterval
    property string announcementsReaderText
    property string announcementsReaderTitle
    property string announcementsReaderURL
    property string announcementsReaderImage
    property string announcementsReaderDate
    property string videoOverlayValue
    property bool mediaStopped
    property bool carModeInternetRadio
    property string autoRecordingTime
    property bool inheritPlaylistMode
    property string carmodeInternetRadioModelURL
    property string carmodeInternetRadioModelTitle
    property string scheduledRecModelURL
    property string autoRecordingTimeStart
    property string autoRecordingTimeEnd
    property string scheduledRecModelStationURL
    property string scheduledRecModelStationName
    property bool internetRadioScheduledRecording: false
    onScheduledRecModelStationURLChanged: {}
    onMediaPlayingChanged: {mediaPlayChanged();}
    peekEnabled: false
    signal videoSourceUpdated
    property int newVideoProgress
    property string newAudioSource
    property bool shuffling
    property bool backFromCarMode
    property bool renamingFile: false
    property int playlistItemsCount
    property bool incomingNewPlaylistAddition
    property string fileTitleToBeAddedToList
    property string fileURLToBeAddedToList
    property bool playlistCleared
    property variant globalIndexPath
    signal carModeShuffle
    signal closePlaylistEditor
    signal openFolderPlay
    signal openCarModePlaylist
    signal addPlaylistItemToList
    property bool playlistEdit
    property bool openingPlaylist
    property bool playlistViewerOpen
    property string playlistName
    property string playlistURL
    property string importSource
    property bool playlistM3uImporting
    property bool playListCreatorFolderMode: false
    property bool playlistCreatorOpen: false
    property bool passportTrackKeyboard
    property bool bypassFormatCheck
    property bool battSavWarning: true
    property bool showVideoUnderControls: false
    property bool aboutToLoadCarMode: false
    property bool touchVolumeControls: true
    property int longPressfowardRewindButtonValue
    property int fowardRewindButtonValue
    property bool carModeAlwaysKeepScreenOn: false
    property bool autoPlayWhenBluetoothIsConnected: false
    property bool resumeCarModeLastPlayedTrack: false
    property bool launchCarModeonStartup: false
    property bool autoResizeAttempted: false
    property bool searchFolderPlaySubFolders
    property string folderToPlaylistURL
    property string globalBob
    property string artWorkUriNonMod
    signal closePicker
    onCarModeChanged: {
        _app.setGlobalCarMode(carMode)
    }
    property string fileToBeDeletedTitle
    property string fileToBeDeletedURL
    property bool carMode: false
    property bool btDeviceConnected: false
    property bool playbackCompleted: false
    property bool playlistEditorOpened: false
    property bool fileSystemLyricsFound: false
    property string fileSystemLyrics
    property string indexPathNonConvert
    property string indexPathNonConvertFinal
    property bool newPassForced: false
    property bool phoneCallActive: false
    property bool customPickerUsed: false
    property bool phoneCallActiveInternal: false
    property bool shuffleMode: false
    property bool clearCacheOnClose: false
    id: mainnav
    signal showPlayerSettingsUI
    signal playbackCompletedSignal()
    onPlaybackCompletedChanged: {
        playbackCompletedSignal();
    }
    property double audRecordLevel
    property bool showArtWorkWhenPossible
    signal updateCoverImage
    signal recordingErrorOccured
    signal fireSleepTimerFeature
    signal flashCoverRecordIcon
    property bool webRecordingActive: false
    signal downloadErrorOccured
    signal bluetoothConnected
    signal internalDownloadErrorOccured
    signal internetRadioStationChanged
    signal updateInternetCountryList
    property bool internetRadioActive: false
    property string stationListHeaderName: ""
    property bool lyricsSearchOpen: false
    property bool internetRadioInvokedHS: false
    property int sleepTimerInterval
    property bool audioIsRecording: false
    property string audioIsRecordingDuration: ""
    signal closeInternetRadioList
    property bool inAppRecordingPlaying: false
    property bool sleepTimerEnabled: false
    property string internetRadioSource: ""
    property int internetRadioModelDownloaded
    property bool internetStationsUpdatingComplete: false
    property string internetStationModelSavePath: _app.homePath() + "/" + internetStationModelSaveName
    property string internetStationModelSaveName: ""
    property bool internetStationsUpdating: false
    signal internetRadioModelDownloadCompleted
    property bool viewingOfflineLyrics: false
    property bool videoOpening: false
    property string modelURL
    property bool playlistMode: false
    property string currentPlaylistIndexPath: ""
    property bool updateChecked: false
    property bool expiredChecked: false
    property bool psw
    property bool lyricsOpen
    property bool lockscreenart
    property bool lyricsDownloading: false
    property string requestedDownloadURL: ""
    property string betaVersion: ""
    property string lyricsEntryTitle
    property bool betaExpired: false
    property bool albumArtActiveFrame: false
    property string favouriteType: ""
    property int propertyToSaveIndexPathAsNumber
    property int stationUpdateCount
    property int rateOpenedCount
    signal resetVideoPanning
    signal resetTouchZoom
    signal showActionBar
    signal closePlayer
    signal closeHistory
    signal nightModeChanged
    signal playMedia
    signal playPause
    signal pauseMedia
    signal stopMedia
    signal themeChanged
    signal closeLyrics
    signal lyricsDownloadCompleted
    
    function exitCleanUp() {
        console.log("Close requested");
        closeLyrics();
        if (audioSource.length > 0) {
            if (playbackCompleted === false) {
                console.log("Should be saving last url");
                appsettings.saveSystemSetting("fileDidNotCompletePosition", videoProgress);
                appsettings.saveSystemSetting("fileDidNotCompleteURL", audioSource);
                console.log("Now, you better have saved;  " + appsettings.getSystemSetting("fileDidNotCompletePosition", "") + appsettings.getSystemSetting("fileDidNotCompleteURL", ""))
            }
        }
        if (clearCacheOnClose) {
            if (lyricsSearchOpen === false) _app.clearCache();
        }
        stopMedia();
        if (appsettings.getSystemSetting("lockscreenart", "") === "true") {
            console.log("Lockscreen default art exists? " +_app.checkFileExists(appsettings.getSystemSetting("lockscreenartdefault", "")))
            if(_app.checkFileExists(appsettings.getSystemSetting("lockscreenartdefault", ""))){
            _app.setLockscreenImage(appsettings.getSystemSetting("lockscreenartdefault", ""))}
            else{
                //cannot really do anything here, message would interrupt closing/user never see it
            }
        }
        if (downloadActive) {
            downloadManager.cancel();
        }
        if (webRecordingActive) {
            stopRecordingInternetRadio();
        }
        Application.quit();
    }
    function setLockScreenArt() {
        setLockScreenArtTimer.start();
    }
    function setLockScreenArtWork() {
        
        if (appsettings.getSystemSetting("lockscreenart", "") === "true") {
            if (artWorkUriNonMod === "") {
                _app.setLockscreenImage(appsettings.getSystemSetting("lockscreenartdefault", ""))
            } else {
                var bob = artWorkUriNonMod.replace("file://", "");
                console.log(bob)
                _app.copyFile(bob, _app.homePath() + "/" + "lockscreenart.jpg")
                _app.setLockscreenImage(_app.homePath() + "/" + "lockscreenart.jpg")
                _app.deleteFile(_app.homePath() + "/" + "lockscreenart.jpg")
            }
        }
        // else{_app.setLockscreenImage(appsettings.getSystemSetting("lockscreenartdefault", ""))}
    
    }
    onWebRecordingActiveChanged: {
        flashCoverRecordIcon();
    }
    onRecordedBytesChanged: {
        if (isNaN(recordedBytes)) {
            return;
        }
        var bytes = recordedBytes;
        var units = [ ' bytes', ' KB', ' MB', ' GB', ' TB', ' PB', ' EB', ' ZB', ' YB' ];
        var amountOf2s = Math.floor(Math.log(+ bytes) / Math.log(2));
        if (amountOf2s < 1) {
            amountOf2s = 0;
        }
        var i = Math.floor(amountOf2s / 10);
        bytes = + bytes / Math.pow(2, 10 * i);
        if (bytes.toString().length > bytes.toFixed(1).toString().length) {
            bytes = bytes.toFixed(1);
        }
        recordedFileSize = bytes + units[i];
    }
    function recordInternetRadio() {
        webRadioDown.download(internetRadioSource, appsettings.getSystemSetting("InternetRecordingLocation", "/accounts/1000/shared/music/") + metaDataTitle + "-" + Qt.formatDateTime(new Date(), "dd-MM-yyyy") + "-" + Qt.formatDateTime(new Date(), "hh-mm-ss") + ".mp3");
    }
    
    function stopRecordingInternetRadio() {
        webRecordingActive = false;
        webRadioDown.cancel();
        recordedFileSize = "";
    }
    function cancelInternetStationUpdate() {
        updateInternetStationsTimer.stop();
        internetRadioModelDownloaded = 0;
    }
    function updateInternetStations() {
        modelURL = "";
        _app.contentsCheck(_app.homePath());
        internetStationsUpdating = true;
        internetStationsUpdatingComplete = false;
        if (internetRadioModelDownloaded === 0) {
            internetStationModelSaveName = "InternetRadioStationsModelUK.xml";
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelUK.xml";
            downloadManager.download(urld, internetStationModelSavePath);
            internetRadioModelDownloaded += 1;
        
        } else if (internetRadioModelDownloaded === 1) {
            internetStationModelSaveName = "InternetRadioStationsModelGermany.xml"
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelGermany.xml";
            downloadManager.download(urld, internetStationModelSavePath)
            internetRadioModelDownloaded += 1;
        } else if (internetRadioModelDownloaded === 2) {
            internetStationModelSaveName = "InternetRadioStationsModelFrance.xml"
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelFrance.xml";
            downloadManager.download(urld, internetStationModelSavePath)
            internetRadioModelDownloaded += 1;
        
        } else if (internetRadioModelDownloaded === 3) {
            internetStationModelSaveName = "InternetRadioStationsModelSpain.xml"
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelSpain.xml";
            downloadManager.download(urld, internetStationModelSavePath)
            internetRadioModelDownloaded += 1;
        } else if (internetRadioModelDownloaded === 4) {
            internetStationModelSaveName = "InternetRadioStationsModelCanada.xml"
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelCanada.xml";
            downloadManager.download(urld, internetStationModelSavePath)
            internetRadioModelDownloaded += 1;
        
        } else if (internetRadioModelDownloaded === 5) {
            internetStationModelSaveName = "InternetRadioStationsModelItalian.xml"
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelItalian.xml";
            downloadManager.download(urld, internetStationModelSavePath)
            internetRadioModelDownloaded += 1;
        
        } else if (internetRadioModelDownloaded === 6) {
            internetStationModelSaveName = "InternetRadioStationsModelUS.xml"
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelUS.xml";
            downloadManager.download(urld, internetStationModelSavePath);
            internetRadioModelDownloaded += 1;
        }
        else if (internetRadioModelDownloaded === 7) {
            internetStationModelSaveName = "InternetRadioStationsModelAlternative.xml"
            _app.deleteFile(internetStationModelSavePath);
            var urld = "http://www.legacy.allstarsoftware.co.uk/StarPlayerBB10/InternetRadio/StationModels/InternetRadioStationsModelAlternative.xml";
            downloadManager.download(urld, internetStationModelSavePath);
            internetRadioModelDownloaded += 1;
            internetRadioModelDownloaded = 0;
            internetStationsUpdatingComplete = true;
            internetRadioModelDownloadCompleted();
            _app.contentsCheck(_app.homePath())
            appsettings.saveSystemSetting("lastStationListUpdate", Qt.formatDateTime(new Date(), "dd-MM-yyyy"))
            console.log(appsettings.getSystemSetting("lastStationListUpdate", ""))
        }
    }
    function launchInto() {
        if (internetRadioInvokedHS === false) {
            if (sourceInvoked === false) {
                
                if (launchCarModeonStartup) {
                    openCarModePlayer();
                } else {
                    var bob = appsettings.getSystemSetting("LaunchAppInto", "")
                    if (bob === "Video Chooser") {
                        if (_app.checkSharedFiles() === true) {
                            if (choose.pickerType === "clean") {
                                creator.createQMLObject("VideoPicker.qml")
                            } else {
                                picker.createObject();
                                activity.running = true;
                                activity.visible = true;
                            }
                        } else {
                            toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")
                        }
                    } else if (bob === "Audio Chooser") {
                        if (_app.checkSharedFiles() === true) {
                            pickerAudio.createObject();
                            activity.running = true;
                            activity.visible = true;
                        } else {
                            toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")
                        }
                    }
                     else if (bob === "Clean Picker") {
                         if (_app.checkSharedFiles() === true) {
                             creator.createQMLObject("VideoPicker.qml");

                         }
                         else {
                             toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")
                         }
                   }
                     
                        else if (bob === "Favourites") {
                        if (protectedMode) {
                            creator.createQMLObject("ProtectedModeFav.qml")
                        } else {
                            creator.createQMLObject("FavouritesPage.qml")
                        }
                    } else if (bob === "Last Played") {
                        if (protectedMode) {
                            creator.createQMLObject("ProtectedModeRec.qml")
                        } else {
                            creator.createQMLObject("RecentlyPlayed.qml")
                        }
                    } else if (bob === "Internet Radio") {
                        if (connectionOnline) creator.createQMLObject("InternetRadioStationsBuiltIn.qml")
                    } else if (bob === "Lyrics Search") {
                        if (connectionOnline) creator.createQMLObject("LyricsSearch.qml")
                    } else if (bob === "Audio Recorder") {
                        if (_app.checkSharedFiles() === true) {
                            creator.createQMLObject("AudioRecorder.qml")
                        } else {
                            toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")
                        }
                    } else if (bob === "Playlist Editor") {
                        creator.createQMLObject("PlaylistEditor.qml")
                    }
                    else if (bob === "Play All") {if(_app.checkSDCard())playAllAction.triggered();}
                }
            }
        }
    
    }
    function showPullMenuTip() {
        if (firstRun) mainCont.add(firstRunPullDown.createObject());
        mainCont.add(creator.createQMLObject("Custom/VideoTapInfoFirstRun.qml"))
    }
    property bool nightModeAskDialogOpen: false
    property int pinnedCount: _pinnedVideos.dataModel.size()
    property bool firstRun: false
    property bool mediaRepeat: false
    property string lyricsURL
    property string lyricsDataArtist
    property string lyricsDataSong
    property int originalPixelHeight
    property int originalPixelWidth
    property int pixelHeight
    property string artWorkURI: ""
    property int pixelWidth
    property bool nightMode: false
    property bool appUpdateInProgress: false
    property int downloadedbytes
    property string recordedFileSize: ""
    property int recordedBytes
    property bool downloadPaused
    property real playerProgress
    property bool mediaPlaying
    property bool mediaPaused
    property string elapsedTime
    property string remainingTime
    property int playerDuration
    property bool downloadActive: false
    property int downloadPercentage
    property real downloadProgress
    property int videoProgress
    property bool thumbnailed: false
    property bool sourceInvoked: false
    property bool sourceStreamed: false
    property string audioSource: ""
    property string originalSource: ""
    property bool connectionOnline
    property string metaDataTitle: ""
    property string metaDataFileName: ""
    property string metaDataFileLocation: ""
    property string metaDataSampleRate: ""
    property string metaDataHeight: ""
    property string metaDataWidth: ""
    property string metaDataFileSize: ""
    property string metaDataDuration: ""
    property string metaDataArtist: ""
    property string metaDataAlbum: ""
    property string metaDataGenre: ""
    property string mediaFormat: ""
    property string metaDataBitRate: ""
    property bool passport: false
    property bool nonPassport: false
    property bool miniSquareDevice: false
    signal closeFavourites
    signal openEQChooser
    signal eQChanged
    property bool device768: false
    property bool responsiveZoom
    property bool fadeInAudio
    property bool liveActiveFrame
    property bool nightModeOverLay
    property bool touchZoom
    property bool autoPausePlayer
    property bool touchPan
    property bool protectedMode
    property bool notifyOnDownloadComplete
    property string themeValue: appsettings.getSystemSetting("themes", "")
    property bool autoHideAppOnPlay
    property real nightModeOverLayBrightness
    property int videoControlsTimeout
    
    property string invokedURL
    onThumbnailedChanged: {
        if (thumbnailed === false) {
            showActionBar();
        }
    }
    function enableNightMode() {
        nightMode = true;
        nightModeChanged();
    }
    onNightModeChanged: {
        if (nightMode === true) {
            Application.themeSupport.setPrimaryColor(Color.DarkGray)
            Application.themeSupport.setVisualStyle(VisualStyle.Dark);
        } else {
            if(appsettings.getSystemSetting("BrightTheme", "")==="true"){Application.themeSupport.setVisualStyle(VisualStyle.Bright);}
            decideTheme();
        }
    
    }
    function playerClose() {
        console.log("FIRED");
        mainnav.pop();
    }
    
    function getFileArtWork() {
        if (artWorkURI === "") {
            if (mediaFormat === "Video") {
                if (_app.getVideoArtWork(originalSource) === "") {
                } else {
                    var bob = _app.getVideoArtWork(originalSource)
                    if (_app.checkFileExists(bob) === true) {
                        artWorkURI = "file://" + bob;
                        artWorkUriNonMod = "file://" + bob;
                    }
                    //   artWorkURI= "file://" +_app.getAudioArtWork(originalSource)
                }
            } else if (mediaFormat === "Audio") {
                if (_app.getAudioArtWork(originalSource) === "") {
                } else {
                    
                    var bob = _app.getAudioArtWork(originalSource)
                    artWorkUriNonMod= "file://" + bob;
                    
                    if (_app.checkFileExists(bob) == true) {                    
                        if(appsettings.getSystemSetting("artworkShape", "")===""){artWorkURI = "file://"+ bob}
                        else if(appsettings.getSystemSetting("artworkShape", "")==="curved" ){artWorkURI = "file://"+_app.roundImageCorners(bob, "curved");}
                        else if(appsettings.getSystemSetting("artworkShape", "")==="circle" ){artWorkURI = "file://"+_app.roundImageCorners(bob, "circle");}
                        
                        //  "file://" + bob
                    }
                    // artWorkURI= "file://" +_app.getAudioArtWork(originalSource)
                }
            }
        }
    }
    
    function openCarModePlayer() {
        carMode = true;
        setFileFormat();
        getFileArtWork();
      //  var page = 
        creator.createQMLObject("CarModePlayer.qml")
       // mainnav.push(page);
    }
    
    function openVideo() {
        if (videoOpening === true) {
        }
        if (bypassFormatCheck) {
            var page = creator.createQMLObject("PlayerPage.qml")
            mainnav.push(page);
        } else {
            if (originalSource === "") {
                invokedURL = audioSource;
                originalSource = invokedURL.replace("file://", "");
                console.log("ORIGINAL SOURCE CHANGED : " + originalSource)
            }
            if (carMode) {
            }
            setFileFormat();
            console.log("MEDIA FORMAT: " + mediaFormat)
            if (mediaFormat === "Unknown") {
                toast.showTextWithButton("Error: Unknown or Unsupported File Format, please contact support for help", "OK", "")
            } else {
                getFileArtWork();
                var page = creator.createQMLObject("PlayerPage.qml")
                mainnav.push(page);
                if (appsettings.getSystemSetting("autoHideAppOnPlay", "") === "true") Application.minimize();
            }
        }
    }
    function openInternetRadioPlayer() {
        var page = creator.createQMLObject("InternetRadioPlayer.qml")
        mainnav.push(page);
        if (appsettings.getSystemSetting("autoHideAppOnPlay", "") === "true") Application.minimize();
    }
    function setFileFormat() {
        var type = getFileType(audioSource);
        console.log("TYPE  " + type)
        
        if (type === "mp3") mediaFormat = "Audio";
        else if (type === "MP3") mediaFormat = "Audio";
        else if (type === "mp4") mediaFormat = "Video";
        else if (type === "MP4") mediaFormat = "Video";
        else if (type === "wma") mediaFormat = "Audio";
        else if (type === "WMA") mediaFormat = "Audio";
        else if (type === "3GP") mediaFormat = "Video";
        else if (type === "3gp") mediaFormat = "Video";
        else if (type === "3GP2") mediaFormat = "Video";
        else if (type === "3gp2") mediaFormat = "Video";
        else if (type === "3gpp") mediaFormat = "Video";
        else if (type === "3GPP") mediaFormat = "Video";
        else if (type === "asf") mediaFormat = "Video";
        else if (type === "ASF") mediaFormat = "Video";
        else if (type === "avi") mediaFormat = "Video";
        else if (type === "AVI") mediaFormat = "Video";
        else if (type === "f4v") mediaFormat = "Video";
        else if (type === "F4V") mediaFormat = "Video";
        else if (type === "M4V") mediaFormat = "Video";
        else if (type === "m4v") mediaFormat = "Video";
        else if (type === "MOV") mediaFormat = "Video";
        else if (type === "mov") mediaFormat = "Video";
        else if (type === "MPEG4") mediaFormat = "Video";
        else if (type === "mpeg4") mediaFormat = "Video";
        else if (type === "WMV") mediaFormat = "Video";
        else if (type === "wmv") mediaFormat = "Video";
        else if (type === "MKV") mediaFormat = "Video";
        else if (type === "mkv") mediaFormat = "Video";
        else if (type === "AAC") mediaFormat = "Audio";
        else if (type === "aac") mediaFormat = "Audio";
        else if (type === "AMR") mediaFormat = "Audio";
        else if (type === "amr") mediaFormat = "Audio";
        else if (type === "OGG") mediaFormat = "Audio";
        else if (type === "ogg") mediaFormat = "Audio";
        else if (type === "WAV") mediaFormat = "Audio";
        else if (type === "wav") mediaFormat = "Audio";
        else if (type === "M4A") mediaFormat = "Audio";
        else if (type === "m4a") mediaFormat = "Audio";
        else if (type === "AWB") mediaFormat = "Audio";
        else if (type === "awb") mediaFormat = "Audio";
        else if (type === "FLAC") mediaFormat = "Audio";
        else if (type === "flac") mediaFormat = "Audio";
        else if (type === "m3u") mediaFormat = "Playlist";
        else if (type === "M3U") mediaFormat = "Playlist";
        else {
            if (sourceStreamed) mediaFormat = "Video";
            else mediaFormat = "Unknown"
        }
    
    }
    function getFileType(fname) {
        return fname.substr((~ - fname.lastIndexOf(".") >>> 0) + 2);
    }
    
    shortcuts: [
        Shortcut {
            key: "c"
            onTriggered: {
                picker.createObject();
                activity.running = true;
                activity.visible = true
            }
        },
        Shortcut {
            key: "s"
            onTriggered: {
                if (connectionOnline) creator.createQMLObject("StreamSource.qml")
            }
        }
    ]
    function openBugReport() {
        bug.openReport();
    }
    function startNightModeTimeChecker() {
        nightModeTimeCheck.start();
        appsettings.saveSystemSetting("nightModeTimeCheck", "")
    }
    function stopNightModeTimeChecker() {
        nightModeTimeCheck.stop();
        appsettings.saveSystemSetting("nightModeTimeCheck", "false");
    }
    function stopNightModeTimeCheckerSession() {
        nightModeTimeCheck.stop();
    }
    
    function clearMetaData() {
        metaDataDuration = "";
        metaDataFileLocation = "";
        metaDataFileName = "";
        metaDataFileSize = "";
        metaDataHeight = "";
        metaDataSampleRate = "";
        metaDataTitle = "";
        metaDataWidth = "";
        metaDataDuration = "";
        metaDataArtist = "";
        metaDataAlbum = "";
        metaDataGenre = "";
        metaDataBitRate = "";
        artWorkURI = "";
    }
    onCreationCompleted: {
        decideTheme();
        if (appsettings.getSystemSetting("firstRun", "") === "") {
            creator.createQMLObject("TutorialSheet.qml")
        } else {
            welcomeScreen();
        }
        events.start();
        console.log(_app.screenWidth());
        if (_app.screenWidth() === 1440) {
            passport = true;
        } else {
            nonPassport = true;
        }
        
        if (_app.screenHeight() === 768) {
            device768 = true;
        }
        if (_app.screenHeight() === 768) {
            device768 = true;
        }
        
        console.log("Passport: " + passport);
        originalPixelHeight = _app.screenHeight();
        originalPixelWidth = _app.screenWidth();
        
        if (originalPixelHeight == originalPixelWidth) {
            if (originalPixelHeight == 720) {
                if (originalPixelWidth == 720) {
                    miniSquareDevice = true;
                }
            }
        }
        var oro = appsettings.getSystemSetting("orientation", "");
        if (oro === "Automatic") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
        } else if (oro === "Portrait") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
        } else if (oro === "Landscape") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayLandscape
        }
        
        console.log(oro)
        //     Application.aboutToQuit.connect(exitCleanUp)
        Application.manualExit.connect(exitCleanUp);
    
    }
    
    function welcomeScreen() {
        welcomeTimer.start();
    
    }
    function createCover() {
        Application.setCover(bob.createObject());
    }
    function getAppColour(){
        if(nightMode){return Color.toHexString(Color.DarkGray)}
        else{
            if (themeValue === ""){return("#0092cc")}
            
            if (themeValue === "#0092cc") {
                return("#0092cc");
            } else if (themeValue === "red") {
                return Color.toHexString(Color.Red);
            } else if (themeValue === "#0000ff") {
                return "#0000ff";
            } else if (themeValue === "#F52887") {
                return "#F52887";
            } else if (themeValue === "#ff00ff") {
                return "#ff00ff";
            } else if (themeValue === "#9900ff") {
                return "#9900ff";
            }}
    }
    function decideTheme() {
        console.log(themeValue)
        if (themeValue === ""){Application.themeSupport.setPrimaryColor(Color.create("#0092cc"))}
        
        if (themeValue === "#0092cc") {
            Application.themeSupport.setPrimaryColor(Color.create("#0092cc"))
        } else if (themeValue === "red") {
            Application.themeSupport.setPrimaryColor(Color.Red)
        } else if (themeValue === "#0000ff") {
            Application.themeSupport.setPrimaryColor(Color.create("#0000ff"))
        } else if (themeValue === "#F52887") {
            Application.themeSupport.setPrimaryColor(Color.create("#F52887"))
        } else if (themeValue === "#ff00ff") {
            Application.themeSupport.setPrimaryColor(Color.create("#ff00ff"))
        } else if (themeValue === "#9900ff") {
            Application.themeSupport.setPrimaryColor(Color.create("#9900ff"))
        }
    }
    
    Menu.definition: MenuDefinition {
        
        settingsAction: SettingsActionItem {
            onTriggered: {
                creator.createQMLObject("Settings.qml")
            }
        }
        actions: [
            ActionItem {
                onTriggered: {
                    creator.createQMLObject("AboutApp.qml");
                }
                imageSource: "asset:///images/ic_info.png"
                title: qsTr("About")
            },
            ActionItem {
                onTriggered: {creator.createQMLObject("Help/HelpMain.qml");
                }
                imageSource: "asset:///images/ic_help.png"
                title: qsTr("Help")
            },
            ActionItem {
                enabled: connectionOnline
                onTriggered: {
                    creator.createQMLObject("Announcements.qml");
                }
                imageSource: "images/ic_entry.png"
                title: qsTr("Announcements")
            }
        ]
    }
    
    function loadInvokedVideo() {
        closeLyrics();
        closePlayer();
        openVideo();
    }
    
    attachedObjects: [
        
        XmlListModel{},
        
        GroupDataModel {
            
            onItemAdded: {
                playlistItemsCount ++;
                playlistCleared = false;
                //mainCont.add(playQueue)
            
            
            
            }
            onItemRemoved: {
                playlistItemsCount --;
            }
            onItemsChanged: {
                
                console.log("Play Queue Cleared? " + size())
            }
            id: playQueue
            sortedAscending: true
            grouping: ItemGrouping.None
            sortingKeys: [ "number", "title", "sourceUrl" ]
        
        },
        SystemTimer {
            id: autoRecordingTimer
            interval: 1000
            onTimeout: {
                autoRecordingTime = Qt.formatDateTime(new Date(), "hh:mm:ss");
                if (autoRecordingTime === autoRecordingTimeStart) {
                    webRadioDown.download(scheduledRecModelStationURL, appsettings.getSystemSetting("InternetRecordingLocation", "/accounts/1000/shared/music/") + metaDataTitle + "-" + Qt.formatDateTime(new Date(), "dd-MM-yyyy") + "-" + Qt.formatDateTime(new Date(), "hh-mm-ss") + ".mp3");
                } else if (autoRecordingTime === autoRecordingTimeEnd) {
                    stopRecordingInternetRadio();
                }
            }
        },
        SystemTimer {
            id: phoneCallActiveChangedTimer
            interval: 1000
            onTimeout: {
                phoneCallActive = phoneCallActiveInternal;
            }
        },
        SystemTimer {
            id: sleepTimer
            interval: parseInt(appsettings.getSystemSetting("sleepTimerInterval", "300000"))
            onTimeout: {
                sleepTimer.stop();
                console.log("Sleep Timer Fired")
                fireSleepTimerFeature();
                if (appsettings.getSystemSetting("sleepTimerFunction", "") === "pause") {
                    pauseMedia();
                } else if (appsettings.getSystemSetting("sleepTimerFunction", "") === "stop") {
                    pauseMedia();
                    closePlayer();
                } else if (appsettings.getSystemSetting("sleepTimerFunction", "") === "close") {
                    if (downloadActive) {
                        downloadManager.cancel();
                    }
                    Application.requestExit();
                } else if (appsettings.getSystemSetting("stoprecord", "") === "stop") {
                    if (internetRadioScheduledRecording === false) {
                        if (webRecordingActive) stopRecordingInternetRadio()
                    }
                }
                
                sleepTimerEnabled = false;
            }
        },
        SystemTimer {
            id: setLockScreenArtTimer
            interval: 2000
            onTimeout: {
                setLockScreenArtTimer.stop();
                setLockScreenArtWork();
            }
        },
        
        MemoryInfo {
            id: memoryInfo
            
            onLowMemory: {
                if (level == LowMemoryWarningLevel.LowPriority) {
                } else if (level == LowMemoryWarningLevel.HighPriority) {
                    _app.clearCache();
                    //    toast.showTextWithButton("The Device is running low on Memory, Star Player will run a small cleanup in an attempt to reduce its memory consumption, the OS may close Star Player at any time.", "Ok", "LowMemHigh")
                
                }
            }
        },
        OrientationHandler {
            id: orientationH
            onOrientationChanged: {
                if (OrientationSupport.orientation == UIOrientation.Portrait) {
                    pixelHeight = originalPixelHeight;
                    pixelWidth = originalPixelWidth;
                } else if (OrientationSupport.orientation == UIOrientation.Landscape) {
                    pixelHeight = originalPixelWidth;
                    pixelWidth = originalPixelHeight
                }
            }
        },
        HardwareInfo {
            id: hardwareInfo},
        
        DisplayInfo {
            id: displayInfo},
        
        SystemTimer {
            id: nightModeTimeCheck
            interval: 600000
            onTimeout: {
                if (Qt.formatDateTime(new Date(), "hh:mm") > "20:00") {
                    if (nightMode == false) {
                        if (nightModeAskDialogOpen === false) {
                            creator.createQMLObject("NightModeAskDialog.qml")
                        }
                    }
                }
            }
        },
        SystemTimer {
            id: welcomeTimer
            interval:750
            onTimeout: {
                welcomeTimer.stop();
                startSplash.hide();
            }
        },
        SystemTimer {
            id: updateInternetStationsTimer
            interval: 1500
            onTimeout: {
                updateInternetStationsTimer.stop();
                updateInternetStations();
            }
        },
        SystemTimer {
            id: events
            interval: 400
            onTimeout: {
                if (Application.isThumbnailed() == true) {
                    thumbnailed = true;
                } else if (Application.isInvisible()) {
                    thumbnailed = true;
                } else {
                    thumbnailed = false;
                }
            }
        
        },
        Notification {
            id: downloadCompleteNotif
            title: qsTr("Download Completed")
            body: qsTr("Your Star Player Download Has Completed")
            type: NotificationType.Default
        
        },
        Connections {
            target: _playlist
        },
        
        Connections {
            target: downloadManager
            onDownloadStarted: {
                console.log("Started");
                if(downloadManager.silentMode===false){
                    
                    
                    if (internetStationsUpdating) {
                    } else {
                        downloadActive = true
                    }
                    if (lyricsDownloading === true) {
                        Application.setClosePrompt(qsTr("Star Player"), qsTr("Closing will cancel your Lyrics Save, are you sure you want to close?"))
                    } else if (internetStationsUpdating) {
                    } else {
                        Application.setClosePrompt(qsTr("Star Player"), qsTr("Closing will cancel your current download, are you sure you want to close?"))
                    }
                }
            }
            onDownloadStatus: {
                downloadProgress = currentStatus;
            }
            onDownloadError: {
                downloadErrorOccured();
            }
            onInternalDownloadError: {
                internalDownloadErrorOccured();
            }
            onProgressPercentage: {
                downloadPercentage = percentage
            }
            onDownloadComplete: {
                if (internetStationsUpdating === true) {
                    if (internetStationsUpdatingComplete) {
                        updateInternetStationsTimer.stop();
                    } else {
                        updateInternetStationsTimer.start();
                    }
                }
                if(downloadingAnnouncements){
                    announcementsDownloaded();
                    downloadingAnnouncements=false
                }
                
                internetStationsUpdating = false;
                
                downloadActive = false;
                if (lyricsDownloading === false) {
                    if (notifyOnDownloadComplete) {
                        downloadCompleteNotif.notify();
                    } else {
                        if (internetStationsUpdating === false) {
                        } else {
                            toast.showText("Download Complete")
                        }
                    }
                }
                lyricsDownloadCompleted();
                downloadManager.downloadCompletedInternal();
                Application.clearClosePrompt();
            }
            onDownloadPaused: {
                downloadPaused = true;
            }
            onDownloadResumed: {
                downloadPaused = false;
            }
            onDownloadCancelled: {
                downloadActive = false;
                if (internetStationsUpdating) {
                    toast.showText("Download Cancelled")
                }
                Application.clearClosePrompt();
            }
            onDownloadedBytes: {
                downloadedbytes = bytesReceived;
            }
        },
        
        Connections {
            target:  _recentlyPlayed
            onHistoryRequested: {
                closeHistory();
                closeFavourites();
                closePlayer();
                closeInternetRadioList();
                closeLyrics();
                closePicker();
                audioSource = videoUrl;
                artWorkURI = art;
                activity.running = true;
                activity.visible = true;
                if (itemType === "Stream") {
                    sourceStreamed = true;
                    streamTimer.start();
                } else {
                    lastrecentPlay.start();
                }
            }
        },
        Connections {
            target: _batterySaver
            onActiveChanged: {
                console.log("enabled : " + _batterySaver.active);
                if (_batterySaver.active) {
                    if (_batterySaver.limitCpuPerformance === true) {
                        if (battSavWarning === true) {
                            toast.showTextWithButton("Battery Saving Mode has been enabled,\nyour device is set to limit CPU peformance to save battery, this may negatively affect the playback performance of Star Player.", "Ok", "battSavWarning")
                        }
                    }
                }
            }
        },
        Connections {
            target:  _fullscreen
            onFullscreenPidChanged: {
            }
            onIsOnHomescreenChanged: { //console.log(_fullscreen.m_isOnHomescreen)
            }
        },
        WebRadioDownloader {
            id: webRadioDown
        },
        Connections {
            
            target:  webRadioDown
            onDownloadStarted: {
                console.log("Web Radio Recording Started")
                webRecordingActive = true;
            }
            onDownloadStatus: {
                //recordingProgress = currentStatus;
            }
            onDownloadError: {
                stopRecordingInternetRadio();
                recordingErrorOccured();
            }
            onProgressPercentage: {
            }
            onDownloadComplete: {
                webRecordingActive = false;
            }
            onDownloadPaused: {
            }
            onDownloadResumed: {
            }
            onDownloadCancelled: {
                webRecordingActive = false;
            }
            
            onDownloadedBytes: {
                recordedBytes = bytesReceived;
            }
        },
        
        DownloadManager {
            property bool silentMode:false
            id: downloadManager
            signal downloadCompletedInternal
        },
        SystemTimer {
            id: favPlay
            interval: 100
            onTimeout: {
                favPlay.stop();
                openVideo();
            }
        },
        SystemTimer {
            id: ti
            interval: 800
            onTimeout: {
                ti.stop();
                audioSource = appsettings.getSystemSetting("carModeReverseURL", "");
                openVideo();
            }
        },
        SystemTimer {
            id: streamTimer
            interval: 400
            onTimeout: {
                streamTimer.stop();
                openVideo();
            }
        },
        SystemTimer {
            id: lastrecentPlay
            interval: 100
            onTimeout: {
                lastrecentPlay.stop();
                openVideo();
            }
        },
        ComponentDefinition {
            id: globalNotifications
            
            NotificationGlobalSettings {
                id: global
                Component.onCompleted: {
                    global.setMode(NotificationMode.AlertsOff);
                    globalNotifications.destroy();
                }
            }
        },
        SystemTimer {
            id: invokeTimer
            interval: 1000
            onTimeout: {
                invokeTimer.stop();
                openVideo();
            }
        },
        SystemTimer {
            id: internetRadioOpenDelay
            interval: 100
            onTimeout: {
                internetRadioOpenDelay.stop();
                openInternetRadioPlayer();
            }
        },
        SystemTimer {
            id: carModedelay
            interval: 2000
            onTimeout: {
                carModedelay.stop();
                openCarModePlayer();
            }
        },
        Connections {
            target: _phoneWatcher
            onPhoneActiveChanged: {
                console.log("Active: " + _phoneWatcher.phoneActive);
                phoneCallActiveInternal = _phoneWatcher.phoneActive;
                phoneCallActiveChangedTimer.start();
            }
        },
        Connections {
            target: _bluetootWatcher
            onBluetoothDeviceConnected: {
                btDeviceConnected = true;
                console.log("Bluetooth Connected : " + btDeviceConnected);
                bluetoothConnected();
            }
            onBluetoothDeviceDisconnected: {
                btDeviceConnected = false;
                console.log("Bluetooth Connected : " + btDeviceConnected)
            }
        },
        Connections {
            id: appConnections
            target:  _app
           
            // onPhoneCallActiveChanged:{console.log("Active: " + isActive); phoneCallActiveInternal= isActive;phoneCallActiveChangedTimer.start();}
            
            onOpenInternetRadio: {
                closeHistory();
                closeFavourites();
                closePlayer();
                closeLyrics();
                closePicker();
                creator.createQMLObject("InternetRadioStationsBuiltIn.qml")
            }
            onOpenInternetRadioStations: {
                
                console.log("Recieved internet radio signal: " + m_uri)
                internetRadioSource = "" + m_uri.replace("starplayer://internetradiostation/", "");
                internetRadioInvokedHS = true;
                activity.running = true;
                activity.visible = true;
                // mainnav.closeLyrics();
                closeHistory();
                closeFavourites();
                closePlayer();
                closeLyrics();
                closePicker();
                closeInternetRadioList();
                artWorkURI = "";
                internetRadioOpenDelay.start();
            }
            onOpenPlaylist: {
                
                playlistURL = "" + m_uri.replace("starplayer://playlist/", "");
                if (_app.checkFileExists(playlistURL) === false) {
                    toast.showText("Unable To Find Playlist, file not found")
                } else {
                    closeHistory();
                    closeFavourites();
                    closePlayer();
                    closeLyrics();
                    closePicker();
                    closeInternetRadioList();
                    playlistName = _app.getFileName(playlistURL);
                    creator.createQMLObject("PlaylistViewer.qml");
                }
            }
            onOpenLyricsSearch: {
                closeHistory();
                closeFavourites();
                closePlayer();
                closeInternetRadioList();
                closePicker();
                if (lyricsSearchOpen === false) {
                    creator.createQMLObject("LyricsSearch.qml")
                }
            }
            
            onInternetRadioStationRequested: {
                artWorkURI = "";
                if (internetRadioActive) {
                    internetRadioSource = stationUrl;
                    metaDataTitle = title;
                    artWorkURI = imageURL;
                    internetRadioStationChanged();
                } else {
                    activity.running = true;
                    activity.visible = true;
                    internetRadioSource = stationUrl;
                    metaDataTitle = title;
                    artWorkURI = imageURL;
                    console.log("backup" + backupURL);
                    metaDataBitRate = bitrate;
                    closeHistory();
                    closeFavourites();
                    closePlayer();
                    closeLyrics();
                    closePicker();
                    closeInternetRadioList();
                    internetRadioOpenDelay.start();
                }
                console.log("Image URL :" + artWorkURI)
            
            }
            onStartupPassword: {
                creator.createQMLObject("StartupPass.qml")
            }
            onOpenLastPlayedPage: {
                closeFavourites();
                closePlayer();
                closeLyrics();
                closePicker();
                closeInternetRadioList();
                if (protectedMode) {
                    creator.createQMLObject("ProtectedModeRec.qml")
                } else {
                    creator.createQMLObject("RecentlyPlayed.qml")
                }
            }
            onOpenFavouritesPage: {
                closeHistory();
                closePlayer();
                closeLyrics();
                closePicker();
                closeInternetRadioList();
                if (protectedMode) {
                    creator.createQMLObject("ProtectedModeFav.qml")
                } else {
                    creator.createQMLObject("FavouritesPage.qml")
                }
            }
            onFavouritePlayRequested: {
                closeHistory();
                closeFavourites();
                closeLyrics();
                closePicker();
                closeInternetRadioList();
                if (type === "Stream") {
                    audioSource = videoUrl;
                    sourceStreamed = true;
                    streamTimer.start();
                } else if (type === "InternetRadioStation") {
                    internetRadioSource = videoUrl;
                    metaDataTitle = title;
                    internetRadioOpenDelay.start();
                } else {
                    audioSource = videoUrl;
                    favPlay.start();
                }
                artWorkURI = art;
                favouriteType = type;
                activity.running = true;
                activity.visible = true;
            
            }
            onOnlineModeChanged: {
                connectionOnline = isOnline;
                console.log(connectionOnline)
            
            }
            onPlayerInvoked: {
                closePlayer();
                clearMetaData();
                closeHistory();
                closeFavourites();
                closeLyrics();
                closePicker();
                closeInternetRadioList();
                sourceInvoked = true;
                activity.running = true;
                activity.visible = true;
                console.log("invoked");
                
                audioSource = "file://" + m_uri.replace("starplayer:///", "");
                invokeTimer.start();
            }
            onPlayerStreamInvoked: {
                closeHistory();
                closeFavourites();
                closePlayer();
                closeLyrics();
                closePicker();
                closeInternetRadioList();
                sourceInvoked = true;
                sourceStreamed = true;
                activity.running = true;
                activity.visible = true;
                console.log("invoked");
                if (type == "http") audioSource = m_uri.replace("starplayer://http//", "http://");
                else if (type == "https") audioSource = m_uri.replace("starplayer://https//", "https://");
                invokeTimer.start();
            }
            
            onPlayerNonHSInvoked: {
                closeHistory();
                closeFavourites();
                closePlayer();
                closeLyrics();
                closePicker();
                closeInternetRadioList();
                sourceInvoked = true;
                activity.running = true;
                activity.visible = true;
                console.log("invoked");
                audioSource = m_uri;
                invokeTimer.start();
            }
        
        },
        SystemTimer {
            id: pinnedVideoTimer
            interval:50
            onTimeout: {
                pinnedVideoTimer.stop();
                openVideo();
            }
        },
        
        AppSettings {
            id: appsettings
        },
        SystemToast {
            id: toast
            property string uid: ""
            onFinished: {
                if (buttonSelection().label === "Ok") {
                    if (uid === "StarTip") {
                        appsettings.saveSystemSetting("StarTip", "true")
                    }
                    if (uid === "battSavWarning") {
                        battSavWarning = false;
                        console.log("battSavWarning bool " + battSavWarning);
                    }
                }
            
            }
            
            function showText(text) {
                button.label = "";
                toast.body = text;
                toast.show()
            }
            function showTextWithButton(text, buttonText, uId) {
                button.label = buttonText;
                uid = uId;
                toast.body = text;
                toast.show()
            }
        },
        ComponentDefinition {
            id: creator
            onError: {
                toast.showTextWithButton(errorMessage, "OK", "")
            }
            function createQMLObject(sourceUrl) {
                source = sourceUrl;
                return creator.createObject()
            
            }
        },
        ComponentDefinition {
            id: bob
            source: "Cover.qml"
        },
        ComponentDefinition {
            id: firstRunPullDown
            source: "Custom/PullDownMenuInfo.qml"
        },
        
        ComponentDefinition {
            id: picker
            signal bob
            content: FilePicker {
                id: filePicker
                onError: {
                    toast.showText(error)
                }
                Component.onCompleted: {
                    open();
                    activity.running = true;
                    activity.visible = true;
                }
                type: FileType.Video
                mode: FilePickerMode.Picker
                title: qsTr("Select Video")
                property string bob
                property string path: appsettings.getSystemSetting("filepickerDefaultPath", "/accounts/")
                directories: [ path ]
                filter: FileType.Video
                
                onCanceled: {
                    activity.running = false;
                    activity.visible = false;
                }
                onFileSelected: {
                    
                    activity.running = true;
                    activity.visible = true;
                    console.log("FileSelected signal received : " + selectedFiles);
                    if (getFileType(selectedFiles[0].toString()) === "m3u") {
                        canceled();
                        importSource = selectedFiles[0].toString();
                        playlistM3uImporting = true;
                        creator.createQMLObject("PlaylistCreator.qml")
                    } else {
                        audioSource = "file://" + selectedFiles[0].toString();
                        originalSource = selectedFiles[0].toString();
                        var bob0 = selectedFiles[0].toString()
                        var bob1 = _app.getFileName(selectedFiles[0].toString());
                        var bob2 = getFileType(bob0);
                        var bob3 = bob1 + "." + bob2
                        console.log("PLSSSSSSS WRRRK  " + bob3)
                        bob = bob0.replace(bob3, "")
                        if (appsettings.getSystemSetting("filepickerDefaultPathLast", "") === "true") {
                            appsettings.saveSystemSetting("filepickerDefaultPath", bob)
                        }
                        console.log("ggggggggg       " + bob)
                        sourceInvoked = false;
                        
                        openVideo();
                    }
                }
            }
        },
        ComponentDefinition {
            id: pickerAudio
            content: FilePicker {
                id: filePicker1
                Component.onCompleted: {
                    open();
                    activity.running = true;
                    activity.visible = true;
                }
                type: FileType.Music
                mode: FilePickerMode.Picker
                property string bob
                title: qsTr("Select Audio")
                property string path: appsettings.getSystemSetting("filepickerDefaultPath", "/accounts/")
                directories: [ path ]
                filter: FileType.Music
                
                onCanceled: {
                    activity.running = false;
                    activity.visible = false;
                }
                onFileSelected: {
                    activity.running = true;
                    activity.visible = true;
                    console.log("FileSelected signal received : " + selectedFiles);
                    if (getFileType(selectedFiles[0].toString()) === "m3u") {
                        canceled();
                        importSource = selectedFiles[0].toString();
                        playlistM3uImporting = true;
                        creator.createQMLObject("PlaylistCreator.qml")
                    } else {
                        
                        audioSource = "file://" + selectedFiles[0].toString();
                        originalSource = selectedFiles[0].toString();
                        var bob0 = selectedFiles[0].toString()
                        var bob1 = _app.getFileName(selectedFiles[0].toString());
                        var bob2 = getFileType(bob0);
                        var bob3 = bob1 + "." + bob2
                        console.log("PLSSSSSSS WRRRK  " + bob3)
                        bob = bob0.replace(bob3, "")
                        if (appsettings.getSystemSetting("filepickerDefaultPathLast", "") === "true") {
                            appsettings.saveSystemSetting("filepickerDefaultPath", bob)
                        }
                        console.log("ggggggggg       " + bob)
                        sourceInvoked = false;
                        openVideo();
                    }
                }
            }
        }
    ]
    Page {
        id: mainpage
        titleBar: TitleBar {
            visibility: downloadActive ? ChromeVisibility.Default : ChromeVisibility.Hidden
            title: qsTr("Downloading..") + downloadPercentage + "%"
            dismissAction: ActionItem {
                title: "Cancel"
                enabled: downloadActive ? true : false
                
                onTriggered: {
                    creator.createQMLObject("DownloadCancelDialog.qml")
                }
            }
        
        }
        actionBarVisibility: ChromeVisibility.Hidden
        actions: [
          ActionItem {
              id: playAllAction
              enabled: _app.checkSharedFiles()? _app.checkSDCard()? true:false:false
              property bool created: false
              attachedObjects: [
                  SystemListDialog {
                  id: listDialog
                  title:qsTr("Play All")
                  confirmButton.label: qsTr("Choose")
                  cancelButton.label: qsTr("Cancel")
                  onFinished: {
                      playQueue.clear();
                      playAllMode=true;
                      if(result == SystemUiResult.ConfirmButtonSelection) {
                          if(selectedIndices==0){_app.playAllCustom("/accounts/1000/removable/sdcard/", true, true);creator.createQMLObject("PlayAllDialog.qml");}
              else if(selectedIndices==1){_app.playAllCustom("/accounts/1000/removable/sdcard/", true, false);creator.createQMLObject("PlayAllDialog.qml");}
             else if(selectedIndices==2){_app.playAll("/accounts/1000/removable/sdcard/", true);creator.createQMLObject("PlayAllDialog.qml");}
                      }
                      else if (result == SystemUiResult.CancelButtonSelection) {
                          listDialog.cancel(); playAllMode=false;
                      }
                  
                  }
              }]
            title: "Play All"
            imageSource: "asset:///images/ic_play.png"  
            onTriggered: {    
                _app.contentsCheck("/accounts/1000/shared/misc/android/")            
                if(!created)
                {  
                    listDialog.appendItem("Audio")
                    listDialog.appendItem("Video" )
                    listDialog.appendItem("Audio & Video")
                    created = true;
                }
                
                listDialog.show();
              }
          },
            
            ActionItem {
                title: qsTr("Internet Radio")
                enabled: connectionOnline
                imageSource: internetRadioScheduledRecording ? "images/internet_radio_icon_active.png" : "images/internet_radio_icon.png"
                onTriggered: {
                    creator.createQMLObject("InternetRadioStationsBuiltIn.qml")
                
                }
            },
            
            ActionItem {
                id: choose
                title: qsTr("Choose Video")
                property string pickerType: appsettings.getSystemSetting("homeSigActionPicker", "clean")
                function change() {
                    ActionBar.placement = ActionBarPlacement.InOverflow
                }
                imageSource: passport ? "asset:///images/video_passport.png" : "asset:///images/video.png"
                ActionBar.placement: appsettings.getSystemSetting("homeSigAction", "") === "Aud" ? ActionBarPlacement.InOverflow : ActionBarPlacement.Signature
                onTriggered: {
                    
                    if (_app.checkSharedFiles() === true) {
                        if (pickerType === "clean") {
                            creator.createQMLObject("VideoPicker.qml")
                        } else {
                            picker.createObject()
                            activity.running = true;
                            activity.visible = true;
                        }
                    } else {
                        toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")
                    }
                
                }
            },
            ActionItem {
                id: chooseaud
                title: qsTr("Choose Audio")
                imageSource: "asset:///images/music_small.png"
                ActionBar.placement: appsettings.getSystemSetting("homeSigAction", "") === "Aud" ? ActionBarPlacement.Signature : ActionBarPlacement.InOverflow
                onTriggered: {
                    if (_app.checkSharedFiles() === true) {
                        
                        pickerAudio.createObject();
                        activity.running = true;
                        activity.visible = true;
                    } else {
                        toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")
                    }
                
                }
            },
            
            ActionItem {
                title: qsTr("Folder Play")
                imageSource: "asset:///images/folder.png"
                attachedObjects: ComponentDefinition {
                    id: picker2
                    signal bob
                    content: FilePicker {
                        id: filePicker2
                        onError: {
                            toast.showText(error)
                        }
                        Component.onCompleted: {
                            open();
                        }
                        mode: FilePickerMode.SaverMultiple
                        title: "Select Folder Path"
                        property string path: appsettings.getSystemSetting("filepickerDefaultPath", "/accounts/")
                        directories: [ path ]
                        // filter: FileType.Music
                        onFileSelected: {
                            console.log("FileSelected signal received : " + selectedFiles);
                            folderToPlaylistURL = selectedFiles[0].toString();
                            
                            playListCreatorFolderMode = true;
                            
                            creator.createQMLObject("PlaylistCreator.qml")
                        
                        }
                    }
                }
                onTriggered: {
                    if (appsettings.getSystemSetting("FolderPlayTut", "") === "") {
                        creator.createQMLObject("FolderPlayTutorial.qml")
                    } else {
                        picker2.createObject();
                    }
                }
            },
            
            ActionItem {
                id: re
                title: qsTr("Last Played")
                enabled: true
                imageSource: "images/ic_history.png"
                ActionBar.placement: ActionBarPlacement.InOverflow
                onTriggered: {
                    
                    if (protectedMode) {
                        creator.createQMLObject("ProtectedModeRec.qml")
                    } else {
                        creator.createQMLObject("RecentlyPlayed.qml")
                    }
                }
            },
            
            ActionItem {
                enabled: downloadActive ? false : true
                title: qsTr("Audio Recorder")
                imageSource: "images/record.png"
                onTriggered: {
                    if (_app.checkSharedFiles() === true) {
                        creator.createQMLObject("AudioRecorder.qml")
                    } else {
                        toast.showTextWithButton("Unable to access file system, please enable the Shared Files Permission", "OK", "sharedFiles")
                    }
                
                }
            },
           /* ActionItem {
                id: bug
                function openReport() {
                    creator.createQMLObject("ContactForm.qml")
                }
                title: qsTr("Contact Us")
                ActionBar.placement: ActionBarPlacement.InOverflow
                imageSource: "asset:///images/bug.png"
                onTriggered: {
                    creator.createQMLObject("ContactForm.qml")
                }
            },*/
            ActionItem {
                id: f
                enabled: true
                title: qsTr("Playlists")
                imageSource: "asset:///images/playlist.png"
                ActionBar.placement: ActionBarPlacement.InOverflow
                onTriggered: {
                    creator.createQMLObject("PlaylistEditor.qml")
                }
            },
            ActionItem {
                id: cmact
                title: "Car Mode"
                imageSource: "images/CarModeAction.png"
                onTriggered: {
                    carModedelay.start();
                    activity.running = true;
                    activity.visible = true;
                }
            },  ActionItem {
                title: "Donate"
                imageSource: "images/beer.png"
                onTriggered: {Qt.openUrlExternally("http://paypal.me/Allstarsoftware")
                
                }
            }
            
        ]
        
        Container {
            id: mainCont
            layout: DockLayout {
            }
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                Label {
                    visible: _pinnedVideos.dataModel.childCount(0) === 0 ? true : false
                    text: qsTr("No Pinned Media")
                    textStyle.color: brightTheme? Color.Black: Color.White
                    opacity: nightMode ? 0.6 : 0.8
                    textStyle {
                        fontSize: FontSize.PointValue
                        fontSizeValue: 17
                        base: SystemDefaults.TextStyles.BigText
                    }
                }
            }
            ImageButtonWithLabel {
                id: downloadsButton
                attachedObjects: [
                    Connections {
                        target: orientationH
                        onOrientationAboutToChange: {
                            downloadsButton.hide();
                        }
                        onOrientationChanged: {
                            reOpacity.start();
                        }
                    },
                    SystemTimer {
                        id: reOpacity
                        interval: 500
                        onTimeout: {
                            reOpacity.stop();
                            downloadsButton.show();
                        }
                    }
                
                ]
                horizontalAlignment: HorizontalAlignment.Left
                verticalAlignment: VerticalAlignment.Bottom
                bottomPadding: device768 ? 185 : passport ? 175 : 125
                leftPadding: 20
                title: qsTr("Downloads")
                defaultSource: downloadActive ? "asset:///images/ic_download_active.png": brightTheme?  "asset:///images/ic_download_dark.png": "asset:///images/ic_download.png"
                disabledSource: brightTheme? "asset:///images/ic_download_dark.png": "images/ic_download.png"
                buttonEnabled: downloadActive ? true : false
                pressedSource: "asset:///images/ic_download_active_pressed.png"
                onPressed: {
                    creator.createQMLObject("Downloads.qml")
                }
            }
            
            ImageButtonWithLabel {
                id: streamButton
                attachedObjects: [
                    Connections {
                        target: orientationH
                        onOrientationAboutToChange: {
                            streamButton.hide();
                        }
                        onOrientationChanged: {
                            reOpacity1.start();
                        }
                    },
                    SystemTimer {
                        id: reOpacity1
                        interval: 500
                        onTimeout: {
                            reOpacity1.stop();
                            streamButton.show();
                        }
                    }
                
                ]
                horizontalAlignment: HorizontalAlignment.Right
                verticalAlignment: VerticalAlignment.Bottom
                bottomPadding: device768 ? 185 : passport ? 175 : 125
                rightPadding: 20
                title: qsTr("Web Stream")
                defaultSource:connectionOnline?brightTheme? "asset:///images/ic_browser_dark.png" : "asset:///images/ic_browser.png" : "asset:///images/ic_browser_error.png"
                
                /*if(connectionOnline){
                 if(brightTheme){return "asset:///images/ic_browser_dark.png";}
                 else{return "asset:///images/ic_browser.png";}
                 }
                 else{
                 
                 
                 }*/
                disabledSource: "images/ic_browser_error.png"
                pressedSource: brightTheme? "images/ic_browser_dark_pressed.png":"images/ic_browser_pressed.png"
                buttonEnabled: connectionOnline ? true : false
                onPressed: {
                    if (appsettings.getSystemSetting("webStreamTut", "") === "") creator.createQMLObject("StreamTutorial.qml");
                    else creator.createQMLObject("StreamSource.qml")
                }
            }
            
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Bottom
                bottomPadding: device768 ? 185 : passport ? 175 : 125
                minWidth: if (passport === true) {
                    return 500
                } else if (OrientationSupport.orientation == UIOrientation.Landscape) {
                    return 450
                } else if (OrientationSupport.orientation == UIOrientation.Portrait) {
                    return 300
                }
                
                maxWidth: 350
                maxHeight: device768 ? 295 : passport ? 290 : 225
                minHeight: device768 ? 295 : passport ? 290 : 225
                layout: DockLayout {
                }
                
                ImageButtonWithLabel {
                    id: favButton
                    
                    attachedObjects: [
                        Connections {
                            target: orientationH
                            onOrientationAboutToChange: {
                                favButton.hide();
                            }
                            onOrientationChanged: {
                                reOpacity2.start();
                            }
                        },
                        SystemTimer {
                            id: reOpacity2
                            interval: 500
                            onTimeout: {
                                reOpacity2.stop();
                                favButton.show();
                            }
                        }
                    
                    ]
                    horizontalAlignment: HorizontalAlignment.Right
                    verticalAlignment: VerticalAlignment.Center
                    title: qsTr("Favourites")
                    defaultSource: brightTheme?  "images/ic_favorite_dark.png":"images/ic_favorite.png"
                    pressedSource: brightTheme? "images/ic_favorite_dark_pressed.png": "images/ic_favorite_pressed.png"
                    buttonEnabled: true
                    onPressed: {
                        if (protectedMode) {
                            creator.createQMLObject("ProtectedModeFav.qml")
                        } else {
                            creator.createQMLObject("FavouritesPage.qml")
                        }
                    }
                }
                ImageButtonWithLabel {
                    id: night
                    attachedObjects: [
                        Connections {
                            target: orientationH
                            onOrientationAboutToChange: {
                                night.hide();
                            }
                            onOrientationChanged: {
                                reOpacity3.start();
                            }
                        },
                        SystemTimer {
                            id: reOpacity3
                            interval: 500
                            onTimeout: {
                                reOpacity3.stop();
                                night.show();
                            }
                        }
                    
                    ]
                    horizontalAlignment: HorizontalAlignment.Left
                    verticalAlignment: VerticalAlignment.Center
                    title: qsTr("Night Mode")
                    defaultSource: brightTheme? "images/night_dark.png":"images/night.png"
                    pressedSource: brightTheme? "images/night_dark_pressed.png":"images/night_pressed.png"
                    buttonEnabled: true
                    onPressed: {
                        if (nightMode === true) {
                            nightMode = false;
                            toast.showText(qsTr("Night Mode Disabled"))
                        } else {
                            nightMode = true;
                            toast.showText(qsTr("Night Mode Enabled"));
                        
                        }
                        nightModeChanged();
                    
                    }
                }
            }
            
            Container {
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                layout: DockLayout {
                }
                background: brightTheme? Color.White: Color.Black
                opacity: activity.running ? 0.8 : 0
                Container {
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    
                    ActivityIndicator {
                        id: activity
                        visible: true
                        running: false
                        minHeight: passport ? 170 : 150
                        minWidth: passport ? 170 : 150
                    }
                }
            }
            Container {
                id: pinnedMediaHolder
                horizontalAlignment: HorizontalAlignment.Fill
                property variant bober
                function createNewStyle() {
                    bober = newStyle.createObject();
                    pinnedMediaHolder.add(bober)
                }
                function createOldStyle() {
                    bober = oldStyle.createObject();
                    pinnedMediaHolder.add(bober)
                }
                function createWelcomeSlate(){
                    bober = welcomeSlate.createObject();
                    pinnedMediaHolder.add(bober)
                }
                
                attachedObjects: [
                    ComponentDefinition {
                        id: welcomeSlate
                        content: HomescreenWelcomeSlate {
                            visible: _pinnedVideos.dataModel.childCount(0) === 0 ? true:false
                            onCreationCompleted: {show();}
                            id:welcomeSlateHS
                            horizontalAlignment: HorizontalAlignment.Fill
                            verticalAlignment: VerticalAlignment.Top
                        }
                    },
                    ComponentDefinition {
                        id: newStyle
                        content: HomescreenPinnedVideos {
                            visible: _pinnedVideos.dataModel.childCount(0) === 0 ? false : true
                            onCreationCompleted: {show();}
                            id: pinnedVideosHS
                            horizontalAlignment: HorizontalAlignment.Fill
                            verticalAlignment: VerticalAlignment.Top
                        }
                    },
                    ComponentDefinition {
                        id: oldStyle
                        content: ExpandableView {
                            collapseMode: CollapseMode.UserCollapse
                            id: pinnedExpandable
                            opacity: nightMode ? 0.8 : 1
                            visible: _pinnedVideos.dataModel.childCount(0) === 0 ? false : true
                            enabled: downloadActive ? false : true
                            horizontalAlignment: HorizontalAlignment.Fill
                            maxHeight: _app.screenHeight() - 200
                            
                            onCreationCompleted: {
                                loadList();
                            }
                            function loadList() {
                                boberr = endede.createObject();
                                pinnedCont.add(boberr)
                            }
                            property variant boberr
                            Container {
                                id: pinnedCont
                                bottomPadding: 200
                                attachedObjects: ComponentDefinition {
                                    id: endede
                                    content: ListView {
                                        
                                        onCreationCompleted: {
                                            opacity = 1;
                                        }
                                        scrollRole: ScrollRole.None
                                        opacity: 0
                                        dataModel: _pinnedVideos.dataModel
                                        flickMode: FlickMode.None
                                        
                                        horizontalAlignment: HorizontalAlignment.Fill
                                        verticalAlignment: VerticalAlignment.Fill
                                        layout: StackListLayout {
                                            headerMode: ListHeaderMode.Sticky
                                        }
                                        
                                        listItemComponents: [
                                            
                                            ListItemComponent {
                                                type: "item"
                                                
                                                StandardListItem {
                                                    title: ListItemData.videoTitle
                                                    description: ListItemData.itemType === "Playlist" ? "" : ListItemData.videoURL
                                                    status: ListItemData.videoDuration
                                                    imageSource: ListItemData.artWork === "" ? Application.themeSupport.theme.colorTheme.style == VisualStyle.Bright?"images/pin_dark.png": "images/pin.png" : ListItemData.artWork
                                                
                                                }
                                            },
                                            ListItemComponent {
                                                type: "header"
                                                Header {
                                                    mode: HeaderMode.Interactive
                                                    title: qsTr("Pinned Media")
                                                }
                                            }
                                        
                                        ]
                                        onTriggered: {
                                            var dat = _pinnedVideos.dataModel.data(indexPath);
                                            
                                            if (dat.itemType === "InternetRadioStation") {
                                                internetRadioSource = dat.videoURL;
                                                activity.running = true;
                                                activity.visible = true;
                                                artWorkURI = dat.artWork;
                                                internetRadioOpenDelay.start();
                                            } else if (dat.itemType === "WebStream") {
                                                audioSource = dat.videoURL;
                                                activity.running = true;
                                                activity.visible = true;
                                                sourceStreamed = true;
                                                streamTimer.start();
                                            } else if (dat.itemType === "Playlist") {
                                                playlistURL = dat.videoURL;
                                                playlistName = dat.videoTitle;
                                                creator.createQMLObject("PlaylistViewer.qml");
                                            
                                            } else {
                                                audioSource = dat.videoURL;
                                                artWorkURI = dat.artWork;
                                                activity.running = true;
                                                activity.visible = true;
                                                pinnedVideoTimer.start();
                                                
                                                console.log("URL " + dat.videoURL)
                                                console.log("Title " + dat.videoTitle)
                                                console.log("Page value " + dat.page)
                                                console.log("ArtWork " + dat.artWork)
                                                console.log("Type " + dat.itemType)
                                            }
                                        }
                                    
                                    }
                                }
                            
                            }
                        
                        }
                    }
                ]
            }
            
            Container {
                id: startSplash
                opacity: 1
                onCreationCompleted: {
                    //  if(appsettings.getSystemSetting("BrightTheme", "true")){Application.themeSupport.setVisualStyle(VisualStyle.Bright);}
                
                }
                layout: DockLayout {
                }
                visible: true
                function hide() {
                    fadeOut.play();
                }
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                animations: FadeTransition {
                    id: fadeOut
                    fromOpacity: 1
                    toOpacity: 0
                    duration: 450
                    onEnded: {
                        mainpage.actionBarVisibility = ChromeVisibility.Compact;
                        favButton.show();
                        night.show();
                        streamButton.show();
                        downloadsButton.show();
                        pinnedMediaHolder.createWelcomeSlate();
                        if (appsettings.getSystemSetting("PinnedMediaViewer", "") === "") {
                            pinnedMediaHolder.createNewStyle();
                        } else {
                            pinnedMediaHolder.createOldStyle();
                        }
                        protectedMode = appsettings.getSystemSetting("protectedMode", "") === "" ? false : true
                        startSplash.removeAll();
                        startSplash.destroy();
                        if (miniSquareDevice == true) {
                            mainpage.removeAction(cmact)
                        }
                        createCover();
                        
                        //  showArtWorkWhenPossible= appsettings.getSystemSetting("ShowArtWorkWhenPossible", "")
                        sleepTimerInterval = parseInt(appsettings.getSystemSetting("sleepTimerInterval", ""))
                        liveActiveFrame = appsettings.getSystemSetting("liveActiveFrame", "") === "" ? true : false
                        touchZoom = appsettings.getSystemSetting("touchZoom", "") === "" ? true : false
                        responsiveZoom = appsettings.getSystemSetting("FasttouchZoom", "") === "" ? false : true
                        lockscreenart = appsettings.getSystemSetting("lockscreenart", "") === "" ? false : true
                        touchPan = appsettings.getSystemSetting("touchPan", "") === "" ? false : true
                        autoPausePlayer = appsettings.getSystemSetting("autoPausePlayer", "") === "" ? true : false
                        autoHideAppOnPlay = appsettings.getSystemSetting("autoHideAppOnPlay", "") === "" ? false : true
                        notifyOnDownloadComplete = appsettings.getSystemSetting("notifyOnDownloadComplete", "") === "" ? false : true
                        fadeInAudio = appsettings.getSystemSetting("fadeInAudio", "") === "" ? false : true
                        nightModeOverLay = appsettings.getSystemSetting("nightModeOverLay", "") === "" ? true : false
                        videoControlsTimeout = parseInt(appsettings.getSystemSetting("videoControlsTimeout", "7000"));
                        nightModeOverLayBrightness = appsettings.getSystemSetting("nightModeOverLayBrightness", "") === "" ? 0.4 : appsettings.getSystemSetting("nightModeOverLayBrightness", "")
                        videoOverlayValue= appsettings.getSystemSetting("videoOverlayValue", "");
                        //  if (firstRun) if (appsettings.getSystemSetting("audioBlankWarning", "") === "") creator.createQMLObject("SoundWarningDialog.qml")
                        if (appsettings.getSystemSetting("launchDoNotDisturb", "") === "true") {
                            globalNotifications.createObject();
                        }
                        if (firstRun)showPullMenuTip();
                        if (appsettings.getSystemSetting("nightModeTimeCheck", "") === "") {
                            startNightModeTimeChecker();
                        }
                        rewindInterval= appsettings.getSystemSetting("rewindInterval", "10000");
                        forwardInterval= appsettings.getSystemSetting("forwardInterval", "10000");
                        
                        clearCacheOnClose = appsettings.getSystemSetting("ClearLyricsCacheOnClose", "") === "" ? false : true
                        showArtWorkWhenPossible = appsettings.getSystemSetting("ShowArtWorkWhenPossible", "") === "" ? true : false
                        touchVolumeControls = appsettings.getSystemSetting("touchVolumeControls", "") === "" ? true : false
                        passportTrackKeyboard = appsettings.getSystemSetting("passportTrackKeyboard", "") === "" ? false : true
                        
                        carModeAlwaysKeepScreenOn = appsettings.getSystemSetting("carModeAlwaysKeepScreenOn", "") === "" ? true : false
                        
                        autoPlayWhenBluetoothIsConnected = appsettings.getSystemSetting("autoPlayWhenBluetoothIsConnected", "") === "" ? false : true
                        resumeCarModeLastPlayedTrack = appsettings.getSystemSetting("resumeCarModeLastPlayedTrack", "") === "" ? false : true
                        launchCarModeonStartup = appsettings.getSystemSetting("LaunchCarModeonStartup", "") === "" ? false : true
                        fowardRewindButtonValue = parseInt(appsettings.getSystemSetting("fowardRewindButtonValue", "10000"));
                        longPressfowardRewindButtonValue = parseInt(appsettings.getSystemSetting("longPressfowardRewindButtonValue", "20000"))
                        showVideoUnderControls = appsettings.getSystemSetting("showVideoUnderControls", "") === "" ? true : false
                        lastAnnouncementsCount= parseInt(appsettings.getSystemSetting("lastAnnouncementsCount",""));
                     
                        /*if (sourceInvoked === false) if (appsettings.getSystemSetting("appclosed", "") === "notset") {
                            creator.createQMLObject("AppNotCloseProperly.qml")
                        } else {
                            appsettings.saveSystemSetting("appclosed", "notset")
                        }*/
                        
                        if(appsettings.getSystemSetting("announcementsAutoCheck", "")===""){creator.createQMLObject("Custom/BackgroundAnnouncementsChecker.qml")}
                        launchInto();
                       /* rateOpenedCount = parseInt(appsettings.getSystemSetting("rateappdiocount", ""));
                       
                        if (appsettings.getSystemSetting("rateappdiocount", "") === "5") {
                            creator.createQMLObject("RateAppDio.qml");
                            rateOpenedCount += 1;
                            appsettings.saveSystemSetting("rateappdiocount", rateOpenedCount)
                        } else {
                            rateOpenedCount += 1;
                            appsettings.saveSystemSetting("rateappdiocount", rateOpenedCount)
                        }*/
                        
                       
                    
                    }
                }
                background: brightTheme? Color.White: Color.Black
                Container {
                    
                    layout: DockLayout {
                    }
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    SplashScreenImage {
                    }
                }
            
            }
        
        }
    }
    onPopTransitionEnded: {
        _app.setScreenIdle("Normal");
        if (playbackCompleted === false) {
            if (renamingFile === false) {
                console.log("Should be saving last url");
                appsettings.saveSystemSetting("fileDidNotCompletePosition", videoProgress);
                appsettings.saveSystemSetting("fileDidNotCompleteURL", audioSource);
                console.log("Now, you better have saved;  " + appsettings.getSystemSetting("fileDidNotCompletePosition", "") + appsettings.getSystemSetting("fileDidNotCompleteURL", ""))
            }
        }
        
        if (webRecordingActive) webRadioDown.cancel();
        page.destroy();
        autoResizeAttempted = false;
        carModeInternetRadio=false;
        
        
        setLockScreenArt();
        var oro = appsettings.getSystemSetting("orientation", "");
        if (oro === "Automatic") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.All
        } else if (oro === "Portrait") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayPortrait
        } else if (oro === "Landscape") {
            OrientationSupport.supportedDisplayOrientation = SupportedDisplayOrientation.DisplayLandscape
        }
        
        
        if (aboutToLoadCarMode) {
            activity.running = true;activity.visible = true;  carModedelay.start(); 
        
        }
        else{
            playQueue.clear();

            playAllMode=false;
            artWorkURI = "";
            artWorkUriNonMod="";
            playerDuration = 0;
            playerProgress = 0;
            elapsedTime = "";
            playlistMode = false;
            mediaPlaying = false;
            sourceInvoked = false;
            sourceStreamed = false;
            activity.running = false;
            activity.visible = false;
            videoOpening = false;
            clearMetaData();
            
            mediaRepeat = false;
            // customPickerUsed=false;
            inAppRecordingPlaying = false;
            internetRadioActive = false;
          //  albumArtActiveFrame = false;
            shuffleMode = false;
            bypassFormatCheck = false;
            internetRadioSource = "";
            fileSystemLyricsFound = false;
            originalSource = "";
            updateCoverImage();
            playlistEditorOpened = false;
            carModeInternetRadio=false;
            autoResizeAttempted = false;
        }
    }
}
